/* operating system */
/* release >= 5.9 */
/* Copyright (C) 1991-2017 Free Software Foundation, Inc.
   This file is part of the GNU C Library.
   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.
   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   <http:
/*
 *	ISO C99 Standard 7.4: Character handling	<ctype.h>
 */
/* Copyright (C) 1991-2017 Free Software Foundation, Inc.
   This file is part of the GNU C Library.
   The GNU C Library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.
   The GNU C Library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.
   You should have received a copy of the GNU Lesser General Public
   License along with the GNU C Library; if not, see
   <http:
/* These are defined by the user (or the compiler)
   to specify the desired environment:
   __STRICT_ANSI__	ISO Standard C.
   _ISOC99_SOURCE	Extensions to ISO C89 from ISO C99.
   _ISOC11_SOURCE	Extensions to ISO C99 from ISO C11.
   __STDC_WANT_LIB_EXT2__
			Extensions to ISO C99 from TR 27431-2:2010.
   __STDC_WANT_IEC_60559_BFP_EXT__
			Extensions to ISO C11 from TS 18661-1:2014.
   __STDC_WANT_IEC_60559_FUNCS_EXT__
			Extensions to ISO C11 from TS 18661-4:2015.
   __STDC_WANT_IEC_60559_TYPES_EXT__
			Extensions to ISO C11 from TS 18661-3:2015.
   _POSIX_SOURCE	IEEE Std 1003.1.
   _POSIX_C_SOURCE	If ==1, like _POSIX_SOURCE; if >=2 add IEEE Std 1003.2;
			if >=199309L, add IEEE Std 1003.1b-1993;
			if >=199506L, add IEEE Std 1003.1c-1995;
			if >=200112L, all of IEEE 1003.1-2004
			if >=200809L, all of IEEE 1003.1-2008
   _XOPEN_SOURCE	Includes POSIX and XPG things.  Set to 500 if
			Single Unix conformance is wanted, to 600 for the
			sixth revision, to 700 for the seventh revision.
   _XOPEN_SOURCE_EXTENDED XPG things and X/Open Unix extensions.
   _LARGEFILE_SOURCE	Some more functions for correct standard I/O.
   _LARGEFILE64_SOURCE	Additional functionality from LFS for large files.
   _FILE_OFFSET_BITS=N	Select default filesystem interface.
   _ATFILE_SOURCE	Additional *at interfaces.
   _GNU_SOURCE		All of the above, plus GNU extensions.
   _DEFAULT_SOURCE	The default set of features (taking precedence over
			__STRICT_ANSI__).
   _FORTIFY_SOURCE	Add security hardening to many library functions.
			Set to 1 or 2; 2 performs stricter checks than 1.
   _REENTRANT, _THREAD_SAFE
			Obsolete; equivalent to _POSIX_C_SOURCE=199506L.
   The `-ansi' switch to the GNU C compiler, and standards conformance
   options such as `-std=c99', define __STRICT_ANSI__.  If none of
   these are defined, or if _DEFAULT_SOURCE is defined, the default is
   to have _POSIX_SOURCE set to one and _POSIX_C_SOURCE set to
   200809L, as well as enabling miscellaneous functions from BSD and
   SVID.  If more than one of these are defined, they accumulate.  For
   example __STRICT_ANSI__, _POSIX_SOURCE and _POSIX_C_SOURCE together
   give you ISO C, 1003.1, and 1003.2, but nothing else.
   These are defined by this file and are used by the
   header files to decide what to declare or define:
   __GLIBC_USE (F)	Define things from feature set F.  This is defined
			to 1 or 0; the subsequent macros are either defined
			or undefined, and those tests should be moved to
			__GLIBC_USE.
   __USE_ISOC11		Define ISO C11 things.
   __USE_ISOC99		Define ISO C99 things.
   __USE_ISOC95		Define ISO C90 AMD1 (C95) things.
   __USE_POSIX		Define IEEE Std 1003.1 things.
   __USE_POSIX2		Define IEEE Std 1003.2 things.
   __USE_POSIX199309	Define IEEE Std 1003.1, and .1b things.
   __USE_POSIX199506	Define IEEE Std 1003.1, .1b, .1c and .1i things.
   __USE_XOPEN		Define XPG things.
   __USE_XOPEN_EXTENDED	Define X/Open Unix things.
   __USE_UNIX98		Define Single Unix V2 things.
   __USE_XOPEN2K        Define XPG6 things.
   __USE_XOPEN2KXSI     Define XPG6 XSI things.
   __USE_XOPEN2K8       Define XPG7 things.
   __USE_XOPEN2K8XSI    Define XPG7 XSI things.
   __USE_LARGEFILE	Define correct standard I/O things.
   __USE_LARGEFILE64	Define LFS things with separate names.
   __USE_FILE_OFFSET64	Define 64bit interface as default.
   __USE_MISC		Define things from 4.3BSD or System V Unix.
   __USE_ATFILE		Define *at interfaces and AT_* constants for them.
   __USE_GNU		Define GNU extensions.
   __USE_FORTIFY_LEVEL	Additional security measures used, according to level.
   The macros `__GNU_LIBRARY__', `__GLIBC__', and `__GLIBC_MINOR__' are
   defined by this file unconditionally.  `__GNU_LIBRARY__' is provided
   only for compatibility.  All new code should use the other symbols
   to test for features.
   All macros listed above as possibly being defined by this file are
   explicitly undefined if they are not explicitly defined.
   Feature-test macros that are not defined by the user or compiler
   but are implied by the other feature-test macros defined (or by the
   lack of any definitions) are defined by the file.
   ISO C feature test macros depend on the definition of the macro
   when an affected header is included, not when the first system
   header is included, and so they are handled in
   <bits/libc-header-start.h>, which does not have a multiple include
   guard.  Feature test macros that can be handled from the first
   system header included are handled here.  */
/* Undefine everything, so we get a clean slate.  */
/* Suppress kernel-name space pollution unless user expressedly asks
   for it.  */
/* Convenience macro to test the version of gcc.
   Use like this:
   #if __GNUC_PREREQ (2,8)
   ... code requiring gcc 2.8 or later ...
   #endif
   Note: only works for GCC 2.0 and later, because __GNUC_MINOR__ was
   added in 2.0.  */
/* Similarly for clang.  Features added to GCC after version 4.2 may
   or may not also be available in clang, and clang's definitions of
   __GNUC(_MINOR)__ are fixed at 4 and 2 respectively.  Not all such
   features can be queried via __has_extension/__has_feature.  */
typedef unsigned char __u_char;
typedef unsigned short int __u_short;
typedef unsigned int __u_int;
typedef unsigned long int __u_long;
typedef signed char __int8_t;
typedef unsigned char __uint8_t;
typedef signed short int __int16_t;
typedef unsigned short int __uint16_t;
typedef signed int __int32_t;
typedef unsigned int __uint32_t;
typedef signed long int __int64_t;
typedef unsigned long int __uint64_t;
typedef long int __quad_t;
typedef unsigned long int __u_quad_t;
typedef long int __intmax_t;
typedef unsigned long int __uintmax_t;
typedef unsigned long int __dev_t; 
typedef unsigned int __uid_t; 
typedef unsigned int __gid_t; 
typedef unsigned long int __ino_t; 
typedef unsigned long int __ino64_t; 
typedef unsigned int __mode_t; 
typedef unsigned long int __nlink_t; 
typedef long int __off_t; 
typedef long int __off64_t; 
typedef int __pid_t; 
typedef struct { int __val[2]; } __fsid_t; 
typedef long int __clock_t; 
typedef unsigned long int __rlim_t; 
typedef unsigned long int __rlim64_t; 
typedef unsigned int __id_t; 
typedef long int __time_t; 
typedef unsigned int __useconds_t; 
typedef long int __suseconds_t; 
typedef int __daddr_t; 
typedef int __key_t; 
typedef int __clockid_t;
typedef void * __timer_t;
typedef long int __blksize_t;
typedef long int __blkcnt_t;
typedef long int __blkcnt64_t;
typedef unsigned long int __fsblkcnt_t;
typedef unsigned long int __fsblkcnt64_t;
typedef unsigned long int __fsfilcnt_t;
typedef unsigned long int __fsfilcnt64_t;
typedef long int __fsword_t;
typedef long int __ssize_t; 
typedef long int __syscall_slong_t;
typedef unsigned long int __syscall_ulong_t;
typedef __off64_t __loff_t; 
typedef __quad_t *__qaddr_t;
typedef char *__caddr_t;
typedef long int __intptr_t;
typedef unsigned int __socklen_t;
typedef int __sig_atomic_t;
static __inline __uint16_t
__uint16_identity (__uint16_t __x)
{
  return __x;
}
static __inline __uint32_t
__uint32_identity (__uint32_t __x)
{
  return __x;
}
static __inline __uint64_t
__uint64_identity (__uint64_t __x)
{
  return __x;
}
enum
{
  _ISupper = ((0) < 8 ? ((1 << (0)) << 8) : ((1 << (0)) >> 8)), 
  _ISlower = ((1) < 8 ? ((1 << (1)) << 8) : ((1 << (1)) >> 8)), 
  _ISalpha = ((2) < 8 ? ((1 << (2)) << 8) : ((1 << (2)) >> 8)), 
  _ISdigit = ((3) < 8 ? ((1 << (3)) << 8) : ((1 << (3)) >> 8)), 
  _ISxdigit = ((4) < 8 ? ((1 << (4)) << 8) : ((1 << (4)) >> 8)), 
  _ISspace = ((5) < 8 ? ((1 << (5)) << 8) : ((1 << (5)) >> 8)), 
  _ISprint = ((6) < 8 ? ((1 << (6)) << 8) : ((1 << (6)) >> 8)), 
  _ISgraph = ((7) < 8 ? ((1 << (7)) << 8) : ((1 << (7)) >> 8)), 
  _ISblank = ((8) < 8 ? ((1 << (8)) << 8) : ((1 << (8)) >> 8)), 
  _IScntrl = ((9) < 8 ? ((1 << (9)) << 8) : ((1 << (9)) >> 8)), 
  _ISpunct = ((10) < 8 ? ((1 << (10)) << 8) : ((1 << (10)) >> 8)), 
  _ISalnum = ((11) < 8 ? ((1 << (11)) << 8) : ((1 << (11)) >> 8)) 
};
extern const unsigned short int **__ctype_b_loc (void)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern const __int32_t **__ctype_tolower_loc (void)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern const __int32_t **__ctype_toupper_loc (void)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int isalnum (int) __attribute__ ((__nothrow__ ));
extern int isalpha (int) __attribute__ ((__nothrow__ ));
extern int iscntrl (int) __attribute__ ((__nothrow__ ));
extern int isdigit (int) __attribute__ ((__nothrow__ ));
extern int islower (int) __attribute__ ((__nothrow__ ));
extern int isgraph (int) __attribute__ ((__nothrow__ ));
extern int isprint (int) __attribute__ ((__nothrow__ ));
extern int ispunct (int) __attribute__ ((__nothrow__ ));
extern int isspace (int) __attribute__ ((__nothrow__ ));
extern int isupper (int) __attribute__ ((__nothrow__ ));
extern int isxdigit (int) __attribute__ ((__nothrow__ ));
extern int tolower (int __c) __attribute__ ((__nothrow__ ));
extern int toupper (int __c) __attribute__ ((__nothrow__ ));
extern int isblank (int) __attribute__ ((__nothrow__ ));
extern int isascii (int __c) __attribute__ ((__nothrow__ ));
extern int toascii (int __c) __attribute__ ((__nothrow__ ));
extern int _toupper (int) __attribute__ ((__nothrow__ ));
extern int _tolower (int) __attribute__ ((__nothrow__ ));
struct __locale_struct
{
  struct __locale_data *__locales[13]; 
  const unsigned short int *__ctype_b;
  const int *__ctype_tolower;
  const int *__ctype_toupper;
  const char *__names[13];
};
typedef struct __locale_struct *__locale_t;
typedef __locale_t locale_t;
extern int isalnum_l (int, locale_t) __attribute__ ((__nothrow__ ));
extern int isalpha_l (int, locale_t) __attribute__ ((__nothrow__ ));
extern int iscntrl_l (int, locale_t) __attribute__ ((__nothrow__ ));
extern int isdigit_l (int, locale_t) __attribute__ ((__nothrow__ ));
extern int islower_l (int, locale_t) __attribute__ ((__nothrow__ ));
extern int isgraph_l (int, locale_t) __attribute__ ((__nothrow__ ));
extern int isprint_l (int, locale_t) __attribute__ ((__nothrow__ ));
extern int ispunct_l (int, locale_t) __attribute__ ((__nothrow__ ));
extern int isspace_l (int, locale_t) __attribute__ ((__nothrow__ ));
extern int isupper_l (int, locale_t) __attribute__ ((__nothrow__ ));
extern int isxdigit_l (int, locale_t) __attribute__ ((__nothrow__ ));
extern int isblank_l (int, locale_t) __attribute__ ((__nothrow__ ));
extern int __tolower_l (int __c, locale_t __l) __attribute__ ((__nothrow__ ));
extern int tolower_l (int __c, locale_t __l) __attribute__ ((__nothrow__ ));
extern int __toupper_l (int __c, locale_t __l) __attribute__ ((__nothrow__ ));
extern int toupper_l (int __c, locale_t __l) __attribute__ ((__nothrow__ ));
typedef struct _ut80 {
 unsigned long long Low;
 unsigned short High;
} ut80;
typedef struct _ut96 {
 unsigned long long Low;
 unsigned int High;
} ut96;
typedef struct _ut128 {
 unsigned long long Low;
 long long High;
} ut128;
typedef struct _ut256 {
 ut128 Low;
 ut128 High;
} ut256;
typedef struct _utX{
 ut80 v80;
 ut96 v96;
 ut128 v128;
 ut256 v256;
} utX;
typedef long unsigned int size_t;
struct _IO_FILE;
typedef struct _IO_FILE __FILE;
struct _IO_FILE;
typedef struct _IO_FILE FILE;
typedef struct
{
  int __count;
  union
  {
    unsigned int __wch;
    char __wchb[4];
  } __value; 
} __mbstate_t;
typedef struct
{
  __off_t __pos;
  __mbstate_t __state;
} _G_fpos_t;
typedef struct
{
  __off64_t __pos;
  __mbstate_t __state;
} _G_fpos64_t;
typedef __builtin_va_list va_list;
typedef __builtin_va_list __gnuc_va_list;
struct _IO_jump_t; struct _IO_FILE;
typedef void _IO_lock_t;
struct _IO_marker {
  struct _IO_marker *_next;
  struct _IO_FILE *_sbuf;
  int _pos;
};
enum __codecvt_result
{
  __codecvt_ok,
  __codecvt_partial,
  __codecvt_error,
  __codecvt_noconv
};
struct _IO_FILE {
  int _flags; 
  char* _IO_read_ptr; 
  char* _IO_read_end; 
  char* _IO_read_base; 
  char* _IO_write_base; 
  char* _IO_write_ptr; 
  char* _IO_write_end; 
  char* _IO_buf_base; 
  char* _IO_buf_end; 
  char *_IO_save_base; 
  char *_IO_backup_base; 
  char *_IO_save_end; 
  struct _IO_marker *_markers;
  struct _IO_FILE *_chain;
  int _fileno;
  int _flags2;
  __off_t _old_offset; 
  unsigned short _cur_column;
  signed char _vtable_offset;
  char _shortbuf[1];
  _IO_lock_t *_lock;
  __off64_t _offset;
  void *__pad1;
  void *__pad2;
  void *__pad3;
  void *__pad4;
  size_t __pad5;
  int _mode;
  char _unused2[15 * sizeof (int) - 4 * sizeof (void *) - sizeof (size_t)];
};
typedef struct _IO_FILE _IO_FILE;
struct _IO_FILE_plus;
extern struct _IO_FILE_plus _IO_2_1_stdin_;
extern struct _IO_FILE_plus _IO_2_1_stdout_;
extern struct _IO_FILE_plus _IO_2_1_stderr_;
typedef __ssize_t __io_read_fn (void *__cookie, char *__buf, size_t __nbytes);
typedef __ssize_t __io_write_fn (void *__cookie, const char *__buf,
     size_t __n);
typedef int __io_seek_fn (void *__cookie, __off64_t *__pos, int __w);
typedef int __io_close_fn (void *__cookie);
extern int __underflow (_IO_FILE *);
extern int __uflow (_IO_FILE *);
extern int __overflow (_IO_FILE *, int);
extern int _IO_getc (_IO_FILE *__fp);
extern int _IO_putc (int __c, _IO_FILE *__fp);
extern int _IO_feof (_IO_FILE *__fp) __attribute__ ((__nothrow__ ));
extern int _IO_ferror (_IO_FILE *__fp) __attribute__ ((__nothrow__ ));
extern int _IO_peekc_locked (_IO_FILE *__fp);
extern void _IO_flockfile (_IO_FILE *) __attribute__ ((__nothrow__ ));
extern void _IO_funlockfile (_IO_FILE *) __attribute__ ((__nothrow__ ));
extern int _IO_ftrylockfile (_IO_FILE *) __attribute__ ((__nothrow__ ));
extern int _IO_vfscanf (_IO_FILE * __restrict, const char * __restrict,
   __gnuc_va_list, int *__restrict);
extern int _IO_vfprintf (_IO_FILE *__restrict, const char *__restrict,
    __gnuc_va_list);
extern __ssize_t _IO_padn (_IO_FILE *, int, __ssize_t);
extern size_t _IO_sgetn (_IO_FILE *, void *, size_t);
extern __off64_t _IO_seekoff (_IO_FILE *, __off64_t, int, int);
extern __off64_t _IO_seekpos (_IO_FILE *, __off64_t, int);
extern void _IO_free_backup_area (_IO_FILE *) __attribute__ ((__nothrow__ ));
typedef __gnuc_va_list va_list;
typedef __off_t off_t;
typedef __ssize_t ssize_t;
typedef _G_fpos_t fpos_t;
extern struct _IO_FILE *stdin; 
extern struct _IO_FILE *stdout; 
extern struct _IO_FILE *stderr; 
extern int remove (const char *__filename) __attribute__ ((__nothrow__ ));
extern int rename (const char *__old, const char *__new) __attribute__ ((__nothrow__ ));
extern int renameat (int __oldfd, const char *__old, int __newfd,
       const char *__new) __attribute__ ((__nothrow__ ));
extern FILE *tmpfile (void) ;
extern char *tmpnam (char *__s) __attribute__ ((__nothrow__ )) ;
extern char *tmpnam_r (char *__s) __attribute__ ((__nothrow__ )) ;
extern char *tempnam (const char *__dir, const char *__pfx)
     __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern int fclose (FILE *__stream);
extern int fflush (FILE *__stream);
extern int fflush_unlocked (FILE *__stream);
extern FILE *fopen (const char *__restrict __filename,
      const char *__restrict __modes) ;
extern FILE *freopen (const char *__restrict __filename,
        const char *__restrict __modes,
        FILE *__restrict __stream) ;
extern FILE *fdopen (int __fd, const char *__modes) __attribute__ ((__nothrow__ )) ;
extern FILE *fmemopen (void *__s, size_t __len, const char *__modes)
  __attribute__ ((__nothrow__ )) ;
extern FILE *open_memstream (char **__bufloc, size_t *__sizeloc) __attribute__ ((__nothrow__ )) ;
extern void setbuf (FILE *__restrict __stream, char *__restrict __buf) __attribute__ ((__nothrow__ ));
extern int setvbuf (FILE *__restrict __stream, char *__restrict __buf,
      int __modes, size_t __n) __attribute__ ((__nothrow__ ));
extern void setbuffer (FILE *__restrict __stream, char *__restrict __buf,
         size_t __size) __attribute__ ((__nothrow__ ));
extern void setlinebuf (FILE *__stream) __attribute__ ((__nothrow__ ));
extern int fprintf (FILE *__restrict __stream,
      const char *__restrict __format, ...);
extern int printf (const char *__restrict __format, ...);
extern int sprintf (char *__restrict __s,
      const char *__restrict __format, ...) __attribute__ ((__nothrow__));
extern int vfprintf (FILE *__restrict __s, const char *__restrict __format,
       __gnuc_va_list __arg);
extern int vprintf (const char *__restrict __format, __gnuc_va_list __arg);
extern int vsprintf (char *__restrict __s, const char *__restrict __format,
       __gnuc_va_list __arg) __attribute__ ((__nothrow__));
extern int snprintf (char *__restrict __s, size_t __maxlen,
       const char *__restrict __format, ...)
     __attribute__ ((__nothrow__)) __attribute__ ((__format__ (__printf__, 3, 4)));
extern int vsnprintf (char *__restrict __s, size_t __maxlen,
        const char *__restrict __format, __gnuc_va_list __arg)
     __attribute__ ((__nothrow__)) __attribute__ ((__format__ (__printf__, 3, 0)));
extern int vdprintf (int __fd, const char *__restrict __fmt,
       __gnuc_va_list __arg)
     __attribute__ ((__format__ (__printf__, 2, 0)));
extern int dprintf (int __fd, const char *__restrict __fmt, ...)
     __attribute__ ((__format__ (__printf__, 2, 3)));
extern int fscanf (FILE *__restrict __stream,
     const char *__restrict __format, ...) ;
extern int scanf (const char *__restrict __format, ...) ;
extern int sscanf (const char *__restrict __s,
     const char *__restrict __format, ...) __attribute__ ((__nothrow__ ));
extern int fscanf (FILE *__restrict __stream, const char *__restrict __format, ...) __asm__ ("" "__isoc99_fscanf") ;
extern int scanf (const char *__restrict __format, ...) __asm__ ("" "__isoc99_scanf") ;
extern int sscanf (const char *__restrict __s, const char *__restrict __format, ...) __asm__ ("" "__isoc99_sscanf") __attribute__ ((__nothrow__ ));
extern int vfscanf (FILE *__restrict __s, const char *__restrict __format,
      __gnuc_va_list __arg)
     __attribute__ ((__format__ (__scanf__, 2, 0))) ;
extern int vscanf (const char *__restrict __format, __gnuc_va_list __arg)
     __attribute__ ((__format__ (__scanf__, 1, 0))) ;
extern int vsscanf (const char *__restrict __s,
      const char *__restrict __format, __gnuc_va_list __arg)
     __attribute__ ((__nothrow__ )) __attribute__ ((__format__ (__scanf__, 2, 0)));
extern int vfscanf (FILE *__restrict __s, const char *__restrict __format, __gnuc_va_list __arg) __asm__ ("" "__isoc99_vfscanf")
     __attribute__ ((__format__ (__scanf__, 2, 0))) ;
extern int vscanf (const char *__restrict __format, __gnuc_va_list __arg) __asm__ ("" "__isoc99_vscanf")
     __attribute__ ((__format__ (__scanf__, 1, 0))) ;
extern int vsscanf (const char *__restrict __s, const char *__restrict __format, __gnuc_va_list __arg) __asm__ ("" "__isoc99_vsscanf") __attribute__ ((__nothrow__ ))
     __attribute__ ((__format__ (__scanf__, 2, 0)));
extern int fgetc (FILE *__stream);
extern int getc (FILE *__stream);
extern int getchar (void);
extern int getc_unlocked (FILE *__stream);
extern int getchar_unlocked (void);
extern int fgetc_unlocked (FILE *__stream);
extern int fputc (int __c, FILE *__stream);
extern int putc (int __c, FILE *__stream);
extern int putchar (int __c);
extern int fputc_unlocked (int __c, FILE *__stream);
extern int putc_unlocked (int __c, FILE *__stream);
extern int putchar_unlocked (int __c);
extern int getw (FILE *__stream);
extern int putw (int __w, FILE *__stream);
extern char *fgets (char *__restrict __s, int __n, FILE *__restrict __stream)
          ;
extern __ssize_t __getdelim (char **__restrict __lineptr,
          size_t *__restrict __n, int __delimiter,
          FILE *__restrict __stream) ;
extern __ssize_t getdelim (char **__restrict __lineptr,
        size_t *__restrict __n, int __delimiter,
        FILE *__restrict __stream) ;
extern __ssize_t getline (char **__restrict __lineptr,
       size_t *__restrict __n,
       FILE *__restrict __stream) ;
extern int fputs (const char *__restrict __s, FILE *__restrict __stream);
extern int puts (const char *__s);
extern int ungetc (int __c, FILE *__stream);
extern size_t fread (void *__restrict __ptr, size_t __size,
       size_t __n, FILE *__restrict __stream) ;
extern size_t fwrite (const void *__restrict __ptr, size_t __size,
        size_t __n, FILE *__restrict __s);
extern size_t fread_unlocked (void *__restrict __ptr, size_t __size,
         size_t __n, FILE *__restrict __stream) ;
extern size_t fwrite_unlocked (const void *__restrict __ptr, size_t __size,
          size_t __n, FILE *__restrict __stream);
extern int fseek (FILE *__stream, long int __off, int __whence);
extern long int ftell (FILE *__stream) ;
extern void rewind (FILE *__stream);
extern int fseeko (FILE *__stream, __off_t __off, int __whence);
extern __off_t ftello (FILE *__stream) ;
extern int fgetpos (FILE *__restrict __stream, fpos_t *__restrict __pos);
extern int fsetpos (FILE *__stream, const fpos_t *__pos);
extern void clearerr (FILE *__stream) __attribute__ ((__nothrow__ ));
extern int feof (FILE *__stream) __attribute__ ((__nothrow__ )) ;
extern int ferror (FILE *__stream) __attribute__ ((__nothrow__ )) ;
extern void clearerr_unlocked (FILE *__stream) __attribute__ ((__nothrow__ ));
extern int feof_unlocked (FILE *__stream) __attribute__ ((__nothrow__ )) ;
extern int ferror_unlocked (FILE *__stream) __attribute__ ((__nothrow__ )) ;
extern void perror (const char *__s);
extern int sys_nerr;
extern const char *const sys_errlist[];
extern int fileno (FILE *__stream) __attribute__ ((__nothrow__ )) ;
extern int fileno_unlocked (FILE *__stream) __attribute__ ((__nothrow__ )) ;
extern FILE *popen (const char *__command, const char *__modes) ;
extern int pclose (FILE *__stream);
extern char *ctermid (char *__s) __attribute__ ((__nothrow__ ));
extern void flockfile (FILE *__stream) __attribute__ ((__nothrow__ ));
extern int ftrylockfile (FILE *__stream) __attribute__ ((__nothrow__ )) ;
extern void funlockfile (FILE *__stream) __attribute__ ((__nothrow__ ));
extern void *memcpy (void *__restrict __dest, const void *__restrict __src,
       size_t __n) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern void *memmove (void *__dest, const void *__src, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern void *memccpy (void *__restrict __dest, const void *__restrict __src,
        int __c, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern void *memset (void *__s, int __c, size_t __n) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int memcmp (const void *__s1, const void *__s2, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern void *memchr (const void *__s, int __c, size_t __n)
      __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern char *strcpy (char *__restrict __dest, const char *__restrict __src)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern char *strncpy (char *__restrict __dest,
        const char *__restrict __src, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern char *strcat (char *__restrict __dest, const char *__restrict __src)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern char *strncat (char *__restrict __dest, const char *__restrict __src,
        size_t __n) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int strcmp (const char *__s1, const char *__s2)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern int strncmp (const char *__s1, const char *__s2, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern int strcoll (const char *__s1, const char *__s2)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern size_t strxfrm (char *__restrict __dest,
         const char *__restrict __src, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int strcoll_l (const char *__s1, const char *__s2, locale_t __l)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2, 3)));
extern size_t strxfrm_l (char *__dest, const char *__src, size_t __n,
    locale_t __l) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 4)));
extern char *strdup (const char *__s)
     __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) __attribute__ ((__nonnull__ (1)));
extern char *strndup (const char *__string, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) __attribute__ ((__nonnull__ (1)));
extern char *strchr (const char *__s, int __c)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern char *strrchr (const char *__s, int __c)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern size_t strcspn (const char *__s, const char *__reject)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern size_t strspn (const char *__s, const char *__accept)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern char *strpbrk (const char *__s, const char *__accept)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern char *strstr (const char *__haystack, const char *__needle)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern char *strtok (char *__restrict __s, const char *__restrict __delim)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern char *__strtok_r (char *__restrict __s,
    const char *__restrict __delim,
    char **__restrict __save_ptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 3)));
extern char *strtok_r (char *__restrict __s, const char *__restrict __delim,
         char **__restrict __save_ptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 3)));
extern size_t strlen (const char *__s)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern size_t strnlen (const char *__string, size_t __maxlen)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern char *strerror (int __errnum) __attribute__ ((__nothrow__ ));
extern int strerror_r (int __errnum, char *__buf, size_t __buflen) __asm__ ("" "__xpg_strerror_r") __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern char *strerror_l (int __errnum, locale_t __l) __attribute__ ((__nothrow__ ));
extern int bcmp (const void *__s1, const void *__s2, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern void bcopy (const void *__src, void *__dest, size_t __n)
  __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern void bzero (void *__s, size_t __n) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern char *index (const char *__s, int __c)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern char *rindex (const char *__s, int __c)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1)));
extern int ffs (int __i) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int strcasecmp (const char *__s1, const char *__s2)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern int strncasecmp (const char *__s1, const char *__s2, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern int strcasecmp_l (const char *__s1, const char *__s2, locale_t __loc)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2, 3)));
extern int strncasecmp_l (const char *__s1, const char *__s2,
     size_t __n, locale_t __loc)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2, 4)));
extern void explicit_bzero (void *__s, size_t __n) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern char *strsep (char **__restrict __stringp,
       const char *__restrict __delim)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern char *strsignal (int __sig) __attribute__ ((__nothrow__ ));
extern char *__stpcpy (char *__restrict __dest, const char *__restrict __src)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern char *stpcpy (char *__restrict __dest, const char *__restrict __src)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern char *__stpncpy (char *__restrict __dest,
   const char *__restrict __src, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern char *stpncpy (char *__restrict __dest,
        const char *__restrict __src, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
typedef int wchar_t;
typedef struct
  {
    int quot; 
    int rem; 
  } div_t;
typedef struct
  {
    long int quot; 
    long int rem; 
  } ldiv_t;
__extension__ typedef struct
  {
    long long int quot; 
    long long int rem; 
  } lldiv_t;
extern size_t __ctype_get_mb_cur_max (void) __attribute__ ((__nothrow__ )) ;
extern double atof (const char *__nptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1))) ;
extern int atoi (const char *__nptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1))) ;
extern long int atol (const char *__nptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1))) ;
__extension__ extern long long int atoll (const char *__nptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1))) ;
extern double strtod (const char *__restrict __nptr,
        char **__restrict __endptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern float strtof (const char *__restrict __nptr,
       char **__restrict __endptr) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern long double strtold (const char *__restrict __nptr,
       char **__restrict __endptr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern long int strtol (const char *__restrict __nptr,
   char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern unsigned long int strtoul (const char *__restrict __nptr,
      char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
__extension__
extern long long int strtoq (const char *__restrict __nptr,
        char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
__extension__
extern unsigned long long int strtouq (const char *__restrict __nptr,
           char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
__extension__
extern long long int strtoll (const char *__restrict __nptr,
         char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
__extension__
extern unsigned long long int strtoull (const char *__restrict __nptr,
     char **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern char *l64a (long int __n) __attribute__ ((__nothrow__ )) ;
extern long int a64l (const char *__s)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1))) ;
typedef __u_char u_char;
typedef __u_short u_short;
typedef __u_int u_int;
typedef __u_long u_long;
typedef __quad_t quad_t;
typedef __u_quad_t u_quad_t;
typedef __fsid_t fsid_t;
typedef __loff_t loff_t;
typedef __ino_t ino_t;
typedef __dev_t dev_t;
typedef __gid_t gid_t;
typedef __mode_t mode_t;
typedef __nlink_t nlink_t;
typedef __uid_t uid_t;
typedef __pid_t pid_t;
typedef __id_t id_t;
typedef __daddr_t daddr_t;
typedef __caddr_t caddr_t;
typedef __key_t key_t;
typedef __clock_t clock_t;
typedef __clockid_t clockid_t;
typedef __time_t time_t;
typedef __timer_t timer_t;
typedef unsigned long int ulong;
typedef unsigned short int ushort;
typedef unsigned int uint;
typedef __int8_t int8_t;
typedef __int16_t int16_t;
typedef __int32_t int32_t;
typedef __int64_t int64_t;
typedef unsigned int u_int8_t __attribute__ ((__mode__ (__QI__)));
typedef unsigned int u_int16_t __attribute__ ((__mode__ (__HI__)));
typedef unsigned int u_int32_t __attribute__ ((__mode__ (__SI__)));
typedef unsigned int u_int64_t __attribute__ ((__mode__ (__DI__)));
typedef int register_t __attribute__ ((__mode__ (__word__)));
typedef struct
{
  unsigned long int __val[(1024 / (8 * sizeof (unsigned long int)))];
} __sigset_t;
typedef __sigset_t sigset_t;
struct timeval
{
  __time_t tv_sec; 
  __suseconds_t tv_usec; 
};
struct timespec
{
  __time_t tv_sec; 
  __syscall_slong_t tv_nsec; 
};
typedef __suseconds_t suseconds_t;
typedef long int __fd_mask;
typedef struct
  {
    __fd_mask __fds_bits[1024 / (8 * (int) sizeof (__fd_mask))];
  } fd_set;
typedef __fd_mask fd_mask;
extern int select (int __nfds, fd_set *__restrict __readfds,
     fd_set *__restrict __writefds,
     fd_set *__restrict __exceptfds,
     struct timeval *__restrict __timeout);
extern int pselect (int __nfds, fd_set *__restrict __readfds,
      fd_set *__restrict __writefds,
      fd_set *__restrict __exceptfds,
      const struct timespec *__restrict __timeout,
      const __sigset_t *__restrict __sigmask);
extern unsigned int gnu_dev_major (__dev_t __dev) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern unsigned int gnu_dev_minor (__dev_t __dev) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern __dev_t gnu_dev_makedev (unsigned int __major, unsigned int __minor) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
typedef __blksize_t blksize_t;
typedef __blkcnt_t blkcnt_t; 
typedef __fsblkcnt_t fsblkcnt_t; 
typedef __fsfilcnt_t fsfilcnt_t; 
struct __pthread_rwlock_arch_t
{
  unsigned int __readers;
  unsigned int __writers;
  unsigned int __wrphase_futex;
  unsigned int __writers_futex;
  unsigned int __pad3;
  unsigned int __pad4;
  int __cur_writer;
  int __shared;
  signed char __rwelision;
  unsigned char __pad1[7];
  unsigned long int __pad2;
  unsigned int __flags;
};
typedef struct __pthread_internal_list
{
  struct __pthread_internal_list *__prev;
  struct __pthread_internal_list *__next;
} __pthread_list_t;
struct __pthread_mutex_s
{
  int __lock ;
  unsigned int __count;
  int __owner;
  unsigned int __nusers;
  int __kind;
  short __spins; short __elision;
  __pthread_list_t __list;
};
struct __pthread_cond_s
{
  __extension__ union
  {
    __extension__ unsigned long long int __wseq;
    struct
    {
      unsigned int __low;
      unsigned int __high;
    } __wseq32;
  };
  __extension__ union
  {
    __extension__ unsigned long long int __g1_start;
    struct
    {
      unsigned int __low;
      unsigned int __high;
    } __g1_start32;
  };
  unsigned int __g_refs[2] ;
  unsigned int __g_size[2];
  unsigned int __g1_orig_size;
  unsigned int __wrefs;
  unsigned int __g_signals[2];
};
typedef unsigned long int pthread_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_mutexattr_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_condattr_t;
typedef unsigned int pthread_key_t;
typedef int pthread_once_t;
union pthread_attr_t
{
  char __size[56];
  long int __align;
};
typedef union pthread_attr_t pthread_attr_t;
typedef union
{
  struct __pthread_mutex_s __data;
  char __size[40];
  long int __align;
} pthread_mutex_t;
typedef union
{
  struct __pthread_cond_s __data;
  char __size[48];
  __extension__ long long int __align;
} pthread_cond_t;
typedef union
{
  struct __pthread_rwlock_arch_t __data;
  char __size[56];
  long int __align;
} pthread_rwlock_t;
typedef union
{
  char __size[8];
  long int __align;
} pthread_rwlockattr_t;
typedef volatile int pthread_spinlock_t;
typedef union
{
  char __size[32];
  long int __align;
} pthread_barrier_t;
typedef union
{
  char __size[4];
  int __align;
} pthread_barrierattr_t;
extern long int random (void) __attribute__ ((__nothrow__ ));
extern void srandom (unsigned int __seed) __attribute__ ((__nothrow__ ));
extern char *initstate (unsigned int __seed, char *__statebuf,
   size_t __statelen) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern char *setstate (char *__statebuf) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
struct random_data
  {
    int32_t *fptr; 
    int32_t *rptr; 
    int32_t *state; 
    int rand_type; 
    int rand_deg; 
    int rand_sep; 
    int32_t *end_ptr; 
  };
extern int random_r (struct random_data *__restrict __buf,
       int32_t *__restrict __result) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int srandom_r (unsigned int __seed, struct random_data *__buf)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int initstate_r (unsigned int __seed, char *__restrict __statebuf,
   size_t __statelen,
   struct random_data *__restrict __buf)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 4)));
extern int setstate_r (char *__restrict __statebuf,
         struct random_data *__restrict __buf)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int rand (void) __attribute__ ((__nothrow__ ));
extern void srand (unsigned int __seed) __attribute__ ((__nothrow__ ));
extern int rand_r (unsigned int *__seed) __attribute__ ((__nothrow__ ));
extern double drand48 (void) __attribute__ ((__nothrow__ ));
extern double erand48 (unsigned short int __xsubi[3]) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern long int lrand48 (void) __attribute__ ((__nothrow__ ));
extern long int nrand48 (unsigned short int __xsubi[3])
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern long int mrand48 (void) __attribute__ ((__nothrow__ ));
extern long int jrand48 (unsigned short int __xsubi[3])
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern void srand48 (long int __seedval) __attribute__ ((__nothrow__ ));
extern unsigned short int *seed48 (unsigned short int __seed16v[3])
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern void lcong48 (unsigned short int __param[7]) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
struct drand48_data
  {
    unsigned short int __x[3]; 
    unsigned short int __old_x[3]; 
    unsigned short int __c; 
    unsigned short int __init; 
    __extension__ unsigned long long int __a; 
  };
extern int drand48_r (struct drand48_data *__restrict __buffer,
        double *__restrict __result) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int erand48_r (unsigned short int __xsubi[3],
        struct drand48_data *__restrict __buffer,
        double *__restrict __result) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int lrand48_r (struct drand48_data *__restrict __buffer,
        long int *__restrict __result)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int nrand48_r (unsigned short int __xsubi[3],
        struct drand48_data *__restrict __buffer,
        long int *__restrict __result)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int mrand48_r (struct drand48_data *__restrict __buffer,
        long int *__restrict __result)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int jrand48_r (unsigned short int __xsubi[3],
        struct drand48_data *__restrict __buffer,
        long int *__restrict __result)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int srand48_r (long int __seedval, struct drand48_data *__buffer)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int seed48_r (unsigned short int __seed16v[3],
       struct drand48_data *__buffer) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int lcong48_r (unsigned short int __param[7],
        struct drand48_data *__buffer)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern void *malloc (size_t __size) __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern void *calloc (size_t __nmemb, size_t __size)
     __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern void *realloc (void *__ptr, size_t __size)
     __attribute__ ((__nothrow__ )) __attribute__ ((__warn_unused_result__));
extern void free (void *__ptr) __attribute__ ((__nothrow__ ));
extern void *alloca (size_t __size) __attribute__ ((__nothrow__ ));
extern void *valloc (size_t __size) __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern int posix_memalign (void **__memptr, size_t __alignment, size_t __size)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern void *aligned_alloc (size_t __alignment, size_t __size)
     __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__)) ;
extern void abort (void) __attribute__ ((__nothrow__ )) __attribute__ ((__noreturn__));
extern int atexit (void (*__func) (void)) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int at_quick_exit (void (*__func) (void)) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int on_exit (void (*__func) (int __status, void *__arg), void *__arg)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern void exit (int __status) __attribute__ ((__nothrow__ )) __attribute__ ((__noreturn__));
extern void quick_exit (int __status) __attribute__ ((__nothrow__ )) __attribute__ ((__noreturn__));
extern void _Exit (int __status) __attribute__ ((__nothrow__ )) __attribute__ ((__noreturn__));
extern char *getenv (const char *__name) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern int putenv (char *__string) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int setenv (const char *__name, const char *__value, int __replace)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int unsetenv (const char *__name) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int clearenv (void) __attribute__ ((__nothrow__ ));
extern char *mktemp (char *__template) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int mkstemp (char *__template) __attribute__ ((__nonnull__ (1))) ;
extern int mkstemps (char *__template, int __suffixlen) __attribute__ ((__nonnull__ (1))) ;
extern char *mkdtemp (char *__template) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern int system (const char *__command) ;
extern char *realpath (const char *__restrict __name,
         char *__restrict __resolved) __attribute__ ((__nothrow__ )) ;
typedef int (*__compar_fn_t) (const void *, const void *);
extern void *bsearch (const void *__key, const void *__base,
        size_t __nmemb, size_t __size, __compar_fn_t __compar)
     __attribute__ ((__nonnull__ (1, 2, 5))) ;
extern void qsort (void *__base, size_t __nmemb, size_t __size,
     __compar_fn_t __compar) __attribute__ ((__nonnull__ (1, 4)));
extern int abs (int __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)) ;
extern long int labs (long int __x) __attribute__ ((__nothrow__ )) __attribute__ ((__const__)) ;
__extension__ extern long long int llabs (long long int __x)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__)) ;
extern div_t div (int __numer, int __denom)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__)) ;
extern ldiv_t ldiv (long int __numer, long int __denom)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__)) ;
__extension__ extern lldiv_t lldiv (long long int __numer,
        long long int __denom)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__)) ;
extern char *ecvt (double __value, int __ndigit, int *__restrict __decpt,
     int *__restrict __sign) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4))) ;
extern char *fcvt (double __value, int __ndigit, int *__restrict __decpt,
     int *__restrict __sign) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4))) ;
extern char *gcvt (double __value, int __ndigit, char *__buf)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3))) ;
extern char *qecvt (long double __value, int __ndigit,
      int *__restrict __decpt, int *__restrict __sign)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4))) ;
extern char *qfcvt (long double __value, int __ndigit,
      int *__restrict __decpt, int *__restrict __sign)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4))) ;
extern char *qgcvt (long double __value, int __ndigit, char *__buf)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3))) ;
extern int ecvt_r (double __value, int __ndigit, int *__restrict __decpt,
     int *__restrict __sign, char *__restrict __buf,
     size_t __len) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4, 5)));
extern int fcvt_r (double __value, int __ndigit, int *__restrict __decpt,
     int *__restrict __sign, char *__restrict __buf,
     size_t __len) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4, 5)));
extern int qecvt_r (long double __value, int __ndigit,
      int *__restrict __decpt, int *__restrict __sign,
      char *__restrict __buf, size_t __len)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4, 5)));
extern int qfcvt_r (long double __value, int __ndigit,
      int *__restrict __decpt, int *__restrict __sign,
      char *__restrict __buf, size_t __len)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4, 5)));
extern int mblen (const char *__s, size_t __n) __attribute__ ((__nothrow__ ));
extern int mbtowc (wchar_t *__restrict __pwc,
     const char *__restrict __s, size_t __n) __attribute__ ((__nothrow__ ));
extern int wctomb (char *__s, wchar_t __wchar) __attribute__ ((__nothrow__ ));
extern size_t mbstowcs (wchar_t *__restrict __pwcs,
   const char *__restrict __s, size_t __n) __attribute__ ((__nothrow__ ));
extern size_t wcstombs (char *__restrict __s,
   const wchar_t *__restrict __pwcs, size_t __n)
     __attribute__ ((__nothrow__ ));
extern int rpmatch (const char *__response) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern int getsubopt (char **__restrict __optionp,
        char *const *__restrict __tokens,
        char **__restrict __valuep)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2, 3))) ;
extern int getloadavg (double __loadavg[], int __nelem)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
struct flock
  {
    short int l_type; 
    short int l_whence; 
    __off_t l_start; 
    __off_t l_len; 
    __pid_t l_pid; 
  };
struct stat
  {
    __dev_t st_dev; 
    __ino_t st_ino; 
    __nlink_t st_nlink; 
    __mode_t st_mode; 
    __uid_t st_uid; 
    __gid_t st_gid; 
    int __pad0;
    __dev_t st_rdev; 
    __off_t st_size; 
    __blksize_t st_blksize; 
    __blkcnt_t st_blocks; 
    struct timespec st_atim; 
    struct timespec st_mtim; 
    struct timespec st_ctim; 
    __syscall_slong_t __glibc_reserved[3];
  };
extern int fcntl (int __fd, int __cmd, ...);
extern int open (const char *__file, int __oflag, ...) __attribute__ ((__nonnull__ (1)));
extern int openat (int __fd, const char *__file, int __oflag, ...)
     __attribute__ ((__nonnull__ (2)));
extern int creat (const char *__file, mode_t __mode) __attribute__ ((__nonnull__ (1)));
extern int lockf (int __fd, int __cmd, off_t __len);
extern int posix_fadvise (int __fd, off_t __offset, off_t __len,
     int __advise) __attribute__ ((__nothrow__ ));
extern int posix_fallocate (int __fd, off_t __offset, off_t __len);
static inline unsigned char r_read_ble8(const void *src) {
 if (!src) {
  return 0xFFU;
 }
 return *(unsigned char *)src;
}
static inline unsigned char r_read_at_ble8(const void *src, size_t offset) {
 return r_read_ble8 (((const unsigned char*)src) + offset);
}
static inline void r_write_ble8(void *dest, unsigned char val) {
 *(unsigned char *)dest = val;
}
static inline void r_write_at_ble8(void *dest, unsigned char val, size_t offset) {
 unsigned char *d = (unsigned char*)dest + offset;
 r_write_ble8 (d, val);
}
static inline unsigned char r_read_be8(const void *src) {
 return r_read_ble8 (src);
}
static inline unsigned char r_read_at_be8(const void *src, size_t offset) {
 return r_read_at_ble8 (src, offset);
}
static inline void r_write_be8(void *dest, unsigned char val) {
 r_write_ble8 (dest, val);
}
static inline void r_write_at_be8(void *dest, unsigned char val, size_t offset) {
 r_write_at_ble8 (dest, val, offset);
}
static inline unsigned short r_read_be16(const void *src) {
 const unsigned char *s = (const unsigned char*)src;
 return (((unsigned short)s[0]) << 8) | (((unsigned short)s[1]) << 0);
}
static inline unsigned short r_read_at_be16(const void *src, size_t offset) {
 const unsigned char *s = (const unsigned char*)src + offset;
 return r_read_be16 (s);
}
static inline void r_write_be16(void *dest, unsigned short val) {
 r_write_be8 (dest, val >> 8);
 r_write_at_be8 (dest, val >> 0, sizeof (unsigned char));
}
static inline void r_write_at_be16(void *dest, unsigned short val, size_t offset) {
 unsigned char *d = (unsigned char*)dest + offset;
 r_write_be16 (d, val);
}
static inline unsigned int r_read_be32(const void *src) {
 const unsigned char *s = (const unsigned char*)src;
 return (((unsigned int)s[0]) << 24) | (((unsigned int)s[1]) << 16) |
  (((unsigned int)s[2]) << 8) | (((unsigned int)s[3]) << 0);
}
static inline unsigned int r_read_at_be32(const void *src, size_t offset) {
 const unsigned char *s = (const unsigned char*)src + offset;
 return r_read_be32 (s);
}
static inline void r_write_be32(void *dest, unsigned int val) {
 r_write_be16 (dest, val >> 16);
 r_write_at_be16 (dest, val >> 0, sizeof (unsigned short));
}
static inline void r_write_be24(void *_dest, unsigned int val) {
 unsigned char *dest = (unsigned char*)_dest;
 r_write_be8 (dest++, val >> 16);
 r_write_be8 (dest++, val >> 8);
 r_write_be8 (dest, val >> 0);
}
static inline void r_write_at_be32(void *dest, unsigned int val, size_t offset) {
 unsigned char *d = (unsigned char*)dest + offset;
 r_write_be32 (d, val);
}
static inline unsigned long long r_read_be64(const void *src) {
 unsigned long long val = ((unsigned long long)(r_read_be32 (src))) << 32;
 val |= r_read_at_be32 (src, sizeof (unsigned int));
 return val;
}
static inline unsigned long long r_read_at_be64(const void *src, size_t offset) {
 const unsigned char *s = (const unsigned char*)src + offset;
 return r_read_be64 (s);
}
static inline void r_write_be64(void *dest, unsigned long long val) {
 r_write_be32 (dest, val >> 32);
 r_write_at_be32 (dest, val >> 0, sizeof (unsigned int));
}
static inline void r_write_at_be64(void *dest, unsigned long long val, size_t offset) {
 unsigned char *d = (unsigned char*)dest + offset;
 r_write_be64 (d, val);
}
static inline unsigned char r_read_le8(const void *src) {
 if (!src) {
  return 0xFFU;
 }
 return r_read_ble8 (src);
}
static inline unsigned char r_read_at_le8(const void *src, size_t offset) {
 return r_read_at_ble8 (src, offset);
}
static inline void r_write_le8(void *dest, unsigned char val) {
 r_write_ble8 (dest, val);
}
static inline void r_write_at_le8(void *dest, unsigned char val, size_t offset) {
 r_write_at_ble8 (dest, val, offset);
}
static inline unsigned short r_read_le16(const void *src) {
 if (!src) {
  return 0xFFFFU;
 }
 const unsigned char *s = (const unsigned char*)src;
 return (((unsigned short)s[1]) << 8) | (((unsigned short)s[0]) << 0);
}
static inline unsigned short r_read_at_le16(const void *src, size_t offset) {
 if (!src) {
  return 0xFFFFU;
 }
 const unsigned char *s = (const unsigned char*)src + offset;
 return r_read_le16 (s);
}
static inline void r_write_le16(void *dest, unsigned short val) {
 r_write_le8 (dest, val >> 0);
 r_write_at_le8 (dest, val >> 8, sizeof (unsigned char));
}
static inline void r_write_at_le16(void *dest, unsigned short val, size_t offset) {
 unsigned char *d = (unsigned char *)dest + offset;
 r_write_le16 (d, val);
}
static inline void r_write_le24(void *_dest, unsigned int val) {
 unsigned char* dest = (unsigned char*)_dest;
 r_write_le8 (dest++, val >> 0);
 r_write_le8 (dest++, val >> 8);
 r_write_le8 (dest, val >> 16);
}
static inline unsigned int r_read_le32(const void *src) {
 if (!src) {
  return 0xFFFFFFFFU;
 }
 const unsigned char *s = (const unsigned char*)src;
 return (((unsigned int)s[3]) << 24) | (((unsigned int)s[2]) << 16) |
  (((unsigned int)s[1]) << 8) | (((unsigned int)s[0]) << 0);
}
static inline unsigned int r_read_at_le32(const void *src, size_t offset) {
 if (!src) {
  return 0xFFFFFFFFU;
 }
 const unsigned char *s = (const unsigned char*)src + offset;
 return r_read_le32 (s);
}
static inline void r_write_le32(void *dest, unsigned int val) {
 r_write_le16 (dest, val >> 0);
 r_write_at_le16 (dest, val >> 16, sizeof (unsigned short));
}
static inline void r_write_at_le32(void *dest, unsigned int val, size_t offset) {
 unsigned char *d = ((unsigned char*)dest) + offset;
 r_write_le32 (d, val);
}
static inline unsigned long long r_read_le64(const void *src) {
 unsigned long long val = ((unsigned long long)(r_read_at_le32 (src, sizeof (unsigned int)))) << 32;
 val |= r_read_le32 (src);
 return val;
}
static inline unsigned long long r_read_at_le64(const void *src, size_t offset) {
 const unsigned char *s = ((const unsigned char*)src) + offset;
 return r_read_le64 (s);
}
static inline void r_write_le64(void *dest, unsigned long long val) {
 r_write_le32 (dest, val >> 0);
 r_write_at_le32 (dest, val >> 32, sizeof (unsigned int));
}
static inline void r_write_at_le64(void *dest, unsigned long long val, size_t offset) {
 unsigned char *d = (unsigned char*)dest + offset;
 r_write_le64 (d, val);
}
static inline unsigned char r_read_me8(const void *src) {
 if (!src) {
  return 0xFFU;
 }
 return r_read_ble8 (src);
}
static inline unsigned char r_read_at_me8(const void *src, size_t offset) {
 return r_read_at_ble8 (src, offset);
}
static inline void r_write_me8(void *dest, unsigned char val) {
 r_write_ble8 (dest, val);
}
static inline void r_write_at_me8(void *dest, unsigned char val, size_t offset) {
 r_write_at_ble8 (dest, val, offset);
}
static inline unsigned short r_read_me16(const void *src) {
 if (!src) {
  return 0xFFFFU;
 }
 const unsigned char *s = (const unsigned char*)src;
 return (((unsigned short)s[0]) << 8) | (((unsigned short)s[1]) << 0);
}
static inline unsigned short r_read_at_me16(const void *src, size_t offset) {
 if (!src) {
  return 0xFFFFU;
 }
 const unsigned char *s = (const unsigned char*)src + offset;
 return r_read_me16 (s);
}
static inline void r_write_me16(void *dest, unsigned short val) {
 r_write_me8 (dest, val >> 8);
 r_write_at_me8 (dest, val >> 0, sizeof (unsigned char));
}
static inline void r_write_at_me16(void *dest, unsigned short val, size_t offset) {
 unsigned char *d = (unsigned char *)dest + offset;
 r_write_me16 (d, val);
}
static inline unsigned int r_read_me32(const void *src) {
 if (!src) {
  return 0xFFFFFFFFU;
 }
 const unsigned char *s = (const unsigned char*)src;
 return (((unsigned int)s[2]) << 24) | (((unsigned int)s[1]) << 16) |
  (((unsigned int)s[0]) << 8) | (((unsigned int)s[1]) << 0);
}
static inline unsigned int r_read_at_me32(const void *src, size_t offset) {
 if (!src) {
  return 0xFFFFFFFFU;
 }
 const unsigned char *s = (const unsigned char*)src + offset;
 return r_read_me32 (s);
}
static inline void r_write_me32(void *dest, unsigned int val) {
 r_write_me16 (dest, val >> 0);
 r_write_at_me16 (dest, val >> 16, sizeof (unsigned short));
}
static inline void r_write_at_me32(void *dest, unsigned int val, size_t offset) {
 unsigned char *d = ((unsigned char*)dest) + offset;
 r_write_me32 (d, val);
}
static inline unsigned long long r_read_me64(const void *src) {
 unsigned long long val = ((unsigned long long)(r_read_at_me32 (src, sizeof (unsigned int)))) << 32;
 val |= r_read_me32 (src);
 return val;
}
static inline unsigned long long r_read_at_me64(const void *src, size_t offset) {
 const unsigned char *s = ((const unsigned char*)src) + offset;
 return r_read_me64 (s);
}
static inline void r_write_me64(void *dest, unsigned long long val) {
 r_write_me32 (dest, val >> 0);
 r_write_at_me32 (dest, val >> 32, sizeof (unsigned int));
}
static inline void r_write_at_me64(void *dest, unsigned long long val, size_t offset) {
 unsigned char *d = (unsigned char*)dest + offset;
 r_write_me64 (d, val);
}
static inline unsigned short r_read_ble16(const void *src, _Bool big_endian) {
 return big_endian? r_read_be16 (src): r_read_le16 (src);
}
static inline unsigned int r_read_ble32(const void *src, _Bool big_endian) {
 return big_endian? r_read_be32 (src): r_read_le32 (src);
}
static inline unsigned long long r_read_ble64(const void *src, _Bool big_endian) {
 return big_endian? r_read_be64 (src): r_read_le64 (src);
}
static inline unsigned long long r_read_ble(const void *src, _Bool big_endian, int size) {
 switch (size) {
 case 8:
  return (unsigned long long) ((unsigned char*)src)[0];
 case 16:
  return r_read_ble16 (src, big_endian);
 case 32:
  return r_read_ble32 (src, big_endian);
 case 64:
  return r_read_ble64 (src, big_endian);
 default:
  return 0xFFFFFFFFFFFFFFFFULL;
 }
}
static inline void r_write_ble16(void *dest, unsigned short val, _Bool big_endian) {
 big_endian? r_write_be16 (dest, val): r_write_le16 (dest, val);
}
static inline void r_write_ble24(void *dest, unsigned int val, _Bool big_endian) {
 big_endian? r_write_be24 (dest, val): r_write_le24 (dest, val);
}
static inline void r_write_ble32(void *dest, unsigned int val, _Bool big_endian) {
 big_endian? r_write_be32 (dest, val): r_write_le32 (dest, val);
}
static inline void r_write_ble64(void *dest, unsigned long long val, _Bool big_endian) {
 big_endian? r_write_be64 (dest, val): r_write_le64 (dest, val);
}
static inline void r_write_ble(void *dst, unsigned long long val, _Bool big_endian, int size) {
 switch (size) {
 case 8:
  ((unsigned char*)dst)[0] = (unsigned char) val;
  break;
 case 16:
  r_write_ble16 (dst, (unsigned short) val, big_endian);
  break;
 case 24:
  r_write_ble24 (dst, (unsigned int) val, big_endian);
  break;
 case 32:
  r_write_ble32 (dst, (unsigned int) val, big_endian);
  break;
 case 64:
  r_write_ble64 (dst, val, big_endian);
  break;
 default:
  break;
 }
}
static inline unsigned short r_swap_ut16(unsigned short val) {
 return (val << 8) | (val >> 8 );
}
static inline short r_swap_st16(short val) {
 val = ((val << 8) & 0xFF00FF00 ) | ((val >> 8) & 0xFF00FF );
 return (val << 16) | (val >> 16);
}
static inline unsigned int r_swap_ut32(unsigned int val) {
 val = ((val << 8) & 0xFF00FF00 ) | ((val >> 8) & 0xFF00FF );
 return (val << 16) | (val >> 16);
}
static inline int r_swap_st32(int val) {
 val = ((val << 8) & 0xFF00FF00) | ((val >> 8) & 0xFF00FF );
 return (val << 16) | ((val >> 16) & 0xFFFF);
}
static inline unsigned long long r_swap_ut64(unsigned long long val) {
 val = ((val << 8) & 0xFF00FF00FF00FF00ULL ) | ((val >> 8) & 0x00FF00FF00FF00FFULL );
 val = ((val << 16) & 0xFFFF0000FFFF0000ULL ) | ((val >> 16) & 0x0000FFFF0000FFFFULL );
 return (val << 32) | (val >> 32);
}
static inline long long r_swap_st64(long long val) {
 val = ((val << 8) & 0xFF00FF00FF00FF00ULL ) | ((val >> 8) & 0x00FF00FF00FF00FFULL );
 val = ((val << 16) & 0xFFFF0000FFFF0000ULL ) | ((val >> 16) & 0x0000FFFF0000FFFFULL );
 return (val << 32) | ((val >> 32) & 0xFFFFFFFFULL);
}
static inline int UT64_ADD(unsigned long long *r, unsigned long long a, unsigned long long b) {
 if (0xFFFFFFFFFFFFFFFFULL - a < b) {
  return 0;
 }
 if (r) {
  *r = a + b;
 }
 return 1;
}
static inline int UT64_MUL(unsigned long long *r, unsigned long long a, unsigned long long b) {
 if (a && 0xFFFFFFFFFFFFFFFFULL / a < b) {
  return 0;
 }
 if (r) {
  *r = a * b;
 }
 return 1;
}
static inline int UT64_SUB(unsigned long long *r, unsigned long long a, unsigned long long b) {
 if (b > a) {
  return 0;
 }
 if (r) {
  *r = a - b;
 }
 return 1;
}
static inline int UT32_ADD(unsigned int *r, unsigned int a, unsigned int b) {
 if (0xFFFFFFFFU - a < b) {
  return 0;
 }
 if (r) {
  *r = a + b;
 }
 return 1;
}
static inline int UT32_MUL(unsigned int *r, unsigned int a, unsigned int b) {
 if (a && 0xFFFFFFFFU / a < b) {
  return 0;
 }
 if (r) {
  *r = a * b;
 }
 return 1;
}
static inline int UT32_SUB(unsigned int *r, unsigned int a, unsigned int b) {
 if (b > a) {
  return 0;
 }
 if (r) {
  *r = a - b;
 }
 return 1;
}
static inline int UT16_ADD(unsigned short *r, unsigned short a, unsigned short b) {
 if (0xFFFFU - a < b) {
  return 0;
 }
 if (r) {
  *r = a + b;
 }
 return 1;
}
static inline int UT16_MUL(unsigned short *r, unsigned short a, unsigned short b) {
 if (a && 0xFFFFU / a < b) {
  return 0;
 }
 if (r) {
  *r = a * b;
 }
 return 1;
}
static inline int UT16_SUB(unsigned short *r, unsigned short a, unsigned short b) {
 if (b > a) {
  return 0;
 }
 if (r) {
  *r = a - b;
 }
 return 1;
}
static inline int UT8_ADD(unsigned char *r, unsigned char a, unsigned char b) {
 if (0xFFU - a < b) {
  return 0;
 }
 if (r) {
  *r = a + b;
 }
 return 1;
}
static inline int UT8_MUL(unsigned char *r, unsigned char a, unsigned char b) {
 if (a && 0xFFU / a < b) {
  return 0;
 }
 if (r) {
  *r = a * b;
 }
 return 1;
}
static inline int UT8_SUB(unsigned char *r, unsigned char a, unsigned char b) {
 if (b > a) {
  return 0;
 }
 if (r) {
  *r = a - b;
 }
 return 1;
}
typedef void (*PrintfCallback)(const char *str, ...);
static inline void *r_new_copy(int size, void *data) {
 void *a = malloc(size);
 if (a) {
  memcpy (a, data, size);
 }
 return a;
}
extern int stat (const char *__restrict __file,
   struct stat *__restrict __buf) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int fstat (int __fd, struct stat *__buf) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int fstatat (int __fd, const char *__restrict __file,
      struct stat *__restrict __buf, int __flag)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 3)));
extern int lstat (const char *__restrict __file,
    struct stat *__restrict __buf) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int chmod (const char *__file, __mode_t __mode)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int lchmod (const char *__file, __mode_t __mode)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int fchmod (int __fd, __mode_t __mode) __attribute__ ((__nothrow__ ));
extern int fchmodat (int __fd, const char *__file, __mode_t __mode,
       int __flag)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2))) ;
extern __mode_t umask (__mode_t __mask) __attribute__ ((__nothrow__ ));
extern int mkdir (const char *__path, __mode_t __mode)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int mkdirat (int __fd, const char *__path, __mode_t __mode)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int mknod (const char *__path, __mode_t __mode, __dev_t __dev)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int mknodat (int __fd, const char *__path, __mode_t __mode,
      __dev_t __dev) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int mkfifo (const char *__path, __mode_t __mode)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int mkfifoat (int __fd, const char *__path, __mode_t __mode)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int utimensat (int __fd, const char *__path,
        const struct timespec __times[2],
        int __flags)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int futimens (int __fd, const struct timespec __times[2]) __attribute__ ((__nothrow__ ));
extern int __fxstat (int __ver, int __fildes, struct stat *__stat_buf)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3)));
extern int __xstat (int __ver, const char *__filename,
      struct stat *__stat_buf) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 3)));
extern int __lxstat (int __ver, const char *__filename,
       struct stat *__stat_buf) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 3)));
extern int __fxstatat (int __ver, int __fildes, const char *__filename,
         struct stat *__stat_buf, int __flag)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 4)));
extern int __xmknod (int __ver, const char *__path, __mode_t __mode,
       __dev_t *__dev) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 4)));
extern int __xmknodat (int __ver, int __fd, const char *__path,
         __mode_t __mode, __dev_t *__dev)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3, 5)));
struct dirent
  {
    __ino_t d_ino;
    __off_t d_off;
    unsigned short int d_reclen;
    unsigned char d_type;
    char d_name[256]; 
  };
enum
  {
    DT_UNKNOWN = 0,
    DT_FIFO = 1,
    DT_CHR = 2,
    DT_DIR = 4,
    DT_BLK = 6,
    DT_REG = 8,
    DT_LNK = 10,
    DT_SOCK = 12,
    DT_WHT = 14
  };
typedef struct __dirstream DIR;
extern DIR *opendir (const char *__name) __attribute__ ((__nonnull__ (1)));
extern DIR *fdopendir (int __fd);
extern int closedir (DIR *__dirp) __attribute__ ((__nonnull__ (1)));
extern struct dirent *readdir (DIR *__dirp) __attribute__ ((__nonnull__ (1)));
extern int readdir_r (DIR *__restrict __dirp,
        struct dirent *__restrict __entry,
        struct dirent **__restrict __result)
     __attribute__ ((__nonnull__ (1, 2, 3))) __attribute__ ((__deprecated__));
extern void rewinddir (DIR *__dirp) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern void seekdir (DIR *__dirp, long int __pos) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern long int telldir (DIR *__dirp) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int dirfd (DIR *__dirp) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int scandir (const char *__restrict __dir,
      struct dirent ***__restrict __namelist,
      int (*__selector) (const struct dirent *),
      int (*__cmp) (const struct dirent **,
      const struct dirent **))
     __attribute__ ((__nonnull__ (1, 2)));
extern int alphasort (const struct dirent **__e1,
        const struct dirent **__e2)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern __ssize_t getdirentries (int __fd, char *__restrict __buf,
    size_t __nbytes,
    __off_t *__restrict __basep)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 4)));
typedef __useconds_t useconds_t;
typedef __intptr_t intptr_t;
typedef __socklen_t socklen_t;
extern int access (const char *__name, int __type) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int faccessat (int __fd, const char *__file, int __type, int __flag)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2))) ;
extern __off_t lseek (int __fd, __off_t __offset, int __whence) __attribute__ ((__nothrow__ ));
extern int close (int __fd);
extern ssize_t read (int __fd, void *__buf, size_t __nbytes) ;
extern ssize_t write (int __fd, const void *__buf, size_t __n) ;
extern ssize_t pread (int __fd, void *__buf, size_t __nbytes,
        __off_t __offset) ;
extern ssize_t pwrite (int __fd, const void *__buf, size_t __n,
         __off_t __offset) ;
extern int pipe (int __pipedes[2]) __attribute__ ((__nothrow__ )) ;
extern unsigned int alarm (unsigned int __seconds) __attribute__ ((__nothrow__ ));
extern unsigned int sleep (unsigned int __seconds);
extern __useconds_t ualarm (__useconds_t __value, __useconds_t __interval)
     __attribute__ ((__nothrow__ ));
extern int usleep (__useconds_t __useconds);
extern int pause (void);
extern int chown (const char *__file, __uid_t __owner, __gid_t __group)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern int fchown (int __fd, __uid_t __owner, __gid_t __group) __attribute__ ((__nothrow__ )) ;
extern int lchown (const char *__file, __uid_t __owner, __gid_t __group)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern int fchownat (int __fd, const char *__file, __uid_t __owner,
       __gid_t __group, int __flag)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2))) ;
extern int chdir (const char *__path) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern int fchdir (int __fd) __attribute__ ((__nothrow__ )) ;
extern char *getcwd (char *__buf, size_t __size) __attribute__ ((__nothrow__ )) ;
extern char *getwd (char *__buf)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) __attribute__ ((__deprecated__)) ;
extern int dup (int __fd) __attribute__ ((__nothrow__ )) ;
extern int dup2 (int __fd, int __fd2) __attribute__ ((__nothrow__ ));
extern char **__environ;
extern int execve (const char *__path, char *const __argv[],
     char *const __envp[]) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int fexecve (int __fd, char *const __argv[], char *const __envp[])
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int execv (const char *__path, char *const __argv[])
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int execle (const char *__path, const char *__arg, ...)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int execl (const char *__path, const char *__arg, ...)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int execvp (const char *__file, char *const __argv[])
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int execlp (const char *__file, const char *__arg, ...)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int nice (int __inc) __attribute__ ((__nothrow__ )) ;
extern void _exit (int __status) __attribute__ ((__noreturn__));
enum
  {
    _PC_LINK_MAX,
    _PC_MAX_CANON,
    _PC_MAX_INPUT,
    _PC_NAME_MAX,
    _PC_PATH_MAX,
    _PC_PIPE_BUF,
    _PC_CHOWN_RESTRICTED,
    _PC_NO_TRUNC,
    _PC_VDISABLE,
    _PC_SYNC_IO,
    _PC_ASYNC_IO,
    _PC_PRIO_IO,
    _PC_SOCK_MAXBUF,
    _PC_FILESIZEBITS,
    _PC_REC_INCR_XFER_SIZE,
    _PC_REC_MAX_XFER_SIZE,
    _PC_REC_MIN_XFER_SIZE,
    _PC_REC_XFER_ALIGN,
    _PC_ALLOC_SIZE_MIN,
    _PC_SYMLINK_MAX,
    _PC_2_SYMLINKS
  };
enum
  {
    _SC_ARG_MAX,
    _SC_CHILD_MAX,
    _SC_CLK_TCK,
    _SC_NGROUPS_MAX,
    _SC_OPEN_MAX,
    _SC_STREAM_MAX,
    _SC_TZNAME_MAX,
    _SC_JOB_CONTROL,
    _SC_SAVED_IDS,
    _SC_REALTIME_SIGNALS,
    _SC_PRIORITY_SCHEDULING,
    _SC_TIMERS,
    _SC_ASYNCHRONOUS_IO,
    _SC_PRIORITIZED_IO,
    _SC_SYNCHRONIZED_IO,
    _SC_FSYNC,
    _SC_MAPPED_FILES,
    _SC_MEMLOCK,
    _SC_MEMLOCK_RANGE,
    _SC_MEMORY_PROTECTION,
    _SC_MESSAGE_PASSING,
    _SC_SEMAPHORES,
    _SC_SHARED_MEMORY_OBJECTS,
    _SC_AIO_LISTIO_MAX,
    _SC_AIO_MAX,
    _SC_AIO_PRIO_DELTA_MAX,
    _SC_DELAYTIMER_MAX,
    _SC_MQ_OPEN_MAX,
    _SC_MQ_PRIO_MAX,
    _SC_VERSION,
    _SC_PAGESIZE,
    _SC_RTSIG_MAX,
    _SC_SEM_NSEMS_MAX,
    _SC_SEM_VALUE_MAX,
    _SC_SIGQUEUE_MAX,
    _SC_TIMER_MAX,
    _SC_BC_BASE_MAX,
    _SC_BC_DIM_MAX,
    _SC_BC_SCALE_MAX,
    _SC_BC_STRING_MAX,
    _SC_COLL_WEIGHTS_MAX,
    _SC_EQUIV_CLASS_MAX,
    _SC_EXPR_NEST_MAX,
    _SC_LINE_MAX,
    _SC_RE_DUP_MAX,
    _SC_CHARCLASS_NAME_MAX,
    _SC_2_VERSION,
    _SC_2_C_BIND,
    _SC_2_C_DEV,
    _SC_2_FORT_DEV,
    _SC_2_FORT_RUN,
    _SC_2_SW_DEV,
    _SC_2_LOCALEDEF,
    _SC_PII,
    _SC_PII_XTI,
    _SC_PII_SOCKET,
    _SC_PII_INTERNET,
    _SC_PII_OSI,
    _SC_POLL,
    _SC_SELECT,
    _SC_UIO_MAXIOV,
    _SC_IOV_MAX = _SC_UIO_MAXIOV,
    _SC_PII_INTERNET_STREAM,
    _SC_PII_INTERNET_DGRAM,
    _SC_PII_OSI_COTS,
    _SC_PII_OSI_CLTS,
    _SC_PII_OSI_M,
    _SC_T_IOV_MAX,
    _SC_THREADS,
    _SC_THREAD_SAFE_FUNCTIONS,
    _SC_GETGR_R_SIZE_MAX,
    _SC_GETPW_R_SIZE_MAX,
    _SC_LOGIN_NAME_MAX,
    _SC_TTY_NAME_MAX,
    _SC_THREAD_DESTRUCTOR_ITERATIONS,
    _SC_THREAD_KEYS_MAX,
    _SC_THREAD_STACK_MIN,
    _SC_THREAD_THREADS_MAX,
    _SC_THREAD_ATTR_STACKADDR,
    _SC_THREAD_ATTR_STACKSIZE,
    _SC_THREAD_PRIORITY_SCHEDULING,
    _SC_THREAD_PRIO_INHERIT,
    _SC_THREAD_PRIO_PROTECT,
    _SC_THREAD_PROCESS_SHARED,
    _SC_NPROCESSORS_CONF,
    _SC_NPROCESSORS_ONLN,
    _SC_PHYS_PAGES,
    _SC_AVPHYS_PAGES,
    _SC_ATEXIT_MAX,
    _SC_PASS_MAX,
    _SC_XOPEN_VERSION,
    _SC_XOPEN_XCU_VERSION,
    _SC_XOPEN_UNIX,
    _SC_XOPEN_CRYPT,
    _SC_XOPEN_ENH_I18N,
    _SC_XOPEN_SHM,
    _SC_2_CHAR_TERM,
    _SC_2_C_VERSION,
    _SC_2_UPE,
    _SC_XOPEN_XPG2,
    _SC_XOPEN_XPG3,
    _SC_XOPEN_XPG4,
    _SC_CHAR_BIT,
    _SC_CHAR_MAX,
    _SC_CHAR_MIN,
    _SC_INT_MAX,
    _SC_INT_MIN,
    _SC_LONG_BIT,
    _SC_WORD_BIT,
    _SC_MB_LEN_MAX,
    _SC_NZERO,
    _SC_SSIZE_MAX,
    _SC_SCHAR_MAX,
    _SC_SCHAR_MIN,
    _SC_SHRT_MAX,
    _SC_SHRT_MIN,
    _SC_UCHAR_MAX,
    _SC_UINT_MAX,
    _SC_ULONG_MAX,
    _SC_USHRT_MAX,
    _SC_NL_ARGMAX,
    _SC_NL_LANGMAX,
    _SC_NL_MSGMAX,
    _SC_NL_NMAX,
    _SC_NL_SETMAX,
    _SC_NL_TEXTMAX,
    _SC_XBS5_ILP32_OFF32,
    _SC_XBS5_ILP32_OFFBIG,
    _SC_XBS5_LP64_OFF64,
    _SC_XBS5_LPBIG_OFFBIG,
    _SC_XOPEN_LEGACY,
    _SC_XOPEN_REALTIME,
    _SC_XOPEN_REALTIME_THREADS,
    _SC_ADVISORY_INFO,
    _SC_BARRIERS,
    _SC_BASE,
    _SC_C_LANG_SUPPORT,
    _SC_C_LANG_SUPPORT_R,
    _SC_CLOCK_SELECTION,
    _SC_CPUTIME,
    _SC_THREAD_CPUTIME,
    _SC_DEVICE_IO,
    _SC_DEVICE_SPECIFIC,
    _SC_DEVICE_SPECIFIC_R,
    _SC_FD_MGMT,
    _SC_FIFO,
    _SC_PIPE,
    _SC_FILE_ATTRIBUTES,
    _SC_FILE_LOCKING,
    _SC_FILE_SYSTEM,
    _SC_MONOTONIC_CLOCK,
    _SC_MULTI_PROCESS,
    _SC_SINGLE_PROCESS,
    _SC_NETWORKING,
    _SC_READER_WRITER_LOCKS,
    _SC_SPIN_LOCKS,
    _SC_REGEXP,
    _SC_REGEX_VERSION,
    _SC_SHELL,
    _SC_SIGNALS,
    _SC_SPAWN,
    _SC_SPORADIC_SERVER,
    _SC_THREAD_SPORADIC_SERVER,
    _SC_SYSTEM_DATABASE,
    _SC_SYSTEM_DATABASE_R,
    _SC_TIMEOUTS,
    _SC_TYPED_MEMORY_OBJECTS,
    _SC_USER_GROUPS,
    _SC_USER_GROUPS_R,
    _SC_2_PBS,
    _SC_2_PBS_ACCOUNTING,
    _SC_2_PBS_LOCATE,
    _SC_2_PBS_MESSAGE,
    _SC_2_PBS_TRACK,
    _SC_SYMLOOP_MAX,
    _SC_STREAMS,
    _SC_2_PBS_CHECKPOINT,
    _SC_V6_ILP32_OFF32,
    _SC_V6_ILP32_OFFBIG,
    _SC_V6_LP64_OFF64,
    _SC_V6_LPBIG_OFFBIG,
    _SC_HOST_NAME_MAX,
    _SC_TRACE,
    _SC_TRACE_EVENT_FILTER,
    _SC_TRACE_INHERIT,
    _SC_TRACE_LOG,
    _SC_LEVEL1_ICACHE_SIZE,
    _SC_LEVEL1_ICACHE_ASSOC,
    _SC_LEVEL1_ICACHE_LINESIZE,
    _SC_LEVEL1_DCACHE_SIZE,
    _SC_LEVEL1_DCACHE_ASSOC,
    _SC_LEVEL1_DCACHE_LINESIZE,
    _SC_LEVEL2_CACHE_SIZE,
    _SC_LEVEL2_CACHE_ASSOC,
    _SC_LEVEL2_CACHE_LINESIZE,
    _SC_LEVEL3_CACHE_SIZE,
    _SC_LEVEL3_CACHE_ASSOC,
    _SC_LEVEL3_CACHE_LINESIZE,
    _SC_LEVEL4_CACHE_SIZE,
    _SC_LEVEL4_CACHE_ASSOC,
    _SC_LEVEL4_CACHE_LINESIZE,
    _SC_IPV6 = _SC_LEVEL1_ICACHE_SIZE + 50,
    _SC_RAW_SOCKETS,
    _SC_V7_ILP32_OFF32,
    _SC_V7_ILP32_OFFBIG,
    _SC_V7_LP64_OFF64,
    _SC_V7_LPBIG_OFFBIG,
    _SC_SS_REPL_MAX,
    _SC_TRACE_EVENT_NAME_MAX,
    _SC_TRACE_NAME_MAX,
    _SC_TRACE_SYS_MAX,
    _SC_TRACE_USER_EVENT_MAX,
    _SC_XOPEN_STREAMS,
    _SC_THREAD_ROBUST_PRIO_INHERIT,
    _SC_THREAD_ROBUST_PRIO_PROTECT
  };
enum
  {
    _CS_PATH, 
    _CS_V6_WIDTH_RESTRICTED_ENVS,
    _CS_GNU_LIBC_VERSION,
    _CS_GNU_LIBPTHREAD_VERSION,
    _CS_V5_WIDTH_RESTRICTED_ENVS,
    _CS_V7_WIDTH_RESTRICTED_ENVS,
    _CS_LFS_CFLAGS = 1000,
    _CS_LFS_LDFLAGS,
    _CS_LFS_LIBS,
    _CS_LFS_LINTFLAGS,
    _CS_LFS64_CFLAGS,
    _CS_LFS64_LDFLAGS,
    _CS_LFS64_LIBS,
    _CS_LFS64_LINTFLAGS,
    _CS_XBS5_ILP32_OFF32_CFLAGS = 1100,
    _CS_XBS5_ILP32_OFF32_LDFLAGS,
    _CS_XBS5_ILP32_OFF32_LIBS,
    _CS_XBS5_ILP32_OFF32_LINTFLAGS,
    _CS_XBS5_ILP32_OFFBIG_CFLAGS,
    _CS_XBS5_ILP32_OFFBIG_LDFLAGS,
    _CS_XBS5_ILP32_OFFBIG_LIBS,
    _CS_XBS5_ILP32_OFFBIG_LINTFLAGS,
    _CS_XBS5_LP64_OFF64_CFLAGS,
    _CS_XBS5_LP64_OFF64_LDFLAGS,
    _CS_XBS5_LP64_OFF64_LIBS,
    _CS_XBS5_LP64_OFF64_LINTFLAGS,
    _CS_XBS5_LPBIG_OFFBIG_CFLAGS,
    _CS_XBS5_LPBIG_OFFBIG_LDFLAGS,
    _CS_XBS5_LPBIG_OFFBIG_LIBS,
    _CS_XBS5_LPBIG_OFFBIG_LINTFLAGS,
    _CS_POSIX_V6_ILP32_OFF32_CFLAGS,
    _CS_POSIX_V6_ILP32_OFF32_LDFLAGS,
    _CS_POSIX_V6_ILP32_OFF32_LIBS,
    _CS_POSIX_V6_ILP32_OFF32_LINTFLAGS,
    _CS_POSIX_V6_ILP32_OFFBIG_CFLAGS,
    _CS_POSIX_V6_ILP32_OFFBIG_LDFLAGS,
    _CS_POSIX_V6_ILP32_OFFBIG_LIBS,
    _CS_POSIX_V6_ILP32_OFFBIG_LINTFLAGS,
    _CS_POSIX_V6_LP64_OFF64_CFLAGS,
    _CS_POSIX_V6_LP64_OFF64_LDFLAGS,
    _CS_POSIX_V6_LP64_OFF64_LIBS,
    _CS_POSIX_V6_LP64_OFF64_LINTFLAGS,
    _CS_POSIX_V6_LPBIG_OFFBIG_CFLAGS,
    _CS_POSIX_V6_LPBIG_OFFBIG_LDFLAGS,
    _CS_POSIX_V6_LPBIG_OFFBIG_LIBS,
    _CS_POSIX_V6_LPBIG_OFFBIG_LINTFLAGS,
    _CS_POSIX_V7_ILP32_OFF32_CFLAGS,
    _CS_POSIX_V7_ILP32_OFF32_LDFLAGS,
    _CS_POSIX_V7_ILP32_OFF32_LIBS,
    _CS_POSIX_V7_ILP32_OFF32_LINTFLAGS,
    _CS_POSIX_V7_ILP32_OFFBIG_CFLAGS,
    _CS_POSIX_V7_ILP32_OFFBIG_LDFLAGS,
    _CS_POSIX_V7_ILP32_OFFBIG_LIBS,
    _CS_POSIX_V7_ILP32_OFFBIG_LINTFLAGS,
    _CS_POSIX_V7_LP64_OFF64_CFLAGS,
    _CS_POSIX_V7_LP64_OFF64_LDFLAGS,
    _CS_POSIX_V7_LP64_OFF64_LIBS,
    _CS_POSIX_V7_LP64_OFF64_LINTFLAGS,
    _CS_POSIX_V7_LPBIG_OFFBIG_CFLAGS,
    _CS_POSIX_V7_LPBIG_OFFBIG_LDFLAGS,
    _CS_POSIX_V7_LPBIG_OFFBIG_LIBS,
    _CS_POSIX_V7_LPBIG_OFFBIG_LINTFLAGS,
    _CS_V6_ENV,
    _CS_V7_ENV
  };
extern long int pathconf (const char *__path, int __name)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern long int fpathconf (int __fd, int __name) __attribute__ ((__nothrow__ ));
extern long int sysconf (int __name) __attribute__ ((__nothrow__ ));
extern size_t confstr (int __name, char *__buf, size_t __len) __attribute__ ((__nothrow__ ));
extern __pid_t getpid (void) __attribute__ ((__nothrow__ ));
extern __pid_t getppid (void) __attribute__ ((__nothrow__ ));
extern __pid_t getpgrp (void) __attribute__ ((__nothrow__ ));
extern __pid_t __getpgid (__pid_t __pid) __attribute__ ((__nothrow__ ));
extern __pid_t getpgid (__pid_t __pid) __attribute__ ((__nothrow__ ));
extern int setpgid (__pid_t __pid, __pid_t __pgid) __attribute__ ((__nothrow__ ));
extern int setpgrp (void) __attribute__ ((__nothrow__ ));
extern __pid_t setsid (void) __attribute__ ((__nothrow__ ));
extern __pid_t getsid (__pid_t __pid) __attribute__ ((__nothrow__ ));
extern __uid_t getuid (void) __attribute__ ((__nothrow__ ));
extern __uid_t geteuid (void) __attribute__ ((__nothrow__ ));
extern __gid_t getgid (void) __attribute__ ((__nothrow__ ));
extern __gid_t getegid (void) __attribute__ ((__nothrow__ ));
extern int getgroups (int __size, __gid_t __list[]) __attribute__ ((__nothrow__ )) ;
extern int setuid (__uid_t __uid) __attribute__ ((__nothrow__ )) ;
extern int setreuid (__uid_t __ruid, __uid_t __euid) __attribute__ ((__nothrow__ )) ;
extern int seteuid (__uid_t __uid) __attribute__ ((__nothrow__ )) ;
extern int setgid (__gid_t __gid) __attribute__ ((__nothrow__ )) ;
extern int setregid (__gid_t __rgid, __gid_t __egid) __attribute__ ((__nothrow__ )) ;
extern int setegid (__gid_t __gid) __attribute__ ((__nothrow__ )) ;
extern __pid_t fork (void) __attribute__ ((__nothrow__));
extern __pid_t vfork (void) __attribute__ ((__nothrow__ ));
extern char *ttyname (int __fd) __attribute__ ((__nothrow__ ));
extern int ttyname_r (int __fd, char *__buf, size_t __buflen)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2))) ;
extern int isatty (int __fd) __attribute__ ((__nothrow__ ));
extern int ttyslot (void) __attribute__ ((__nothrow__ ));
extern int link (const char *__from, const char *__to)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2))) ;
extern int linkat (int __fromfd, const char *__from, int __tofd,
     const char *__to, int __flags)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 4))) ;
extern int symlink (const char *__from, const char *__to)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2))) ;
extern ssize_t readlink (const char *__restrict __path,
    char *__restrict __buf, size_t __len)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2))) ;
extern int symlinkat (const char *__from, int __tofd,
        const char *__to) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 3))) ;
extern ssize_t readlinkat (int __fd, const char *__restrict __path,
      char *__restrict __buf, size_t __len)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 3))) ;
extern int unlink (const char *__name) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int unlinkat (int __fd, const char *__name, int __flag)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int rmdir (const char *__path) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern __pid_t tcgetpgrp (int __fd) __attribute__ ((__nothrow__ ));
extern int tcsetpgrp (int __fd, __pid_t __pgrp_id) __attribute__ ((__nothrow__ ));
extern char *getlogin (void);
extern int getlogin_r (char *__name, size_t __name_len) __attribute__ ((__nonnull__ (1)));
extern int setlogin (const char *__name) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern char *optarg;
extern int optind;
extern int opterr;
extern int optopt;
extern int getopt (int ___argc, char *const *___argv, const char *__shortopts)
       __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 3)));
extern int gethostname (char *__name, size_t __len) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int sethostname (const char *__name, size_t __len)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern int sethostid (long int __id) __attribute__ ((__nothrow__ )) ;
extern int getdomainname (char *__name, size_t __len)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern int setdomainname (const char *__name, size_t __len)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern int vhangup (void) __attribute__ ((__nothrow__ ));
extern int revoke (const char *__file) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern int profil (unsigned short int *__sample_buffer, size_t __size,
     size_t __offset, unsigned int __scale)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int acct (const char *__name) __attribute__ ((__nothrow__ ));
extern char *getusershell (void) __attribute__ ((__nothrow__ ));
extern void endusershell (void) __attribute__ ((__nothrow__ )); 
extern void setusershell (void) __attribute__ ((__nothrow__ )); 
extern int daemon (int __nochdir, int __noclose) __attribute__ ((__nothrow__ )) ;
extern int chroot (const char *__path) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern char *getpass (const char *__prompt) __attribute__ ((__nonnull__ (1)));
extern int fsync (int __fd);
extern long int gethostid (void);
extern void sync (void) __attribute__ ((__nothrow__ ));
extern int getpagesize (void) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int getdtablesize (void) __attribute__ ((__nothrow__ ));
extern int truncate (const char *__file, __off_t __length)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) ;
extern int ftruncate (int __fd, __off_t __length) __attribute__ ((__nothrow__ )) ;
extern int brk (void *__addr) __attribute__ ((__nothrow__ )) ;
extern void *sbrk (intptr_t __delta) __attribute__ ((__nothrow__ ));
extern long int syscall (long int __sysno, ...) __attribute__ ((__nothrow__ ));
extern int fdatasync (int __fildes);
int getentropy (void *__buffer, size_t __length) ;
struct timezone
  {
    int tz_minuteswest; 
    int tz_dsttime; 
  };
typedef struct timezone *__restrict __timezone_ptr_t;
extern int gettimeofday (struct timeval *__restrict __tv,
    __timezone_ptr_t __tz) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int settimeofday (const struct timeval *__tv,
    const struct timezone *__tz)
     __attribute__ ((__nothrow__ ));
extern int adjtime (const struct timeval *__delta,
      struct timeval *__olddelta) __attribute__ ((__nothrow__ ));
enum __itimer_which
  {
    ITIMER_REAL = 0,
    ITIMER_VIRTUAL = 1,
    ITIMER_PROF = 2
  };
struct itimerval
  {
    struct timeval it_interval;
    struct timeval it_value;
  };
typedef int __itimer_which_t;
extern int getitimer (__itimer_which_t __which,
        struct itimerval *__value) __attribute__ ((__nothrow__ ));
extern int setitimer (__itimer_which_t __which,
        const struct itimerval *__restrict __new,
        struct itimerval *__restrict __old) __attribute__ ((__nothrow__ ));
extern int utimes (const char *__file, const struct timeval __tvp[2])
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int lutimes (const char *__file, const struct timeval __tvp[2])
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int futimes (int __fd, const struct timeval __tvp[2]) __attribute__ ((__nothrow__ ));
enum {
 R_SYS_ARCH_NONE = 0,
 R_SYS_ARCH_X86 = 0x1,
 R_SYS_ARCH_ARM = 0x2,
 R_SYS_ARCH_PPC = 0x4,
 R_SYS_ARCH_M68K = 0x8,
 R_SYS_ARCH_JAVA = 0x10,
 R_SYS_ARCH_MIPS = 0x20,
 R_SYS_ARCH_SPARC = 0x40,
 R_SYS_ARCH_XAP = 0x80,
 R_SYS_ARCH_MSIL = 0x100,
 R_SYS_ARCH_OBJD = 0x200,
 R_SYS_ARCH_BF = 0x400,
 R_SYS_ARCH_SH = 0x800,
 R_SYS_ARCH_AVR = 0x1000,
 R_SYS_ARCH_DALVIK = 0x2000,
 R_SYS_ARCH_Z80 = 0x4000,
 R_SYS_ARCH_ARC = 0x8000,
 R_SYS_ARCH_I8080 = 0x10000,
 R_SYS_ARCH_RAR = 0x20000,
 R_SYS_ARCH_8051 = 0x40000,
 R_SYS_ARCH_TMS320 = 0x80000,
 R_SYS_ARCH_EBC = 0x100000,
 R_SYS_ARCH_H8300 = 0x200000,
 R_SYS_ARCH_CR16 = 0x400000,
 R_SYS_ARCH_V850 = 0x800000,
 R_SYS_ARCH_SYSZ = 0x1000000,
 R_SYS_ARCH_XCORE = 0x2000000,
 R_SYS_ARCH_PROPELLER = 0x4000000,
 R_SYS_ARCH_MSP430 = 0x8000000LL, 
 R_SYS_ARCH_CRIS = 0x10000000LL, 
 R_SYS_ARCH_HPPA = 0x20000000LL, 
 R_SYS_ARCH_V810 = 0x40000000LL, 
 R_SYS_ARCH_LM32 = 0x80000000LL, 
};
static inline void r_run_call1 (void *fcn, void *arg1) {
 ((void (*)(void *))(fcn))(arg1);
}
static inline void r_run_call2 (void *fcn, void *arg1, void *arg2) {
 ((void (*)(void *, void *))(fcn))(arg1, arg2);
}
static inline void r_run_call3 (void *fcn, void *arg1, void *arg2, void *arg3) {
 ((void (*)(void *, void *, void *))(fcn))(arg1, arg2, arg3);
}
static inline void r_run_call4 (void *fcn, void *arg1, void *arg2, void *arg3, void *arg4) {
 ((void (*)(void *, void *, void *, void *))(fcn))(arg1, arg2, arg3, arg4);
}
static inline void r_run_call5 (void *fcn, void *arg1, void *arg2, void *arg3, void *arg4, void *arg5) {
 ((void (*)(void *, void *, void *, void *, void *))(fcn))(arg1, arg2, arg3, arg4, arg5);
}
static inline void r_run_call6 (void *fcn, void *arg1, void *arg2, void *arg3, void *arg4, void *arg5,
 void *arg6) {
 ((void (*)(void *, void *, void *, void *, void *, void *))(fcn))
  (arg1, arg2, arg3, arg4, arg5, arg6);
}
static inline void r_run_call7 (void *fcn, void *arg1, void *arg2, void *arg3, void *arg4, void *arg5,
 void *arg6, void *arg7) {
 ((void (*)(void *, void *, void *, void *, void *, void *, void *))(fcn))
  (arg1, arg2, arg3, arg4, arg5, arg6, arg7);
}
static inline void r_run_call8 (void *fcn, void *arg1, void *arg2, void *arg3, void *arg4, void *arg5,
 void *arg6, void *arg7, void *arg8) {
 ((void (*)(void *, void *, void *, void *, void *, void *, void *, void *))(fcn))
  (arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8);
}
static inline void r_run_call9 (void *fcn, void *arg1, void *arg2, void *arg3, void *arg4, void *arg5,
 void *arg6, void *arg7, void *arg8, void *arg9) {
 ((void (*)(void *, void *, void *, void *, void *, void *, void *, void *, void *))(fcn))
  (arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9);
}
static inline void r_run_call10 (void *fcn, void *arg1, void *arg2, void *arg3, void *arg4, void *arg5,
 void *arg6, void *arg7, void *arg8, void *arg9, void *arg10) {
 ((void (*)(void *, void *, void *, void *, void *, void *, void *, void *, void *, void *))(fcn))
  (arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10);
}
__attribute__((visibility("default"))) const char *r_socket_version(void);
typedef __uint8_t uint8_t;
typedef __uint16_t uint16_t;
typedef __uint32_t uint32_t;
typedef __uint64_t uint64_t;
struct iovec
  {
    void *iov_base; 
    size_t iov_len; 
  };
enum __socket_type
{
  SOCK_STREAM = 1, 
  SOCK_DGRAM = 2, 
  SOCK_RAW = 3, 
  SOCK_RDM = 4, 
  SOCK_SEQPACKET = 5, 
  SOCK_DCCP = 6, 
  SOCK_PACKET = 10, 
  SOCK_CLOEXEC = 02000000, 
  SOCK_NONBLOCK = 00004000 
};
typedef unsigned short int sa_family_t;
struct sockaddr
  {
    sa_family_t sa_family; 
    char sa_data[14]; 
  };
struct sockaddr_storage
  {
    sa_family_t ss_family; 
    char __ss_padding[(128 - (sizeof (unsigned short int)) - sizeof (unsigned long int))];
    unsigned long int __ss_align; 
  };
enum
  {
    MSG_OOB = 0x01, 
    MSG_PEEK = 0x02, 
    MSG_DONTROUTE = 0x04, 
    MSG_CTRUNC = 0x08, 
    MSG_PROXY = 0x10, 
    MSG_TRUNC = 0x20,
    MSG_DONTWAIT = 0x40, 
    MSG_EOR = 0x80, 
    MSG_WAITALL = 0x100, 
    MSG_FIN = 0x200,
    MSG_SYN = 0x400,
    MSG_CONFIRM = 0x800, 
    MSG_RST = 0x1000,
    MSG_ERRQUEUE = 0x2000, 
    MSG_NOSIGNAL = 0x4000, 
    MSG_MORE = 0x8000, 
    MSG_WAITFORONE = 0x10000, 
    MSG_BATCH = 0x40000, 
    MSG_FASTOPEN = 0x20000000, 
    MSG_CMSG_CLOEXEC = 0x40000000 
  };
struct msghdr
  {
    void *msg_name; 
    socklen_t msg_namelen; 
    struct iovec *msg_iov; 
    size_t msg_iovlen; 
    void *msg_control; 
    size_t msg_controllen; 
    int msg_flags; 
  };
struct cmsghdr
  {
    size_t cmsg_len; 
    int cmsg_level; 
    int cmsg_type; 
    __extension__ unsigned char __cmsg_data []; 
  };
extern struct cmsghdr *__cmsg_nxthdr (struct msghdr *__mhdr,
          struct cmsghdr *__cmsg) __attribute__ ((__nothrow__ ));
enum
  {
    SCM_RIGHTS = 0x01 
  };
struct linger
  {
    int l_onoff; 
    int l_linger; 
  };
struct osockaddr
{
  unsigned short int sa_family;
  unsigned char sa_data[14];
};
enum
{
  SHUT_RD = 0, 
  SHUT_WR, 
  SHUT_RDWR 
};
extern int socket (int __domain, int __type, int __protocol) __attribute__ ((__nothrow__ ));
extern int socketpair (int __domain, int __type, int __protocol,
         int __fds[2]) __attribute__ ((__nothrow__ ));
extern int bind (int __fd, const struct sockaddr * __addr, socklen_t __len)
     __attribute__ ((__nothrow__ ));
extern int getsockname (int __fd, struct sockaddr *__restrict __addr,
   socklen_t *__restrict __len) __attribute__ ((__nothrow__ ));
extern int connect (int __fd, const struct sockaddr * __addr, socklen_t __len);
extern int getpeername (int __fd, struct sockaddr *__restrict __addr,
   socklen_t *__restrict __len) __attribute__ ((__nothrow__ ));
extern ssize_t send (int __fd, const void *__buf, size_t __n, int __flags);
extern ssize_t recv (int __fd, void *__buf, size_t __n, int __flags);
extern ssize_t sendto (int __fd, const void *__buf, size_t __n,
         int __flags, const struct sockaddr * __addr,
         socklen_t __addr_len);
extern ssize_t recvfrom (int __fd, void *__restrict __buf, size_t __n,
    int __flags, struct sockaddr *__restrict __addr,
    socklen_t *__restrict __addr_len);
extern ssize_t sendmsg (int __fd, const struct msghdr *__message,
   int __flags);
extern ssize_t recvmsg (int __fd, struct msghdr *__message, int __flags);
extern int getsockopt (int __fd, int __level, int __optname,
         void *__restrict __optval,
         socklen_t *__restrict __optlen) __attribute__ ((__nothrow__ ));
extern int setsockopt (int __fd, int __level, int __optname,
         const void *__optval, socklen_t __optlen) __attribute__ ((__nothrow__ ));
extern int listen (int __fd, int __n) __attribute__ ((__nothrow__ ));
extern int accept (int __fd, struct sockaddr *__restrict __addr,
     socklen_t *__restrict __addr_len);
extern int shutdown (int __fd, int __how) __attribute__ ((__nothrow__ ));
extern int sockatmark (int __fd) __attribute__ ((__nothrow__ ));
extern int isfdtype (int __fd, int __fdtype) __attribute__ ((__nothrow__ ));
typedef uint32_t in_addr_t;
struct in_addr
  {
    in_addr_t s_addr;
  };
struct ip_opts
  {
    struct in_addr ip_dst; 
    char ip_opts[40]; 
  };
struct ip_mreqn
  {
    struct in_addr imr_multiaddr; 
    struct in_addr imr_address; 
    int imr_ifindex; 
  };
struct in_pktinfo
  {
    int ipi_ifindex; 
    struct in_addr ipi_spec_dst; 
    struct in_addr ipi_addr; 
  };
enum
  {
    IPPROTO_IP = 0, 
    IPPROTO_ICMP = 1, 
    IPPROTO_IGMP = 2, 
    IPPROTO_IPIP = 4, 
    IPPROTO_TCP = 6, 
    IPPROTO_EGP = 8, 
    IPPROTO_PUP = 12, 
    IPPROTO_UDP = 17, 
    IPPROTO_IDP = 22, 
    IPPROTO_TP = 29, 
    IPPROTO_DCCP = 33, 
    IPPROTO_IPV6 = 41, 
    IPPROTO_RSVP = 46, 
    IPPROTO_GRE = 47, 
    IPPROTO_ESP = 50, 
    IPPROTO_AH = 51, 
    IPPROTO_MTP = 92, 
    IPPROTO_BEETPH = 94, 
    IPPROTO_ENCAP = 98, 
    IPPROTO_PIM = 103, 
    IPPROTO_COMP = 108, 
    IPPROTO_SCTP = 132, 
    IPPROTO_UDPLITE = 136, 
    IPPROTO_MPLS = 137, 
    IPPROTO_RAW = 255, 
    IPPROTO_MAX
  };
enum
  {
    IPPROTO_HOPOPTS = 0, 
    IPPROTO_ROUTING = 43, 
    IPPROTO_FRAGMENT = 44, 
    IPPROTO_ICMPV6 = 58, 
    IPPROTO_NONE = 59, 
    IPPROTO_DSTOPTS = 60, 
    IPPROTO_MH = 135 
  };
typedef uint16_t in_port_t;
enum
  {
    IPPORT_ECHO = 7, 
    IPPORT_DISCARD = 9, 
    IPPORT_SYSTAT = 11, 
    IPPORT_DAYTIME = 13, 
    IPPORT_NETSTAT = 15, 
    IPPORT_FTP = 21, 
    IPPORT_TELNET = 23, 
    IPPORT_SMTP = 25, 
    IPPORT_TIMESERVER = 37, 
    IPPORT_NAMESERVER = 42, 
    IPPORT_WHOIS = 43, 
    IPPORT_MTP = 57,
    IPPORT_TFTP = 69, 
    IPPORT_RJE = 77,
    IPPORT_FINGER = 79, 
    IPPORT_TTYLINK = 87,
    IPPORT_SUPDUP = 95, 
    IPPORT_EXECSERVER = 512, 
    IPPORT_LOGINSERVER = 513, 
    IPPORT_CMDSERVER = 514,
    IPPORT_EFSSERVER = 520,
    IPPORT_BIFFUDP = 512,
    IPPORT_WHOSERVER = 513,
    IPPORT_ROUTESERVER = 520,
    IPPORT_RESERVED = 1024,
    IPPORT_USERRESERVED = 5000
  };
struct in6_addr
  {
    union
      {
 uint8_t __u6_addr8[16];
 uint16_t __u6_addr16[8];
 uint32_t __u6_addr32[4];
      } __in6_u;
  };
extern const struct in6_addr in6addr_any; 
extern const struct in6_addr in6addr_loopback; 
struct sockaddr_in
  {
    sa_family_t sin_family;
    in_port_t sin_port; 
    struct in_addr sin_addr; 
    unsigned char sin_zero[sizeof (struct sockaddr) -
      (sizeof (unsigned short int)) -
      sizeof (in_port_t) -
      sizeof (struct in_addr)];
  };
struct sockaddr_in6
  {
    sa_family_t sin6_family;
    in_port_t sin6_port; 
    uint32_t sin6_flowinfo; 
    struct in6_addr sin6_addr; 
    uint32_t sin6_scope_id; 
  };
struct ip_mreq
  {
    struct in_addr imr_multiaddr;
    struct in_addr imr_interface;
  };
struct ip_mreq_source
  {
    struct in_addr imr_multiaddr;
    struct in_addr imr_interface;
    struct in_addr imr_sourceaddr;
  };
struct ipv6_mreq
  {
    struct in6_addr ipv6mr_multiaddr;
    unsigned int ipv6mr_interface;
  };
struct group_req
  {
    uint32_t gr_interface;
    struct sockaddr_storage gr_group;
  };
struct group_source_req
  {
    uint32_t gsr_interface;
    struct sockaddr_storage gsr_group;
    struct sockaddr_storage gsr_source;
  };
struct ip_msfilter
  {
    struct in_addr imsf_multiaddr;
    struct in_addr imsf_interface;
    uint32_t imsf_fmode;
    uint32_t imsf_numsrc;
    struct in_addr imsf_slist[1];
  };
struct group_filter
  {
    uint32_t gf_interface;
    struct sockaddr_storage gf_group;
    uint32_t gf_fmode;
    uint32_t gf_numsrc;
    struct sockaddr_storage gf_slist[1];
};
extern uint32_t ntohl (uint32_t __netlong) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern uint16_t ntohs (uint16_t __netshort)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern uint32_t htonl (uint32_t __hostlong)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern uint16_t htons (uint16_t __hostshort)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int bindresvport (int __sockfd, struct sockaddr_in *__sock_in) __attribute__ ((__nothrow__ ));
extern int bindresvport6 (int __sockfd, struct sockaddr_in6 *__sock_in)
     __attribute__ ((__nothrow__ ));
struct sockaddr_un
  {
    sa_family_t sun_family;
    char sun_path[108]; 
  };
typedef unsigned long int nfds_t;
struct pollfd
  {
    int fd; 
    short int events; 
    short int revents; 
  };
extern int poll (struct pollfd *__fds, nfds_t __nfds, int __timeout);
extern in_addr_t inet_addr (const char *__cp) __attribute__ ((__nothrow__ ));
extern in_addr_t inet_lnaof (struct in_addr __in) __attribute__ ((__nothrow__ ));
extern struct in_addr inet_makeaddr (in_addr_t __net, in_addr_t __host)
     __attribute__ ((__nothrow__ ));
extern in_addr_t inet_netof (struct in_addr __in) __attribute__ ((__nothrow__ ));
extern in_addr_t inet_network (const char *__cp) __attribute__ ((__nothrow__ ));
extern char *inet_ntoa (struct in_addr __in) __attribute__ ((__nothrow__ ));
extern int inet_pton (int __af, const char *__restrict __cp,
        void *__restrict __buf) __attribute__ ((__nothrow__ ));
extern const char *inet_ntop (int __af, const void *__restrict __cp,
         char *__restrict __buf, socklen_t __len)
     __attribute__ ((__nothrow__ ));
extern int inet_aton (const char *__cp, struct in_addr *__inp) __attribute__ ((__nothrow__ ));
extern char *inet_neta (in_addr_t __net, char *__buf, size_t __len) __attribute__ ((__nothrow__ ));
extern char *inet_net_ntop (int __af, const void *__cp, int __bits,
       char *__buf, size_t __len) __attribute__ ((__nothrow__ ));
extern int inet_net_pton (int __af, const char *__cp,
     void *__buf, size_t __len) __attribute__ ((__nothrow__ ));
extern unsigned int inet_nsap_addr (const char *__cp,
        unsigned char *__buf, int __len) __attribute__ ((__nothrow__ ));
extern char *inet_nsap_ntoa (int __len, const unsigned char *__cp,
        char *__buf) __attribute__ ((__nothrow__ ));
struct rpcent
{
  char *r_name; 
  char **r_aliases; 
  int r_number; 
};
extern void setrpcent (int __stayopen) __attribute__ ((__nothrow__ ));
extern void endrpcent (void) __attribute__ ((__nothrow__ ));
extern struct rpcent *getrpcbyname (const char *__name) __attribute__ ((__nothrow__ ));
extern struct rpcent *getrpcbynumber (int __number) __attribute__ ((__nothrow__ ));
extern struct rpcent *getrpcent (void) __attribute__ ((__nothrow__ ));
extern int getrpcbyname_r (const char *__name, struct rpcent *__result_buf,
      char *__buffer, size_t __buflen,
      struct rpcent **__result) __attribute__ ((__nothrow__ ));
extern int getrpcbynumber_r (int __number, struct rpcent *__result_buf,
        char *__buffer, size_t __buflen,
        struct rpcent **__result) __attribute__ ((__nothrow__ ));
extern int getrpcent_r (struct rpcent *__result_buf, char *__buffer,
   size_t __buflen, struct rpcent **__result) __attribute__ ((__nothrow__ ));
struct netent
{
  char *n_name; 
  char **n_aliases; 
  int n_addrtype; 
  uint32_t n_net; 
};
extern int *__h_errno_location (void) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern void herror (const char *__str) __attribute__ ((__nothrow__ ));
extern const char *hstrerror (int __err_num) __attribute__ ((__nothrow__ ));
struct hostent
{
  char *h_name; 
  char **h_aliases; 
  int h_addrtype; 
  int h_length; 
  char **h_addr_list; 
};
extern void sethostent (int __stay_open);
extern void endhostent (void);
extern struct hostent *gethostent (void);
extern struct hostent *gethostbyaddr (const void *__addr, __socklen_t __len,
          int __type);
extern struct hostent *gethostbyname (const char *__name);
extern struct hostent *gethostbyname2 (const char *__name, int __af);
extern int gethostent_r (struct hostent *__restrict __result_buf,
    char *__restrict __buf, size_t __buflen,
    struct hostent **__restrict __result,
    int *__restrict __h_errnop);
extern int gethostbyaddr_r (const void *__restrict __addr, __socklen_t __len,
       int __type,
       struct hostent *__restrict __result_buf,
       char *__restrict __buf, size_t __buflen,
       struct hostent **__restrict __result,
       int *__restrict __h_errnop);
extern int gethostbyname_r (const char *__restrict __name,
       struct hostent *__restrict __result_buf,
       char *__restrict __buf, size_t __buflen,
       struct hostent **__restrict __result,
       int *__restrict __h_errnop);
extern int gethostbyname2_r (const char *__restrict __name, int __af,
        struct hostent *__restrict __result_buf,
        char *__restrict __buf, size_t __buflen,
        struct hostent **__restrict __result,
        int *__restrict __h_errnop);
extern void setnetent (int __stay_open);
extern void endnetent (void);
extern struct netent *getnetent (void);
extern struct netent *getnetbyaddr (uint32_t __net, int __type);
extern struct netent *getnetbyname (const char *__name);
extern int getnetent_r (struct netent *__restrict __result_buf,
   char *__restrict __buf, size_t __buflen,
   struct netent **__restrict __result,
   int *__restrict __h_errnop);
extern int getnetbyaddr_r (uint32_t __net, int __type,
      struct netent *__restrict __result_buf,
      char *__restrict __buf, size_t __buflen,
      struct netent **__restrict __result,
      int *__restrict __h_errnop);
extern int getnetbyname_r (const char *__restrict __name,
      struct netent *__restrict __result_buf,
      char *__restrict __buf, size_t __buflen,
      struct netent **__restrict __result,
      int *__restrict __h_errnop);
struct servent
{
  char *s_name; 
  char **s_aliases; 
  int s_port; 
  char *s_proto; 
};
extern void setservent (int __stay_open);
extern void endservent (void);
extern struct servent *getservent (void);
extern struct servent *getservbyname (const char *__name, const char *__proto);
extern struct servent *getservbyport (int __port, const char *__proto);
extern int getservent_r (struct servent *__restrict __result_buf,
    char *__restrict __buf, size_t __buflen,
    struct servent **__restrict __result);
extern int getservbyname_r (const char *__restrict __name,
       const char *__restrict __proto,
       struct servent *__restrict __result_buf,
       char *__restrict __buf, size_t __buflen,
       struct servent **__restrict __result);
extern int getservbyport_r (int __port, const char *__restrict __proto,
       struct servent *__restrict __result_buf,
       char *__restrict __buf, size_t __buflen,
       struct servent **__restrict __result);
struct protoent
{
  char *p_name; 
  char **p_aliases; 
  int p_proto; 
};
extern void setprotoent (int __stay_open);
extern void endprotoent (void);
extern struct protoent *getprotoent (void);
extern struct protoent *getprotobyname (const char *__name);
extern struct protoent *getprotobynumber (int __proto);
extern int getprotoent_r (struct protoent *__restrict __result_buf,
     char *__restrict __buf, size_t __buflen,
     struct protoent **__restrict __result);
extern int getprotobyname_r (const char *__restrict __name,
        struct protoent *__restrict __result_buf,
        char *__restrict __buf, size_t __buflen,
        struct protoent **__restrict __result);
extern int getprotobynumber_r (int __proto,
          struct protoent *__restrict __result_buf,
          char *__restrict __buf, size_t __buflen,
          struct protoent **__restrict __result);
extern int setnetgrent (const char *__netgroup);
extern void endnetgrent (void);
extern int getnetgrent (char **__restrict __hostp,
   char **__restrict __userp,
   char **__restrict __domainp);
extern int innetgr (const char *__netgroup, const char *__host,
      const char *__user, const char *__domain);
extern int getnetgrent_r (char **__restrict __hostp,
     char **__restrict __userp,
     char **__restrict __domainp,
     char *__restrict __buffer, size_t __buflen);
extern int rcmd (char **__restrict __ahost, unsigned short int __rport,
   const char *__restrict __locuser,
   const char *__restrict __remuser,
   const char *__restrict __cmd, int *__restrict __fd2p);
extern int rcmd_af (char **__restrict __ahost, unsigned short int __rport,
      const char *__restrict __locuser,
      const char *__restrict __remuser,
      const char *__restrict __cmd, int *__restrict __fd2p,
      sa_family_t __af);
extern int rexec (char **__restrict __ahost, int __rport,
    const char *__restrict __name,
    const char *__restrict __pass,
    const char *__restrict __cmd, int *__restrict __fd2p);
extern int rexec_af (char **__restrict __ahost, int __rport,
       const char *__restrict __name,
       const char *__restrict __pass,
       const char *__restrict __cmd, int *__restrict __fd2p,
       sa_family_t __af);
extern int ruserok (const char *__rhost, int __suser,
      const char *__remuser, const char *__locuser);
extern int ruserok_af (const char *__rhost, int __suser,
         const char *__remuser, const char *__locuser,
         sa_family_t __af);
extern int iruserok (uint32_t __raddr, int __suser,
       const char *__remuser, const char *__locuser);
extern int iruserok_af (const void *__raddr, int __suser,
   const char *__remuser, const char *__locuser,
   sa_family_t __af);
extern int rresvport (int *__alport);
extern int rresvport_af (int *__alport, sa_family_t __af);
struct addrinfo
{
  int ai_flags; 
  int ai_family; 
  int ai_socktype; 
  int ai_protocol; 
  socklen_t ai_addrlen; 
  struct sockaddr *ai_addr; 
  char *ai_canonname; 
  struct addrinfo *ai_next; 
};
extern int getaddrinfo (const char *__restrict __name,
   const char *__restrict __service,
   const struct addrinfo *__restrict __req,
   struct addrinfo **__restrict __pai);
extern void freeaddrinfo (struct addrinfo *__ai) __attribute__ ((__nothrow__ ));
extern const char *gai_strerror (int __ecode) __attribute__ ((__nothrow__ ));
extern int getnameinfo (const struct sockaddr *__restrict __sa,
   socklen_t __salen, char *__restrict __host,
   socklen_t __hostlen, char *__restrict __serv,
   socklen_t __servlen, int __flags);
typedef __sig_atomic_t sig_atomic_t;
union sigval
{
  int sival_int;
  void *sival_ptr;
};
typedef union sigval sigval_t;
typedef struct
  {
    int si_signo; 
    int si_errno; 
    int si_code; 
    int __pad0; 
    union
      {
 int _pad[((128 / sizeof (int)) - 4)];
 struct
   {
     __pid_t si_pid; 
     __uid_t si_uid; 
   } _kill;
 struct
   {
     int si_tid; 
     int si_overrun; 
     sigval_t si_sigval; 
   } _timer;
 struct
   {
     __pid_t si_pid; 
     __uid_t si_uid; 
     sigval_t si_sigval; 
   } _rt;
 struct
   {
     __pid_t si_pid; 
     __uid_t si_uid; 
     int si_status; 
     __clock_t si_utime;
     __clock_t si_stime;
   } _sigchld;
 struct
   {
     void *si_addr; 
     short int si_addr_lsb; 
     union
       {
  struct
    {
      void *_lower;
      void *_upper;
    } _addr_bnd;
  __uint32_t _pkey;
       } _bounds;
   } _sigfault;
 struct
   {
     long int si_band; 
     int si_fd;
   } _sigpoll;
 struct
   {
     void *_call_addr; 
     int _syscall; 
     unsigned int _arch; 
   } _sigsys;
      } _sifields;
  } siginfo_t ;
enum
{
  SI_ASYNCNL = -60, 
  SI_TKILL = -6, 
  SI_SIGIO, 
  SI_ASYNCIO, 
  SI_MESGQ, 
  SI_TIMER, 
  SI_QUEUE, 
  SI_USER, 
  SI_KERNEL = 0x80 
};
enum
{
  ILL_ILLOPC = 1, 
  ILL_ILLOPN, 
  ILL_ILLADR, 
  ILL_ILLTRP, 
  ILL_PRVOPC, 
  ILL_PRVREG, 
  ILL_COPROC, 
  ILL_BADSTK 
};
enum
{
  FPE_INTDIV = 1, 
  FPE_INTOVF, 
  FPE_FLTDIV, 
  FPE_FLTOVF, 
  FPE_FLTUND, 
  FPE_FLTRES, 
  FPE_FLTINV, 
  FPE_FLTSUB 
};
enum
{
  SEGV_MAPERR = 1, 
  SEGV_ACCERR 
};
enum
{
  BUS_ADRALN = 1, 
  BUS_ADRERR, 
  BUS_OBJERR, 
  BUS_MCEERR_AR, 
  BUS_MCEERR_AO 
};
enum
{
  CLD_EXITED = 1, 
  CLD_KILLED, 
  CLD_DUMPED, 
  CLD_TRAPPED, 
  CLD_STOPPED, 
  CLD_CONTINUED 
};
enum
{
  POLL_IN = 1, 
  POLL_OUT, 
  POLL_MSG, 
  POLL_ERR, 
  POLL_PRI, 
  POLL_HUP 
};
typedef struct sigevent
  {
    sigval_t sigev_value;
    int sigev_signo;
    int sigev_notify;
    union
      {
 int _pad[((64 / sizeof (int)) - 4)];
 __pid_t _tid;
 struct
   {
     void (*_function) (sigval_t); 
     pthread_attr_t *_attribute; 
   } _sigev_thread;
      } _sigev_un;
  } sigevent_t;
enum
{
  SIGEV_SIGNAL = 0, 
  SIGEV_NONE, 
  SIGEV_THREAD, 
  SIGEV_THREAD_ID = 4 
};
typedef void (*__sighandler_t) (int);
extern __sighandler_t __sysv_signal (int __sig, __sighandler_t __handler)
     __attribute__ ((__nothrow__ ));
extern __sighandler_t signal (int __sig, __sighandler_t __handler)
     __attribute__ ((__nothrow__ ));
extern int kill (__pid_t __pid, int __sig) __attribute__ ((__nothrow__ ));
extern int killpg (__pid_t __pgrp, int __sig) __attribute__ ((__nothrow__ ));
extern int raise (int __sig) __attribute__ ((__nothrow__ ));
extern __sighandler_t ssignal (int __sig, __sighandler_t __handler)
     __attribute__ ((__nothrow__ ));
extern int gsignal (int __sig) __attribute__ ((__nothrow__ ));
extern void psignal (int __sig, const char *__s);
extern void psiginfo (const siginfo_t *__pinfo, const char *__s);
extern int sigblock (int __mask) __attribute__ ((__nothrow__ )) __attribute__ ((__deprecated__));
extern int sigsetmask (int __mask) __attribute__ ((__nothrow__ )) __attribute__ ((__deprecated__));
extern int siggetmask (void) __attribute__ ((__nothrow__ )) __attribute__ ((__deprecated__));
typedef __sighandler_t sig_t;
extern int sigemptyset (sigset_t *__set) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int sigfillset (sigset_t *__set) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int sigaddset (sigset_t *__set, int __signo) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int sigdelset (sigset_t *__set, int __signo) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int sigismember (const sigset_t *__set, int __signo)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
struct sigaction
  {
    union
      {
 __sighandler_t sa_handler;
 void (*sa_sigaction) (int, siginfo_t *, void *);
      }
    __sigaction_handler;
    __sigset_t sa_mask;
    int sa_flags;
    void (*sa_restorer) (void);
  };
extern int sigprocmask (int __how, const sigset_t *__restrict __set,
   sigset_t *__restrict __oset) __attribute__ ((__nothrow__ ));
extern int sigsuspend (const sigset_t *__set) __attribute__ ((__nonnull__ (1)));
extern int sigaction (int __sig, const struct sigaction *__restrict __act,
        struct sigaction *__restrict __oact) __attribute__ ((__nothrow__ ));
extern int sigpending (sigset_t *__set) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int sigwait (const sigset_t *__restrict __set, int *__restrict __sig)
     __attribute__ ((__nonnull__ (1, 2)));
extern int sigwaitinfo (const sigset_t *__restrict __set,
   siginfo_t *__restrict __info) __attribute__ ((__nonnull__ (1)));
extern int sigtimedwait (const sigset_t *__restrict __set,
    siginfo_t *__restrict __info,
    const struct timespec *__restrict __timeout)
     __attribute__ ((__nonnull__ (1)));
extern int sigqueue (__pid_t __pid, int __sig, const union sigval __val)
     __attribute__ ((__nothrow__ ));
extern const char *const _sys_siglist[(64 + 1)];
extern const char *const sys_siglist[(64 + 1)];
struct _fpx_sw_bytes
{
  __uint32_t magic1;
  __uint32_t extended_size;
  __uint64_t xstate_bv;
  __uint32_t xstate_size;
  __uint32_t __glibc_reserved1[7];
};
struct _fpreg
{
  unsigned short significand[4];
  unsigned short exponent;
};
struct _fpxreg
{
  unsigned short significand[4];
  unsigned short exponent;
  unsigned short __glibc_reserved1[3];
};
struct _xmmreg
{
  __uint32_t element[4];
};
struct _fpstate
{
  __uint16_t cwd;
  __uint16_t swd;
  __uint16_t ftw;
  __uint16_t fop;
  __uint64_t rip;
  __uint64_t rdp;
  __uint32_t mxcsr;
  __uint32_t mxcr_mask;
  struct _fpxreg _st[8];
  struct _xmmreg _xmm[16];
  __uint32_t __glibc_reserved1[24];
};
struct sigcontext
{
  __uint64_t r8;
  __uint64_t r9;
  __uint64_t r10;
  __uint64_t r11;
  __uint64_t r12;
  __uint64_t r13;
  __uint64_t r14;
  __uint64_t r15;
  __uint64_t rdi;
  __uint64_t rsi;
  __uint64_t rbp;
  __uint64_t rbx;
  __uint64_t rdx;
  __uint64_t rax;
  __uint64_t rcx;
  __uint64_t rsp;
  __uint64_t rip;
  __uint64_t eflags;
  unsigned short cs;
  unsigned short gs;
  unsigned short fs;
  unsigned short __pad0;
  __uint64_t err;
  __uint64_t trapno;
  __uint64_t oldmask;
  __uint64_t cr2;
  __extension__ union
    {
      struct _fpstate * fpstate;
      __uint64_t __fpstate_word;
    };
  __uint64_t __reserved1 [8];
};
struct _xsave_hdr
{
  __uint64_t xstate_bv;
  __uint64_t __glibc_reserved1[2];
  __uint64_t __glibc_reserved2[5];
};
struct _ymmh_state
{
  __uint32_t ymmh_space[64];
};
struct _xstate
{
  struct _fpstate fpstate;
  struct _xsave_hdr xstate_hdr;
  struct _ymmh_state ymmh;
};
extern int sigreturn (struct sigcontext *__scp) __attribute__ ((__nothrow__ ));
typedef struct
  {
    void *ss_sp;
    int ss_flags;
    size_t ss_size;
  } stack_t;
__extension__ typedef long long int greg_t;
typedef greg_t gregset_t[23];
struct _libc_fpxreg
{
  unsigned short int significand[4];
  unsigned short int exponent;
  unsigned short int __glibc_reserved1[3];
};
struct _libc_xmmreg
{
  __uint32_t element[4];
};
struct _libc_fpstate
{
  __uint16_t cwd;
  __uint16_t swd;
  __uint16_t ftw;
  __uint16_t fop;
  __uint64_t rip;
  __uint64_t rdp;
  __uint32_t mxcsr;
  __uint32_t mxcr_mask;
  struct _libc_fpxreg _st[8];
  struct _libc_xmmreg _xmm[16];
  __uint32_t __glibc_reserved1[24];
};
typedef struct _libc_fpstate *fpregset_t;
typedef struct
  {
    gregset_t gregs;
    fpregset_t fpregs;
    __extension__ unsigned long long __reserved1 [8];
} mcontext_t;
typedef struct ucontext_t
  {
    unsigned long int uc_flags;
    struct ucontext_t *uc_link;
    stack_t uc_stack;
    mcontext_t uc_mcontext;
    sigset_t uc_sigmask;
    struct _libc_fpstate __fpregs_mem;
  } ucontext_t;
extern int siginterrupt (int __sig, int __interrupt) __attribute__ ((__nothrow__ ));
enum
{
  SS_ONSTACK = 1,
  SS_DISABLE
};
extern int sigaltstack (const stack_t *__restrict __ss,
   stack_t *__restrict __oss) __attribute__ ((__nothrow__ ));
struct sigstack
  {
    void *ss_sp; 
    int ss_onstack; 
  };
extern int sigstack (struct sigstack *__ss, struct sigstack *__oss)
     __attribute__ ((__nothrow__ )) __attribute__ ((__deprecated__));
extern int pthread_sigmask (int __how,
       const __sigset_t *__restrict __newmask,
       __sigset_t *__restrict __oldmask)__attribute__ ((__nothrow__ ));
extern int pthread_kill (pthread_t __threadid, int __signo) __attribute__ ((__nothrow__ ));
extern int __libc_current_sigrtmin (void) __attribute__ ((__nothrow__ ));
extern int __libc_current_sigrtmax (void) __attribute__ ((__nothrow__ ));
typedef enum
{
  P_ALL, 
  P_PID, 
  P_PGID 
} idtype_t;
extern __pid_t wait (int *__stat_loc);
extern __pid_t waitpid (__pid_t __pid, int *__stat_loc, int __options);
extern int waitid (idtype_t __idtype, __id_t __id, siginfo_t *__infop,
     int __options);
struct rusage;
extern __pid_t wait3 (int *__stat_loc, int __options,
        struct rusage * __usage) __attribute__ ((__nothrow__));
extern __pid_t wait4 (__pid_t __pid, int *__stat_loc, int __options,
        struct rusage *__usage) __attribute__ ((__nothrow__));
typedef signed char int_least8_t;
typedef short int int_least16_t;
typedef int int_least32_t;
typedef long int int_least64_t;
typedef unsigned char uint_least8_t;
typedef unsigned short int uint_least16_t;
typedef unsigned int uint_least32_t;
typedef unsigned long int uint_least64_t;
typedef signed char int_fast8_t;
typedef long int int_fast16_t;
typedef long int int_fast32_t;
typedef long int int_fast64_t;
typedef unsigned char uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long int uint_fast64_t;
typedef unsigned long int uintptr_t;
typedef __intmax_t intmax_t;
typedef __uintmax_t uintmax_t;
typedef uint32_t tcp_seq;
struct tcphdr
  {
    __extension__ union
    {
      struct
      {
 uint16_t th_sport; 
 uint16_t th_dport; 
 tcp_seq th_seq; 
 tcp_seq th_ack; 
 uint8_t th_x2:4; 
 uint8_t th_off:4; 
 uint8_t th_flags;
 uint16_t th_win; 
 uint16_t th_sum; 
 uint16_t th_urp; 
      };
      struct
      {
 uint16_t source;
 uint16_t dest;
 uint32_t seq;
 uint32_t ack_seq;
 uint16_t res1:4;
 uint16_t doff:4;
 uint16_t fin:1;
 uint16_t syn:1;
 uint16_t rst:1;
 uint16_t psh:1;
 uint16_t ack:1;
 uint16_t urg:1;
 uint16_t res2:2;
 uint16_t window;
 uint16_t check;
 uint16_t urg_ptr;
      };
    };
};
enum
{
  TCP_ESTABLISHED = 1,
  TCP_SYN_SENT,
  TCP_SYN_RECV,
  TCP_FIN_WAIT1,
  TCP_FIN_WAIT2,
  TCP_TIME_WAIT,
  TCP_CLOSE,
  TCP_CLOSE_WAIT,
  TCP_LAST_ACK,
  TCP_LISTEN,
  TCP_CLOSING 
};
enum tcp_ca_state
{
  TCP_CA_Open = 0,
  TCP_CA_Disorder = 1,
  TCP_CA_CWR = 2,
  TCP_CA_Recovery = 3,
  TCP_CA_Loss = 4
};
struct tcp_info
{
  uint8_t tcpi_state;
  uint8_t tcpi_ca_state;
  uint8_t tcpi_retransmits;
  uint8_t tcpi_probes;
  uint8_t tcpi_backoff;
  uint8_t tcpi_options;
  uint8_t tcpi_snd_wscale : 4, tcpi_rcv_wscale : 4;
  uint32_t tcpi_rto;
  uint32_t tcpi_ato;
  uint32_t tcpi_snd_mss;
  uint32_t tcpi_rcv_mss;
  uint32_t tcpi_unacked;
  uint32_t tcpi_sacked;
  uint32_t tcpi_lost;
  uint32_t tcpi_retrans;
  uint32_t tcpi_fackets;
  uint32_t tcpi_last_data_sent;
  uint32_t tcpi_last_ack_sent; 
  uint32_t tcpi_last_data_recv;
  uint32_t tcpi_last_ack_recv;
  uint32_t tcpi_pmtu;
  uint32_t tcpi_rcv_ssthresh;
  uint32_t tcpi_rtt;
  uint32_t tcpi_rttvar;
  uint32_t tcpi_snd_ssthresh;
  uint32_t tcpi_snd_cwnd;
  uint32_t tcpi_advmss;
  uint32_t tcpi_reordering;
  uint32_t tcpi_rcv_rtt;
  uint32_t tcpi_rcv_space;
  uint32_t tcpi_total_retrans;
};
struct tcp_md5sig
{
  struct sockaddr_storage tcpm_addr; 
  uint16_t __tcpm_pad1; 
  uint16_t tcpm_keylen; 
  uint32_t __tcpm_pad2; 
  uint8_t tcpm_key[80]; 
};
struct tcp_repair_opt
{
  uint32_t opt_code;
  uint32_t opt_val;
};
enum
{
  TCP_NO_QUEUE,
  TCP_RECV_QUEUE,
  TCP_SEND_QUEUE,
  TCP_QUEUES_NR,
};
struct tcp_cookie_transactions
{
  uint16_t tcpct_flags;
  uint8_t __tcpct_pad1;
  uint8_t tcpct_cookie_desired;
  uint16_t tcpct_s_data_desired;
  uint16_t tcpct_used;
  uint8_t tcpct_value[536U];
};
struct tcp_repair_window
{
  uint32_t snd_wl1;
  uint32_t snd_wnd;
  uint32_t max_window;
  uint32_t rcv_wnd;
  uint32_t rcv_wup;
};
typedef struct {
 int magic;
 int child;
 int input[2];
 int output[2];
} R2Pipe;
typedef struct r_socket_t {
 int fd;
 int is_ssl;
 int local; 
 int port;
 struct sockaddr_in sa;
} RSocket;
__attribute__((visibility("default"))) RSocket *r_socket_new_from_fd(int fd);
__attribute__((visibility("default"))) RSocket *r_socket_new(int is_ssl);
__attribute__((visibility("default"))) _Bool r_socket_connect(RSocket *s, const char *host, const char *port, int proto, unsigned int timeout);
__attribute__((visibility("default"))) int r_socket_spawn (RSocket *s, const char *cmd, unsigned int timeout);
__attribute__((visibility("default"))) int r_socket_connect_serial(RSocket *sock, const char *path, int speed, int parity);
__attribute__((visibility("default"))) int r_socket_unix_listen(RSocket *s, const char *file);
__attribute__((visibility("default"))) int r_socket_port_by_name(const char *name);
__attribute__((visibility("default"))) int r_socket_close_fd(RSocket *s);
__attribute__((visibility("default"))) int r_socket_close(RSocket *s);
__attribute__((visibility("default"))) int r_socket_free(RSocket *s);
__attribute__((visibility("default"))) _Bool r_socket_listen(RSocket *s, const char *port, const char *certfile);
__attribute__((visibility("default"))) RSocket *r_socket_accept(RSocket *s);
__attribute__((visibility("default"))) int r_socket_block_time(RSocket *s, int block, int sec);
__attribute__((visibility("default"))) int r_socket_flush(RSocket *s);
__attribute__((visibility("default"))) int r_socket_ready(RSocket *s, int secs, int usecs);
__attribute__((visibility("default"))) char *r_socket_to_string(RSocket *s);
__attribute__((visibility("default"))) int r_socket_write(RSocket *s, void *buf, int len);
__attribute__((visibility("default"))) int r_socket_puts(RSocket *s, char *buf);
__attribute__((visibility("default"))) void r_socket_printf(RSocket *s, const char *fmt, ...);
__attribute__((visibility("default"))) int r_socket_read(RSocket *s, unsigned char *read, int len);
__attribute__((visibility("default"))) int r_socket_read_block(RSocket *s, unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_socket_gets(RSocket *s, char *buf, int size);
__attribute__((visibility("default"))) unsigned char *r_socket_slurp(RSocket *s, int *len);
__attribute__((visibility("default"))) _Bool r_socket_is_connected(RSocket *);
typedef struct r_socket_proc_t {
 int fd0[2];
 int fd1[2];
 int pid;
} RSocketProc;
__attribute__((visibility("default"))) RSocketProc *r_socket_proc_open(char *const argv[]);
__attribute__((visibility("default"))) int r_socket_proc_close(RSocketProc *sp);
__attribute__((visibility("default"))) int r_socket_proc_read(RSocketProc *sp, unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_socket_proc_gets(RSocketProc *sp, char *buf, int size);
__attribute__((visibility("default"))) int r_socket_proc_write(RSocketProc *sp, void *buf, int len);
__attribute__((visibility("default"))) void r_socket_proc_printf(RSocketProc *sp, const char *fmt, ...);
__attribute__((visibility("default"))) int r_socket_proc_ready(RSocketProc *sp, int secs, int usecs);
__attribute__((visibility("default"))) char *r_socket_http_get(const char *url, int *code, int *rlen);
__attribute__((visibility("default"))) char *r_socket_http_post(const char *url, const char *data, int *code, int *rlen);
__attribute__((visibility("default"))) void r_socket_http_server_set_breaked(_Bool *b);
typedef struct r_socket_http_request {
 RSocket *s;
 char *path;
 char *host;
 char *agent;
 char *method;
 char *referer;
 unsigned char *data;
 int data_length;
} RSocketHTTPRequest;
__attribute__((visibility("default"))) RSocketHTTPRequest *r_socket_http_accept(RSocket *s, int timeout);
__attribute__((visibility("default"))) void r_socket_http_response(RSocketHTTPRequest *rs, int code, const char *out, int x, const char *headers);
__attribute__((visibility("default"))) void r_socket_http_close(RSocketHTTPRequest *rs);
__attribute__((visibility("default"))) unsigned char *r_socket_http_handle_upload(const unsigned char *str, int len, int *olen);
typedef int (*rap_server_open)(void *user, const char *file, int flg, int mode);
typedef int (*rap_server_seek)(void *user, unsigned long long offset, int whence);
typedef int (*rap_server_read)(void *user, unsigned char *buf, int len);
typedef int (*rap_server_write)(void *user, unsigned char *buf, int len);
typedef char *(*rap_server_cmd)(void *user, const char *command);
typedef int (*rap_server_close)(void *user, int fd);
enum {
 RAP_RMT_OPEN = 0x01,
 RAP_RMT_READ,
 RAP_RMT_WRITE,
 RAP_RMT_SEEK,
 RAP_RMT_CLOSE,
 RAP_RMT_CMD,
 RAP_RMT_REPLY = 0x80,
 RAP_RMT_MAX = 4096
};
typedef struct r_socket_rap_server_t {
 RSocket *fd;
 char port[5];
 unsigned char buf[RAP_RMT_MAX + 32]; 
 rap_server_open open;
 rap_server_seek seek;
 rap_server_read read;
 rap_server_write write;
 rap_server_cmd system;
 rap_server_cmd cmd;
 rap_server_close close;
 void *user; 
} RSocketRapServer;
__attribute__((visibility("default"))) RSocketRapServer *r_socket_rap_server_new(int is_ssl, const char *port);
__attribute__((visibility("default"))) RSocketRapServer *r_socket_rap_server_create(const char *pathname);
__attribute__((visibility("default"))) void r_socket_rap_server_free(RSocketRapServer *rap_s);
__attribute__((visibility("default"))) int r_socket_rap_server_listen(RSocketRapServer *rap_s, const char *certfile);
__attribute__((visibility("default"))) RSocket *r_socket_rap_server_accept(RSocketRapServer *rap_s);
__attribute__((visibility("default"))) _Bool r_socket_rap_server_continue(RSocketRapServer *rap_s);
typedef struct r_run_profile_t {
 char *_args[512];
 int _argc;
 char *_system;
 char *_program;
 char *_runlib;
 char *_runlib_fcn;
 char *_stdio;
 char *_stdin;
 char *_stdout;
 char *_stderr;
 char *_chgdir;
 char *_chroot;
 char *_libpath;
 char *_preload;
 int _bits;
 int _pid;
 char *_pidfile;
 int _r2preload;
 int _docore;
 int _dofork;
 int _dodebug;
 int _aslr;
 int _maxstack;
 int _maxproc;
 int _maxfd;
 int _r2sleep;
 int _execve;
 char *_setuid;
 char *_seteuid;
 char *_setgid;
 char *_setegid;
 char *_input;
 char *_connect;
 char *_listen;
 int _pty;
 int _timeout;
 int _timeout_sig;
 int _nice;
} RRunProfile;
__attribute__((visibility("default"))) RRunProfile *r_run_new(const char *str);
__attribute__((visibility("default"))) _Bool r_run_parse(RRunProfile *pf, const char *profile);
__attribute__((visibility("default"))) void r_run_free(RRunProfile *r);
__attribute__((visibility("default"))) _Bool r_run_parseline(RRunProfile *p, char *b);
__attribute__((visibility("default"))) const char *r_run_help(void);
__attribute__((visibility("default"))) int r_run_config_env(RRunProfile *p);
__attribute__((visibility("default"))) int r_run_start(RRunProfile *p);
__attribute__((visibility("default"))) void r_run_reset(RRunProfile *p);
__attribute__((visibility("default"))) int r_run_parsefile(RRunProfile *p, const char *b);
__attribute__((visibility("default"))) int r2p_close(R2Pipe *r2p);
__attribute__((visibility("default"))) R2Pipe *r2p_open(const char *cmd);
__attribute__((visibility("default"))) int r2p_write(R2Pipe *r2p, const char *str);
__attribute__((visibility("default"))) char *r2p_read(R2Pipe *r2p);
__attribute__((visibility("default"))) void r2p_free(R2Pipe *r2p);
__attribute__((visibility("default"))) char *r2p_cmd(R2Pipe *r2p, const char *str);
__attribute__((visibility("default"))) char *r2p_cmdf(R2Pipe *r2p, const char *fmt, ...);
__attribute__((visibility("default"))) const char *r_magic_version(void);
union VALUETYPE {
 unsigned char b;
 unsigned short h;
 unsigned int l;
 unsigned long long q;
 unsigned char hs[2]; 
 unsigned char hl[4]; 
 unsigned char hq[8]; 
 char s[32]; 
 float f;
 double d;
}; 
struct r_magic {
 unsigned short cont_level; 
 unsigned char flag;
 unsigned char dummy1;
 unsigned char reln; 
 unsigned char vallen; 
 unsigned char type; 
 unsigned char in_type; 
 unsigned char in_op; 
 unsigned char mask_op; 
 unsigned char cond; 
 unsigned char dummy2;
 unsigned int offset; 
 unsigned int in_offset; 
 unsigned int lineno; 
 union {
  unsigned long long _mask; 
  struct {
   unsigned int _count; 
   unsigned int _flags; 
  } _s; 
 } _u;
 union VALUETYPE value;
 char desc[64]; 
 char mimetype[64]; 
};
struct mlist {
 struct r_magic *magic; 
 unsigned int nmagic; 
 int mapped; 
 struct mlist *next, *prev;
};
struct r_magic_set {
 struct mlist *mlist;
 struct cont {
  size_t len;
  struct level_info {
   int off;
   int got_match;
   int last_match;
   int last_cond; 
  } *li;
 } c;
 struct out {
  char *buf; 
  char *pbuf; 
 } o;
 unsigned int offset;
 int error;
 int flags;
 int haderr;
 const char *file;
 size_t line; 
 struct {
  const char *s; 
  size_t s_len; 
  size_t offset; 
  size_t rm_len; 
 } search;
 union VALUETYPE ms_value; 
};
typedef struct r_magic_set RMagic;
__attribute__((visibility("default"))) RMagic* r_magic_new(int flags);
__attribute__((visibility("default"))) void r_magic_free(RMagic*);
__attribute__((visibility("default"))) const char *r_magic_file(RMagic*, const char *);
__attribute__((visibility("default"))) const char *r_magic_descriptor(RMagic*, int);
__attribute__((visibility("default"))) const char *r_magic_buffer(RMagic*, const void *, size_t);
__attribute__((visibility("default"))) const char *r_magic_error(RMagic*);
__attribute__((visibility("default"))) void r_magic_setflags(RMagic*, int);
__attribute__((visibility("default"))) int r_magic_load(RMagic*, const char *);
__attribute__((visibility("default"))) int r_magic_compile(RMagic*, const char *);
__attribute__((visibility("default"))) int r_magic_check(RMagic*, const char *);
__attribute__((visibility("default"))) int r_magic_errno(RMagic*);
__attribute__((visibility("default"))) void **r_flist_resize(void **it, int n);
static inline void **r_flist_init(void **it, int n) {
 *it = it;
 memset (++it, 0, (n+1) * sizeof (void*));
 return it;
}
static inline void **r_flist_new(int n) {
 void **it;
 if (((n + 2) * sizeof(void*)) < sizeof(void*)) return ((void*)0);
 if (!(it = (void **)calloc ((n + 2), sizeof (void*)))) {
  return ((void*)0);
 }
 return r_flist_init (it, n);
}
static inline void **r_flist_prev(void **it) {
 void **p = it--;
 return (it==*it)?p:it;
}
static inline void r_flist_set(void **it, int idx, void *data) {
 while(it!=*it) it--; it++;;
 it[idx] = data;
}
static inline void r_flist_delete(void **it, int idx) {
 while(it!=*it) it--; it++;;
 free (it[idx]);
 for(it += idx; *it; it++) *it = *(it+1);
}
static inline void r_flist_free(void **it) {
 void *pos;
 while(it!=*it) it--; it++;; while (*it!=0 && (pos = *(it++)))
  free (pos);
 while(it!=*it) it--; it++;;
 free (--it);
}
static inline int r_flist_length (void **it) {
 void *pos;
 int len = 0;
 while(it!=*it) it--; it++;; while (*it!=0 && (pos = *(it++)))
  len++;
 return len;
}
typedef int __gwchar_t;
typedef struct
  {
    long int quot; 
    long int rem; 
  } imaxdiv_t;
extern intmax_t imaxabs (intmax_t __n) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern imaxdiv_t imaxdiv (intmax_t __numer, intmax_t __denom)
      __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern intmax_t strtoimax (const char *__restrict __nptr,
      char **__restrict __endptr, int __base) __attribute__ ((__nothrow__ ));
extern uintmax_t strtoumax (const char *__restrict __nptr,
       char ** __restrict __endptr, int __base) __attribute__ ((__nothrow__ ));
extern intmax_t wcstoimax (const __gwchar_t *__restrict __nptr,
      __gwchar_t **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ ));
extern uintmax_t wcstoumax (const __gwchar_t *__restrict __nptr,
       __gwchar_t ** __restrict __endptr, int __base)
     __attribute__ ((__nothrow__ ));
static inline int seek_set(int fd, off_t pos) {
 return ((fd == -1) || (lseek (fd, (off_t) pos, 0) == -1))? 0:1;
}
static inline void ut32_pack(char s[4], unsigned int u) {
 s[0] = u & 255;
 u >>= 8;
 s[1] = u & 255;
 u >>= 8;
 s[2] = u & 255;
 s[3] = u >> 8;
}
static inline void ut32_pack_big(char s[4], unsigned int u) {
 s[3] = u & 255;
 u >>= 8;
 s[2] = u & 255;
 u >>= 8;
 s[1] = u & 255;
 s[0] = u >> 8;
}
static inline void ut32_unpack(char s[4], unsigned int *u) {
 unsigned int result = 0;
 result = (unsigned char) s[3];
 result <<= 8;
 result += (unsigned char) s[2];
 result <<= 8;
 result += (unsigned char) s[1];
 result <<= 8;
 result += (unsigned char) s[0];
 *u = result;
}
typedef void (*SdbListFree)(void *ptr);
typedef int (*SdbListComparator)(const void *a, const void *b);
typedef struct ls_iter_t {
 void *data;
 struct ls_iter_t *n, *p;
} SdbListIter;
typedef struct ls_t {
 size_t length;
 SdbListIter *head;
 SdbListIter *tail;
 SdbListFree free;
 SdbListComparator cmp;
 _Bool sorted;
} SdbList;
__attribute__((visibility("default"))) SdbList *ls_new(void);
__attribute__((visibility("default"))) SdbList *ls_newf(SdbListFree freefn);
__attribute__((visibility("default"))) SdbListIter *ls_append(SdbList *list, void *data);
__attribute__((visibility("default"))) SdbListIter *ls_prepend(SdbList *list, void *data);
__attribute__((visibility("default"))) _Bool ls_sort(SdbList *list, SdbListComparator cmp);
__attribute__((visibility("default"))) _Bool ls_merge_sort(SdbList *list, SdbListComparator cmp);
__attribute__((visibility("default"))) void ls_delete(SdbList *list, SdbListIter *iter);
__attribute__((visibility("default"))) _Bool ls_delete_data(SdbList *list, void *ptr);
__attribute__((visibility("default"))) void ls_iter_init(SdbListIter *iter, SdbList *list);
__attribute__((visibility("default"))) void ls_destroy(SdbList *list);
__attribute__((visibility("default"))) void ls_free(SdbList *list);
__attribute__((visibility("default"))) SdbListIter *ls_item_new(void *data);
__attribute__((visibility("default"))) void ls_unlink(SdbList *list, void *ptr);
__attribute__((visibility("default"))) void ls_split(SdbList *list, void *ptr);
__attribute__((visibility("default"))) void ls_split_iter(SdbList *list, SdbListIter *iter);
__attribute__((visibility("default"))) void *ls_get_n(SdbList *list, int n);
__attribute__((visibility("default"))) void *ls_get_top(SdbList *list);
__attribute__((visibility("default"))) void *ls_pop(SdbList *list);
__attribute__((visibility("default"))) void ls_reverse(SdbList *list);
__attribute__((visibility("default"))) SdbList *ls_clone(SdbList *list);
__attribute__((visibility("default"))) int ls_join(SdbList *first, SdbList *second);
__attribute__((visibility("default"))) int ls_del_n(SdbList *list, int n);
__attribute__((visibility("default"))) SdbListIter *ls_insert(SdbList *list, int n, void *data);
__attribute__((visibility("default"))) void *ls_pop_head(SdbList *list);
typedef struct ht_kv {
 char *key;
 void *value;
 unsigned int key_len;
 unsigned int value_len;
} HtKv;
typedef void (*HtKvFreeFunc)(HtKv *);
typedef char* (*DupKey)(void *);
typedef char* (*DupValue)(void *);
typedef size_t (*CalcSize)(void *);
typedef unsigned int (*HashFunction)(const char*);
typedef int (*ListComparator)(const char *a, const char *b);
typedef _Bool (*HtForeachCallback)(void *user, const char *k, void *v);
typedef struct ht_t {
 unsigned int size; 
 unsigned int count; 
 ListComparator cmp; 
 HashFunction hashfn; 
 DupKey dupkey; 
 DupValue dupvalue; 
 CalcSize calcsizeK; 
 CalcSize calcsizeV; 
 HtKvFreeFunc freefn; 
 SdbList ** table; 
 SdbList* deleted;
 unsigned int load_factor; 
 unsigned int prime_idx;
} SdbHash;
SdbHash* ht_new(DupValue valdup, HtKvFreeFunc pair_free, CalcSize valueSize);
void ht_free(SdbHash* ht);
void ht_free_deleted(SdbHash* ht);
_Bool ht_insert(SdbHash* ht, const char* key, void* value);
_Bool ht_insert_kv(SdbHash *ht, HtKv *kv, _Bool update);
_Bool ht_update(SdbHash* ht, const char* key, void* value);
_Bool ht_delete(SdbHash* ht, const char* key);
void* ht_find(SdbHash* ht, const char* key, _Bool* found);
HtKv* ht_find_kv(SdbHash* ht, const char* key, _Bool* found);
void ht_foreach(SdbHash *ht, HtForeachCallback cb, void *user);
SdbList* ht_foreach_list(SdbHash *ht, _Bool sorted);
typedef struct sdb_kv {
 char *key;
 char *value;
 unsigned int key_len;
 unsigned int value_len;
 unsigned int cas;
 unsigned long long expire;
} SdbKv;
__attribute__((visibility("default"))) SdbKv* sdb_kv_new2(const char *k, int kl, const char *v, int vl);
extern SdbKv* sdb_kv_new(const char *k, const char *v);
extern unsigned int sdb_hash(const char *key);
extern void sdb_kv_free(SdbKv *kv);
SdbHash* sdb_ht_new(void);
void sdb_ht_free(SdbHash* ht);
void sdb_ht_free_deleted(SdbHash* ht);
_Bool sdb_ht_insert(SdbHash* ht, const char* key, const char* value);
_Bool sdb_ht_insert_kvp(SdbHash* ht, SdbKv *kvp, _Bool update);
_Bool sdb_ht_update(SdbHash* ht, const char* key, const char* value);
_Bool sdb_ht_delete(SdbHash* ht, const char* key);
char* sdb_ht_find(SdbHash* ht, const char* key, _Bool* found);
SdbKv* sdb_ht_find_kvp(SdbHash* ht, const char* key, _Bool* found);
typedef unsigned long long dicti;
typedef struct {
 dicti k;
 dicti v;
 void *u;
} dictkv;
typedef void (*dict_freecb)(void *);
typedef struct {
 void **table; 
 dict_freecb f;
 unsigned int size;
} dict;
typedef dict SdbMini;
__attribute__((visibility("default"))) dict *dict_new(unsigned int size, dict_freecb f);
__attribute__((visibility("default"))) void dict_free(dict*);
__attribute__((visibility("default"))) _Bool dict_init(dict *m, unsigned int, dict_freecb f);
__attribute__((visibility("default"))) void dict_fini(dict *m);
__attribute__((visibility("default"))) void dict_stats(dict *m);
__attribute__((visibility("default"))) dicti dict_hash(const char *s);
__attribute__((visibility("default"))) _Bool dict_set(dict *m, dicti k, dicti v, void *u);
__attribute__((visibility("default"))) dictkv *dict_getr(dict *m, dicti k);
__attribute__((visibility("default"))) dictkv *dict_getr(dict *m, dicti k);
__attribute__((visibility("default"))) dicti dict_get(dict *m, dicti k);
__attribute__((visibility("default"))) dicti dict_get(dict *m, dicti k);
__attribute__((visibility("default"))) void *dict_getu(dict *m, dicti k);
__attribute__((visibility("default"))) _Bool dict_add(dict *m, dicti k, dicti v, void *u);
__attribute__((visibility("default"))) _Bool dict_del(dict *m, dicti k);
struct cdb {
 char *map; 
 int fd; 
 unsigned int size; 
 unsigned int loop; 
 unsigned int khash; 
 unsigned int kpos; 
 unsigned int hpos; 
 unsigned int hslots; 
 unsigned int dpos; 
 unsigned int dlen; 
};
_Bool cdb_getkvlen(struct cdb *db, unsigned int *klen, unsigned int *vlen, unsigned int pos);
void cdb_free(struct cdb *);
_Bool cdb_init(struct cdb *, int fd);
void cdb_findstart(struct cdb *);
_Bool cdb_read(struct cdb *, char *, unsigned int, unsigned int);
int cdb_findnext(struct cdb *, unsigned int u, const char *, unsigned int);
typedef int (*BufferOp)(int, const char *, int);
typedef struct buffer {
 char *x;
 unsigned int p;
 unsigned int n;
 int fd;
 BufferOp op;
} buffer;
extern void buffer_init(buffer *,BufferOp,int,char *,unsigned int);
extern int buffer_flush(buffer *);
extern int buffer_put(buffer *,const char *,unsigned int);
extern int buffer_putalign(buffer *,const char *,unsigned int);
extern int buffer_putflush(buffer *,const char *,unsigned int);
extern int buffer_get(buffer *,char *,unsigned int);
extern int buffer_bget(buffer *,char *,unsigned int);
extern int buffer_feed(buffer *);
extern char *buffer_peek(buffer *);
extern void buffer_seek(buffer *,unsigned int);
extern int buffer_copy(buffer *,buffer *);
extern buffer *buffer_0;
extern buffer *buffer_0small;
extern buffer *buffer_1;
extern buffer *buffer_1small;
extern buffer *buffer_2;
struct cdb_hp { unsigned int h; unsigned int p; } ;
struct cdb_hplist {
 struct cdb_hp hp[1000];
 struct cdb_hplist *next;
 int num;
};
struct cdb_make {
 char bspace[8192];
 char final[1024];
 unsigned int count[256];
 unsigned int start[256];
 struct cdb_hplist *head;
 struct cdb_hp *split; 
 struct cdb_hp *hash;
 unsigned int numentries;
 unsigned int memsize;
 buffer b;
 unsigned int pos;
 int fd;
};
extern int cdb_make_start(struct cdb_make *,int);
extern int cdb_make_addbegin(struct cdb_make *,unsigned int,unsigned int);
extern int cdb_make_addend(struct cdb_make *,unsigned int,unsigned int,unsigned int);
extern int cdb_make_add(struct cdb_make *,const char *,unsigned int,const char *,unsigned int);
extern int cdb_make_finish(struct cdb_make *);
typedef struct sdb_t {
 char *dir; 
 char *path;
 char *name;
 int fd;
 int refs; 
 int lock;
 int journal;
 struct cdb db;
 struct cdb_make m;
 SdbHash *ht;
 unsigned int eod;
 unsigned int pos;
 int fdump;
 char *ndump;
 unsigned long long expire;
 unsigned long long last; 
 int options;
 int ns_lock; 
 SdbList *ns;
 SdbList *hooks;
 SdbKv tmpkv;
 unsigned int depth;
 _Bool timestamped;
 SdbMini mht;
} Sdb;
typedef struct sdb_ns_t {
 char *name;
 unsigned int hash;
 Sdb *sdb;
} SdbNs;
__attribute__((visibility("default"))) Sdb* sdb_new0(void);
__attribute__((visibility("default"))) Sdb* sdb_new(const char *path, const char *file, int lock);
__attribute__((visibility("default"))) int sdb_open(Sdb *s, const char *file);
__attribute__((visibility("default"))) void sdb_close(Sdb *s);
__attribute__((visibility("default"))) void sdb_config(Sdb *s, int options);
__attribute__((visibility("default"))) _Bool sdb_free(Sdb* s);
__attribute__((visibility("default"))) void sdb_file(Sdb* s, const char *dir);
__attribute__((visibility("default"))) _Bool sdb_merge(Sdb* d, Sdb *s);
__attribute__((visibility("default"))) int sdb_count(Sdb* s);
__attribute__((visibility("default"))) void sdb_reset(Sdb* s);
__attribute__((visibility("default"))) void sdb_setup(Sdb* s, int options);
__attribute__((visibility("default"))) void sdb_drain(Sdb*, Sdb*);
__attribute__((visibility("default"))) _Bool sdb_stats(Sdb *s, unsigned int *disk, unsigned int *mem);
__attribute__((visibility("default"))) _Bool sdb_dump_hasnext (Sdb* s);
typedef int (*SdbForeachCallback)(void *user, const char *k, const char *v);
_Bool sdb_foreach(Sdb* s, SdbForeachCallback cb, void *user);
SdbList *sdb_foreach_list(Sdb* s, _Bool sorted);
SdbList *sdb_foreach_match(Sdb* s, const char *expr, _Bool sorted);
int sdb_query(Sdb* s, const char *cmd);
int sdb_queryf(Sdb* s, const char *fmt, ...);
int sdb_query_lines(Sdb *s, const char *cmd);
char *sdb_querys(Sdb* s, char *buf, size_t len, const char *cmd);
char *sdb_querysf(Sdb* s, char *buf, size_t buflen, const char *fmt, ...);
int sdb_query_file(Sdb *s, const char* file);
_Bool sdb_exists(Sdb*, const char *key);
_Bool sdb_remove(Sdb*, const char *key, unsigned int cas);
int sdb_unset(Sdb*, const char *key, unsigned int cas);
int sdb_unset_like(Sdb *s, const char *k);
char** sdb_like(Sdb *s, const char *k, const char *v, SdbForeachCallback cb);
char *sdb_get(Sdb*, const char *key, unsigned int *cas);
char *sdb_get_len(Sdb*, const char *key, int *vlen, unsigned int *cas);
const char *sdb_const_get(Sdb*, const char *key, unsigned int *cas);
const char *sdb_const_get_len(Sdb* s, const char *key, int *vlen, unsigned int *cas);
int sdb_set(Sdb*, const char *key, const char *data, unsigned int cas);
int sdb_set_owned(Sdb* s, const char *key, char *val, unsigned int cas);
int sdb_concat(Sdb *s, const char *key, const char *value, unsigned int cas);
int sdb_uncat(Sdb *s, const char *key, const char *value, unsigned int cas);
int sdb_add(Sdb* s, const char *key, const char *val, unsigned int cas);
_Bool sdb_sync(Sdb*);
void sdb_kv_free(SdbKv *kv);
int sdb_num_exists(Sdb*, const char *key);
int sdb_num_base(const char *s);
unsigned long long sdb_num_get(Sdb* s, const char *key, unsigned int *cas);
int sdb_num_set(Sdb* s, const char *key, unsigned long long v, unsigned int cas);
int sdb_num_add(Sdb *s, const char *key, unsigned long long v, unsigned int cas);
unsigned long long sdb_num_inc(Sdb* s, const char *key, unsigned long long n, unsigned int cas);
unsigned long long sdb_num_dec(Sdb* s, const char *key, unsigned long long n, unsigned int cas);
int sdb_num_min(Sdb* s, const char *key, unsigned long long v, unsigned int cas);
int sdb_num_max(Sdb* s, const char *key, unsigned long long v, unsigned int cas);
int sdb_ptr_set(Sdb *db, const char *key, void *p, unsigned int cas);
void* sdb_ptr_get(Sdb *db, const char *key, unsigned int *cas);
__attribute__((visibility("default"))) _Bool sdb_disk_create(Sdb* s);
int sdb_disk_insert(Sdb* s, const char *key, const char *val);
__attribute__((visibility("default"))) _Bool sdb_disk_finish(Sdb* s);
__attribute__((visibility("default"))) _Bool sdb_disk_unlink(Sdb* s);
__attribute__((visibility("default"))) void sdb_dump_begin(Sdb* s);
__attribute__((visibility("default"))) SdbKv *sdb_dump_next(Sdb* s);
__attribute__((visibility("default"))) _Bool sdb_dump_dupnext(Sdb* s, char *key, char **value, int *_vlen);
__attribute__((visibility("default"))) _Bool sdb_journal_close(Sdb *s);
__attribute__((visibility("default"))) _Bool sdb_journal_open(Sdb *s);
__attribute__((visibility("default"))) int sdb_journal_load(Sdb *s);
__attribute__((visibility("default"))) _Bool sdb_journal_log(Sdb *s, const char *key, const char *val);
__attribute__((visibility("default"))) _Bool sdb_journal_clear(Sdb *s);
__attribute__((visibility("default"))) _Bool sdb_journal_unlink(Sdb *s);
char *sdb_itoa(unsigned long long n, char *s, int base);
unsigned long long sdb_atoi(const char *s);
__attribute__((visibility("default"))) _Bool sdb_lock(const char *s);
__attribute__((visibility("default"))) const char *sdb_lock_file(const char *f);
__attribute__((visibility("default"))) void sdb_unlock(const char *s);
__attribute__((visibility("default"))) int sdb_unlink(Sdb* s);
__attribute__((visibility("default"))) int sdb_lock_wait(const char *s __attribute__((__unused__)));
__attribute__((visibility("default"))) _Bool sdb_expire_set(Sdb* s, const char *key, unsigned long long expire, unsigned int cas);
__attribute__((visibility("default"))) unsigned long long sdb_expire_get(Sdb* s, const char *key, unsigned int *cas);
__attribute__((visibility("default"))) unsigned long long sdb_now(void);
__attribute__((visibility("default"))) unsigned long long sdb_unow(void);
__attribute__((visibility("default"))) unsigned int sdb_hash(const char *key);
__attribute__((visibility("default"))) unsigned int sdb_hash_len(const char *key, unsigned int *len);
__attribute__((visibility("default"))) unsigned char sdb_hash_byte(const char *s);
__attribute__((visibility("default"))) _Bool sdb_isjson(const char *k);
__attribute__((visibility("default"))) char *sdb_json_get(Sdb* s, const char *key, const char *p, unsigned int *cas);
__attribute__((visibility("default"))) _Bool sdb_json_set(Sdb* s, const char *k, const char *p, const char *v, unsigned int cas);
__attribute__((visibility("default"))) int sdb_json_num_get(Sdb* s, const char *k, const char *p, unsigned int *cas);
__attribute__((visibility("default"))) int sdb_json_num_set(Sdb* s, const char *k, const char *p, int v, unsigned int cas);
__attribute__((visibility("default"))) int sdb_json_num_dec(Sdb* s, const char *k, const char *p, int n, unsigned int cas);
__attribute__((visibility("default"))) int sdb_json_num_inc(Sdb* s, const char *k, const char *p, int n, unsigned int cas);
char *sdb_json_indent(const char *s, const char *tab);
char *sdb_json_unindent(const char *s);
typedef struct {
 char *buf;
 size_t blen;
 size_t len;
} SdbJsonString;
const char *sdb_json_format(SdbJsonString* s, const char *fmt, ...);
Sdb* sdb_ns(Sdb *s, const char *name, int create);
Sdb *sdb_ns_path(Sdb *s, const char *path, int create);
void sdb_ns_init(Sdb* s);
void sdb_ns_free(Sdb* s);
void sdb_ns_lock(Sdb *s, int lock, int depth);
void sdb_ns_sync(Sdb* s);
int sdb_ns_set(Sdb *s, const char *name, Sdb *r);
_Bool sdb_ns_unset(Sdb *s, const char *name, Sdb *r);
int sdb_array_contains(Sdb* s, const char *key, const char *val, unsigned int *cas);
int sdb_array_contains_num(Sdb *s, const char *key, unsigned long long val, unsigned int *cas);
int sdb_array_indexof(Sdb *s, const char *key, const char *val, unsigned int cas);
int sdb_array_set(Sdb* s, const char *key, int idx, const char *val, unsigned int cas);
int sdb_array_set_num(Sdb* s, const char *key, int idx, unsigned long long val, unsigned int cas);
_Bool sdb_array_append(Sdb *s, const char *key, const char *val, unsigned int cas);
_Bool sdb_array_append_num(Sdb *s, const char *key, unsigned long long val, unsigned int cas);
int sdb_array_prepend(Sdb *s, const char *key, const char *val, unsigned int cas);
int sdb_array_prepend_num(Sdb *s, const char *key, unsigned long long val, unsigned int cas);
char *sdb_array_get(Sdb* s, const char *key, int idx, unsigned int *cas);
unsigned long long sdb_array_get_num(Sdb* s, const char *key, int idx, unsigned int *cas);
int sdb_array_get_idx(Sdb *s, const char *key, const char *val, unsigned int cas); 
int sdb_array_insert(Sdb* s, const char *key, int idx, const char *val, unsigned int cas);
int sdb_array_insert_num(Sdb* s, const char *key, int idx, unsigned long long val, unsigned int cas);
int sdb_array_unset(Sdb* s, const char *key, int n, unsigned int cas); 
int sdb_array_delete(Sdb* s, const char *key, int n, unsigned int cas);
void sdb_array_sort(Sdb* s, const char *key, unsigned int cas);
void sdb_array_sort_num(Sdb* s, const char *key, unsigned int cas);
int sdb_array_add(Sdb* s, const char *key, const char *val, unsigned int cas);
int sdb_array_add_num(Sdb* s, const char *key, unsigned long long val, unsigned int cas);
int sdb_array_add_sorted(Sdb *s, const char *key, const char *val, unsigned int cas);
int sdb_array_add_sorted_num(Sdb *s, const char *key, unsigned long long val, unsigned int cas);
int sdb_array_remove(Sdb *s, const char *key, const char *val, unsigned int cas);
int sdb_array_remove_num(Sdb* s, const char *key, unsigned long long val, unsigned int cas);
char *sdb_anext(char *str, char **next);
const char *sdb_const_anext(const char *str, const char **next);
int sdb_alen(const char *str);
int sdb_alen_ignore_empty(const char *str);
int sdb_array_size(Sdb* s, const char *key);
int sdb_array_length(Sdb* s, const char *key);
int sdb_array_list(Sdb* s, const char *key);
int sdb_array_push(Sdb *s, const char *key, const char *val, unsigned int cas);
char *sdb_array_pop(Sdb *s, const char *key, unsigned int *cas);
int sdb_array_push_num(Sdb *s, const char *key, unsigned long long num, unsigned int cas);
unsigned long long sdb_array_pop_num(Sdb *s, const char *key, unsigned int *cas);
char *sdb_array_pop_head(Sdb *s, const char *key, unsigned int *cas);
char *sdb_array_pop_tail(Sdb *s, const char *key, unsigned int *cas);
typedef void (*SdbHook)(Sdb *s, void *user, const char *k, const char *v);
void sdb_global_hook(SdbHook hook, void *user);
__attribute__((visibility("default"))) _Bool sdb_hook(Sdb* s, SdbHook cb, void* user);
__attribute__((visibility("default"))) _Bool sdb_unhook(Sdb* s, SdbHook h);
int sdb_hook_call(Sdb *s, const char *k, const char *v);
void sdb_hook_free(Sdb *s);
int sdb_isnum(const char *s);
const char *sdb_type(const char *k);
_Bool sdb_match(const char *str, const char *glob);
int sdb_bool_set(Sdb *db, const char *str, _Bool v, unsigned int cas);
_Bool sdb_bool_get(Sdb *db, const char *str, unsigned int *cas);
unsigned char *sdb_decode(const char *in, int *len);
char *sdb_encode(const unsigned char *bin, int len);
void sdb_encode_raw(char *bout, const unsigned char *bin, int len);
int sdb_decode_raw(unsigned char *bout, const char *bin, int len);
char *sdb_fmt(int n, const char *fmt, ...);
int sdb_fmt_init(void *p, const char *fmt);
void sdb_fmt_free(void *p, const char *fmt);
int sdb_fmt_tobin(const char *_str, const char *fmt, void *stru);
char *sdb_fmt_tostr(void *stru, const char *fmt);
__attribute__((visibility("default"))) char** sdb_fmt_array(const char *list);
__attribute__((visibility("default"))) unsigned long long* sdb_fmt_array_num(const char *list);
char *sdb_array_compact(char *p);
char *sdb_aslice(char *out, int from, int to);
typedef void (*RListFree)(void *ptr);
typedef struct r_list_iter_t {
 void *data;
 struct r_list_iter_t *n, *p;
} RListIter;
typedef struct r_list_t {
 RListIter *head;
 RListIter *tail;
 RListFree free;
 int length;
 _Bool sorted;
} RList;
typedef struct r_list_range_t {
 SdbHash *h;
 RList *l;
} RListRange;
typedef int (*RListComparator)(const void *a, const void *b);
typedef struct r_oflist_t {
 RList super; 
 void** *array; 
} ROFList;
__attribute__((visibility("default"))) RList *r_list_new(void);
__attribute__((visibility("default"))) RList *r_list_newf(RListFree f);
__attribute__((visibility("default"))) RListIter *r_list_iter_get_next(RListIter *list);
__attribute__((visibility("default"))) int r_list_set_n(RList *list, int n, void *p);
__attribute__((visibility("default"))) void *r_list_iter_get_data(RListIter *list);
__attribute__((visibility("default"))) RListIter *r_list_append(RList *list, void *data);
__attribute__((visibility("default"))) RListIter *r_list_prepend(RList *list, void *data);
__attribute__((visibility("default"))) RListIter *r_list_insert(RList *list, int n, void *data);
__attribute__((visibility("default"))) int r_list_length(const RList *list);
__attribute__((visibility("default"))) void *r_list_first(const RList *list);
__attribute__((visibility("default"))) RListIter *r_list_add_sorted(RList *list, void *data, RListComparator cmp);
__attribute__((visibility("default"))) void r_list_sort(RList *list, RListComparator cmp);
__attribute__((visibility("default"))) void r_list_merge_sort(RList *list, RListComparator cmp);
__attribute__((visibility("default"))) void r_list_insertion_sort(RList *list, RListComparator cmp);
__attribute__((visibility("default"))) void r_list_init(RList *list);
__attribute__((visibility("default"))) void r_list_delete(RList *list, RListIter *iter);
__attribute__((visibility("default"))) _Bool r_list_delete_data(RList *list, void *ptr);
__attribute__((visibility("default"))) void r_list_iter_init(RListIter *iter, RList *list);
__attribute__((visibility("default"))) void r_list_purge(RList *list);
__attribute__((visibility("default"))) void r_list_free(RList *list);
__attribute__((visibility("default"))) RListIter *r_list_item_new(void *data);
__attribute__((visibility("default"))) void r_list_split(RList *list, void *ptr);
__attribute__((visibility("default"))) void r_list_split_iter(RList *list, RListIter *iter);
__attribute__((visibility("default"))) int r_list_join(RList *list1, RList *list2);
__attribute__((visibility("default"))) void *r_list_get_n(const RList *list, int n);
__attribute__((visibility("default"))) int r_list_del_n(RList *list, int n);
__attribute__((visibility("default"))) void *r_list_get_top(const RList *list);
__attribute__((visibility("default"))) void *r_list_get_bottom(const RList *list);
__attribute__((visibility("default"))) void *r_list_pop(RList *list);
__attribute__((visibility("default"))) void *r_list_pop_head(RList *list);
__attribute__((visibility("default"))) void r_list_reverse(RList *list);
__attribute__((visibility("default"))) RList *r_list_clone(RList *list);
__attribute__((visibility("default"))) RListIter *r_list_contains(const RList *list, const void *p);
__attribute__((visibility("default"))) RListIter *r_list_find(const RList *list, const void *p, RListComparator cmp);
__attribute__((visibility("default"))) const char *r_diff_version(void);
typedef struct r_diff_op_t {
 unsigned long long a_off;
 const unsigned char *a_buf;
 int a_len;
 unsigned long long b_off;
 const unsigned char *b_buf;
 int b_len;
} RDiffOp;
typedef struct r_diff_t {
 unsigned long long off_a;
 unsigned long long off_b;
 int delta;
 void *user;
 _Bool verbose;
 int type;
 int (*callback)(struct r_diff_t *diff, void *user, RDiffOp *op);
} RDiff;
typedef int (*RDiffCallback)(RDiff *diff, void *user, RDiffOp *op);
__attribute__((visibility("default"))) RDiff *r_diff_new(void);
__attribute__((visibility("default"))) RDiff *r_diff_new_from(unsigned long long off_a, unsigned long long off_b);
__attribute__((visibility("default"))) RDiff *r_diff_free(RDiff *d);
__attribute__((visibility("default"))) int r_diff_buffers(RDiff *d, const unsigned char *a, unsigned int la, const unsigned char *b, unsigned int lb);
__attribute__((visibility("default"))) int r_diff_buffers_static(RDiff *d, const unsigned char *a, int la, const unsigned char *b, int lb);
__attribute__((visibility("default"))) int r_diff_buffers_radiff(RDiff *d, const unsigned char *a, int la, const unsigned char *b, int lb);
__attribute__((visibility("default"))) int r_diff_buffers_delta(RDiff *diff, const unsigned char *sa, int la, const unsigned char *sb, int lb);
__attribute__((visibility("default"))) int r_diff_buffers(RDiff *d, const unsigned char *a, unsigned int la, const unsigned char *b, unsigned int lb);
__attribute__((visibility("default"))) int r_diff_set_callback(RDiff *d, RDiffCallback callback, void *user);
__attribute__((visibility("default"))) _Bool r_diff_buffers_distance(RDiff *d, const unsigned char *a, unsigned int la, const unsigned char *b, unsigned int lb, unsigned int *distance, double *similarity);
__attribute__((visibility("default"))) _Bool r_diff_buffers_distance_myers(RDiff *diff, const unsigned char *a, unsigned int la, const unsigned char *b, unsigned int lb, unsigned int *distance, double *similarity);
__attribute__((visibility("default"))) _Bool r_diff_buffers_distance_levenstein(RDiff *d, const unsigned char *a, unsigned int la, const unsigned char *b, unsigned int lb, unsigned int *distance, double *similarity);
__attribute__((visibility("default"))) int r_diff_buffers_unified(RDiff *d, const unsigned char *a, int la, const unsigned char *b, int lb);
__attribute__((visibility("default"))) int r_diff_lines(const char *file1, const char *sa, int la, const char *file2, const char *sb, int lb);
__attribute__((visibility("default"))) int r_diff_set_delta(RDiff *d, int delta);
__attribute__((visibility("default"))) int r_diff_gdiff(const char *file1, const char *file2, int rad, int va);
struct btree_node {
 void *data;
 int hits; 
 struct btree_node *left;
 struct btree_node *right;
};
__attribute__((visibility("default"))) void btree_init(struct btree_node **T);
__attribute__((visibility("default"))) struct btree_node *btree_remove(struct btree_node *p, int (* del )(void *));
__attribute__((visibility("default"))) void *btree_search(struct btree_node *proot, void *x, int (* cmp )(const void *, const void *), int parent);
__attribute__((visibility("default"))) void btree_traverse(struct btree_node *proot, int reverse, void *context, void (* trv )(const void *, const void *));
__attribute__((visibility("default"))) _Bool btree_del(struct btree_node *proot, void *x, int (* cmp )(const void *, const void *), int (* del )(void *));
__attribute__((visibility("default"))) void *btree_get(struct btree_node *proot, void *x, int (* cmp )(const void *, const void *));
__attribute__((visibility("default"))) void btree_insert(struct btree_node **T, struct btree_node *p, int (* cmp )(const void *, const void *));
__attribute__((visibility("default"))) void btree_add(struct btree_node **T, void *e, int (* cmp )(const void *, const void *));
__attribute__((visibility("default"))) void btree_cleartree(struct btree_node *proot, int (* del )(void *));
typedef struct r_regex_t {
 int re_magic;
 size_t re_nsub; 
 const char *re_endp; 
 struct re_guts *re_g; 
 int re_flags;
} RRegex;
typedef struct r_regmatch_t {
 off_t rm_so; 
 off_t rm_eo; 
} RRegexMatch;
__attribute__((visibility("default"))) RRegex *r_regex_new (const char *pattern, const char *cflags);
__attribute__((visibility("default"))) int r_regex_run (const char *pattern, const char *flags, const char *text);
__attribute__((visibility("default"))) int r_regex_match (const char *pattern, const char *flags, const char *text);
__attribute__((visibility("default"))) int r_regex_flags(const char *flags);
__attribute__((visibility("default"))) int r_regex_comp(RRegex*, const char *, int);
__attribute__((visibility("default"))) size_t r_regex_error(int, const RRegex*, char *, size_t);
__attribute__((visibility("default"))) _Bool r_regex_check(const RRegex *rr, const char *str);
__attribute__((visibility("default"))) int r_regex_exec(const RRegex *, const char *, size_t, RRegexMatch __pmatch[], int);
__attribute__((visibility("default"))) void r_regex_free(RRegex *);
__attribute__((visibility("default"))) void r_regex_fini(RRegex *);
typedef struct r_skiplist_node_t {
 void *data; 
 struct r_skiplist_node_t **forward; 
} RSkipListNode;
typedef struct r_skiplist_t {
 RSkipListNode *head; 
 int list_level; 
 int size;
 RListFree freefn;
 RListComparator compare;
} RSkipList;
__attribute__((visibility("default"))) RSkipList* r_skiplist_new(RListFree freefn, RListComparator comparefn);
__attribute__((visibility("default"))) void r_skiplist_free(RSkipList *list);
__attribute__((visibility("default"))) void r_skiplist_purge(RSkipList *list);
__attribute__((visibility("default"))) RSkipListNode* r_skiplist_insert(RSkipList* list, void* data);
__attribute__((visibility("default"))) _Bool r_skiplist_delete(RSkipList* list, void* data);
__attribute__((visibility("default"))) _Bool r_skiplist_delete_node(RSkipList *list, RSkipListNode *node);
__attribute__((visibility("default"))) RSkipListNode* r_skiplist_find(RSkipList* list, void* data);
__attribute__((visibility("default"))) RSkipListNode* r_skiplist_find_geq(RSkipList* list, void* data);
__attribute__((visibility("default"))) RSkipListNode* r_skiplist_find_leq(RSkipList* list, void* data);
__attribute__((visibility("default"))) void r_skiplist_join(RSkipList *l1, RSkipList *l2);
__attribute__((visibility("default"))) void *r_skiplist_get_first(RSkipList *list);
__attribute__((visibility("default"))) void *r_skiplist_get_n(RSkipList *list, int n);
__attribute__((visibility("default"))) void* r_skiplist_get_geq(RSkipList* list, void* data);
__attribute__((visibility("default"))) void* r_skiplist_get_leq(RSkipList* list, void* data);
__attribute__((visibility("default"))) _Bool r_skiplist_empty(RSkipList *list);
__attribute__((visibility("default"))) RList *r_skiplist_to_list(RSkipList *list);
struct sched_param
{
  int sched_priority;
};
typedef unsigned long int __cpu_mask;
typedef struct
{
  __cpu_mask __bits[1024 / (8 * sizeof (__cpu_mask))];
} cpu_set_t;
extern int __sched_cpucount (size_t __setsize, const cpu_set_t *__setp)
     __attribute__ ((__nothrow__ ));
extern cpu_set_t *__sched_cpualloc (size_t __count) __attribute__ ((__nothrow__ )) ;
extern void __sched_cpufree (cpu_set_t *__set) __attribute__ ((__nothrow__ ));
extern int sched_setparam (__pid_t __pid, const struct sched_param *__param)
     __attribute__ ((__nothrow__ ));
extern int sched_getparam (__pid_t __pid, struct sched_param *__param) __attribute__ ((__nothrow__ ));
extern int sched_setscheduler (__pid_t __pid, int __policy,
          const struct sched_param *__param) __attribute__ ((__nothrow__ ));
extern int sched_getscheduler (__pid_t __pid) __attribute__ ((__nothrow__ ));
extern int sched_yield (void) __attribute__ ((__nothrow__ ));
extern int sched_get_priority_max (int __algorithm) __attribute__ ((__nothrow__ ));
extern int sched_get_priority_min (int __algorithm) __attribute__ ((__nothrow__ ));
extern int sched_rr_get_interval (__pid_t __pid, struct timespec *__t) __attribute__ ((__nothrow__ ));
struct tm
{
  int tm_sec; 
  int tm_min; 
  int tm_hour; 
  int tm_mday; 
  int tm_mon; 
  int tm_year; 
  int tm_wday; 
  int tm_yday; 
  int tm_isdst; 
  long int tm_gmtoff; 
  const char *tm_zone; 
};
struct itimerspec
  {
    struct timespec it_interval;
    struct timespec it_value;
  };
struct sigevent;
extern clock_t clock (void) __attribute__ ((__nothrow__ ));
extern time_t time (time_t *__timer) __attribute__ ((__nothrow__ ));
extern double difftime (time_t __time1, time_t __time0)
     __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern time_t mktime (struct tm *__tp) __attribute__ ((__nothrow__ ));
extern size_t strftime (char *__restrict __s, size_t __maxsize,
   const char *__restrict __format,
   const struct tm *__restrict __tp) __attribute__ ((__nothrow__ ));
extern size_t strftime_l (char *__restrict __s, size_t __maxsize,
     const char *__restrict __format,
     const struct tm *__restrict __tp,
     locale_t __loc) __attribute__ ((__nothrow__ ));
extern struct tm *gmtime (const time_t *__timer) __attribute__ ((__nothrow__ ));
extern struct tm *localtime (const time_t *__timer) __attribute__ ((__nothrow__ ));
extern struct tm *gmtime_r (const time_t *__restrict __timer,
       struct tm *__restrict __tp) __attribute__ ((__nothrow__ ));
extern struct tm *localtime_r (const time_t *__restrict __timer,
          struct tm *__restrict __tp) __attribute__ ((__nothrow__ ));
extern char *asctime (const struct tm *__tp) __attribute__ ((__nothrow__ ));
extern char *ctime (const time_t *__timer) __attribute__ ((__nothrow__ ));
extern char *asctime_r (const struct tm *__restrict __tp,
   char *__restrict __buf) __attribute__ ((__nothrow__ ));
extern char *ctime_r (const time_t *__restrict __timer,
        char *__restrict __buf) __attribute__ ((__nothrow__ ));
extern char *__tzname[2]; 
extern int __daylight; 
extern long int __timezone; 
extern char *tzname[2];
extern void tzset (void) __attribute__ ((__nothrow__ ));
extern int daylight;
extern long int timezone;
extern int stime (const time_t *__when) __attribute__ ((__nothrow__ ));
extern time_t timegm (struct tm *__tp) __attribute__ ((__nothrow__ ));
extern time_t timelocal (struct tm *__tp) __attribute__ ((__nothrow__ ));
extern int dysize (int __year) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int nanosleep (const struct timespec *__requested_time,
        struct timespec *__remaining);
extern int clock_getres (clockid_t __clock_id, struct timespec *__res) __attribute__ ((__nothrow__ ));
extern int clock_gettime (clockid_t __clock_id, struct timespec *__tp) __attribute__ ((__nothrow__ ));
extern int clock_settime (clockid_t __clock_id, const struct timespec *__tp)
     __attribute__ ((__nothrow__ ));
extern int clock_nanosleep (clockid_t __clock_id, int __flags,
       const struct timespec *__req,
       struct timespec *__rem);
extern int clock_getcpuclockid (pid_t __pid, clockid_t *__clock_id) __attribute__ ((__nothrow__ ));
extern int timer_create (clockid_t __clock_id,
    struct sigevent *__restrict __evp,
    timer_t *__restrict __timerid) __attribute__ ((__nothrow__ ));
extern int timer_delete (timer_t __timerid) __attribute__ ((__nothrow__ ));
extern int timer_settime (timer_t __timerid, int __flags,
     const struct itimerspec *__restrict __value,
     struct itimerspec *__restrict __ovalue) __attribute__ ((__nothrow__ ));
extern int timer_gettime (timer_t __timerid, struct itimerspec *__value)
     __attribute__ ((__nothrow__ ));
extern int timer_getoverrun (timer_t __timerid) __attribute__ ((__nothrow__ ));
extern int timespec_get (struct timespec *__ts, int __base)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
typedef long int __jmp_buf[8];
enum
{
  PTHREAD_CREATE_JOINABLE,
  PTHREAD_CREATE_DETACHED
};
enum
{
  PTHREAD_MUTEX_TIMED_NP,
  PTHREAD_MUTEX_RECURSIVE_NP,
  PTHREAD_MUTEX_ERRORCHECK_NP,
  PTHREAD_MUTEX_ADAPTIVE_NP
  ,
  PTHREAD_MUTEX_NORMAL = PTHREAD_MUTEX_TIMED_NP,
  PTHREAD_MUTEX_RECURSIVE = PTHREAD_MUTEX_RECURSIVE_NP,
  PTHREAD_MUTEX_ERRORCHECK = PTHREAD_MUTEX_ERRORCHECK_NP,
  PTHREAD_MUTEX_DEFAULT = PTHREAD_MUTEX_NORMAL
};
enum
{
  PTHREAD_MUTEX_STALLED,
  PTHREAD_MUTEX_STALLED_NP = PTHREAD_MUTEX_STALLED,
  PTHREAD_MUTEX_ROBUST,
  PTHREAD_MUTEX_ROBUST_NP = PTHREAD_MUTEX_ROBUST
};
enum
{
  PTHREAD_PRIO_NONE,
  PTHREAD_PRIO_INHERIT,
  PTHREAD_PRIO_PROTECT
};
enum
{
  PTHREAD_RWLOCK_PREFER_READER_NP,
  PTHREAD_RWLOCK_PREFER_WRITER_NP,
  PTHREAD_RWLOCK_PREFER_WRITER_NONRECURSIVE_NP,
  PTHREAD_RWLOCK_DEFAULT_NP = PTHREAD_RWLOCK_PREFER_READER_NP
};
enum
{
  PTHREAD_INHERIT_SCHED,
  PTHREAD_EXPLICIT_SCHED
};
enum
{
  PTHREAD_SCOPE_SYSTEM,
  PTHREAD_SCOPE_PROCESS
};
enum
{
  PTHREAD_PROCESS_PRIVATE,
  PTHREAD_PROCESS_SHARED
};
struct _pthread_cleanup_buffer
{
  void (*__routine) (void *); 
  void *__arg; 
  int __canceltype; 
  struct _pthread_cleanup_buffer *__prev; 
};
enum
{
  PTHREAD_CANCEL_ENABLE,
  PTHREAD_CANCEL_DISABLE
};
enum
{
  PTHREAD_CANCEL_DEFERRED,
  PTHREAD_CANCEL_ASYNCHRONOUS
};
extern int pthread_create (pthread_t *__restrict __newthread,
      const pthread_attr_t *__restrict __attr,
      void *(*__start_routine) (void *),
      void *__restrict __arg) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1, 3)));
extern void pthread_exit (void *__retval) __attribute__ ((__noreturn__));
extern int pthread_join (pthread_t __th, void **__thread_return);
extern int pthread_detach (pthread_t __th) __attribute__ ((__nothrow__ ));
extern pthread_t pthread_self (void) __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int pthread_equal (pthread_t __thread1, pthread_t __thread2)
  __attribute__ ((__nothrow__ )) __attribute__ ((__const__));
extern int pthread_attr_init (pthread_attr_t *__attr) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_attr_destroy (pthread_attr_t *__attr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_attr_getdetachstate (const pthread_attr_t *__attr,
     int *__detachstate)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_attr_setdetachstate (pthread_attr_t *__attr,
     int __detachstate)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_attr_getguardsize (const pthread_attr_t *__attr,
          size_t *__guardsize)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_attr_setguardsize (pthread_attr_t *__attr,
          size_t __guardsize)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_attr_getschedparam (const pthread_attr_t *__restrict __attr,
           struct sched_param *__restrict __param)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_attr_setschedparam (pthread_attr_t *__restrict __attr,
           const struct sched_param *__restrict
           __param) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_attr_getschedpolicy (const pthread_attr_t *__restrict
     __attr, int *__restrict __policy)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_attr_setschedpolicy (pthread_attr_t *__attr, int __policy)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_attr_getinheritsched (const pthread_attr_t *__restrict
      __attr, int *__restrict __inherit)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_attr_setinheritsched (pthread_attr_t *__attr,
      int __inherit)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_attr_getscope (const pthread_attr_t *__restrict __attr,
      int *__restrict __scope)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_attr_setscope (pthread_attr_t *__attr, int __scope)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_attr_getstackaddr (const pthread_attr_t *__restrict
          __attr, void **__restrict __stackaddr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2))) __attribute__ ((__deprecated__));
extern int pthread_attr_setstackaddr (pthread_attr_t *__attr,
          void *__stackaddr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1))) __attribute__ ((__deprecated__));
extern int pthread_attr_getstacksize (const pthread_attr_t *__restrict
          __attr, size_t *__restrict __stacksize)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_attr_setstacksize (pthread_attr_t *__attr,
          size_t __stacksize)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_attr_getstack (const pthread_attr_t *__restrict __attr,
      void **__restrict __stackaddr,
      size_t *__restrict __stacksize)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2, 3)));
extern int pthread_attr_setstack (pthread_attr_t *__attr, void *__stackaddr,
      size_t __stacksize) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_setschedparam (pthread_t __target_thread, int __policy,
      const struct sched_param *__param)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (3)));
extern int pthread_getschedparam (pthread_t __target_thread,
      int *__restrict __policy,
      struct sched_param *__restrict __param)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2, 3)));
extern int pthread_setschedprio (pthread_t __target_thread, int __prio)
     __attribute__ ((__nothrow__ ));
extern int pthread_once (pthread_once_t *__once_control,
    void (*__init_routine) (void)) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_setcancelstate (int __state, int *__oldstate);
extern int pthread_setcanceltype (int __type, int *__oldtype);
extern int pthread_cancel (pthread_t __th);
extern void pthread_testcancel (void);
typedef struct
{
  struct
  {
    __jmp_buf __cancel_jmp_buf;
    int __mask_was_saved;
  } __cancel_jmp_buf[1];
  void *__pad[4];
} __pthread_unwind_buf_t __attribute__ ((__aligned__));
struct __pthread_cleanup_frame
{
  void (*__cancel_routine) (void *);
  void *__cancel_arg;
  int __do_it;
  int __cancel_type;
};
extern void __pthread_register_cancel (__pthread_unwind_buf_t *__buf)
                            ;
extern void __pthread_unregister_cancel (__pthread_unwind_buf_t *__buf)
                         ;
extern void __pthread_unwind_next (__pthread_unwind_buf_t *__buf)
                             __attribute__ ((__noreturn__))
     __attribute__ ((__weak__))
     ;
struct __jmp_buf_tag;
extern int __sigsetjmp (struct __jmp_buf_tag *__env, int __savemask) __attribute__ ((__nothrow__));
extern int pthread_mutex_init (pthread_mutex_t *__mutex,
          const pthread_mutexattr_t *__mutexattr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_mutex_destroy (pthread_mutex_t *__mutex)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_mutex_trylock (pthread_mutex_t *__mutex)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int pthread_mutex_lock (pthread_mutex_t *__mutex)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int pthread_mutex_timedlock (pthread_mutex_t *__restrict __mutex,
        const struct timespec *__restrict
        __abstime) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_mutex_unlock (pthread_mutex_t *__mutex)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int pthread_mutex_getprioceiling (const pthread_mutex_t *
      __restrict __mutex,
      int *__restrict __prioceiling)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_mutex_setprioceiling (pthread_mutex_t *__restrict __mutex,
      int __prioceiling,
      int *__restrict __old_ceiling)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 3)));
extern int pthread_mutex_consistent (pthread_mutex_t *__mutex)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_mutexattr_init (pthread_mutexattr_t *__attr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_mutexattr_destroy (pthread_mutexattr_t *__attr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_mutexattr_getpshared (const pthread_mutexattr_t *
      __restrict __attr,
      int *__restrict __pshared)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_mutexattr_setpshared (pthread_mutexattr_t *__attr,
      int __pshared)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_mutexattr_gettype (const pthread_mutexattr_t *__restrict
          __attr, int *__restrict __kind)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_mutexattr_settype (pthread_mutexattr_t *__attr, int __kind)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_mutexattr_getprotocol (const pthread_mutexattr_t *
       __restrict __attr,
       int *__restrict __protocol)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_mutexattr_setprotocol (pthread_mutexattr_t *__attr,
       int __protocol)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_mutexattr_getprioceiling (const pthread_mutexattr_t *
          __restrict __attr,
          int *__restrict __prioceiling)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_mutexattr_setprioceiling (pthread_mutexattr_t *__attr,
          int __prioceiling)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_mutexattr_getrobust (const pthread_mutexattr_t *__attr,
     int *__robustness)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_mutexattr_setrobust (pthread_mutexattr_t *__attr,
     int __robustness)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_rwlock_init (pthread_rwlock_t *__restrict __rwlock,
    const pthread_rwlockattr_t *__restrict
    __attr) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_rwlock_destroy (pthread_rwlock_t *__rwlock)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_rwlock_rdlock (pthread_rwlock_t *__rwlock)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int pthread_rwlock_tryrdlock (pthread_rwlock_t *__rwlock)
  __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int pthread_rwlock_timedrdlock (pthread_rwlock_t *__restrict __rwlock,
           const struct timespec *__restrict
           __abstime) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_rwlock_wrlock (pthread_rwlock_t *__rwlock)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int pthread_rwlock_trywrlock (pthread_rwlock_t *__rwlock)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int pthread_rwlock_timedwrlock (pthread_rwlock_t *__restrict __rwlock,
           const struct timespec *__restrict
           __abstime) __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_rwlock_unlock (pthread_rwlock_t *__rwlock)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int pthread_rwlockattr_init (pthread_rwlockattr_t *__attr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_rwlockattr_destroy (pthread_rwlockattr_t *__attr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_rwlockattr_getpshared (const pthread_rwlockattr_t *
       __restrict __attr,
       int *__restrict __pshared)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_rwlockattr_setpshared (pthread_rwlockattr_t *__attr,
       int __pshared)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_rwlockattr_getkind_np (const pthread_rwlockattr_t *
       __restrict __attr,
       int *__restrict __pref)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_rwlockattr_setkind_np (pthread_rwlockattr_t *__attr,
       int __pref) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_cond_init (pthread_cond_t *__restrict __cond,
         const pthread_condattr_t *__restrict __cond_attr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_cond_destroy (pthread_cond_t *__cond)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_cond_signal (pthread_cond_t *__cond)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int pthread_cond_broadcast (pthread_cond_t *__cond)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int pthread_cond_wait (pthread_cond_t *__restrict __cond,
         pthread_mutex_t *__restrict __mutex)
     __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_cond_timedwait (pthread_cond_t *__restrict __cond,
       pthread_mutex_t *__restrict __mutex,
       const struct timespec *__restrict __abstime)
     __attribute__ ((__nonnull__ (1, 2, 3)));
extern int pthread_condattr_init (pthread_condattr_t *__attr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_condattr_destroy (pthread_condattr_t *__attr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_condattr_getpshared (const pthread_condattr_t *
     __restrict __attr,
     int *__restrict __pshared)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_condattr_setpshared (pthread_condattr_t *__attr,
     int __pshared) __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_condattr_getclock (const pthread_condattr_t *
          __restrict __attr,
          __clockid_t *__restrict __clock_id)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_condattr_setclock (pthread_condattr_t *__attr,
          __clockid_t __clock_id)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_spin_init (pthread_spinlock_t *__lock, int __pshared)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_spin_destroy (pthread_spinlock_t *__lock)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_spin_lock (pthread_spinlock_t *__lock)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int pthread_spin_trylock (pthread_spinlock_t *__lock)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int pthread_spin_unlock (pthread_spinlock_t *__lock)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int pthread_barrier_init (pthread_barrier_t *__restrict __barrier,
     const pthread_barrierattr_t *__restrict
     __attr, unsigned int __count)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_barrier_destroy (pthread_barrier_t *__barrier)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_barrier_wait (pthread_barrier_t *__barrier)
     __attribute__ ((__nothrow__)) __attribute__ ((__nonnull__ (1)));
extern int pthread_barrierattr_init (pthread_barrierattr_t *__attr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_barrierattr_destroy (pthread_barrierattr_t *__attr)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_barrierattr_getpshared (const pthread_barrierattr_t *
        __restrict __attr,
        int *__restrict __pshared)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int pthread_barrierattr_setpshared (pthread_barrierattr_t *__attr,
        int __pshared)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_key_create (pthread_key_t *__key,
          void (*__destr_function) (void *))
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1)));
extern int pthread_key_delete (pthread_key_t __key) __attribute__ ((__nothrow__ ));
extern void *pthread_getspecific (pthread_key_t __key) __attribute__ ((__nothrow__ ));
extern int pthread_setspecific (pthread_key_t __key,
    const void *__pointer) __attribute__ ((__nothrow__ )) ;
extern int pthread_getcpuclockid (pthread_t __thread_id,
      __clockid_t *__clock_id)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (2)));
extern int pthread_atfork (void (*__prepare) (void),
      void (*__parent) (void),
      void (*__child) (void)) __attribute__ ((__nothrow__ ));
typedef struct r_th_lock_t {
 int refs;
 pthread_mutex_t lock;
} RThreadLock;
typedef struct r_th_t {
 pthread_t tid;
 RThreadLock *lock;
 int (*fun)(struct r_th_t *);
 void *user; 
 int running;
 int breaked; 
 int delay; 
 int ready; 
} RThread;
typedef struct r_th_pool_t {
 int size;
 RThread **threads;
} RThreadPool;
__attribute__((visibility("default"))) RThread *r_th_new(int (*fun)(struct r_th_t *), void *user, int delay);
__attribute__((visibility("default"))) _Bool r_th_start(RThread *th, int enable);
__attribute__((visibility("default"))) int r_th_wait(RThread *th);
__attribute__((visibility("default"))) int r_th_wait_async(RThread *th);
__attribute__((visibility("default"))) void r_th_break(RThread *th);
__attribute__((visibility("default"))) void *r_th_free(RThread *th);
__attribute__((visibility("default"))) int r_th_kill(RThread *th, int force);
__attribute__((visibility("default"))) RThreadLock *r_th_lock_new(_Bool recursive);
__attribute__((visibility("default"))) int r_th_lock_wait(RThreadLock *th);
__attribute__((visibility("default"))) int r_th_lock_check(RThreadLock *thl);
__attribute__((visibility("default"))) int r_th_lock_enter(RThreadLock *thl);
__attribute__((visibility("default"))) int r_th_lock_leave(RThreadLock *thl);
__attribute__((visibility("default"))) void *r_th_lock_free(RThreadLock *thl);
typedef struct r_thread_msg_t {
 char *text;
 char done;
 char *res;
 RThread *th;
} RThreadMsg;
__attribute__((visibility("default"))) RThreadMsg* r_th_msg_new (const char *cmd, void *cb);
__attribute__((visibility("default"))) void r_th_msg_free (RThreadMsg* msg);
typedef struct r_addr_interval_t {
 unsigned long long addr;
 unsigned long long size;
} RAddrInterval;
static inline unsigned long long r_itv_begin(RAddrInterval itv) {
 return itv.addr;
}
static inline unsigned long long r_itv_end(RAddrInterval itv) {
 return itv.addr + itv.size;
}
static inline _Bool r_itv_contain(RAddrInterval itv, unsigned long long addr) {
 unsigned long long end = itv.addr + itv.size;
 return itv.addr <= addr && (!end || addr < end);
}
static inline _Bool r_itv_include(RAddrInterval itv, RAddrInterval x) {
 unsigned long long end = itv.addr + itv.size;
 return itv.addr <= x.addr && (!end || (x.addr + x.size && x.addr + x.size <= end));
}
static inline _Bool r_itv_overlap(RAddrInterval itv, RAddrInterval x) {
 unsigned long long end = itv.addr + itv.size, end1 = x.addr + x.size;
 return (!end1 || itv.addr < end1) && (!end || x.addr < end);
}
static inline _Bool r_itv_overlap2(RAddrInterval itv, unsigned long long addr, unsigned long long size) {
 return r_itv_overlap (itv, (RAddrInterval){addr, size});
}
static inline RAddrInterval r_itv_intersect(RAddrInterval itv, RAddrInterval x) {
 unsigned long long addr = (((itv.addr)>(x.addr))?(itv.addr):(x.addr)),
   end = (((itv.addr + itv.size - 1)>(x.addr + x.size - 1))?(x.addr + x.size - 1):(itv.addr + itv.size - 1)) + 1;
 return (RAddrInterval){addr, end - addr};
}
typedef long int ptrdiff_t;
typedef struct {
  long long __clang_max_align_nonce1
      __attribute__((__aligned__(__alignof__(long long))));
  long double __clang_max_align_nonce2
      __attribute__((__aligned__(__alignof__(long double))));
} max_align_t;
typedef struct r_rb_node_t {
 struct r_rb_node_t *child[2];
 _Bool red;
} RBNode;
typedef int (*RBComparator)(const void *incoming, const RBNode *in_tree);
typedef void (*RBNodeFree)(RBNode *);
typedef void (*RBNodeSum)(RBNode *);
typedef struct r_rb_iter_t {
 int len;
 RBNode *path[62];
} RBIter;
__attribute__((visibility("default"))) _Bool r_rbtree_aug_delete(RBNode **root, void *data, RBComparator cmp, RBNodeFree freefn, RBNodeSum sum);
__attribute__((visibility("default"))) void r_rbtree_aug_insert(RBNode **root, void *data, RBNode *node, RBComparator cmp, RBNodeSum sum);
__attribute__((visibility("default"))) _Bool r_rbtree_delete(RBNode **root, void *data, RBComparator cmp, RBNodeFree freefn);
__attribute__((visibility("default"))) RBNode *r_rbtree_find(RBNode *root, void *data, RBComparator cmp);
__attribute__((visibility("default"))) void r_rbtree_free(RBNode *root, RBNodeFree freefn);
__attribute__((visibility("default"))) void r_rbtree_insert(RBNode **root, void *data, RBNode *node, RBComparator cmp);
__attribute__((visibility("default"))) RBNode *r_rbtree_lower_bound(RBNode *root, void *data, RBComparator cmp);
__attribute__((visibility("default"))) RBNode *r_rbtree_upper_bound(RBNode *root, void *data, RBComparator cmp);
__attribute__((visibility("default"))) RBIter r_rbtree_first(RBNode *root);
__attribute__((visibility("default"))) RBIter r_rbtree_last(RBNode *root);
__attribute__((visibility("default"))) RBIter r_rbtree_lower_bound_backward(RBNode *root, void *data, RBComparator cmp);
__attribute__((visibility("default"))) RBIter r_rbtree_lower_bound_forward(RBNode *root, void *data, RBComparator cmp);
__attribute__((visibility("default"))) RBIter r_rbtree_upper_bound_backward(RBNode *root, void *data, RBComparator cmp);
__attribute__((visibility("default"))) RBIter r_rbtree_upper_bound_forward(RBNode *root, void *data, RBComparator cmp);
__attribute__((visibility("default"))) void r_rbtree_iter_next(RBIter *it);
__attribute__((visibility("default"))) void r_rbtree_iter_prev(RBIter *it);
typedef struct r_num_big_t {
 char dgts[10000];
 int sign, last;
} RNumBig;
__attribute__((visibility("default"))) RNumBig *r_big_new(RNumBig *b);
__attribute__((visibility("default"))) void r_big_free(RNumBig *b);
__attribute__((visibility("default"))) void r_big_sub(RNumBig *a, RNumBig *b, RNumBig *c);
__attribute__((visibility("default"))) void r_big_print(RNumBig *n);
__attribute__((visibility("default"))) void r_big_set(RNumBig *a, RNumBig *b);
__attribute__((visibility("default"))) void r_big_set_st(RNumBig *n, int v);
__attribute__((visibility("default"))) void r_big_set_st64(RNumBig *n, long long v);
__attribute__((visibility("default"))) void r_big_set_str(RNumBig *n, const char *str);
__attribute__((visibility("default"))) void r_big_add(RNumBig *c, RNumBig *a, RNumBig *b);
__attribute__((visibility("default"))) void r_big_sub(RNumBig *c, RNumBig *a, RNumBig *b);
__attribute__((visibility("default"))) int r_big_cmp(RNumBig *a, RNumBig *b);
__attribute__((visibility("default"))) int r_big_cmp_st(RNumBig *n, int v);
__attribute__((visibility("default"))) void r_big_shift(RNumBig *n, int d);
__attribute__((visibility("default"))) void r_big_mul(RNumBig *c, RNumBig *a, RNumBig *b);
__attribute__((visibility("default"))) void r_big_mul_ut(RNumBig *c, RNumBig *a, unsigned int b);
__attribute__((visibility("default"))) void r_big_div(RNumBig *c, RNumBig *a, RNumBig *b);
__attribute__((visibility("default"))) void r_big_div_ut(RNumBig *a, RNumBig *b, unsigned int c);
__attribute__((visibility("default"))) int r_big_divisible_ut(RNumBig *n, unsigned int v);
__attribute__((visibility("default"))) void r_big_mod(RNumBig *c, RNumBig *a, RNumBig *b);
__attribute__((visibility("default"))) int r_base64_encode(char *bout, const unsigned char *bin, int len);
__attribute__((visibility("default"))) int r_base64_decode(unsigned char *bout, const char *bin, int len);
__attribute__((visibility("default"))) unsigned char *r_base64_decode_dyn(const char *in, int len);
__attribute__((visibility("default"))) char *r_base64_encode_dyn(const char *str, int len);
__attribute__((visibility("default"))) int r_base91_encode(char *bout, const unsigned char *bin, int len);
__attribute__((visibility("default"))) int r_base91_decode(unsigned char *bout, const char *bin, int len);
typedef struct r_mmap_t {
 unsigned char *buf;
 unsigned long long base;
 int len;
 int fd;
 int rw;
} RMmap;
typedef struct r_mem_pool_t {
 unsigned char **nodes;
 int ncount;
 int npool;
 int nodesize;
 int poolsize;
 int poolcount;
} RMemoryPool;
__attribute__((visibility("default"))) unsigned long long r_mem_get_num(const unsigned char *b, int size);
__attribute__((visibility("default"))) RMemoryPool* r_mem_pool_deinit(RMemoryPool *pool);
__attribute__((visibility("default"))) RMemoryPool *r_mem_pool_new(int nodesize, int poolsize, int poolcount);
__attribute__((visibility("default"))) RMemoryPool *r_mem_pool_free(RMemoryPool *pool);
__attribute__((visibility("default"))) void* r_mem_pool_alloc(RMemoryPool *pool);
__attribute__((visibility("default"))) void *r_mem_dup(void *s, int l);
__attribute__((visibility("default"))) void *r_mem_alloc(int sz);
__attribute__((visibility("default"))) void r_mem_free(void *);
__attribute__((visibility("default"))) void r_mem_reverse(unsigned char *b, int l);
__attribute__((visibility("default"))) int r_mem_protect(void *ptr, int size, const char *prot);
__attribute__((visibility("default"))) int r_mem_set_num(unsigned char *dest, int dest_size, unsigned long long num);
__attribute__((visibility("default"))) int r_mem_eq(unsigned char *a, unsigned char *b, int len);
__attribute__((visibility("default"))) void r_mem_copybits(unsigned char *dst, const unsigned char *src, int bits);
__attribute__((visibility("default"))) void r_mem_copybits(unsigned char *dst, const unsigned char *src, int bits);
__attribute__((visibility("default"))) void r_mem_copybits_delta(unsigned char *dst, int doff, const unsigned char *src, int soff, int bits);
__attribute__((visibility("default"))) void r_mem_copyloop(unsigned char *dest, const unsigned char *orig, int dsize, int osize);
__attribute__((visibility("default"))) void r_mem_swaporcopy(unsigned char *dest, const unsigned char *src, int len, _Bool big_endian);
__attribute__((visibility("default"))) void r_mem_swapendian(unsigned char *dest, const unsigned char *orig, int size);
__attribute__((visibility("default"))) int r_mem_cmp_mask(const unsigned char *dest, const unsigned char *orig, const unsigned char *mask, int len);
__attribute__((visibility("default"))) const unsigned char *r_mem_mem(const unsigned char *haystack, int hlen, const unsigned char *needle, int nlen);
__attribute__((visibility("default"))) const unsigned char *r_mem_mem_aligned(const unsigned char *haystack, int hlen, const unsigned char *needle, int nlen, int align);
__attribute__((visibility("default"))) int r_mem_count(const unsigned char **addr);
__attribute__((visibility("default"))) _Bool r_mem_is_printable (const unsigned char *a, int la);
__attribute__((visibility("default"))) _Bool r_mem_is_zero(const unsigned char *b, int l);
typedef struct r_buf_t {
 unsigned char *buf;
 unsigned long long length;
 long long cur;
 unsigned long long base;
 RMmap *mmap;
 _Bool empty;
 _Bool ro; 
 int fd;
 int Oxff;
 RList *sparse;
} RBuffer;
typedef struct r_buf_cache_t {
        unsigned long long from;
        unsigned long long to;
        int size;
        unsigned char *data;
        unsigned char *odata;
        int written;
} RBufferSparse;
__attribute__((visibility("default"))) RBuffer *r_buf_new(void);
__attribute__((visibility("default"))) RBuffer *r_buf_new_with_bytes(const unsigned char* bytes, unsigned long long len);
__attribute__((visibility("default"))) RBuffer *r_buf_new_with_string (const char *msg);
__attribute__((visibility("default"))) RBuffer *r_buf_new_with_pointers(const unsigned char *bytes, unsigned long long len);
__attribute__((visibility("default"))) RBuffer *r_buf_new_with_buf(RBuffer *b);
__attribute__((visibility("default"))) RBuffer *r_buf_new_file(const char *file, _Bool newFile);
__attribute__((visibility("default"))) RBuffer *r_buf_new_slurp(const char *file);
__attribute__((visibility("default"))) RBuffer *r_buf_new_empty (unsigned long long len);
__attribute__((visibility("default"))) RBuffer *r_buf_mmap(const char *file, int flags);
__attribute__((visibility("default"))) RBuffer *r_buf_new_sparse(unsigned char Oxff);
__attribute__((visibility("default"))) _Bool r_buf_dump (RBuffer *buf, const char *file);
__attribute__((visibility("default"))) _Bool r_buf_set_bits(RBuffer *b, unsigned long long at, const unsigned char* buf, int bitoff, int count);
__attribute__((visibility("default"))) int r_buf_set_bytes(RBuffer *b, const unsigned char *buf, unsigned long long length);
__attribute__((visibility("default"))) int r_buf_set_bytes_steal(RBuffer *b, const unsigned char *buf, unsigned long long length);
__attribute__((visibility("default"))) int r_buf_append_string(RBuffer *b, const char *str);
__attribute__((visibility("default"))) _Bool r_buf_append_buf(RBuffer *b, RBuffer *a);
__attribute__((visibility("default"))) _Bool r_buf_append_bytes(RBuffer *b, const unsigned char *buf, int length);
__attribute__((visibility("default"))) _Bool r_buf_append_nbytes(RBuffer *b, int length);
__attribute__((visibility("default"))) _Bool r_buf_append_ut32(RBuffer *b, unsigned int n);
__attribute__((visibility("default"))) _Bool r_buf_append_ut64(RBuffer *b, unsigned long long n);
__attribute__((visibility("default"))) _Bool r_buf_append_ut16(RBuffer *b, unsigned short n);
__attribute__((visibility("default"))) _Bool r_buf_prepend_bytes(RBuffer *b, const unsigned char *buf, int length);
__attribute__((visibility("default"))) char *r_buf_to_string(RBuffer *b);
__attribute__((visibility("default"))) unsigned char *r_buf_get_at(RBuffer *b, unsigned long long addr, int *len);
__attribute__((visibility("default"))) int r_buf_read_at(RBuffer *b, unsigned long long addr, unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_buf_seek(RBuffer *b, long long addr, int whence);
__attribute__((visibility("default"))) int r_buf_fread_at(RBuffer *b, unsigned long long addr, unsigned char *buf, const char *fmt, int n);
__attribute__((visibility("default"))) int r_buf_write_at(RBuffer *b, unsigned long long addr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_buf_fwrite_at(RBuffer *b, unsigned long long addr, unsigned char *buf, const char *fmt, int n);
__attribute__((visibility("default"))) void r_buf_free(RBuffer *b);
__attribute__((visibility("default"))) char *r_buf_free_to_string(RBuffer *b);
__attribute__((visibility("default"))) const unsigned char *r_buf_buffer(RBuffer *b);
__attribute__((visibility("default"))) unsigned long long r_buf_size(RBuffer *b);
__attribute__((visibility("default"))) _Bool r_buf_resize(RBuffer *b, unsigned long long newsize);
typedef struct r_bitmap_t {
 int length;
 unsigned long long *bitmap;
} RBitmap;
__attribute__((visibility("default"))) RBitmap *r_bitmap_new(size_t len);
__attribute__((visibility("default"))) void r_bitmap_set_bytes(RBitmap *b, const unsigned char *buf, int len);
__attribute__((visibility("default"))) void r_bitmap_free(RBitmap *b);
__attribute__((visibility("default"))) void r_bitmap_set(RBitmap *b, size_t bit);
__attribute__((visibility("default"))) void r_bitmap_unset(RBitmap *b, size_t bit);
__attribute__((visibility("default"))) int r_bitmap_test(RBitmap *b, size_t bit);
typedef struct r_constr_t {
 char *b;
 int l;
 int i;
} RConstr;
__attribute__((visibility("default"))) RConstr* r_constr_new(int size);
__attribute__((visibility("default"))) void r_constr_free(RConstr *c);
__attribute__((visibility("default"))) const char *r_constr_get(RConstr *c, const char *str);
__attribute__((visibility("default"))) const char *r_constr_append(RConstr *c, const char *str);
__attribute__((visibility("default"))) const char *r_constr_add(RConstr *c, const char *str);
__attribute__((visibility("default"))) char* r_debruijn_pattern(int size, int start, const char* charset);
__attribute__((visibility("default"))) int r_debruijn_offset(unsigned long long value, _Bool is_big_endian);
typedef struct r_cache_t {
 unsigned long long base;
 unsigned char *buf;
 unsigned long long len;
} RCache;
typedef struct r_prof_t {
 struct timeval begin;
 double result;
} RProfile;
__attribute__((visibility("default"))) RCache* r_cache_new(void);
__attribute__((visibility("default"))) void r_cache_free(RCache *c);
__attribute__((visibility("default"))) const unsigned char* r_cache_get(RCache *c, unsigned long long addr, int *len);
__attribute__((visibility("default"))) int r_cache_set(RCache *c, unsigned long long addr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) void r_cache_flush(RCache *c);
__attribute__((visibility("default"))) void r_prof_start(RProfile *p);
__attribute__((visibility("default"))) double r_prof_end(RProfile *p);
typedef struct des_context_t {
    unsigned int round_key_lo[16]; 
    unsigned int round_key_hi[16]; 
    int round;
} RDESContext;
__attribute__((visibility("default"))) void r_des_permute_key (unsigned int *keylo, unsigned int *keyhi);
__attribute__((visibility("default"))) void r_des_permute_block0 (unsigned int *blocklo, unsigned int *blockhi);
__attribute__((visibility("default"))) void r_des_permute_block1 (unsigned int *blocklo, unsigned int *blockhi);
__attribute__((visibility("default"))) void r_des_round_key (int i, unsigned int *keylo, unsigned int *keyhi, unsigned int *deskeylo, unsigned int *deskeyhi);
__attribute__((visibility("default"))) void r_des_round (unsigned int *buflo, unsigned int *bufhi, unsigned int *roundkeylo, unsigned int *roundkeyhi);
__attribute__((visibility("default"))) int r_file_is_abspath(const char *file);
__attribute__((visibility("default"))) _Bool r_file_truncate(const char *filename, unsigned long long newsize);
__attribute__((visibility("default"))) unsigned long long r_file_size(const char *str);
__attribute__((visibility("default"))) char *r_file_root(const char *root, const char *path);
__attribute__((visibility("default"))) _Bool r_file_is_directory(const char *str);
__attribute__((visibility("default"))) _Bool r_file_is_regular(const char *str);
__attribute__((visibility("default"))) RMmap *r_file_mmap(const char *file, _Bool rw, unsigned long long base);
__attribute__((visibility("default"))) int r_file_mmap_read(const char *file, unsigned long long addr, unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_file_mmap_write(const char *file, unsigned long long addr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) void r_file_mmap_free(RMmap *m);
__attribute__((visibility("default"))) int r_file_chmod(const char *file, const char *mod, int recursive);
__attribute__((visibility("default"))) char *r_file_temp(const char *prefix);
__attribute__((visibility("default"))) char *r_file_path(const char *bin);
__attribute__((visibility("default"))) const char *r_file_basename(const char *path);
__attribute__((visibility("default"))) char *r_file_dirname(const char *path);
__attribute__((visibility("default"))) char *r_file_abspath(const char *file);
__attribute__((visibility("default"))) unsigned char *r_inflate(const unsigned char *src, int srcLen, int *srcConsumed, int *dstLen);
__attribute__((visibility("default"))) unsigned char *r_file_gzslurp(const char *str, int *outlen, int origonfail);
__attribute__((visibility("default"))) char *r_stdin_slurp(int *sz);
__attribute__((visibility("default"))) char *r_file_slurp(const char *str, int *usz);
__attribute__((visibility("default"))) char *r_file_slurp_range(const char *str, unsigned long long off, int sz, int *osz);
__attribute__((visibility("default"))) char *r_file_slurp_random_line(const char *file);
__attribute__((visibility("default"))) char *r_file_slurp_random_line_count(const char *file, int *linecount);
__attribute__((visibility("default"))) unsigned char *r_file_slurp_hexpairs(const char *str, int *usz);
__attribute__((visibility("default"))) _Bool r_file_dump(const char *file, const unsigned char *buf, int len, int append);
__attribute__((visibility("default"))) _Bool r_file_hexdump(const char *file, const unsigned char *buf, int len, int append);
__attribute__((visibility("default"))) _Bool r_file_rm(const char *file);
__attribute__((visibility("default"))) _Bool r_file_exists(const char *str);
__attribute__((visibility("default"))) _Bool r_file_fexists(const char *fmt, ...);
__attribute__((visibility("default"))) char *r_file_slurp_line(const char *file, int line, int context);
__attribute__((visibility("default"))) int r_file_mkstemp(const char *prefix, char **oname);
__attribute__((visibility("default"))) char *r_file_tmpdir(void);
__attribute__((visibility("default"))) char *r_file_readlink(const char *path);
__attribute__((visibility("default"))) _Bool r_file_copy (const char *src, const char *dst);
__attribute__((visibility("default"))) int r_hex_pair2bin(const char *arg);
__attribute__((visibility("default"))) int r_hex_str2binmask(const char *in, unsigned char *out, unsigned char *mask);
__attribute__((visibility("default"))) int r_hex_str2bin(const char *in, unsigned char *out);
__attribute__((visibility("default"))) int r_hex_bin2str(const unsigned char *in, int len, char *out);
__attribute__((visibility("default"))) char *r_hex_bin2strdup(const unsigned char *in, int len);
__attribute__((visibility("default"))) int r_hex_to_byte(unsigned char *val, unsigned char c);
__attribute__((visibility("default"))) int r_hex_str_is_valid(const char *s);
__attribute__((visibility("default"))) long long r_hex_bin_truncate(unsigned long long in, int n);
__attribute__((visibility("default"))) char *r_hex_from_c(const char *code);
__attribute__((visibility("default"))) char *r_hex_from_py(const char *code);
__attribute__((visibility("default"))) char *r_hex_from_code(const char *code);
__attribute__((visibility("default"))) char *r_hex_no_code(const char *code);
__attribute__((visibility("default"))) char *r_hex_from_py_str(char *out, const char *code);
__attribute__((visibility("default"))) char *r_hex_from_py_array(char *out, const char *code);
__attribute__((visibility("default"))) char *r_hex_from_c_str(char *out, const char **code);
__attribute__((visibility("default"))) char *r_hex_from_c_array(char *out, const char *code);
__attribute__((visibility("default"))) void r_log_msg(const char *str);
__attribute__((visibility("default"))) void r_log_error(const char *str);
__attribute__((visibility("default"))) void r_log_file(const char *str);
__attribute__((visibility("default"))) void r_log_progress(const char *str, int percent);
typedef struct r_mixed_data_t {
 int size;
 union {
  SdbHash *ht;
  SdbHash *ht64;
 } hash;
} RMixedData;
typedef struct r_mixed_t {
 RList *list;
 RMixedData *keys[256];
 unsigned long long state[256]; 
} RMixed;
__attribute__((visibility("default"))) int r_name_check(const char *name);
__attribute__((visibility("default"))) int r_name_filter(char *name, int len);
__attribute__((visibility("default"))) char *r_name_filter2(const char *name);
__attribute__((visibility("default"))) int r_name_validate_char(const char ch);
typedef struct {
 double d;
 unsigned long long n;
} RNumCalcValue;
typedef enum {
 RNCNAME, RNCNUMBER, RNCEND, RNCINC, RNCDEC,
 RNCPLUS='+', RNCMINUS='-', RNCMUL='*', RNCDIV='/', RNCMOD='%',
 RNCNEG='~', RNCAND='&', RNCORR='|', RNCXOR='^',
 RNCPRINT=';', RNCASSIGN='=', RNCLEFTP='(', RNCRIGHTP=')',
 RNCSHL='<', RNCSHR = '>'
} RNumCalcToken;
typedef struct r_num_calc_t {
 RNumCalcToken curr_tok;
 RNumCalcValue number_value;
 char string_value[1024];
 int errors;
 char oc;
 const char *calc_err;
 int calc_i;
 const char *calc_buf;
 int calc_len;
} RNumCalc;
typedef struct r_num_t {
 unsigned long long (*callback)(struct r_num_t *userptr, const char *str, int *ok);
 const char *(*cb_from_value)(struct r_num_t *userptr, unsigned long long value, int *ok);
 unsigned long long value;
 double fvalue;
 void *userptr;
 int dbz; 
 RNumCalc nc;
} RNum;
typedef unsigned long long (*RNumCallback)(struct r_num_t *self, const char *str, int *ok);
typedef const char *(*RNumCallback2)(struct r_num_t *self, unsigned long long, int *ok);
__attribute__((visibility("default"))) RNum *r_num_new(RNumCallback cb, RNumCallback2 cb2, void *ptr);
__attribute__((visibility("default"))) void r_num_free(RNum *num);
__attribute__((visibility("default"))) char *r_num_units(char *buf, unsigned long long num);
__attribute__((visibility("default"))) int r_num_conditional(RNum *num, const char *str);
__attribute__((visibility("default"))) unsigned long long r_num_calc(RNum *num, const char *str, const char **err);
__attribute__((visibility("default"))) const char *r_num_calc_index(RNum *num, const char *p);
__attribute__((visibility("default"))) unsigned long long r_num_chs(int cylinder, int head, int sector, int sectorsize);
__attribute__((visibility("default"))) int r_num_is_valid_input(RNum *num, const char *input_value);
__attribute__((visibility("default"))) unsigned long long r_num_get_input_value(RNum *num, const char *input_value);
__attribute__((visibility("default"))) const char *r_num_get_name(RNum *num, unsigned long long n);
__attribute__((visibility("default"))) char* r_num_as_string(RNum *___, unsigned long long n, _Bool printable_only);
__attribute__((visibility("default"))) unsigned long long r_num_tail(RNum *num, unsigned long long addr, const char *hex);
__attribute__((visibility("default"))) void r_num_minmax_swap(unsigned long long *a, unsigned long long *b);
__attribute__((visibility("default"))) void r_num_minmax_swap_i(int *a, int *b); 
__attribute__((visibility("default"))) unsigned long long r_num_math(RNum *num, const char *str);
__attribute__((visibility("default"))) unsigned long long r_num_get(RNum *num, const char *str);
__attribute__((visibility("default"))) int r_num_to_bits(char *out, unsigned long long num);
__attribute__((visibility("default"))) int r_num_to_trits(char *out, unsigned long long num); 
__attribute__((visibility("default"))) int r_num_rand(int max);
__attribute__((visibility("default"))) void r_num_irand(void);
__attribute__((visibility("default"))) unsigned short r_num_ntohs(unsigned short foo);
__attribute__((visibility("default"))) unsigned long long r_get_input_num_value(RNum *num, const char *input_value);
__attribute__((visibility("default"))) int r_is_valid_input_num_value(RNum *num, const char *input_value);
__attribute__((visibility("default"))) int r_num_between(RNum *num, const char *input_value);
__attribute__((visibility("default"))) _Bool r_num_is_op(const char c);
__attribute__((visibility("default"))) int r_num_str_len(const char *str);
__attribute__((visibility("default"))) int r_num_str_split(char *str);
__attribute__((visibility("default"))) RList *r_num_str_split_list(char *str);
typedef struct r_graph_node_t {
    unsigned int idx;
    void *data;
    RList *out_nodes;
    RList *in_nodes;
    RList *all_neighbours;
    RListFree free;
} RGraphNode;
typedef struct r_graph_edge_t {
    RGraphNode *from;
    RGraphNode *to;
    int nth;
} RGraphEdge;
typedef struct r_graph_t {
    unsigned int n_nodes;
    unsigned int n_edges;
    int last_index;
    RList *nodes; 
} RGraph;
typedef struct r_graph_visitor_t {
    void (*discover_node)(RGraphNode *n, struct r_graph_visitor_t *vis);
    void (*finish_node)(RGraphNode *n, struct r_graph_visitor_t *vis);
    void (*tree_edge)(const RGraphEdge *e, struct r_graph_visitor_t *vis);
    void (*back_edge)(const RGraphEdge *e, struct r_graph_visitor_t *vis);
    void (*fcross_edge)(const RGraphEdge *e, struct r_graph_visitor_t *vis);
    void *data;
} RGraphVisitor;
typedef void (*RGraphNodeCallback)(RGraphNode *n, RGraphVisitor *vis);
typedef void (*RGraphEdgeCallback)(const RGraphEdge *e, RGraphVisitor *vis);
__attribute__((visibility("default"))) RGraph *r_graph_new(void);
__attribute__((visibility("default"))) void r_graph_free(RGraph* g);
__attribute__((visibility("default"))) RGraphNode *r_graph_get_node(const RGraph *g, unsigned int idx);
__attribute__((visibility("default"))) RListIter *r_graph_node_iter(const RGraph *g, unsigned int idx);
__attribute__((visibility("default"))) void r_graph_reset(RGraph *g);
__attribute__((visibility("default"))) RGraphNode *r_graph_add_node(RGraph *g, void *data);
__attribute__((visibility("default"))) void r_graph_del_node(RGraph *g, RGraphNode *n);
__attribute__((visibility("default"))) void r_graph_add_edge(RGraph *g, RGraphNode *from, RGraphNode *to);
__attribute__((visibility("default"))) void r_graph_add_edge_at(RGraph *g, RGraphNode *from, RGraphNode *to, int nth);
__attribute__((visibility("default"))) void r_graph_del_edge(RGraph *g, RGraphNode *from, RGraphNode *to);
__attribute__((visibility("default"))) const RList *r_graph_get_neighbours(const RGraph *g, const RGraphNode *n);
__attribute__((visibility("default"))) RGraphNode *r_graph_nth_neighbour(const RGraph *g, const RGraphNode *n, int nth);
__attribute__((visibility("default"))) const RList *r_graph_innodes(const RGraph *g, const RGraphNode *n);
__attribute__((visibility("default"))) const RList *r_graph_all_neighbours(const RGraph *g, const RGraphNode *n);
__attribute__((visibility("default"))) const RList *r_graph_get_nodes(const RGraph *g);
__attribute__((visibility("default"))) int r_graph_adjacent(const RGraph *g, const RGraphNode *from, const RGraphNode *to);
__attribute__((visibility("default"))) void r_graph_dfs_node(RGraph *g, RGraphNode *n, RGraphVisitor *vis);
__attribute__((visibility("default"))) void r_graph_dfs(RGraph *g, RGraphVisitor *vis);
typedef struct r_mem_pool_factory_t {
 int limit;
 RMemoryPool **pools;
} RPoolFactory;
__attribute__((visibility("default"))) RPoolFactory *r_poolfactory_instance(void);
__attribute__((visibility("default"))) void r_poolfactory_init (int limit);
__attribute__((visibility("default"))) RPoolFactory* r_poolfactory_new(int limit);
__attribute__((visibility("default"))) void *r_poolfactory_alloc(RPoolFactory *pf, int nodesize);
__attribute__((visibility("default"))) void r_poolfactory_stats(RPoolFactory *pf);
__attribute__((visibility("default"))) void r_poolfactory_free(RPoolFactory *pf);
__attribute__((visibility("default"))) char *r_punycode_encode(const unsigned char *src, int srclen, int *dstlen);
__attribute__((visibility("default"))) char *r_punycode_decode(const char *src, int srclen, int *dstlen);
typedef struct r_queue_t {
 void **elems;
 unsigned int capacity;
 unsigned int front;
 int rear;
 unsigned int size;
} RQueue;
__attribute__((visibility("default"))) RQueue *r_queue_new(int n);
__attribute__((visibility("default"))) void r_queue_free(RQueue *q);
__attribute__((visibility("default"))) int r_queue_enqueue(RQueue *q, void *el);
__attribute__((visibility("default"))) void *r_queue_dequeue(RQueue *q);
__attribute__((visibility("default"))) int r_queue_is_empty(RQueue *q);
typedef struct r_range_tiny_t {
 int pairs;
 int count;
 unsigned long long *ranges;
} RRangeTiny;
__attribute__((visibility("default"))) RRangeTiny *r_tinyrange_new(void);
__attribute__((visibility("default"))) void r_tinyrange_init(RRangeTiny *bbr);
__attribute__((visibility("default"))) void r_tinyrange_fini(RRangeTiny *bbr);
__attribute__((visibility("default"))) _Bool r_tinyrange_in(RRangeTiny *bbr, unsigned long long at);
__attribute__((visibility("default"))) _Bool r_tinyrange_add(RRangeTiny *bbr, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) void r_tinyrange_free(RRangeTiny *bbr);
typedef struct r_range_item_t {
 unsigned long long fr;
 unsigned long long to;
 unsigned char *data;
 int datalen;
} RRangeItem;
typedef struct r_range_t {
 int count;
 int changed;
 RList *ranges;
} RRange;
__attribute__((visibility("default"))) RRange *r_range_new(void);
__attribute__((visibility("default"))) RRange *r_range_new_from_string(const char *string);
__attribute__((visibility("default"))) RRange *r_range_free(RRange *r);
__attribute__((visibility("default"))) RRangeItem *r_range_item_get(RRange *r, unsigned long long addr);
__attribute__((visibility("default"))) unsigned long long r_range_size(RRange *r);
__attribute__((visibility("default"))) int r_range_add_from_string(RRange *rgs, const char *string);
__attribute__((visibility("default"))) RRangeItem *r_range_add(RRange *rgs, unsigned long long from, unsigned long long to, int rw);
__attribute__((visibility("default"))) int r_range_sub(RRange *rgs, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) void r_range_merge(RRange *rgs, RRange *r);
__attribute__((visibility("default"))) int r_range_contains(RRange *rgs, unsigned long long addr);
__attribute__((visibility("default"))) int r_range_sort(RRange *rgs);
__attribute__((visibility("default"))) void r_range_percent(RRange *rgs);
__attribute__((visibility("default"))) int r_range_list(RRange *rgs, int rad);
__attribute__((visibility("default"))) int r_range_get_n(RRange *rgs, int n, unsigned long long *from, unsigned long long *to);
__attribute__((visibility("default"))) RRange *r_range_inverse(RRange *rgs, unsigned long long from, unsigned long long to, int flags);
__attribute__((visibility("default"))) int r_range_overlap(unsigned long long a0, unsigned long long a1, unsigned long long b0, unsigned long long b1, int *d);
__attribute__((visibility("default"))) DIR* r_sandbox_opendir(const char *path);
__attribute__((visibility("default"))) int r_sandbox_lseek(int fd, unsigned long long addr, int mode);
__attribute__((visibility("default"))) int r_sandbox_close(int fd);
__attribute__((visibility("default"))) int r_sandbox_read(int fd, unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_sandbox_write(int fd, const unsigned char *buf, int len);
__attribute__((visibility("default"))) _Bool r_sandbox_enable(_Bool e);
__attribute__((visibility("default"))) _Bool r_sandbox_disable(_Bool e);
__attribute__((visibility("default"))) int r_sandbox_system(const char *x, int fork);
__attribute__((visibility("default"))) _Bool r_sandbox_creat(const char *path, int mode);
__attribute__((visibility("default"))) int r_sandbox_open(const char *path, int mode, int perm);
__attribute__((visibility("default"))) FILE *r_sandbox_fopen(const char *path, const char *mode);
__attribute__((visibility("default"))) int r_sandbox_chdir(const char *path);
__attribute__((visibility("default"))) _Bool r_sandbox_check_path(const char *path);
__attribute__((visibility("default"))) int r_sandbox_kill(int pid, int sig);
__attribute__((visibility("default"))) int r_signal_from_string (const char *str);
__attribute__((visibility("default"))) const char* r_signal_to_string (int code);
typedef struct r_space_t {
 char *name;
 int space_idx;
 char *spaces[512];
 RList *spacestack;
 PrintfCallback cb_printf;
 void (*unset_for)(void *user, int idx);
 int (*count_for)(void *user, int idx);
 void (*rename_for)(void *user, int idx, const char *oname, const char *nname);
 void *user;
} RSpaces;
__attribute__((visibility("default"))) void r_space_new(RSpaces *s, const char *name, void (*unset_for)(void*,int), int (*count_for)(void*,int), void (*rename_for)(void*,int,const char*,const char*), void *user);
__attribute__((visibility("default"))) void r_space_free(RSpaces *s);
__attribute__((visibility("default"))) int r_space_get(RSpaces *s, const char *name);
__attribute__((visibility("default"))) const char *r_space_get_i(RSpaces *s, int idx);
__attribute__((visibility("default"))) int r_space_add(RSpaces *s, const char *name);
__attribute__((visibility("default"))) _Bool r_space_push(RSpaces *s, const char *name);
__attribute__((visibility("default"))) _Bool r_space_pop(RSpaces *s);
__attribute__((visibility("default"))) int r_space_set(RSpaces *s, const char *name);
__attribute__((visibility("default"))) int r_space_unset (RSpaces *s, const char *name);
__attribute__((visibility("default"))) int r_space_list(RSpaces *s, int mode);
__attribute__((visibility("default"))) _Bool r_space_rename (RSpaces *s, const char *oname, const char *nname);
typedef void (*RStackFree)(void *ptr);
typedef struct r_stack_t {
 void **elems;
 unsigned int n_elems;
 int top;
 RStackFree free;
} RStack;
__attribute__((visibility("default"))) RStack *r_stack_new(unsigned int n);
__attribute__((visibility("default"))) void r_stack_free(RStack *s);
__attribute__((visibility("default"))) _Bool r_stack_is_empty(RStack *s);
__attribute__((visibility("default"))) RStack *r_stack_newf(unsigned int n, RStackFree f);
__attribute__((visibility("default"))) int r_stack_push(RStack *s, void *el);
__attribute__((visibility("default"))) void *r_stack_pop(RStack *s);
__attribute__((visibility("default"))) unsigned int r_stack_size(RStack *s);
__attribute__((visibility("default"))) void *r_stack_peek(RStack *s);
typedef unsigned int wint_t;
typedef __mbstate_t mbstate_t;
struct tm;
extern wchar_t *wcscpy (wchar_t *__restrict __dest,
   const wchar_t *__restrict __src)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern wchar_t *wcsncpy (wchar_t *__restrict __dest,
    const wchar_t *__restrict __src, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern wchar_t *wcscat (wchar_t *__restrict __dest,
   const wchar_t *__restrict __src)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern wchar_t *wcsncat (wchar_t *__restrict __dest,
    const wchar_t *__restrict __src, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__nonnull__ (1, 2)));
extern int wcscmp (const wchar_t *__s1, const wchar_t *__s2)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern int wcsncmp (const wchar_t *__s1, const wchar_t *__s2, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__)) __attribute__ ((__nonnull__ (1, 2)));
extern int wcscasecmp (const wchar_t *__s1, const wchar_t *__s2) __attribute__ ((__nothrow__ ));
extern int wcsncasecmp (const wchar_t *__s1, const wchar_t *__s2,
   size_t __n) __attribute__ ((__nothrow__ ));
extern int wcscasecmp_l (const wchar_t *__s1, const wchar_t *__s2,
    locale_t __loc) __attribute__ ((__nothrow__ ));
extern int wcsncasecmp_l (const wchar_t *__s1, const wchar_t *__s2,
     size_t __n, locale_t __loc) __attribute__ ((__nothrow__ ));
extern int wcscoll (const wchar_t *__s1, const wchar_t *__s2) __attribute__ ((__nothrow__ ));
extern size_t wcsxfrm (wchar_t *__restrict __s1,
         const wchar_t *__restrict __s2, size_t __n) __attribute__ ((__nothrow__ ));
extern int wcscoll_l (const wchar_t *__s1, const wchar_t *__s2,
        locale_t __loc) __attribute__ ((__nothrow__ ));
extern size_t wcsxfrm_l (wchar_t *__s1, const wchar_t *__s2,
    size_t __n, locale_t __loc) __attribute__ ((__nothrow__ ));
extern wchar_t *wcsdup (const wchar_t *__s) __attribute__ ((__nothrow__ )) __attribute__ ((__malloc__));
extern wchar_t *wcschr (const wchar_t *__wcs, wchar_t __wc)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__));
extern wchar_t *wcsrchr (const wchar_t *__wcs, wchar_t __wc)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__));
extern size_t wcscspn (const wchar_t *__wcs, const wchar_t *__reject)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__));
extern size_t wcsspn (const wchar_t *__wcs, const wchar_t *__accept)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__));
extern wchar_t *wcspbrk (const wchar_t *__wcs, const wchar_t *__accept)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__));
extern wchar_t *wcsstr (const wchar_t *__haystack, const wchar_t *__needle)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__));
extern wchar_t *wcstok (wchar_t *__restrict __s,
   const wchar_t *__restrict __delim,
   wchar_t **__restrict __ptr) __attribute__ ((__nothrow__ ));
extern size_t wcslen (const wchar_t *__s) __attribute__ ((__nothrow__ )) __attribute__ ((__pure__));
extern size_t wcsnlen (const wchar_t *__s, size_t __maxlen)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__));
extern wchar_t *wmemchr (const wchar_t *__s, wchar_t __c, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__));
extern int wmemcmp (const wchar_t *__s1, const wchar_t *__s2, size_t __n)
     __attribute__ ((__nothrow__ )) __attribute__ ((__pure__));
extern wchar_t *wmemcpy (wchar_t *__restrict __s1,
    const wchar_t *__restrict __s2, size_t __n) __attribute__ ((__nothrow__ ));
extern wchar_t *wmemmove (wchar_t *__s1, const wchar_t *__s2, size_t __n)
     __attribute__ ((__nothrow__ ));
extern wchar_t *wmemset (wchar_t *__s, wchar_t __c, size_t __n) __attribute__ ((__nothrow__ ));
extern wint_t btowc (int __c) __attribute__ ((__nothrow__ ));
extern int wctob (wint_t __c) __attribute__ ((__nothrow__ ));
extern int mbsinit (const mbstate_t *__ps) __attribute__ ((__nothrow__ )) __attribute__ ((__pure__));
extern size_t mbrtowc (wchar_t *__restrict __pwc,
         const char *__restrict __s, size_t __n,
         mbstate_t *__restrict __p) __attribute__ ((__nothrow__ ));
extern size_t wcrtomb (char *__restrict __s, wchar_t __wc,
         mbstate_t *__restrict __ps) __attribute__ ((__nothrow__ ));
extern size_t __mbrlen (const char *__restrict __s, size_t __n,
   mbstate_t *__restrict __ps) __attribute__ ((__nothrow__ ));
extern size_t mbrlen (const char *__restrict __s, size_t __n,
        mbstate_t *__restrict __ps) __attribute__ ((__nothrow__ ));
extern size_t mbsrtowcs (wchar_t *__restrict __dst,
    const char **__restrict __src, size_t __len,
    mbstate_t *__restrict __ps) __attribute__ ((__nothrow__ ));
extern size_t wcsrtombs (char *__restrict __dst,
    const wchar_t **__restrict __src, size_t __len,
    mbstate_t *__restrict __ps) __attribute__ ((__nothrow__ ));
extern size_t mbsnrtowcs (wchar_t *__restrict __dst,
     const char **__restrict __src, size_t __nmc,
     size_t __len, mbstate_t *__restrict __ps) __attribute__ ((__nothrow__ ));
extern size_t wcsnrtombs (char *__restrict __dst,
     const wchar_t **__restrict __src,
     size_t __nwc, size_t __len,
     mbstate_t *__restrict __ps) __attribute__ ((__nothrow__ ));
extern double wcstod (const wchar_t *__restrict __nptr,
        wchar_t **__restrict __endptr) __attribute__ ((__nothrow__ ));
extern float wcstof (const wchar_t *__restrict __nptr,
       wchar_t **__restrict __endptr) __attribute__ ((__nothrow__ ));
extern long double wcstold (const wchar_t *__restrict __nptr,
       wchar_t **__restrict __endptr) __attribute__ ((__nothrow__ ));
extern long int wcstol (const wchar_t *__restrict __nptr,
   wchar_t **__restrict __endptr, int __base) __attribute__ ((__nothrow__ ));
extern unsigned long int wcstoul (const wchar_t *__restrict __nptr,
      wchar_t **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ ));
__extension__
extern long long int wcstoll (const wchar_t *__restrict __nptr,
         wchar_t **__restrict __endptr, int __base)
     __attribute__ ((__nothrow__ ));
__extension__
extern unsigned long long int wcstoull (const wchar_t *__restrict __nptr,
     wchar_t **__restrict __endptr,
     int __base) __attribute__ ((__nothrow__ ));
extern wchar_t *wcpcpy (wchar_t *__restrict __dest,
   const wchar_t *__restrict __src) __attribute__ ((__nothrow__ ));
extern wchar_t *wcpncpy (wchar_t *__restrict __dest,
    const wchar_t *__restrict __src, size_t __n)
     __attribute__ ((__nothrow__ ));
extern __FILE *open_wmemstream (wchar_t **__bufloc, size_t *__sizeloc) __attribute__ ((__nothrow__ ));
extern int fwide (__FILE *__fp, int __mode) __attribute__ ((__nothrow__ ));
extern int fwprintf (__FILE *__restrict __stream,
       const wchar_t *__restrict __format, ...)
     ;
extern int wprintf (const wchar_t *__restrict __format, ...)
     ;
extern int swprintf (wchar_t *__restrict __s, size_t __n,
       const wchar_t *__restrict __format, ...)
     __attribute__ ((__nothrow__ )) ;
extern int vfwprintf (__FILE *__restrict __s,
        const wchar_t *__restrict __format,
        __gnuc_va_list __arg)
     ;
extern int vwprintf (const wchar_t *__restrict __format,
       __gnuc_va_list __arg)
     ;
extern int vswprintf (wchar_t *__restrict __s, size_t __n,
        const wchar_t *__restrict __format,
        __gnuc_va_list __arg)
     __attribute__ ((__nothrow__ )) ;
extern int fwscanf (__FILE *__restrict __stream,
      const wchar_t *__restrict __format, ...)
     ;
extern int wscanf (const wchar_t *__restrict __format, ...)
     ;
extern int swscanf (const wchar_t *__restrict __s,
      const wchar_t *__restrict __format, ...)
     __attribute__ ((__nothrow__ )) ;
extern int fwscanf (__FILE *__restrict __stream, const wchar_t *__restrict __format, ...) __asm__ ("" "__isoc99_fwscanf")
     ;
extern int wscanf (const wchar_t *__restrict __format, ...) __asm__ ("" "__isoc99_wscanf")
     ;
extern int swscanf (const wchar_t *__restrict __s, const wchar_t *__restrict __format, ...) __asm__ ("" "__isoc99_swscanf") __attribute__ ((__nothrow__ ))
     ;
extern int vfwscanf (__FILE *__restrict __s,
       const wchar_t *__restrict __format,
       __gnuc_va_list __arg)
     ;
extern int vwscanf (const wchar_t *__restrict __format,
      __gnuc_va_list __arg)
     ;
extern int vswscanf (const wchar_t *__restrict __s,
       const wchar_t *__restrict __format,
       __gnuc_va_list __arg)
     __attribute__ ((__nothrow__ )) ;
extern int vfwscanf (__FILE *__restrict __s, const wchar_t *__restrict __format, __gnuc_va_list __arg) __asm__ ("" "__isoc99_vfwscanf")
     ;
extern int vwscanf (const wchar_t *__restrict __format, __gnuc_va_list __arg) __asm__ ("" "__isoc99_vwscanf")
     ;
extern int vswscanf (const wchar_t *__restrict __s, const wchar_t *__restrict __format, __gnuc_va_list __arg) __asm__ ("" "__isoc99_vswscanf") __attribute__ ((__nothrow__ ))
     ;
extern wint_t fgetwc (__FILE *__stream);
extern wint_t getwc (__FILE *__stream);
extern wint_t getwchar (void);
extern wint_t fputwc (wchar_t __wc, __FILE *__stream);
extern wint_t putwc (wchar_t __wc, __FILE *__stream);
extern wint_t putwchar (wchar_t __wc);
extern wchar_t *fgetws (wchar_t *__restrict __ws, int __n,
   __FILE *__restrict __stream);
extern int fputws (const wchar_t *__restrict __ws,
     __FILE *__restrict __stream);
extern wint_t ungetwc (wint_t __wc, __FILE *__stream);
extern size_t wcsftime (wchar_t *__restrict __s, size_t __maxsize,
   const wchar_t *__restrict __format,
   const struct tm *__restrict __tp) __attribute__ ((__nothrow__ ));
typedef enum {
 R_STRING_ENC_LATIN1 = 'a',
 R_STRING_ENC_UTF8 = '8',
 R_STRING_ENC_UTF16LE = 'u',
 R_STRING_ENC_UTF32LE = 'U',
 R_STRING_ENC_GUESS = 'g',
} RStrEnc;
typedef int (*RStrRangeCallback) (void *, int);
static inline void r_str_rmch(char *s, char ch) {
 for (;*s; s++) {
  if (*s==ch)
   memmove (s, s+1, strlen (s));
 }
}
__attribute__((visibility("default"))) const char *r_str_pad(const char ch, int len);
__attribute__((visibility("default"))) const char *r_str_rstr(const char *base, const char *p);
__attribute__((visibility("default"))) const char *r_str_rchr(const char *base, const char *p, int ch);
__attribute__((visibility("default"))) const char *r_str_closer_chr(const char *b, const char *s);
__attribute__((visibility("default"))) int r_str_bounds(const char *str, int *h);
__attribute__((visibility("default"))) char *r_str_crop(const char *str, unsigned int x, unsigned int y, unsigned int x2, unsigned int y2);
__attribute__((visibility("default"))) _Bool r_str_range_in(const char *r, unsigned long long addr);
__attribute__((visibility("default"))) int r_str_len_utf8(const char *s);
__attribute__((visibility("default"))) int r_str_len_utf8char(const char *s, int left);
__attribute__((visibility("default"))) void r_str_filter_zeroline(char *str, int len);
__attribute__((visibility("default"))) int r_str_write(int fd, const char *b);
__attribute__((visibility("default"))) void r_str_ncpy(char *dst, const char *src, int n);
__attribute__((visibility("default"))) void r_str_sanitize(char *c);
__attribute__((visibility("default"))) const char *r_str_casestr(const char *a, const char *b);
__attribute__((visibility("default"))) const char *r_str_firstbut(const char *s, char ch, const char *but);
__attribute__((visibility("default"))) const char *r_str_lastbut(const char *s, char ch, const char *but);
__attribute__((visibility("default"))) int r_str_split(char *str, char ch);
__attribute__((visibility("default"))) RList *r_str_split_list(char *str);
__attribute__((visibility("default"))) int *r_str_split_lines(char *str, int *count);
__attribute__((visibility("default"))) char* r_str_replace(char *str, const char *key, const char *val, int g);
__attribute__((visibility("default"))) char *r_str_replace_in(char *str, unsigned int sz, const char *key, const char *val, int g);
__attribute__((visibility("default"))) int r_str_bits(char *strout, const unsigned char *buf, int len, const char *bitz);
__attribute__((visibility("default"))) int r_str_bits64(char *strout, unsigned long long in);
__attribute__((visibility("default"))) unsigned long long r_str_bits_from_string(const char *buf, const char *bitz);
__attribute__((visibility("default"))) int r_str_rwx(const char *str);
__attribute__((visibility("default"))) int r_str_replace_char(char *s, int a, int b);
__attribute__((visibility("default"))) int r_str_replace_char_once(char *s, int a, int b);
__attribute__((visibility("default"))) const char *r_str_rwx_i(int rwx);
__attribute__((visibility("default"))) void r_str_writef(int fd, const char *fmt, ...);
__attribute__((visibility("default"))) char *r_str_arg_escape(const char *arg);
__attribute__((visibility("default"))) char **r_str_argv(const char *str, int *_argc);
__attribute__((visibility("default"))) void r_str_argv_free(char **argv);
__attribute__((visibility("default"))) char *r_str_new(const char *str);
__attribute__((visibility("default"))) int r_snprintf (char *string, int len, const char *fmt, ...);
__attribute__((visibility("default"))) _Bool r_str_is_ascii(const char *str);
__attribute__((visibility("default"))) int r_str_is_printable(const char *str);
__attribute__((visibility("default"))) _Bool r_str_is_printable_incl_newlines(const char *str);
__attribute__((visibility("default"))) char *r_str_appendlen(char *ptr, const char *string, int slen);
__attribute__((visibility("default"))) char *r_str_newf(const char *fmt, ...);
__attribute__((visibility("default"))) char *r_str_newlen(const char *str, int len);
__attribute__((visibility("default"))) const char *r_str_bool(int b);
__attribute__((visibility("default"))) const char *r_str_ansi_chrn(const char *str, int n);
__attribute__((visibility("default"))) int r_str_ansi_len(const char *str);
__attribute__((visibility("default"))) int r_str_ansi_chop(char *str, int str_len, int n);
__attribute__((visibility("default"))) int r_str_ansi_filter(char *str, char **out, int **cposs, int len);
__attribute__((visibility("default"))) char *r_str_ansi_crop(const char *str, unsigned int x, unsigned int y, unsigned int x2, unsigned int y2);
__attribute__((visibility("default"))) int r_str_word_count(const char *string);
__attribute__((visibility("default"))) int r_str_char_count(const char *string, char ch);
__attribute__((visibility("default"))) char *r_str_word_get0set(char *stra, int stralen, int idx, const char *newstr, int *newlen);
__attribute__((visibility("default"))) int r_str_word_set0(char *str);
__attribute__((visibility("default"))) int r_str_word_set0_stack(char *str);
__attribute__((visibility("default"))) const char *r_str_word_get0(const char *str, int idx);
__attribute__((visibility("default"))) char *r_str_word_get_first(const char *string);
__attribute__((visibility("default"))) char *r_str_chop(char *str);
__attribute__((visibility("default"))) const char *r_str_chop_ro(const char *str);
__attribute__((visibility("default"))) char *r_str_trim_head(char *str);
__attribute__((visibility("default"))) const char *r_str_trim_const(const char *str);
__attribute__((visibility("default"))) char *r_str_trim_tail(char *str);
__attribute__((visibility("default"))) char *r_str_trim_head_tail(char *str);
__attribute__((visibility("default"))) unsigned int r_str_hash(const char *str);
__attribute__((visibility("default"))) unsigned long long r_str_hash64(const char *str);
__attribute__((visibility("default"))) char *r_str_clean(char *str);
__attribute__((visibility("default"))) const char *r_str_nstr(const char *from, const char *to, int size);
__attribute__((visibility("default"))) const char *r_str_lchr(const char *str, char chr);
__attribute__((visibility("default"))) const char *r_sub_str_lchr(const char *str, int start, int end, char chr);
__attribute__((visibility("default"))) const char *r_sub_str_rchr(const char *str, int start, int end, char chr);
__attribute__((visibility("default"))) char *r_str_ichr(char *str, char chr);
__attribute__((visibility("default"))) int r_str_ccmp(const char *dst, const char *orig, int ch);
__attribute__((visibility("default"))) int r_str_cmp(const char *dst, const char *orig, int len);
__attribute__((visibility("default"))) int r_str_ccpy(char *dst, char *orig, int ch);
__attribute__((visibility("default"))) const char *r_str_get(const char *str);
__attribute__((visibility("default"))) const char *r_str_get2(const char *str);
__attribute__((visibility("default"))) char *r_str_ndup(const char *ptr, int len);
__attribute__((visibility("default"))) char *r_str_dup(char *ptr, const char *string);
__attribute__((visibility("default"))) void *r_str_free(void *ptr);
__attribute__((visibility("default"))) int r_str_inject(char *begin, char *end, char *str, int maxlen);
__attribute__((visibility("default"))) int r_str_delta(char *p, char a, char b);
__attribute__((visibility("default"))) void r_str_filter(char *str, int len);
__attribute__((visibility("default"))) const char * r_str_tok(const char *str1, const char b, size_t len);
__attribute__((visibility("default"))) wchar_t *r_str_mb_to_wc(const char *buf);
__attribute__((visibility("default"))) char *r_str_wc_to_mb(const wchar_t *buf);
__attribute__((visibility("default"))) wchar_t *r_str_mb_to_wc_l(const char *buf, int len);
__attribute__((visibility("default"))) char *r_str_wc_to_mb_l(const wchar_t *buf, int len);
typedef void(*str_operation)(char *c);
__attribute__((visibility("default"))) int r_str_do_until_token(str_operation op, char *str, const char tok);
__attribute__((visibility("default"))) const char *r_str_const(const char *ptr);
__attribute__((visibility("default"))) const char *r_str_const_at(char ***consts, const char *ptr);
__attribute__((visibility("default"))) void r_str_const_free(char ***consts);
__attribute__((visibility("default"))) void r_str_reverse(char *str);
__attribute__((visibility("default"))) int r_str_re_match(const char *str, const char *reg);
__attribute__((visibility("default"))) int r_str_re_replace(const char *str, const char *reg, const char *sub);
__attribute__((visibility("default"))) int r_str_unescape(char *buf);
__attribute__((visibility("default"))) char *r_str_escape(const char *buf);
__attribute__((visibility("default"))) char *r_str_escape_dot(const char *buf);
__attribute__((visibility("default"))) char *r_str_escape_latin1(const char *buf, _Bool show_asciidot, _Bool esc_bslash);
__attribute__((visibility("default"))) char *r_str_escape_utf8(const char *buf, _Bool show_asciidot, _Bool esc_bslash);
__attribute__((visibility("default"))) char *r_str_escape_utf16le(const char *buf, int buf_size, _Bool show_asciidot);
__attribute__((visibility("default"))) char *r_str_escape_utf32le(const char *buf, int buf_size, _Bool show_asciidot);
__attribute__((visibility("default"))) void r_str_uri_decode(char *buf);
__attribute__((visibility("default"))) char *r_str_uri_encode(const char *buf);
__attribute__((visibility("default"))) char *r_str_utf16_decode(const unsigned char *s, int len);
__attribute__((visibility("default"))) int r_str_utf16_to_utf8(unsigned char *dst, int len_dst, const unsigned char *src, int len_src, int little_endian);
__attribute__((visibility("default"))) char *r_str_utf16_encode(const char *s, int len);
__attribute__((visibility("default"))) char *r_str_home(const char *str);
__attribute__((visibility("default"))) int r_str_nlen(const char *s, int n);
__attribute__((visibility("default"))) int r_str_nlen_w(const char *s, int n);
__attribute__((visibility("default"))) int r_wstr_clen(const char *s);
__attribute__((visibility("default"))) char *r_str_prefix(char *ptr, const char *string);
__attribute__((visibility("default"))) char *r_str_prefix_all(char *s, const char *pfx);
__attribute__((visibility("default"))) char *r_str_append(char *ptr, const char *string);
__attribute__((visibility("default"))) char *r_str_appendf(char *ptr, const char *fmt, ...);
__attribute__((visibility("default"))) char *r_str_appendch(char *x, char y);
__attribute__((visibility("default"))) void r_str_case(char *str, _Bool up);
__attribute__((visibility("default"))) void r_str_chop_path(char *s);
__attribute__((visibility("default"))) unsigned char r_str_contains_macro(const char *input_value);
__attribute__((visibility("default"))) void r_str_truncate_cmd(char *string);
__attribute__((visibility("default"))) char* r_str_replace_thunked(char *str, char *clean, int *thunk, int clen,
      const char *key, const char *val, int g);
__attribute__((visibility("default"))) _Bool r_str_glob(const char *str, const char *glob);
__attribute__((visibility("default"))) int r_str_binstr2bin(const char *str, unsigned char *out, int outlen);
__attribute__((visibility("default"))) char *r_str_between(const char *str, const char *prefix, const char *suffix);
__attribute__((visibility("default"))) _Bool r_str_startswith(const char *str, const char *needle);
__attribute__((visibility("default"))) _Bool r_str_endswith(const char *str, const char *needle);
__attribute__((visibility("default"))) _Bool r_str_isnumber (const char *str);
__attribute__((visibility("default"))) const char *r_str_last (const char *in, const char *ch);
__attribute__((visibility("default"))) char* r_str_highlight(char *str, const char *word, const char *color);
__attribute__((visibility("default"))) char *r_qrcode_gen(const unsigned char *text, int len, _Bool utf8, _Bool inverted);
__attribute__((visibility("default"))) char *r_str_from_ut64(unsigned long long val);
typedef struct {
 int len;
 char *ptr;
 int ptrlen;
 char buf[64];
} RStrBuf;
__attribute__((visibility("default"))) RStrBuf *r_strbuf_new(const char *s);
__attribute__((visibility("default"))) _Bool r_strbuf_set(RStrBuf *sb, const char *s);
__attribute__((visibility("default"))) _Bool r_strbuf_setf(RStrBuf *sb, const char *fmt, ...);
__attribute__((visibility("default"))) int r_strbuf_append(RStrBuf *sb, const char *s);
__attribute__((visibility("default"))) int r_strbuf_append_n(RStrBuf *sb, const char *s, int l);
__attribute__((visibility("default"))) int r_strbuf_appendf(RStrBuf *sb, const char *fmt, ...);
__attribute__((visibility("default"))) char *r_strbuf_get(RStrBuf *sb);
__attribute__((visibility("default"))) char *r_strbuf_drain(RStrBuf *sb);
__attribute__((visibility("default"))) void r_strbuf_free(RStrBuf *sb);
__attribute__((visibility("default"))) void r_strbuf_fini(RStrBuf *sb);
__attribute__((visibility("default"))) void r_strbuf_init(RStrBuf *sb);
typedef struct {
 char *str;
 int len;
 int size;
} RStrpool;
__attribute__((visibility("default"))) RStrpool* r_strpool_new(int sz);
__attribute__((visibility("default"))) char *r_strpool_alloc(RStrpool *p, int l);
__attribute__((visibility("default"))) int r_strpool_memcat(RStrpool *p, const char *s, int len);
__attribute__((visibility("default"))) int r_strpool_ansi_chop(RStrpool *p, int n);
__attribute__((visibility("default"))) int r_strpool_append(RStrpool *p, const char *s);
__attribute__((visibility("default"))) void r_strpool_free(RStrpool *p);
__attribute__((visibility("default"))) int r_strpool_fit(RStrpool *p);
__attribute__((visibility("default"))) char *r_strpool_get(RStrpool *p, int index);
__attribute__((visibility("default"))) char *r_strpool_get_i(RStrpool *p, int index);
__attribute__((visibility("default"))) int r_strpool_get_index(RStrpool *p, const char *s);
__attribute__((visibility("default"))) char *r_strpool_next(RStrpool *p, int index);
__attribute__((visibility("default"))) char *r_strpool_slice(RStrpool *p, int index);
__attribute__((visibility("default"))) char *r_strpool_empty(RStrpool *p);
enum {
 R_SYS_BITS_8 = 1,
 R_SYS_BITS_16 = 2,
 R_SYS_BITS_32 = 4,
 R_SYS_BITS_64 = 8,
};
__attribute__((visibility("default"))) char **r_sys_get_environ(void);
__attribute__((visibility("default"))) void r_sys_set_environ(char **e);
__attribute__((visibility("default"))) unsigned long long r_sys_now(void);
__attribute__((visibility("default"))) int r_sys_fork(void);
__attribute__((visibility("default"))) _Bool r_sys_stop(void);
__attribute__((visibility("default"))) char *r_sys_pid_to_path(int pid);
__attribute__((visibility("default"))) int r_sys_run(const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_sys_getpid(void);
__attribute__((visibility("default"))) int r_sys_crash_handler(const char *cmd);
__attribute__((visibility("default"))) const char *r_sys_arch_str(int arch);
__attribute__((visibility("default"))) int r_sys_arch_id(const char *arch);
__attribute__((visibility("default"))) _Bool r_sys_arch_match(const char *archstr, const char *arch);
__attribute__((visibility("default"))) RList *r_sys_dir(const char *path);
__attribute__((visibility("default"))) void r_sys_perror_str(const char *fun);
__attribute__((visibility("default"))) _Bool r_sys_mkdir(const char *dir);
__attribute__((visibility("default"))) _Bool r_sys_mkdirp(const char *dir);
__attribute__((visibility("default"))) int r_sys_sleep(int secs);
__attribute__((visibility("default"))) int r_sys_usleep(int usecs);
__attribute__((visibility("default"))) char *r_sys_getenv(const char *key);
__attribute__((visibility("default"))) int r_sys_setenv(const char *key, const char *value);
__attribute__((visibility("default"))) int r_sys_clearenv(void);
__attribute__((visibility("default"))) char *r_sys_whoami(char *buf);
__attribute__((visibility("default"))) char *r_sys_getdir(void);
__attribute__((visibility("default"))) int r_sys_chdir(const char *s);
__attribute__((visibility("default"))) int r_sys_cmd_str_full(const char *cmd, const char *input, char **output, int *len, char **sterr);
__attribute__((visibility("default"))) int r_sys_truncate(const char *file, int sz);
__attribute__((visibility("default"))) int r_sys_cmd(const char *cmd);
__attribute__((visibility("default"))) int r_sys_cmdbg(const char *cmd);
__attribute__((visibility("default"))) int r_sys_cmdf(const char *fmt, ...);
__attribute__((visibility("default"))) char *r_sys_cmd_str(const char *cmd, const char *input, int *len);
__attribute__((visibility("default"))) char *r_sys_cmd_strf(const char *cmd, ...);
__attribute__((visibility("default"))) void r_sys_backtrace(void);
__attribute__((visibility("default"))) _Bool r_sys_tts(const char *txt, _Bool bg);
__attribute__((visibility("default"))) char *r_syscmd_ls(const char *input);
__attribute__((visibility("default"))) char *r_syscmd_cat(const char *file);
__attribute__((visibility("default"))) char *r_syscmd_mkdir(const char *dir);
__attribute__((visibility("default"))) _Bool r_syscmd_mv(const char *input);
struct r_tree_t;
typedef struct r_tree_node_t {
 struct r_tree_node_t *parent;
 struct r_tree_t *tree;
 RList *children; 
 unsigned int n_children;
 int depth;
 RListFree free;
 void *data;
} RTreeNode;
typedef struct r_tree_t {
 RTreeNode *root;
} RTree;
typedef struct r_tree_visitor_t {
 void (*pre_visit)(RTreeNode *, struct r_tree_visitor_t *);
 void (*post_visit)(RTreeNode *, struct r_tree_visitor_t *);
 void (*discover_child)(RTreeNode *, struct r_tree_visitor_t *);
 void *data;
} RTreeVisitor;
typedef void (*RTreeNodeVisitCb)(RTreeNode *n, RTreeVisitor *vis);
__attribute__((visibility("default"))) RTree *r_tree_new(void);
__attribute__((visibility("default"))) RTreeNode *r_tree_add_node(RTree *t, RTreeNode *node, void *child_data);
__attribute__((visibility("default"))) void r_tree_reset(RTree *t);
__attribute__((visibility("default"))) void r_tree_free(RTree *t);
__attribute__((visibility("default"))) void r_tree_dfs(RTree *t, RTreeVisitor *vis);
__attribute__((visibility("default"))) void r_tree_bfs(RTree *t, RTreeVisitor *vis);
__attribute__((visibility("default"))) const unsigned char *r_uleb128(const unsigned char *data, int datalen, unsigned long long *v);
__attribute__((visibility("default"))) const unsigned char *r_uleb128_decode(const unsigned char *data, int *datalen, unsigned long long *v);
__attribute__((visibility("default"))) const unsigned char *r_uleb128_encode(const unsigned long long s, int *len);
__attribute__((visibility("default"))) const unsigned char *r_leb128(const unsigned char *data, long long *v);
__attribute__((visibility("default"))) long long r_sleb128(const unsigned char **data, const unsigned char *end);
__attribute__((visibility("default"))) size_t read_u32_leb128(const unsigned char *p, const unsigned char *max, unsigned int *out_val);
__attribute__((visibility("default"))) size_t read_i32_leb128(const unsigned char *p, const unsigned char *max, int *out_val);
__attribute__((visibility("default"))) size_t read_u64_leb128(const unsigned char *p, const unsigned char *max, unsigned long long *out_val);
__attribute__((visibility("default"))) size_t read_i64_leb128(const unsigned char *p, const unsigned char *max, long long *out_val);
typedef struct { unsigned int from, to; const char *name; } RUtfBlock;
typedef unsigned int RRune;
__attribute__((visibility("default"))) int r_utf8_encode(unsigned char *ptr, const RRune ch);
__attribute__((visibility("default"))) int r_utf8_decode(const unsigned char *ptr, int ptrlen, RRune *ch);
__attribute__((visibility("default"))) int r_utf8_encode_str(const RRune *str, unsigned char *dst, const int dst_length);
__attribute__((visibility("default"))) int r_utf8_size(const unsigned char *ptr);
__attribute__((visibility("default"))) int r_utf8_strlen(const unsigned char *str);
__attribute__((visibility("default"))) int r_isprint(const RRune c);
__attribute__((visibility("default"))) char *r_utf16_to_utf8(const wchar_t *wc);
__attribute__((visibility("default"))) const char *r_utf_block_name(int idx);
__attribute__((visibility("default"))) wchar_t *r_utf8_to_utf16(const char *cstring);
__attribute__((visibility("default"))) int r_utf_block_idx (RRune ch);
__attribute__((visibility("default"))) int *r_utf_block_list (const unsigned char *str);
__attribute__((visibility("default"))) int r_utf16le_decode(const unsigned char *ptr, int ptrlen, RRune *ch);
__attribute__((visibility("default"))) int r_utf32le_decode(const unsigned char *ptr, int ptrlen, RRune *ch);
typedef struct r_id_pool_t {
 unsigned int start_id;
 unsigned int last_id;
 unsigned int next_id;
 RQueue *freed_ids;
} RIDPool;
__attribute__((visibility("default"))) RIDPool *r_id_pool_new(unsigned int start_id, unsigned int last_id);
__attribute__((visibility("default"))) _Bool r_id_pool_grab_id(RIDPool *pool, unsigned int *grabber);
__attribute__((visibility("default"))) _Bool r_id_pool_kick_id(RIDPool *pool, unsigned int kick);
__attribute__((visibility("default"))) void r_id_pool_free(RIDPool *pool);
typedef struct r_id_storage_t {
 RIDPool *pool;
 void **data;
 unsigned int top_id;
 unsigned int size;
} RIDStorage;
typedef _Bool (*RIDStorageForeachCb)(void *user, void *data, unsigned int id);
__attribute__((visibility("default"))) RIDStorage *r_id_storage_new(unsigned int start_id, unsigned int last_id);
__attribute__((visibility("default"))) _Bool r_id_storage_set(RIDStorage *storage, void *data, unsigned int id);
__attribute__((visibility("default"))) _Bool r_id_storage_add(RIDStorage *storage, void *data, unsigned int *id);
__attribute__((visibility("default"))) void *r_id_storage_get(RIDStorage *storage, unsigned int id);
__attribute__((visibility("default"))) void r_id_storage_delete(RIDStorage *storage, unsigned int id);
__attribute__((visibility("default"))) void *r_id_storage_take(RIDStorage *storage, unsigned int id);
__attribute__((visibility("default"))) _Bool r_id_storage_foreach(RIDStorage *storage, RIDStorageForeachCb cb, void *user);
__attribute__((visibility("default"))) void r_id_storage_free(RIDStorage *storage);
typedef struct r_asn1_string_t {
 unsigned int length;
 const char *string;
 _Bool allocated;
} RASN1String;
typedef struct r_asn1_list_t {
 unsigned int length;
 struct r_asn1_object_t **objects;
} ASN1List;
typedef struct r_asn1_bin_t {
 unsigned int length;
 const unsigned char *binary;
} RASN1Binary;
typedef struct r_asn1_object_t {
 unsigned char klass; 
 unsigned char form; 
 unsigned char tag; 
 const unsigned char *sector; 
 unsigned int length; 
 ASN1List list; 
} RASN1Object;
__attribute__((visibility("default"))) RASN1Object *r_asn1_create_object (const unsigned char *buffer, unsigned int length);
__attribute__((visibility("default"))) RASN1Binary *r_asn1_create_binary (const unsigned char *buffer, unsigned int length);
__attribute__((visibility("default"))) RASN1String *r_asn1_stringify_bits (const unsigned char *buffer, unsigned int length);
__attribute__((visibility("default"))) RASN1String *r_asn1_stringify_utctime (const unsigned char *buffer, unsigned int length);
__attribute__((visibility("default"))) RASN1String *r_asn1_stringify_time (const unsigned char *buffer, unsigned int length);
__attribute__((visibility("default"))) RASN1String *r_asn1_stringify_integer (const unsigned char *buffer, unsigned int length);
__attribute__((visibility("default"))) RASN1String *r_asn1_stringify_string (const unsigned char *buffer, unsigned int length);
__attribute__((visibility("default"))) RASN1String *r_asn1_stringify_bytes (const unsigned char *buffer, unsigned int length);
__attribute__((visibility("default"))) RASN1String *r_asn1_stringify_boolean (const unsigned char *buffer, unsigned int length);
__attribute__((visibility("default"))) RASN1String *r_asn1_stringify_oid (const unsigned char* buffer, unsigned int length);
__attribute__((visibility("default"))) RASN1String *r_asn1_stringify_tag (RASN1Object *object);
__attribute__((visibility("default"))) RASN1String *r_asn1_stringify_object (RASN1Object *object);
void r_asn1_free_object (RASN1Object *object);
void r_asn1_free_string (RASN1String *string);
void r_asn1_free_binary (RASN1Binary *string);
typedef struct r_json_var RJSVar;
typedef struct r_json_string {
 const char* s;
 unsigned int l;
} RJSString;
typedef struct r_json_array {
 RJSVar** a;
 unsigned int l;
} RJSArray;
typedef struct r_json_object {
 RJSVar** a;
 const char** n;
 unsigned int l;
} RJSObject;
struct r_json_var {
 int type;
 unsigned int ref;
 union {
  int number;
  _Bool boolean;
  RJSArray array;
  RJSString string;
  RJSObject object;
 };
};
__attribute__((visibility("default"))) void r_json_var_free(RJSVar* var);
__attribute__((visibility("default"))) RJSVar* r_json_object_new(void);
__attribute__((visibility("default"))) RJSVar* r_json_array_new(int len);
__attribute__((visibility("default"))) RJSVar* r_json_string_new(const char* name);
__attribute__((visibility("default"))) RJSVar* r_json_number_new(int value);
__attribute__((visibility("default"))) RJSVar* r_json_boolean_new(_Bool value);
__attribute__((visibility("default"))) RJSVar* r_json_null_new(void);
__attribute__((visibility("default"))) _Bool r_json_object_add(RJSVar* object, const char* name, RJSVar* value);
__attribute__((visibility("default"))) _Bool r_json_array_add(RJSVar* array, RJSVar* value);
__attribute__((visibility("default"))) RJSVar* r_json_object_get(RJSVar* object, const char* name);
__attribute__((visibility("default"))) RJSVar* r_json_array_get(RJSVar* array, int index);
__attribute__((visibility("default"))) char* r_json_stringify(RJSVar* var, _Bool expanded);
typedef struct r_x509_validity_t {
 RASN1String *notBefore;
 RASN1String *notAfter;
} RX509Validity;
typedef struct r_x509_name_t {
 unsigned int length;
 RASN1String **oids;
 RASN1String **names;
} RX509Name;
typedef struct r_x509_algorithmidentifier_t {
 RASN1String *algorithm; 
 RASN1String *parameters; 
} RX509AlgorithmIdentifier;
typedef struct r_x509_authoritykeyidentifier_t {
 RASN1Binary *keyIdentifier;
 RX509Name authorityCertIssuer;
 RASN1Binary *authorityCertSerialNumber;
} RX509AuthorityKeyIdentifier;
typedef struct r_x509_subjectpublickeyinfo_t {
 RX509AlgorithmIdentifier algorithm;
 RASN1Binary *subjectPublicKey; 
 RASN1Binary *subjectPublicKeyExponent;
 RASN1Binary *subjectPublicKeyModule;
} RX509SubjectPublicKeyInfo;
typedef struct r_x509_extension_t {
 RASN1String *extnID; 
 _Bool critical;
 RASN1Binary *extnValue; 
} RX509Extension;
typedef struct r_x509_extensions_t {
 unsigned int length;
 RX509Extension **extensions;
} RX509Extensions;
typedef struct r_x509_tbscertificate_t {
 unsigned int version; 
 RASN1String *serialNumber; 
 RX509AlgorithmIdentifier signature;
 RX509Name issuer;
 RX509Validity validity;
 RX509Name subject;
 RX509SubjectPublicKeyInfo subjectPublicKeyInfo;
 RASN1Binary *issuerUniqueID; 
 RASN1Binary *subjectUniqueID; 
 RX509Extensions extensions;
} RX509TBSCertificate;
typedef struct r_x509_certificate_t {
 RX509TBSCertificate tbsCertificate;
 RX509AlgorithmIdentifier algorithmIdentifier;
 RASN1Binary *signature; 
} RX509Certificate;
typedef struct r_x509_crlentry {
 RASN1Binary *userCertificate; 
 RASN1String *revocationDate; 
} RX509CRLEntry;
typedef struct r_x509_certificaterevocationlist {
 RX509AlgorithmIdentifier signature;
 RX509Name issuer;
 RASN1String *lastUpdate; 
 RASN1String *nextUpdate; 
 unsigned int length;
 RX509CRLEntry **revokedCertificates;
} RX509CertificateRevocationList;
__attribute__((visibility("default"))) RX509CertificateRevocationList* r_x509_parse_crl(RASN1Object *object);
__attribute__((visibility("default"))) void r_x509_free_crl(RX509CertificateRevocationList *crl);
__attribute__((visibility("default"))) char* r_x509_crl_dump(RX509CertificateRevocationList *crl, char* buffer, unsigned int length, const char* pad);
__attribute__((visibility("default"))) RJSVar *r_x509_crl_json(RX509CertificateRevocationList *crl);
__attribute__((visibility("default"))) RX509Certificate *r_x509_parse_certificate(RASN1Object *object);
__attribute__((visibility("default"))) RX509Certificate *r_x509_parse_certificate2(const unsigned char *buffer, unsigned int length);
__attribute__((visibility("default"))) void r_x509_free_certificate(RX509Certificate* certificate);
__attribute__((visibility("default"))) char* r_x509_certificate_dump(RX509Certificate* certificate, char* buffer, unsigned int length, const char* pad);
__attribute__((visibility("default"))) RJSVar* r_x509_certificate_json(RX509Certificate *certificate);
typedef struct r_pkcs7_certificaterevocationlists_t {
 unsigned int length;
 RX509CertificateRevocationList **elements;
} RPKCS7CertificateRevocationLists;
typedef struct r_pkcs7_extendedcertificatesandcertificates_t {
 unsigned int length;
 RX509Certificate **elements;
} RPKCS7ExtendedCertificatesAndCertificates;
typedef struct r_pkcs7_digestalgorithmidentifiers_t {
 unsigned int length;
 RX509AlgorithmIdentifier **elements;
} RPKCS7DigestAlgorithmIdentifiers;
typedef struct r_pkcs7_contentinfo_t {
 RASN1String *contentType; 
 RASN1Binary *content; 
} RPKCS7ContentInfo;
typedef struct r_pkcs7_issuerandserialnumber_t {
 RX509Name issuer;
 RASN1Binary *serialNumber;
} RPKCS7IssuerAndSerialNumber;
typedef struct r_pkcs7_attribute_t {
 RASN1String *oid; 
 RASN1Binary *data; 
} RPKCS7Attribute;
typedef struct r_pkcs7_attributes_t {
 unsigned int length;
 RPKCS7Attribute **elements;
} RPKCS7Attributes;
typedef struct r_pkcs7_signerinfo_t {
 unsigned int version;
 RPKCS7IssuerAndSerialNumber issuerAndSerialNumber;
 RX509AlgorithmIdentifier digestAlgorithm;
 RPKCS7Attributes authenticatedAttributes; 
 RX509AlgorithmIdentifier digestEncryptionAlgorithm;
 RASN1Binary *encryptedDigest;
 RPKCS7Attributes unauthenticatedAttributes; 
} RPKCS7SignerInfo;
typedef struct r_pkcs7_signerinfos_t {
 unsigned int length;
 RPKCS7SignerInfo **elements;
} RPKCS7SignerInfos;
typedef struct r_pkcs7_signeddata_t {
 unsigned int version;
 RPKCS7DigestAlgorithmIdentifiers digestAlgorithms;
 RPKCS7ContentInfo contentInfo;
 RPKCS7ExtendedCertificatesAndCertificates certificates; 
 RPKCS7CertificateRevocationLists crls; 
 RPKCS7SignerInfos signerinfos;
} RPKCS7SignedData;
typedef struct r_pkcs7_container_t {
 RASN1String *contentType;
 RPKCS7SignedData signedData;
} RCMS;
__attribute__((visibility("default"))) RCMS *r_pkcs7_parse_cms(const unsigned char *buffer, unsigned int length);
__attribute__((visibility("default"))) void r_pkcs7_free_cms(RCMS* container);
__attribute__((visibility("default"))) char* r_pkcs7_cms_dump(RCMS* container);
__attribute__((visibility("default"))) RJSVar *r_pkcs7_cms_json(RCMS* container);
typedef enum {
 R_INTERVAL_UNDEFINED = 0,
 R_INTERVAL_OPEN_OPEN,
 R_INTERVAL_OPEN_CLOSED,
 R_INTERVAL_CLOSED_OPEN,
 R_INTERVAL_CLOSED_CLOSED
} RIntervalType;
typedef struct r_interval_t {
 RIntervalType type;
 unsigned long long from;
 unsigned long long to;
} RInterval;
__attribute__((visibility("default"))) _Bool r_interval_init (RInterval *interv, RIntervalType type, unsigned long long from, unsigned long long size);
__attribute__((visibility("default"))) unsigned long long r_interval_first (RInterval interv, _Bool *err);
__attribute__((visibility("default"))) unsigned long long r_interval_last (RInterval interv, _Bool *err);
__attribute__((visibility("default"))) unsigned long long r_interval_size (RInterval interv, _Bool *err);
__attribute__((visibility("default"))) unsigned long long r_interval_to_end (RInterval interv, unsigned long long from, _Bool *err);
__attribute__((visibility("default"))) unsigned long long r_interval_intersection_lower_bound (RInterval inter, RInterval val, _Bool *intersection);
__attribute__((visibility("default"))) unsigned long long r_interval_instersection_upper_bound (RInterval inter, RInterval val, _Bool *intersection);
__attribute__((visibility("default"))) _Bool r_interval_in_me (RInterval interv, unsigned long long you);
__attribute__((visibility("default"))) const char *r_util_version(void);
typedef struct r_vector_t {
 void **a;
 int len;
 int capacity;
} RVector;
typedef int (*RVectorComparator)(const void *a, const void *b);
__attribute__((visibility("default"))) void r_vector_clear(RVector *vec, void (*elem_free)(void *));
__attribute__((visibility("default"))) RVector *r_vector_clone(RVector *vec);
__attribute__((visibility("default"))) void **r_vector_contains(RVector *vec, void *x);
__attribute__((visibility("default"))) void *r_vector_delete_at(RVector *vec, int n);
__attribute__((visibility("default"))) _Bool r_vector_empty(RVector *vec);
__attribute__((visibility("default"))) void r_vector_fini(RVector *vec);
__attribute__((visibility("default"))) void r_vector_free(RVector *vec, void (*elem_free)(void *));
__attribute__((visibility("default"))) void r_vector_init(RVector *vec);
__attribute__((visibility("default"))) void **r_vector_insert(RVector *vec, int n, void *x);
__attribute__((visibility("default"))) void **r_vector_insert_range(RVector *vec, int n, void **first, void **last);
__attribute__((visibility("default"))) RVector *r_vector_new(void);
__attribute__((visibility("default"))) void *r_vector_pop(RVector *vec);
__attribute__((visibility("default"))) void *r_vector_pop_front(RVector *vec);
__attribute__((visibility("default"))) void **r_vector_push(RVector *vec, void *x);
__attribute__((visibility("default"))) void **r_vector_push_front(RVector *vec, void *x);
__attribute__((visibility("default"))) void **r_vector_reserve(RVector *vec, int capacity);
__attribute__((visibility("default"))) void **r_vector_shrink(RVector *vec);
__attribute__((visibility("default"))) void r_vector_sort(RVector *vec, RVectorComparator cmp);
__attribute__((visibility("default"))) const char *r_io_version(void);
typedef struct r_io_undos_t {
 unsigned long long off;
 int cursor;
} RIOUndos;
typedef struct r_io_undo_t {
 int s_enable;
 int w_enable;
 RList *w_list;
 int w_init;
 int idx;
 int undos; 
 int redos; 
 RIOUndos seek[64];
} RIOUndo;
typedef struct r_io_undo_w_t {
 int set;
 unsigned long long off;
 unsigned char *o; 
 unsigned char *n; 
 int len; 
} RIOUndoWrite;
typedef struct r_io_t {
 struct r_io_desc_t *desc;
 int ret; 
 unsigned long long off;
 int bits;
 int va; 
 int ff;
 int Oxff;
 int addrbytes;
 int aslr;
 int autofd;
 int cached;
 _Bool cachemode; 
 int p_cache;
 int buffer_enabled;
 int debug;
 RIDPool *sec_ids;
 RIDPool *map_ids;
 SdbList *maps; 
 RVector map_skyline; 
 SdbList *sections;
 RIDStorage *files;
 RCache *buffer;
 RList *cache; 
 unsigned char *write_mask;
 int write_mask_len;
 RIOUndo undo;
 SdbList *plugins;
 char *runprofile;
 char *args;
 void *user;
 void (*cb_printf)(const char *str, ...);
 int (*cb_core_cmd)(void *user, const char *str);
 char* (*cb_core_cmdstr)(void *user, const char *str);
 void (*cb_core_post_write)(void *user, unsigned long long maddr, unsigned char *orig_bytes, int orig_len);
} RIO;
typedef struct r_io_desc_t {
 int fd;
 int flags;
 int obsz; 
 char *uri;
 char *name;
 char *referer;
 Sdb *cache;
 void *data;
 struct r_io_plugin_t *plugin;
 RIO *io;
} RIODesc;
typedef struct {
 unsigned int magic;
 int pid;
 int tid;
 void *data;
} RIODescData;
typedef struct {
 RSocket *fd;
 RSocket *client;
 int listener;
} RIORap;
typedef struct r_io_plugin_t {
 char *name;
 char *desc;
 char *version;
 char *author;
 char *license;
 void *widget;
 int (*listener)(RIODesc *io);
 int (*init)(void);
 RIOUndo undo;
 _Bool isdbg;
 char *(*system)(RIO *io, RIODesc *fd, const char *);
 RIODesc* (*open)(RIO *io, const char *, int rw, int mode);
 RList*  (*open_many)(RIO *io, const char *, int rw, int mode);
 int (*read)(RIO *io, RIODesc *fd, unsigned char *buf, int count);
 unsigned long long (*lseek)(RIO *io, RIODesc *fd, unsigned long long offset, int whence);
 int (*write)(RIO *io, RIODesc *fd, const unsigned char *buf, int count);
 int (*close)(RIODesc *desc);
 _Bool (*is_blockdevice)(RIODesc *desc);
 int (*getpid)(RIODesc *desc);
 int (*gettid)(RIODesc *desc);
 _Bool (*getbase)(RIODesc *desc, unsigned long long *base);
 _Bool (*resize)(RIO *io, RIODesc *fd, unsigned long long size);
 int (*extend)(RIO *io, RIODesc *fd, unsigned long long size);
 _Bool (*accept)(RIO *io, RIODesc *desc, int fd);
 int (*create)(RIO *io, const char *file, int mode, int type);
 _Bool (*check)(RIO *io, const char *, _Bool many);
} RIOPlugin;
typedef struct r_io_map_t {
 int fd;
 int flags;
 unsigned int id;
 RAddrInterval itv;
 unsigned long long delta; 
 char *name;
} RIOMap;
typedef struct r_io_map_skyline_t {
 RIOMap *map;
 RAddrInterval itv;
} RIOMapSkyline;
typedef struct r_io_section_t {
 char *name;
 unsigned long long paddr;
 unsigned long long size;
 unsigned long long vaddr;
 unsigned long long vsize;
 int flags;
 unsigned int id;
 unsigned int bin_id;
 int arch;
 int bits;
 int fd;
 unsigned int filemap;
 unsigned int memmap;
} RIOSection;
typedef enum {
 R_IO_SECTION_APPLY_FOR_PATCH,
 R_IO_SECTION_APPLY_FOR_ANALYSIS,
 R_IO_SECTION_APPLY_FOR_EMULATOR
} RIOSectionApplyMethod;
typedef struct r_io_cache_t {
 unsigned long long from;
 unsigned long long to;
 int size;
 unsigned char *data;
 unsigned char *odata;
 int written;
} RIOCache;
typedef struct r_io_desc_cache_t {
 unsigned long long cached;
 unsigned char cdata[(sizeof(unsigned long long) * 8)];
} RIODescCache;
typedef struct r_io_access_log_element_t {
 unsigned long long vaddr;
 unsigned long long paddr;
 int buf_idx;
 int expect_len;
 int len;
 int fd;
 int mapid;
 int flags;
} RIOAccessLogElement;
typedef struct r_io_access_log_t {
 _Bool allocation_failed;
 unsigned char *buf;
 RList *log;
} RIOAccessLog;
struct r_io_bind_t;
typedef _Bool (*RIODescUse) (RIO *io, int fd);
typedef RIODesc *(*RIODescGet) (RIO *io, int fd);
typedef unsigned long long (*RIODescSize) (RIODesc *desc);
typedef RIODesc *(*RIOOpen) (RIO *io, const char *uri, int flags, int mode);
typedef RIODesc *(*RIOOpenAt) (RIO *io, const char *uri, int flags, int mode, unsigned long long at);
typedef _Bool (*RIOClose) (RIO *io, int fd);
typedef _Bool (*RIOReadAt) (RIO *io, unsigned long long addr, unsigned char *buf, int len);
typedef RIOAccessLog *(*RIOAlReadAt) (RIO *io, unsigned long long addr, unsigned char *buf, int len);
typedef _Bool (*RIOWriteAt) (RIO *io, unsigned long long addr, const unsigned char *buf, int len);
typedef char *(*RIOSystem) (RIO *io, const char* cmd);
typedef int (*RIOFdOpen) (RIO *io, const char *uri, int flags, int mode);
typedef _Bool (*RIOFdClose) (RIO *io, int fd);
typedef unsigned long long (*RIOFdSeek) (RIO *io, int fd, unsigned long long addr, int whence);
typedef unsigned long long (*RIOFdSize) (RIO *io, int fd);
typedef int (*RIOFdRead) (RIO *io, int fd, unsigned char *buf, int len);
typedef int (*RIOFdWrite) (RIO *io, int fd, const unsigned char *buf, int len);
typedef int (*RIOFdReadAt) (RIO *io, int fd, unsigned long long addr, unsigned char *buf, int len);
typedef int (*RIOFdWriteAt) (RIO *io, int fd, unsigned long long addr, const unsigned char *buf, int len);
typedef _Bool (*RIOFdIsDbg) (RIO *io, int fd);
typedef const char *(*RIOFdGetName) (RIO *io, int fd);
typedef void (*RIOAlSort) (RIOAccessLog *log);
typedef void (*RIOAlFree) (RIOAccessLog *log);
typedef unsigned char *(*RIOAlGetFbufByflags) (RIOAccessLog *log, int flags, unsigned long long *addr, int *len);
typedef _Bool (*RIOIsValidOff) (RIO *io, unsigned long long addr, int hasperm);
typedef SdbList *(*RIOSectionVgetSecsAt) (RIO *io, unsigned long long vaddr);
typedef RIOSection *(*RIOSectionVgetSec) (RIO *io, unsigned long long vaddr);
typedef RIOSection *(*RIOSectionAdd) (RIO *io, unsigned long long addr, unsigned long long vaddr, unsigned long long size, unsigned long long vsize, int rwx, const char *name, unsigned int bin_id, int fd);
typedef struct r_io_bind_t {
 int init;
 RIO *io;
 RIODescUse desc_use;
 RIODescGet desc_get;
 RIODescSize desc_size;
 RIOOpen open;
 RIOOpenAt open_at;
 RIOClose close;
 RIOReadAt read_at;
 RIOAlReadAt al_read_at; 
 RIOWriteAt write_at;
 RIOSystem system;
 RIOFdOpen fd_open;
 RIOFdClose fd_close;
 RIOFdSeek fd_seek; 
 RIOFdSize fd_size;
 RIOFdRead fd_read; 
 RIOFdWrite fd_write; 
 RIOFdReadAt fd_read_at;
 RIOFdWriteAt fd_write_at;
 RIOFdIsDbg fd_is_dbg;
 RIOFdGetName fd_get_name;
 RIOAlSort al_sort; 
 RIOAlFree al_free; 
 RIOAlGetFbufByflags al_buf_byflags; 
 RIOIsValidOff is_valid_offset;
 RIOSectionVgetSecsAt sections_vget;
 RIOSectionVgetSec sect_vget;
 RIOSectionAdd section_add;
} RIOBind;
__attribute__((visibility("default"))) RIOMap *r_io_map_new (RIO *io, int fd, int flags, unsigned long long delta, unsigned long long addr, unsigned long long size, _Bool do_skyline);
__attribute__((visibility("default"))) void r_io_map_init (RIO *io);
__attribute__((visibility("default"))) _Bool r_io_map_remap (RIO *io, unsigned int id, unsigned long long addr);
__attribute__((visibility("default"))) _Bool r_io_map_exists (RIO *io, RIOMap *map);
__attribute__((visibility("default"))) _Bool r_io_map_exists_for_id (RIO *io, unsigned int id);
__attribute__((visibility("default"))) RIOMap *r_io_map_resolve (RIO *io, unsigned int id);
__attribute__((visibility("default"))) RIOMap *r_io_map_add (RIO *io, int fd, int flags, unsigned long long delta, unsigned long long addr, unsigned long long size, _Bool do_skyline);
__attribute__((visibility("default"))) RIOMap *r_io_map_get (RIO *io, unsigned long long addr); 
__attribute__((visibility("default"))) RIOMap *r_io_map_get_paddr (RIO *io, unsigned long long paddr); 
__attribute__((visibility("default"))) void r_io_map_reset(RIO* io);
__attribute__((visibility("default"))) _Bool r_io_map_del (RIO *io, unsigned int id);
__attribute__((visibility("default"))) _Bool r_io_map_del_for_fd (RIO *io, int fd);
__attribute__((visibility("default"))) _Bool r_io_map_priorize (RIO *io, unsigned int id);
__attribute__((visibility("default"))) _Bool r_io_map_priorize_for_fd (RIO *io, int fd);
__attribute__((visibility("default"))) void r_io_map_cleanup (RIO *io);
__attribute__((visibility("default"))) void r_io_map_fini (RIO *io);
__attribute__((visibility("default"))) _Bool r_io_map_is_in_range (RIOMap *map, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) void r_io_map_set_name (RIOMap *map, const char *name);
__attribute__((visibility("default"))) void r_io_map_del_name (RIOMap *map);
__attribute__((visibility("default"))) RIOMap *r_io_map_add_next_available(RIO *io, int fd, int flags, unsigned long long delta, unsigned long long addr, unsigned long long size, unsigned long long load_align);
__attribute__((visibility("default"))) void r_io_map_calculate_skyline(RIO *io);
__attribute__((visibility("default"))) RList* r_io_map_get_for_fd(RIO *io, int fd);
__attribute__((visibility("default"))) _Bool r_io_map_resize(RIO *io, unsigned int id, unsigned long long newsize);
__attribute__((visibility("default"))) RIO *r_io_new (void);
__attribute__((visibility("default"))) RIO *r_io_init (RIO *io);
__attribute__((visibility("default"))) RIODesc *r_io_open_nomap (RIO *io, const char *uri, int flags, int mode); 
__attribute__((visibility("default"))) RIODesc *r_io_open (RIO *io, const char *uri, int flags, int mode);
__attribute__((visibility("default"))) RIODesc *r_io_open_at (RIO *io, const char *uri, int flags, int mode, unsigned long long at);
__attribute__((visibility("default"))) RList *r_io_open_many (RIO *io, const char *uri, int flags, int mode);
__attribute__((visibility("default"))) _Bool r_io_close (RIO *io);
__attribute__((visibility("default"))) _Bool r_io_reopen (RIO *io, int fd, int flags, int mode);
__attribute__((visibility("default"))) int r_io_close_all (RIO *io);
__attribute__((visibility("default"))) int r_io_pread_at (RIO *io, unsigned long long paddr, unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_io_pwrite_at (RIO *io, unsigned long long paddr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) _Bool r_io_vread_at (RIO *io, unsigned long long vaddr, unsigned char *buf, int len);
__attribute__((visibility("default"))) _Bool r_io_vwrite_at (RIO *io, unsigned long long vaddr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) RIOAccessLog *r_io_al_vread_at (RIO *io, unsigned long long vaddr, unsigned char *buf, int len);
__attribute__((visibility("default"))) RIOAccessLog *r_io_al_vwrite_at (RIO *io, unsigned long long vaddr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) _Bool r_io_read_at (RIO *io, unsigned long long addr, unsigned char *buf, int len);
__attribute__((visibility("default"))) RIOAccessLog *r_io_al_read_at (RIO *io, unsigned long long addr, unsigned char *buf, int len);
__attribute__((visibility("default"))) void r_io_alprint(RList *ls);
__attribute__((visibility("default"))) _Bool r_io_write_at (RIO *io, unsigned long long addr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) _Bool r_io_read (RIO *io, unsigned char *buf, int len);
__attribute__((visibility("default"))) _Bool r_io_write (RIO *io, unsigned char *buf, int len);
__attribute__((visibility("default"))) unsigned long long r_io_size (RIO *io);
__attribute__((visibility("default"))) _Bool r_io_is_listener (RIO *io);
__attribute__((visibility("default"))) char *r_io_system (RIO *io, const char* cmd);
__attribute__((visibility("default"))) _Bool r_io_resize (RIO *io, unsigned long long newsize);
__attribute__((visibility("default"))) int r_io_extend_at (RIO *io, unsigned long long addr, unsigned long long size);
__attribute__((visibility("default"))) _Bool r_io_set_write_mask (RIO *io, const unsigned char *mask, int len);
__attribute__((visibility("default"))) int r_io_bind (RIO *io, RIOBind *bnd);
__attribute__((visibility("default"))) int r_io_shift (RIO *io, unsigned long long start, unsigned long long end, long long move);
__attribute__((visibility("default"))) int r_io_create (RIO *io, const char *file, int mode, int type);
__attribute__((visibility("default"))) unsigned long long r_io_seek (RIO *io, unsigned long long offset, int whence);
__attribute__((visibility("default"))) int r_io_fini (RIO *io);
__attribute__((visibility("default"))) void r_io_free (RIO *io);
__attribute__((visibility("default"))) _Bool r_io_plugin_init(RIO *io);
__attribute__((visibility("default"))) int r_io_plugin_open(RIO *io, int fd, RIOPlugin *plugin);
__attribute__((visibility("default"))) int r_io_plugin_close(RIO *io, int fd, RIOPlugin *plugin);
__attribute__((visibility("default"))) int r_io_plugin_generate(RIO *io);
__attribute__((visibility("default"))) _Bool r_io_plugin_add(RIO *io, RIOPlugin *plugin);
__attribute__((visibility("default"))) int r_io_plugin_list(RIO *io);
__attribute__((visibility("default"))) int r_io_plugin_list_json(RIO *io);
__attribute__((visibility("default"))) RIOPlugin *r_io_plugin_resolve(RIO *io, const char *filename, _Bool many);
__attribute__((visibility("default"))) RIOPlugin *r_io_plugin_resolve_fd(RIO *io, int fd);
__attribute__((visibility("default"))) RIOPlugin *r_io_plugin_get_default(RIO *io, const char *filename, _Bool many);
__attribute__((visibility("default"))) int r_io_undo_init(RIO *io);
__attribute__((visibility("default"))) void r_io_undo_enable(RIO *io, int seek, int write);
__attribute__((visibility("default"))) RIOUndos *r_io_sundo(RIO *io, unsigned long long offset);
__attribute__((visibility("default"))) RIOUndos *r_io_sundo_redo(RIO *io);
__attribute__((visibility("default"))) void r_io_sundo_push(RIO *io, unsigned long long off, int cursor);
__attribute__((visibility("default"))) void r_io_sundo_reset(RIO *io);
__attribute__((visibility("default"))) RList *r_io_sundo_list(RIO *io, int mode);
__attribute__((visibility("default"))) void r_io_wundo_new(RIO *io, unsigned long long off, const unsigned char *data, int len);
__attribute__((visibility("default"))) void r_io_wundo_apply_all(RIO *io, int set);
__attribute__((visibility("default"))) int r_io_wundo_apply(RIO *io, struct r_io_undo_w_t *u, int set);
__attribute__((visibility("default"))) void r_io_wundo_clear(RIO *io);
__attribute__((visibility("default"))) int r_io_wundo_size(RIO *io);
__attribute__((visibility("default"))) void r_io_wundo_list(RIO *io);
__attribute__((visibility("default"))) int r_io_wundo_set_t(RIO *io, RIOUndoWrite *u, int set) ;
__attribute__((visibility("default"))) void r_io_wundo_set_all(RIO *io, int set);
__attribute__((visibility("default"))) int r_io_wundo_set(RIO *io, int n, int set);
__attribute__((visibility("default"))) _Bool r_io_desc_init (RIO *io);
__attribute__((visibility("default"))) RIODesc *r_io_desc_new (RIO *io, RIOPlugin *plugin, const char *uri, int flags, int mode, void *data);
__attribute__((visibility("default"))) RIODesc *r_io_desc_open (RIO *io, const char *uri, int flags, int mode);
__attribute__((visibility("default"))) _Bool r_io_desc_close (RIODesc *desc);
__attribute__((visibility("default"))) int r_io_desc_read (RIODesc *desc, unsigned char *buf, int count);
__attribute__((visibility("default"))) int r_io_desc_write (RIODesc *desc, const unsigned char *buf, int count);
__attribute__((visibility("default"))) void r_io_desc_free (RIODesc *desc);
__attribute__((visibility("default"))) _Bool r_io_desc_add (RIO *io, RIODesc *desc);
__attribute__((visibility("default"))) _Bool r_io_desc_del (RIO *io, int fd);
__attribute__((visibility("default"))) RIODesc *r_io_desc_get (RIO *io, int fd);
__attribute__((visibility("default"))) unsigned long long r_io_desc_seek (RIODesc *desc, unsigned long long offset, int whence);
__attribute__((visibility("default"))) _Bool r_io_desc_resize (RIODesc *desc, unsigned long long newsize);
__attribute__((visibility("default"))) unsigned long long r_io_desc_size (RIODesc *desc);
__attribute__((visibility("default"))) _Bool r_io_desc_is_blockdevice (RIODesc *desc);
__attribute__((visibility("default"))) _Bool r_io_desc_exchange (RIO *io, int fd, int fdx); 
__attribute__((visibility("default"))) _Bool r_io_desc_is_dbg (RIODesc *desc);
__attribute__((visibility("default"))) int r_io_desc_get_pid (RIODesc *desc);
__attribute__((visibility("default"))) int r_io_desc_get_tid (RIODesc *desc);
__attribute__((visibility("default"))) _Bool r_io_desc_get_base (RIODesc *desc, unsigned long long *base);
__attribute__((visibility("default"))) int r_io_desc_read_at (RIODesc *desc, unsigned long long addr, unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_io_desc_write_at (RIODesc *desc, unsigned long long addr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) _Bool r_io_desc_fini (RIO *io);
__attribute__((visibility("default"))) int r_io_cache_invalidate(RIO *io, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) _Bool r_io_cache_at(RIO *io, unsigned long long addr);
__attribute__((visibility("default"))) void r_io_cache_commit(RIO *io, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) void r_io_cache_init(RIO *io);
__attribute__((visibility("default"))) int r_io_cache_list(RIO *io, int rad);
__attribute__((visibility("default"))) void r_io_cache_reset(RIO *io, int set);
__attribute__((visibility("default"))) _Bool r_io_cache_write(RIO *io, unsigned long long addr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) _Bool r_io_cache_read(RIO *io, unsigned long long addr, unsigned char *buf, int len);
__attribute__((visibility("default"))) void r_io_section_init (RIO *io);
__attribute__((visibility("default"))) void r_io_section_fini (RIO *io);
__attribute__((visibility("default"))) int r_io_section_exists_for_id (RIO *io, unsigned int id);
__attribute__((visibility("default"))) RIOSection *r_io_section_add (RIO *io, unsigned long long addr, unsigned long long vaddr, unsigned long long size, unsigned long long vsize, int rwx, const char *name, unsigned int bin_id, int fd);
__attribute__((visibility("default"))) RIOSection *r_io_section_get_i (RIO *io, unsigned int id);
__attribute__((visibility("default"))) int r_io_section_rm (RIO *io, unsigned int id);
__attribute__((visibility("default"))) SdbList *r_io_section_bin_get (RIO *io, unsigned int bin_id);
__attribute__((visibility("default"))) _Bool r_io_section_bin_rm (RIO *io, unsigned int bin_id);
__attribute__((visibility("default"))) RIOSection *r_io_section_get_name (RIO *io, const char *name);
__attribute__((visibility("default"))) void r_io_section_cleanup (RIO *io);
__attribute__((visibility("default"))) SdbList *r_io_sections_get (RIO *io, unsigned long long addr);
__attribute__((visibility("default"))) SdbList *r_io_sections_vget (RIO *io, unsigned long long vaddr);
__attribute__((visibility("default"))) int r_io_section_set_archbits (RIO *io, unsigned int id, const char *arch, int bits);
__attribute__((visibility("default"))) const char *r_io_section_get_archbits (RIO *io, unsigned long long vaddr, int *bits);
__attribute__((visibility("default"))) int r_io_section_bin_set_archbits (RIO *io, unsigned int bin_id, const char *arch, int bits);
__attribute__((visibility("default"))) _Bool r_io_section_priorize (RIO *io, unsigned int id);
__attribute__((visibility("default"))) _Bool r_io_section_priorize_bin (RIO *io, unsigned int bin_id);
__attribute__((visibility("default"))) _Bool r_io_section_apply (RIO *io, unsigned int id, RIOSectionApplyMethod method);
__attribute__((visibility("default"))) _Bool r_io_section_reapply (RIO *io, unsigned int id, RIOSectionApplyMethod method);
__attribute__((visibility("default"))) _Bool r_io_section_apply_bin (RIO *io, unsigned int bin_id, RIOSectionApplyMethod method);
__attribute__((visibility("default"))) _Bool r_io_section_reapply_bin (RIO *io, unsigned int bin_id, RIOSectionApplyMethod method);
__attribute__((visibility("default"))) RIOSection* r_io_section_get(RIO *io, unsigned long long paddr);
__attribute__((visibility("default"))) RIOSection* r_io_section_vget(RIO *io, unsigned long long vaddr);
__attribute__((visibility("default"))) unsigned long long r_io_section_get_paddr_at(RIO *io, unsigned long long addr);
__attribute__((visibility("default"))) unsigned long long r_io_section_get_vaddr_at(RIO *io, unsigned long long addr);
__attribute__((visibility("default"))) _Bool r_io_desc_cache_init (RIODesc *desc);
__attribute__((visibility("default"))) int r_io_desc_cache_write (RIODesc *desc, unsigned long long paddr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_io_desc_cache_read (RIODesc *desc, unsigned long long paddr, unsigned char *buf, int len);
__attribute__((visibility("default"))) _Bool r_io_desc_cache_commit (RIODesc *desc);
__attribute__((visibility("default"))) void r_io_desc_cache_cleanup (RIODesc *desc);
__attribute__((visibility("default"))) void r_io_desc_cache_fini (RIODesc *desc);
__attribute__((visibility("default"))) void r_io_desc_cache_fini_all (RIO *io);
__attribute__((visibility("default"))) RList *r_io_desc_cache_list (RIODesc *desc);
__attribute__((visibility("default"))) int r_io_desc_extend(RIODesc *desc, unsigned long long size);
__attribute__((visibility("default"))) int r_io_buffer_read (RIO* io, unsigned long long addr, unsigned char* buf, int len);
__attribute__((visibility("default"))) int r_io_buffer_load (RIO* io, unsigned long long addr, int len);
__attribute__((visibility("default"))) void r_io_buffer_close (RIO* io);
__attribute__((visibility("default"))) int r_io_fd_open (RIO *io, const char *uri, int flags, int mode);
__attribute__((visibility("default"))) _Bool r_io_fd_close (RIO *io, int fd);
__attribute__((visibility("default"))) int r_io_fd_read (RIO *io, int fd, unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_io_fd_write (RIO *io, int fd, const unsigned char *buf, int len);
__attribute__((visibility("default"))) unsigned long long r_io_fd_seek (RIO *io, int fd, unsigned long long addr, int whence);
__attribute__((visibility("default"))) unsigned long long r_io_fd_size (RIO *io, int fd);
__attribute__((visibility("default"))) _Bool r_io_fd_resize (RIO *io, int fd, unsigned long long newsize);
__attribute__((visibility("default"))) _Bool r_io_fd_is_blockdevice (RIO *io, int fd);
__attribute__((visibility("default"))) int r_io_fd_read_at (RIO *io, int fd, unsigned long long addr, unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_io_fd_write_at (RIO *io, int fd, unsigned long long addr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) _Bool r_io_fd_is_dbg (RIO *io, int fd);
__attribute__((visibility("default"))) int r_io_fd_get_pid (RIO *io, int fd);
__attribute__((visibility("default"))) int r_io_fd_get_tid (RIO *io, int fd);
__attribute__((visibility("default"))) _Bool r_io_fd_get_base (RIO *io, int fd, unsigned long long *base);
__attribute__((visibility("default"))) const char *r_io_fd_get_name (RIO *io, int fd);
__attribute__((visibility("default"))) int r_io_fd_get_current(RIO *io);
__attribute__((visibility("default"))) _Bool r_io_use_fd (RIO *io, int fd);
__attribute__((visibility("default"))) _Bool r_io_create_mem_map(RIO *io, RIOSection *sec, unsigned long long at, _Bool null, _Bool do_skyline);
__attribute__((visibility("default"))) _Bool r_io_create_file_map(RIO *io, RIOSection *sec, unsigned long long size, _Bool patch, _Bool do_skyline);
__attribute__((visibility("default"))) _Bool r_io_create_mem_for_section(RIO *io, RIOSection *sec);
__attribute__((visibility("default"))) _Bool r_io_is_valid_offset (RIO *io, unsigned long long offset, int hasperm);
__attribute__((visibility("default"))) _Bool r_io_addr_is_mapped(RIO *io, unsigned long long vaddr);
__attribute__((visibility("default"))) _Bool r_io_read_i (RIO* io, unsigned long long addr, unsigned long long *val, int size, _Bool endian);
__attribute__((visibility("default"))) _Bool r_io_write_i (RIO* io, unsigned long long addr, unsigned long long *val, int size, _Bool endian);
__attribute__((visibility("default"))) RIOAccessLog *r_io_accesslog_new (void);
__attribute__((visibility("default"))) void r_io_accesslog_free (RIOAccessLog *log);
__attribute__((visibility("default"))) void r_io_accesslog_sort (RIOAccessLog *log);
__attribute__((visibility("default"))) void r_io_accesslog_sqash_ignore_gaps (RIOAccessLog *log);
__attribute__((visibility("default"))) void r_io_accesslog_sqash_byflags (RIOAccessLog *log, int flags);
__attribute__((visibility("default"))) unsigned char *r_io_accesslog_getf_buf_byflags (RIOAccessLog *log, int flags, unsigned long long *addr, int *len);
extern RIOPlugin r_io_plugin_procpid;
extern RIOPlugin r_io_plugin_malloc;
extern RIOPlugin r_io_plugin_sparse;
extern RIOPlugin r_io_plugin_ptrace;
extern RIOPlugin r_io_plugin_w32dbg;
extern RIOPlugin r_io_plugin_mach;
extern RIOPlugin r_io_plugin_debug;
extern RIOPlugin r_io_plugin_shm;
extern RIOPlugin r_io_plugin_gdb;
extern RIOPlugin r_io_plugin_rap;
extern RIOPlugin r_io_plugin_http;
extern RIOPlugin r_io_plugin_bfdbg;
extern RIOPlugin r_io_plugin_w32;
extern RIOPlugin r_io_plugin_zip;
extern RIOPlugin r_io_plugin_mmap;
extern RIOPlugin r_io_plugin_default;
extern RIOPlugin r_io_plugin_ihex;
extern RIOPlugin r_io_plugin_self;
extern RIOPlugin r_io_plugin_gzip;
extern RIOPlugin r_io_plugin_windbg;
extern RIOPlugin r_io_plugin_r2pipe;
extern RIOPlugin r_io_plugin_r2web;
extern RIOPlugin r_io_plugin_qnx;
extern RIOPlugin r_io_plugin_r2k;
extern RIOPlugin r_io_plugin_tcp;
extern RIOPlugin r_io_plugin_bochs;
extern RIOPlugin r_io_plugin_null;
extern RIOPlugin r_io_plugin_ar;
extern RIOPlugin r_io_plugin_rbuf;
extern RIOPlugin r_io_plugin_winedbg;
typedef int (*RCoreCmd)(void *core, const char *cmd);
typedef int (*RCoreCmdF)(void *user, const char *fmt, ...);
typedef int (*RCoreDebugBpHit)(void *core, void *bp);
typedef char* (*RCoreCmdStr)(void *core, const char *cmd);
typedef char* (*RCoreCmdStrF)(void *core, const char *cmd, ...);
typedef void (*RCorePuts)(const char *cmd);
typedef void (*RCoreSetArchBits)(void *core, const char *arch, int bits);
typedef const char *(*RCoreGetName)(void *core, unsigned long long off);
typedef char *(*RCoreGetNameDelta)(void *core, unsigned long long off);
typedef void (*RCoreSeekArchBits)(void *core, unsigned long long addr);
typedef int (*RCoreConfigGetI)(void *core, const char *key);
typedef struct r_core_bind_t {
 void *core;
 RCoreCmd cmd;
 RCoreCmdF cmdf;
 RCoreCmdStr cmdstr;
 RCoreCmdStrF cmdstrf;
 RCorePuts puts;
 RCoreDebugBpHit bphit;
 RCoreSetArchBits setab;
 RCoreGetName getName;
 RCoreGetNameDelta getNameDelta;
 RCoreSeekArchBits archbits;
 RCoreConfigGetI cfggeti;
} RCoreBind;
__attribute__((visibility("default"))) const char *r_fs_version(void);
struct r_fs_plugin_t;
struct r_fs_root_t;
struct r_fs_t;
typedef struct r_fs_t {
 RIOBind iob;
 RCoreBind cob;
 RList  *plugins;
 RList  *roots;
 int view;
 void *ptr;
} RFS;
typedef struct r_fs_partition_plugin_t {
 const char *name;
} RFSPartitionPlugin;
typedef struct r_fs_file_t {
 char *name;
 char *path;
 unsigned long long off;
 unsigned int size;
 unsigned char *data;
 void *ctx;
 char type;
 unsigned long long time;
 struct r_fs_plugin_t *p;
 struct r_fs_root_t *root;
 void *ptr; 
} RFSFile;
typedef struct r_fs_root_t {
 char *path;
 unsigned long long delta;
 struct r_fs_plugin_t *p;
 void *ptr;
 RIOBind iob;
 RCoreBind cob;
} RFSRoot;
typedef struct r_fs_plugin_t {
 const char *name;
 const char *desc;
 const char *license;
 RFSFile* (*slurp)(RFSRoot *root, const char *path);
 RFSFile* (*open)(RFSRoot *root, const char *path);
 _Bool (*read)(RFSFile *fs, unsigned long long addr, int len);
 void (*close)(RFSFile *fs);
 RList *(*dir)(RFSRoot *root, const char *path, int view);
 void (*init)(void);
 void (*fini)(void);
 int (*mount)(RFSRoot *root);
 void (*umount)(RFSRoot *root);
} RFSPlugin;
typedef struct r_fs_partition_t {
 int number;
 unsigned long long start;
 unsigned long long length;
 int index;
 int type;
} RFSPartition;
typedef int (*RFSPartitionIterator)(void *disk, void *ptr, void *user);
typedef struct r_fs_partition_type_t {
 const char *name;
 void *ptr; 
 RFSPartitionIterator iterate;
} RFSPartitionType;
enum {
 R_FS_VIEW_NORMAL = 0,
 R_FS_VIEW_DELETED = 1,
 R_FS_VIEW_SPECIAL = 2,
 R_FS_VIEW_ALL = 0xff,
};
__attribute__((visibility("default"))) RFS *r_fs_new(void);
__attribute__((visibility("default"))) void r_fs_view(RFS* fs, int view);
__attribute__((visibility("default"))) void r_fs_free(RFS* fs);
__attribute__((visibility("default"))) void r_fs_add(RFS *fs, RFSPlugin *p);
__attribute__((visibility("default"))) void r_fs_del(RFS *fs, RFSPlugin *p);
__attribute__((visibility("default"))) RFSRoot *r_fs_mount(RFS* fs, const char *fstype, const char *path, unsigned long long delta);
__attribute__((visibility("default"))) _Bool r_fs_umount(RFS* fs, const char *path);
__attribute__((visibility("default"))) RList *r_fs_root(RFS *fs, const char *path);
__attribute__((visibility("default"))) RFSFile *r_fs_open(RFS* fs, const char *path);
__attribute__((visibility("default"))) void r_fs_close(RFS* fs, RFSFile *file);
__attribute__((visibility("default"))) int r_fs_read(RFS* fs, RFSFile *file, unsigned long long addr, int len);
__attribute__((visibility("default"))) RFSFile *r_fs_slurp(RFS* fs, const char *path);
__attribute__((visibility("default"))) RList *r_fs_dir(RFS* fs, const char *path);
__attribute__((visibility("default"))) int r_fs_dir_dump(RFS* fs, const char *path, const char *name);
__attribute__((visibility("default"))) RList *r_fs_find_name(RFS* fs, const char *name, const char *glob);
__attribute__((visibility("default"))) RList *r_fs_find_off(RFS* fs, const char *name, unsigned long long off);
__attribute__((visibility("default"))) RList *r_fs_partitions(RFS* fs, const char *ptype, unsigned long long delta);
__attribute__((visibility("default"))) char *r_fs_name(RFS *fs, unsigned long long offset);
__attribute__((visibility("default"))) int r_fs_prompt(RFS *fs, const char *root);
__attribute__((visibility("default"))) _Bool r_fs_check(RFS *fs, const char *p);
__attribute__((visibility("default"))) RFSFile *r_fs_file_new(RFSRoot *root, const char *path);
__attribute__((visibility("default"))) void r_fs_file_free(RFSFile *file);
__attribute__((visibility("default"))) RFSRoot *r_fs_root_new(const char *path, unsigned long long delta);
__attribute__((visibility("default"))) void r_fs_root_free(RFSRoot *root);
__attribute__((visibility("default"))) RFSPartition *r_fs_partition_new(int num, unsigned long long start, unsigned long long length);
__attribute__((visibility("default"))) void r_fs_partition_free(RFSPartition *p);
__attribute__((visibility("default"))) const char *r_fs_partition_type(const char *part, int type);
__attribute__((visibility("default"))) const char *r_fs_partition_type_get(int n);
__attribute__((visibility("default"))) int r_fs_partition_get_size(void); 
extern RFSPlugin r_fs_plugin_io;
extern RFSPlugin r_fs_plugin_r2;
extern RFSPlugin r_fs_plugin_ext2;
extern RFSPlugin r_fs_plugin_fat;
extern RFSPlugin r_fs_plugin_ntfs;
extern RFSPlugin r_fs_plugin_hfs;
extern RFSPlugin r_fs_plugin_hfsplus;
extern RFSPlugin r_fs_plugin_reiserfs;
extern RFSPlugin r_fs_plugin_tar;
extern RFSPlugin r_fs_plugin_iso9660;
extern RFSPlugin r_fs_plugin_udf;
extern RFSPlugin r_fs_plugin_ufs;
extern RFSPlugin r_fs_plugin_ufs2;
extern RFSPlugin r_fs_plugin_sfs;
extern RFSPlugin r_fs_plugin_tar;
extern RFSPlugin r_fs_plugin_btrfs;
extern RFSPlugin r_fs_plugin_jfs;
extern RFSPlugin r_fs_plugin_afs;
extern RFSPlugin r_fs_plugin_affs;
extern RFSPlugin r_fs_plugin_cpio;
extern RFSPlugin r_fs_plugin_xfs;
extern RFSPlugin r_fs_plugin_fb;
extern RFSPlugin r_fs_plugin_minix;
extern RFSPlugin r_fs_plugin_posix;
__attribute__((visibility("default"))) const char *r_lib_version(void);
typedef struct r_lib_plugin_t {
 int type;
 char *file;
 void *data; 
 struct r_lib_handler_t *handler;
 void *dl_handler; 
 char *author;
 char *version;
 void (*free)(void *data);
} RLibPlugin;
typedef struct r_lib_handler_t {
 int type;
 char desc[128];
 void *user; 
 int (*constructor)(RLibPlugin *, void *user, void *data);
 int (*destructor)(RLibPlugin *, void *user, void *data);
} RLibHandler;
typedef struct r_lib_struct_t {
 int type;
 void *data; 
 const char *version; 
 void (*free)(void *data);
} RLibStruct;
enum {
 R_LIB_TYPE_IO, 
 R_LIB_TYPE_DBG, 
 R_LIB_TYPE_LANG, 
 R_LIB_TYPE_ASM, 
 R_LIB_TYPE_ANAL, 
 R_LIB_TYPE_PARSE, 
 R_LIB_TYPE_BIN, 
 R_LIB_TYPE_BIN_XTR, 
 R_LIB_TYPE_BP, 
 R_LIB_TYPE_SYSCALL, 
 R_LIB_TYPE_FASTCALL,
 R_LIB_TYPE_CRYPTO, 
 R_LIB_TYPE_CORE, 
 R_LIB_TYPE_EGG, 
 R_LIB_TYPE_FS, 
 R_LIB_TYPE_LAST
};
typedef struct r_lib_t {
 char symname[32];
 RList  *plugins;
 RList  *handlers;
} RLib;
__attribute__((visibility("default"))) void *r_lib_dl_open(const char *libname);
__attribute__((visibility("default"))) void *r_lib_dl_sym(void *handler, const char *name);
__attribute__((visibility("default"))) int r_lib_dl_close(void *handler);
__attribute__((visibility("default"))) int r_lib_dl_check_filename(const char *file);
__attribute__((visibility("default"))) RLib *r_lib_new(const char *symname);
__attribute__((visibility("default"))) RLib *r_lib_free(RLib *lib);
__attribute__((visibility("default"))) int r_lib_run_handler(RLib *lib, RLibPlugin *plugin, RLibStruct *symbol);
__attribute__((visibility("default"))) RLibHandler *r_lib_get_handler(RLib *lib, int type);
__attribute__((visibility("default"))) int r_lib_open(RLib *lib, const char *file);
__attribute__((visibility("default"))) int r_lib_opendir(RLib *lib, const char *path);
__attribute__((visibility("default"))) int r_lib_open_ptr (RLib *lib, const char *file, void *handler, RLibStruct *stru);
__attribute__((visibility("default"))) char *r_lib_path(const char *libname);
__attribute__((visibility("default"))) void r_lib_list(RLib *lib);
__attribute__((visibility("default"))) int r_lib_add_handler(RLib *lib, int type, const char *desc,
 int (*cb)(RLibPlugin *, void *, void *),
 int (*dt)(RLibPlugin *, void *, void *),
 void *user );
__attribute__((visibility("default"))) int r_lib_del_handler(RLib *lib, int type);
__attribute__((visibility("default"))) int r_lib_close(RLib *lib, const char *file);
__attribute__((visibility("default"))) const char *r_lib_types_get(int idx);
__attribute__((visibility("default"))) int r_lib_types_get_i(const char *str);
typedef struct {
 unsigned int total_length;
 unsigned short version;
 unsigned int plen;
 unsigned char mininstlen;
 unsigned char is_stmt;
 char line_base;
 unsigned char line_range;
 unsigned char opcode_base;
 unsigned int oplentable[12];
 const char **incdirs;
 const char *file[128];
} RBinDwarfInfoHeader;
typedef struct {
 unsigned long long address;
 unsigned int file;
 unsigned int line;
 unsigned int column;
 int is_stmt;
 int basic_block;
 int end_sequence;
} RBinDwarfState;
typedef struct {
 unsigned long long address;
 char *file;
 unsigned int line;
 unsigned int column;
} RBinDwarfRow;
typedef struct {
 unsigned int part1;
 unsigned long long part2;
} initial_length;
typedef union {
 unsigned int offset32;
 unsigned long long offset64;
} section_offset;
typedef struct {
 initial_length unit_length;
 unsigned short version;
 section_offset debug_abbrev_offset;
 unsigned char address_size;
} RBinDwarfCompilationUnitHeader;
typedef struct {
 initial_length unit_length;
 unsigned short version;
 section_offset debug_abbrev_offset;
 unsigned char address_size;
 unsigned long long type_signature;
 section_offset type_offset;
} RBinDwarfTypeUnitHeader;
typedef struct {
 initial_length unit_length;
 unsigned short version;
 section_offset debug_info_offset;
 unsigned char address_size;
 unsigned char segment_size;
} RBinDwarfAddressRangeTable;
typedef struct {
 unsigned long long attr_name;
 unsigned long long attr_form;
} RBinDwarfAttrSpec;
typedef struct {
 unsigned long long length;
 unsigned char *data;
} RBinDwarfBlock;
typedef union {
 unsigned long long address;
 RBinDwarfBlock block;
 unsigned long long constant;
 unsigned char flag;
 unsigned long long data;
 long long sdata;
 unsigned long long reference;
 struct {
  char *string;
  unsigned long long offset;
 } str_struct;
} RBinDwarfAttrEnc;
typedef struct {
 unsigned long long name;
 unsigned long long form;
 RBinDwarfAttrEnc encoding;
} RBinDwarfAttrValue;
typedef struct {
 unsigned int length;
 unsigned short version;
 unsigned int abbrev_offset;
 unsigned char pointer_size;
} RBinDwarfCompUnitHdr;
typedef struct {
 unsigned long long tag;
 unsigned long long abbrev_code;
 size_t length;
 size_t capacity;
 RBinDwarfAttrValue *attr_values;
} RBinDwarfDIE;
typedef struct {
 RBinDwarfCompUnitHdr hdr;
 unsigned long long offset;
 size_t length;
 size_t capacity;
 RBinDwarfDIE *dies;
} RBinDwarfCompUnit;
typedef struct {
 size_t length;
 size_t capacity;
 RBinDwarfCompUnit *comp_units;
} RBinDwarfDebugInfo;
typedef struct {
 unsigned long long code;
 unsigned long long tag;
 unsigned long long offset;
 unsigned char has_children;
 size_t length;
 size_t capacity;
 RBinDwarfAttrSpec *specs;
} RBinDwarfAbbrevDecl;
typedef struct {
 size_t length;
 size_t capacity;
 RBinDwarfAbbrevDecl *decls;
} RBinDwarfDebugAbbrev;
typedef struct {
 unsigned long long address;
 unsigned long long op_index;
 unsigned long long file;
 unsigned long long line;
 unsigned long long column;
 unsigned char is_stmt;
 unsigned char basic_block;
 unsigned char end_sequence;
 unsigned char prologue_end;
 unsigned char epilogue_begin;
 unsigned long long isa;
 unsigned long long discriminator;
} RBinDwarfSMRegisters;
typedef struct {
 char *name;
 unsigned int id_idx, mod_time, file_len;
} file_entry;
typedef struct {
 initial_length unit_length;
 unsigned short version;
 unsigned long long header_length;
 unsigned char min_inst_len;
 unsigned char max_ops_per_inst;
 unsigned char default_is_stmt;
 char line_base;
 unsigned char line_range;
 unsigned char opcode_base;
 unsigned char *std_opcode_lengths;
 char **include_directories;
 file_entry *file_names;
 size_t file_names_count;
} RBinDwarfLNPHeader;
__attribute__((visibility("default"))) int r_bin_dwarf_parse_info_raw(Sdb *s, RBinDwarfDebugAbbrev *da,
  const unsigned char *obuf, size_t len,
  const unsigned char *debug_str, size_t debug_str_len, int mode);
__attribute__((visibility("default"))) void r_bin_dwarf_free_debug_abbrev(RBinDwarfDebugAbbrev *da);
struct R_PDB;
struct R_PDB7_ROOT_STREAM;
typedef struct R_PDB {
 _Bool (*pdb_parse)(struct R_PDB *pdb);
 void (*finish_pdb_parse)(struct R_PDB *pdb);
 void (*print_types)(struct R_PDB *pdb, int mode);
 PrintfCallback cb_printf;
 struct R_PDB7_ROOT_STREAM *root_stream;
 void *stream_map;
 RList *pdb_streams;
 RList *pdb_streams2;
 RBuffer *buf; 
 void (*print_gvars)(struct R_PDB *pdb, unsigned long long img_base, int format);
} R_PDB;
__attribute__((visibility("default"))) _Bool init_pdb_parser(R_PDB *pdb, const char *filename);
__attribute__((visibility("default"))) const char *r_bin_version(void);
enum {
 R_BIN_SYM_ENTRY,
 R_BIN_SYM_INIT,
 R_BIN_SYM_MAIN,
 R_BIN_SYM_FINI,
 R_BIN_SYM_LAST
};
enum {
 R_BIN_NM_NONE = 0,
 R_BIN_NM_JAVA = 1,
 R_BIN_NM_CXX = 1<<1,
 R_BIN_NM_OBJC = 1<<2,
 R_BIN_NM_SWIFT = 1<<3,
 R_BIN_NM_DLANG = 1<<4,
 R_BIN_NM_MSVC = 1<<5,
 R_BIN_NM_RUST = 1<<6,
 R_BIN_NM_ANY = -1,
};
enum {
 R_STRING_TYPE_DETECT = '?',
 R_STRING_TYPE_ASCII = 'a',
 R_STRING_TYPE_UTF8 = 'u',
 R_STRING_TYPE_WIDE = 'w', 
 R_STRING_TYPE_WIDE32 = 'W', 
 R_STRING_TYPE_BASE64 = 'b',
};
enum {
 R_BIN_CLASS_PRIVATE,
 R_BIN_CLASS_PUBLIC,
 R_BIN_CLASS_FRIENDLY,
 R_BIN_CLASS_PROTECTED,
};
enum {
 R_BIN_RELOC_8 = 8,
 R_BIN_RELOC_16 = 16,
 R_BIN_RELOC_32 = 32,
 R_BIN_RELOC_64 = 64
};
typedef struct r_bin_addr_t {
 unsigned long long vaddr;
 unsigned long long paddr;
 unsigned long long haddr;
 int type;
 int bits;
} RBinAddr;
typedef struct r_bin_hash_t {
 const char *type;
 unsigned long long addr;
 int len;
 unsigned long long from;
 unsigned long long to;
 unsigned char buf[32];
 const char *cmd;
} RBinHash;
typedef struct r_bin_info_t {
 char *file;
 char *type;
 char *bclass;
 char *rclass;
 char *arch;
 char *cpu;
 char *machine;
 char *os;
 char *subsystem;
 char *rpath;
 char *guid;
 char *debug_file_name;
 const char *lang;
 int bits;
 int has_va;
 int has_pi; 
 int has_canary;
 int has_crypto;
 int has_nx;
 int big_endian;
 _Bool has_lit;
 char *actual_checksum;
 char *claimed_checksum;
 int pe_overlay;
 _Bool signature;
 unsigned long long dbg_info;
 RBinHash sum[3];
 unsigned long long baddr;
 char *intrp;
} RBinInfo;
typedef struct r_bin_object_t {
 unsigned int id;
 unsigned long long baddr;
 unsigned long long baddr_shift;
 unsigned long long loadaddr;
 unsigned long long boffset;
 unsigned long long size;
 unsigned long long obj_size;
 RList *sections;
 RList *imports;
 RList *symbols;
 RList *entries;
 RList *fields;
 RList *libs;
 RList *relocs;
 RList *strings;
 RList *classes;
 RList *lines;
 RList *mem; 
 RBinInfo *info;
 RBinAddr *binsym[R_BIN_SYM_LAST];
 struct r_bin_plugin_t *plugin;
 int referenced;
 int lang;
 Sdb *kv;
 void *bin_obj; 
} RBinObject;
typedef struct r_bin_file_t {
 char *file;
 int fd;
 int size;
 int rawstr;
 unsigned int id;
 RBuffer *buf;
 unsigned long long offset;
 RBinObject *o;
 void *xtr_obj;
 unsigned long long loadaddr;
 int minstrlen;
 int maxstrlen;
 int narch;
 struct r_bin_xtr_plugin_t *curxtr;
 struct r_bin_plugin_t *curplugin;
 RList *objs;
 RList *xtr_data;
 Sdb *sdb;
 Sdb *sdb_info;
 Sdb *sdb_addrinfo;
 struct r_bin_t *rbin;
} RBinFile;
typedef struct r_bin_t {
 const char *file;
 RBinFile *cur;
 int narch;
 void *user;
 int debase64;
 int minstrlen;
 int maxstrlen;
 unsigned long long maxstrbuf;
 int rawstr;
 Sdb *sdb;
 RIDPool *file_ids;
 RList *plugins;
 RList *binxtrs;
 RList *binfiles;
 PrintfCallback cb_printf;
 int loadany;
 RIOBind iob;
 char *force;
 int is_debugger;
 _Bool want_dbginfo;
 int filter; 
 char strfilter; 
 int strpurge; 
 char *srcdir; 
 char *prefix; 
 unsigned long long filter_rules;
 _Bool demanglercmd;
 _Bool verbose;
 _Bool io_owned;
} RBin;
typedef struct r_bin_xtr_metadata_t {
 char *arch;
 int bits;
 char *libname;
 char *machine;
 char *type;
} RBinXtrMetadata;
typedef int (*FREE_XTR)(void *xtr_obj);
typedef struct r_bin_xtr_extract_t {
 char *file;
 unsigned char *buffer;
 unsigned long long size;
 unsigned long long offset;
 unsigned long long baddr;
 unsigned long long laddr;
 int file_count;
 int loaded;
 RBinXtrMetadata *metadata;
} RBinXtrData;
__attribute__((visibility("default"))) RBinXtrData * r_bin_xtrdata_new (RBuffer *buf, unsigned long long offset, unsigned long long size, unsigned int file_count, RBinXtrMetadata *metadata);
__attribute__((visibility("default"))) void r_bin_xtrdata_free (void  *data);
__attribute__((visibility("default"))) void r_bin_info_free (RBinInfo *rb);
__attribute__((visibility("default"))) void r_bin_import_free(void *_imp);
__attribute__((visibility("default"))) void r_bin_symbol_free(void *_sym);
__attribute__((visibility("default"))) void r_bin_string_free(void *_str);
typedef struct r_bin_xtr_plugin_t {
 char *name;
 char *desc;
 char *license;
 int (*init)(void *user);
 int (*fini)(void *user);
 _Bool (*check_bytes)(const unsigned char *bytes, unsigned long long sz);
 RBinXtrData * (*extract_from_bytes)(RBin *bin, const unsigned char *buf, unsigned long long size, int idx);
 RList * (*extractall_from_bytes)(RBin *bin, const unsigned char *buf, unsigned long long size);
 RBinXtrData * (*extract)(RBin *bin, int idx);
 RList * (*extractall)(RBin *bin);
 _Bool (*load)(RBin *bin);
 int (*size)(RBin *bin);
 int (*destroy)(RBin *bin);
 int (*free_xtr)(void *xtr_obj);
} RBinXtrPlugin;
typedef struct r_bin_plugin_t {
 char *name;
 char *desc;
 char *author;
 char *version;
 char *license;
 int (*init)(void *user);
 int (*fini)(void *user);
 Sdb * (*get_sdb)(RBinFile *obj);
 _Bool (*load)(RBinFile *arch);
 void *(*load_bytes)(RBinFile *arch, const unsigned char *buf, unsigned long long sz, unsigned long long loadaddr, Sdb *sdb);
 unsigned long long (*size)(RBinFile *bin); 
 int (*destroy)(RBinFile *arch);
 _Bool (*check_bytes)(const unsigned char *buf, unsigned long long length);
 unsigned long long (*baddr)(RBinFile *arch);
 unsigned long long (*boffset)(RBinFile *arch);
 RBinAddr* (*binsym)(RBinFile *arch, int num);
 RList* (*entries)(RBinFile *arch);
 RList* (*sections)(RBinFile *arch);
 RList* (*lines)(RBinFile *arch);
 RList* (*symbols)(RBinFile *arch);
 RList* (*imports)(RBinFile *arch);
 RList* (*strings)(RBinFile *arch);
 RBinInfo* (*info)(RBinFile *arch);
 RList* (*fields)(RBinFile *arch);
 RList* (*libs)(RBinFile *arch);
 RList* (*relocs)(RBinFile *arch);
 RList* (*classes)(RBinFile *arch);
 RList* (*mem)(RBinFile *arch);
 RList* (*patch_relocs)(RBin *bin);
 void (*header)(RBinFile *arch);
 char* (*signature)(RBinFile *arch, _Bool json);
 int (*demangle_type)(const char *str);
 struct r_bin_dbginfo_t *dbginfo;
 struct r_bin_write_t *write;
 int (*get_offset)(RBinFile *arch, int type, int idx);
 char* (*get_name)(RBinFile *arch, int type, int idx);
 unsigned long long (*get_vaddr)(RBinFile *arch, unsigned long long baddr, unsigned long long paddr, unsigned long long vaddr);
 RBuffer* (*create)(RBin *bin, const unsigned char *code, int codelen, const unsigned char *data, int datalen);
 char* (*demangle)(const char *str);
 int minstrlen;
 char strfilter;
 void *user;
} RBinPlugin;
typedef struct r_bin_section_t {
 char name[512 + 1]; 
 unsigned long long size;
 unsigned long long vsize;
 unsigned long long vaddr;
 unsigned long long paddr;
 unsigned int srwx;
 const char *arch;
 char *format;
 int bits;
 _Bool has_strings;
 _Bool add; 
 _Bool is_data;
} RBinSection;
typedef struct r_bin_class_t {
 char *name;
 char *super;
 char *visibility_str;
 int index;
 unsigned long long addr;
 RList *methods; 
 RList *fields; 
 int visibility;
} RBinClass;
typedef struct r_bin_symbol_t {
 char *name;
 char *dname;
 char *classname;
 const char *forwarder;
 const char *bind;
 const char *type;
   const char *rtype;
 const char *visibility_str;
 unsigned long long vaddr;
 unsigned long long paddr;
 unsigned int size;
 unsigned int ordinal;
 unsigned int visibility;
 int bits;
 unsigned long long method_flags;
 int dup_count;
} RBinSymbol;
typedef struct r_bin_import_t {
 char *name;
 const char *bind;
 const char *type;
 char *classname;
 char *descriptor;
 unsigned int ordinal;
 unsigned int visibility;
} RBinImport;
typedef struct r_bin_reloc_t {
 unsigned char type;
 unsigned char additive;
 RBinSymbol *symbol;
 RBinImport *import;
 long long addend;
 unsigned long long vaddr;
 unsigned long long paddr;
 unsigned int visibility;
 _Bool is_ifunc;
} RBinReloc;
typedef struct r_bin_string_t {
 char *string;
 unsigned long long vaddr;
 unsigned long long paddr;
 unsigned int ordinal;
 unsigned int size; 
 unsigned int length; 
 char type; 
} RBinString;
typedef struct r_bin_field_t {
 unsigned long long vaddr;
 unsigned long long paddr;
 int size;
 unsigned int visibility;
 char *name;
 char *type;
 char *comment;
 char *format;
 unsigned long long flags;
} RBinField;
__attribute__((visibility("default"))) RBinField *r_bin_field_new(unsigned long long paddr, unsigned long long vaddr, int size, const char *name, const char *comment, const char *format);
__attribute__((visibility("default"))) void r_bin_field_free(void *); 
typedef struct r_bin_mem_t { 
 char *name;
 unsigned long long addr;
 int size;
 int perms;
 RList *mirrors; 
} RBinMem;
typedef struct r_bin_dbginfo_t {
 int (*get_line)(RBinFile *arch, unsigned long long addr, char *file, int len, int *line);
} RBinDbgInfo;
typedef struct r_bin_write_t {
 unsigned long long (*scn_resize)(RBinFile *arch, const char *name, unsigned long long size);
 _Bool (*scn_perms)(RBinFile *arch, const char *name, int perms);
 int (*rpath_del)(RBinFile *arch);
 _Bool (*entry)(RBinFile *arch, unsigned long long addr);
 _Bool (*addlib)(RBinFile *arch, const char *lib);
} RBinWrite;
typedef int (*RBinGetOffset)(RBin *bin, int type, int idx);
typedef const char *(*RBinGetName)(RBin *bin, int type, int idx);
typedef RList *(*RBinGetSections)(RBin *bin);
typedef RBinSection *(*RBinGetSectionAt)(RBin *bin, unsigned long long addr);
typedef struct r_bin_bind_t {
 RBin *bin;
 RBinGetOffset get_offset;
 RBinGetName get_name;
 RBinGetSections get_sections;
 RBinGetSectionAt get_vsect_at;
 unsigned int visibility;
} RBinBind;
__attribute__((visibility("default"))) void r_bin_load_filter(RBin *bin, unsigned long long rules);
__attribute__((visibility("default"))) int r_bin_load(RBin *bin, const char *file, unsigned long long baseaddr, unsigned long long loadaddr, int xtr_idx, int fd, int rawstr);
__attribute__((visibility("default"))) int r_bin_reload(RBin *bin, int fd, unsigned long long baseaddr);
__attribute__((visibility("default"))) int r_bin_load_as(RBin *bin, const char *file, unsigned long long baseaddr, unsigned long long loadaddr, int xtr_idx, int fd, int rawstr, int fileoffset, const char *name);
__attribute__((visibility("default"))) int r_bin_load_io(RBin *bin, int fd, unsigned long long baseaddr, unsigned long long loadaddr, int xtr_idx);
__attribute__((visibility("default"))) _Bool r_bin_load_io_at_offset_as(RBin *bin, int fd, unsigned long long baseaddr, unsigned long long loadaddr, int xtr_idx, unsigned long long offset, const char *name);
__attribute__((visibility("default"))) int r_bin_load_io_at_offset_as_sz(RBin *bin, int fd, unsigned long long baseaddr, unsigned long long loadaddr, int xtr_idx, unsigned long long offset, const char *name, unsigned long long sz);
__attribute__((visibility("default"))) void r_bin_bind(RBin *b, RBinBind *bnd);
__attribute__((visibility("default"))) int r_bin_add(RBin *bin, RBinPlugin *foo);
__attribute__((visibility("default"))) int r_bin_xtr_add(RBin *bin, RBinXtrPlugin *foo);
__attribute__((visibility("default"))) void* r_bin_free(RBin *bin);
__attribute__((visibility("default"))) int r_bin_load_languages(RBinFile *binfile);
__attribute__((visibility("default"))) int r_bin_dump_strings(RBinFile *a, int min);
__attribute__((visibility("default"))) RList* r_bin_raw_strings(RBinFile *a, int min);
__attribute__((visibility("default"))) int r_bin_read_at (RBin *bin, unsigned long long addr, unsigned char *buf, int size);
__attribute__((visibility("default"))) int r_bin_write_at (RBin *bin, unsigned long long addr, const unsigned char *buf, int size);
__attribute__((visibility("default"))) int r_bin_file_deref_by_bind (RBinBind * binb);
__attribute__((visibility("default"))) int r_bin_file_deref (RBin *bin, RBinFile * a);
__attribute__((visibility("default"))) int r_bin_file_ref_by_bind (RBinBind * binb);
__attribute__((visibility("default"))) int r_bin_file_ref (RBin *bin, RBinFile * a);
__attribute__((visibility("default"))) _Bool r_bin_file_object_new_from_xtr_data(RBin *bin, RBinFile *bf,
      unsigned long long baseaddr, unsigned long long loadaddr,
      RBinXtrData *xtr_data);
__attribute__((visibility("default"))) int r_bin_list(RBin *bin, int json);
__attribute__((visibility("default"))) int r_bin_list_plugin(RBin *bin, const char* name, int json);
__attribute__((visibility("default"))) RBinObject *r_bin_get_object(RBin *bin);
__attribute__((visibility("default"))) unsigned long long r_binfile_get_baddr (RBinFile *binfile);
__attribute__((visibility("default"))) unsigned long long r_bin_get_baddr(RBin *bin);
__attribute__((visibility("default"))) void r_bin_set_baddr(RBin *bin, unsigned long long baddr);
__attribute__((visibility("default"))) unsigned long long r_bin_get_laddr(RBin *bin);
__attribute__((visibility("default"))) unsigned long long r_bin_get_boffset(RBin *bin);
__attribute__((visibility("default"))) RBinAddr* r_bin_get_sym(RBin *bin, int sym);
__attribute__((visibility("default"))) const char *r_bin_entry_type_string(int etype);
__attribute__((visibility("default"))) char* r_bin_demangle(RBinFile *binfile, const char *lang, const char *str, unsigned long long vaddr);
__attribute__((visibility("default"))) int r_bin_demangle_type (const char *str);
__attribute__((visibility("default"))) char *r_bin_demangle_java(const char *str);
__attribute__((visibility("default"))) char *r_bin_demangle_cxx(RBinFile *binfile, const char *str, unsigned long long vaddr);
__attribute__((visibility("default"))) char *r_bin_demangle_msvc(const char *str);
__attribute__((visibility("default"))) char *r_bin_demangle_swift(const char *s, _Bool syscmd);
__attribute__((visibility("default"))) char *r_bin_demangle_objc(RBinFile *binfile, const char *sym);
__attribute__((visibility("default"))) char *r_bin_demangle_rust(RBinFile *binfile, const char *str, unsigned long long vaddr);
__attribute__((visibility("default"))) int r_bin_lang_type(RBinFile *binfile, const char *def, const char *sym);
__attribute__((visibility("default"))) _Bool r_bin_lang_objc(RBinFile *binfile);
__attribute__((visibility("default"))) _Bool r_bin_lang_swift(RBinFile *binfile);
__attribute__((visibility("default"))) _Bool r_bin_lang_cxx(RBinFile *binfile);
__attribute__((visibility("default"))) _Bool r_bin_lang_msvc(RBinFile *binfile);
__attribute__((visibility("default"))) _Bool r_bin_lang_dlang(RBinFile *binfile);
__attribute__((visibility("default"))) _Bool r_bin_lang_rust(RBinFile *binfile);
__attribute__((visibility("default"))) const char *r_bin_get_meth_flag_string(unsigned long long flag, _Bool compact);
__attribute__((visibility("default"))) RList* r_bin_get_entries(RBin *bin);
__attribute__((visibility("default"))) RList* r_bin_get_fields(RBin *bin);
__attribute__((visibility("default"))) RList* r_bin_get_imports(RBin *bin);
__attribute__((visibility("default"))) RBinInfo* r_bin_get_info(RBin *bin);
__attribute__((visibility("default"))) RList* r_bin_get_libs(RBin *bin);
__attribute__((visibility("default"))) unsigned long long r_bin_get_size (RBin *bin);
__attribute__((visibility("default"))) RList* r_bin_patch_relocs(RBin *bin);
__attribute__((visibility("default"))) RList* r_bin_get_relocs(RBin *bin);
__attribute__((visibility("default"))) RList* r_bin_get_sections(RBin *bin);
__attribute__((visibility("default"))) RList* r_bin_get_classes(RBin *bin);
__attribute__((visibility("default"))) RBinClass *r_bin_class_get (RBinFile *binfile, const char *name);
__attribute__((visibility("default"))) RBinClass *r_bin_class_new (RBinFile *binfile, const char *name, const char *super, int view);
__attribute__((visibility("default"))) void r_bin_class_free(RBinClass *c);
__attribute__((visibility("default"))) RBinSymbol *r_bin_class_add_method (RBinFile *binfile, const char *classname, const char *name, int nargs);
__attribute__((visibility("default"))) void r_bin_class_add_field (RBinFile *binfile, const char *classname, const char *name);
__attribute__((visibility("default"))) RBinSection* r_bin_get_section_at(RBinObject *o, unsigned long long off, int va);
__attribute__((visibility("default"))) RList* r_bin_get_strings(RBin *bin);
__attribute__((visibility("default"))) int r_bin_is_string(RBin *bin, unsigned long long va);
__attribute__((visibility("default"))) RList* r_bin_reset_strings(RBin *bin);
__attribute__((visibility("default"))) RList* r_bin_get_symbols(RBin *bin);
__attribute__((visibility("default"))) RBinSymbol *r_bin_get_symbol_at_vaddr(RBin *bin, unsigned long long addr);
__attribute__((visibility("default"))) RBinSymbol *r_bin_get_symbol_at_paddr(RBin *bin, unsigned long long addr);
__attribute__((visibility("default"))) int r_bin_is_big_endian(RBin *bin);
__attribute__((visibility("default"))) int r_bin_is_stripped(RBin *bin);
__attribute__((visibility("default"))) int r_bin_is_static(RBin *bin);
__attribute__((visibility("default"))) int r_bin_has_dbg_linenums(RBin *bin);
__attribute__((visibility("default"))) int r_bin_has_dbg_syms(RBin *bin);
__attribute__((visibility("default"))) int r_bin_has_dbg_relocs(RBin *bin);
__attribute__((visibility("default"))) RBin* r_bin_new(void);
__attribute__((visibility("default"))) void r_bin_iobind(RBin *bin, RIO *io);
__attribute__((visibility("default"))) RBinFile * r_bin_cur(RBin *bin);
__attribute__((visibility("default"))) RBinObject * r_bin_cur_object(RBin *bin);
__attribute__((visibility("default"))) int r_bin_file_set_cur_binfile_obj(RBin * bin, RBinFile *bf, RBinObject *obj);
__attribute__((visibility("default"))) int r_bin_io_load(RBin *bin, RIO *io, int fd, unsigned long long baseaddr, unsigned long long loadaddr, int dummy);
__attribute__((visibility("default"))) int r_bin_select(RBin *bin, const char *arch, int bits, const char *name);
__attribute__((visibility("default"))) int r_bin_select_idx(RBin *bin, const char *name, int idx);
__attribute__((visibility("default"))) int r_bin_select_by_ids(RBin *bin, unsigned int binfile_id, unsigned int binobj_id );
__attribute__((visibility("default"))) int r_bin_object_delete (RBin *bin, unsigned int binfile_id, unsigned int binobj_id);
__attribute__((visibility("default"))) int r_bin_object_set_items(RBinFile *binfile, RBinObject *o);
__attribute__((visibility("default"))) int r_bin_use_arch(RBin *bin, const char *arch, int bits, const char *name);
__attribute__((visibility("default"))) RBinFile * r_bin_file_find_by_arch_bits(RBin *bin, const char *arch, int bits, const char *name);
__attribute__((visibility("default"))) RBinObject * r_bin_object_find_by_arch_bits (RBinFile *binfile, const char *arch, int bits, const char *name);
__attribute__((visibility("default"))) void r_bin_list_archs(RBin *bin, int mode);
__attribute__((visibility("default"))) void r_bin_set_user_ptr(RBin *bin, void *user);
__attribute__((visibility("default"))) RBuffer *r_bin_create (RBin *bin, const unsigned char *code, int codelen, const unsigned char *data, int datalen);
__attribute__((visibility("default"))) RBuffer *r_bin_package (RBin *bin, const char *type, const char *file, RList *files);
__attribute__((visibility("default"))) unsigned long long r_bin_get_vaddr (RBin *bin, unsigned long long paddr, unsigned long long vaddr);
__attribute__((visibility("default"))) unsigned long long r_bin_a2b (RBin *bin, unsigned long long addr);
__attribute__((visibility("default"))) int r_bin_file_delete(RBin *bin, unsigned int bin_fd);
__attribute__((visibility("default"))) int r_bin_file_delete_all(RBin *bin);
__attribute__((visibility("default"))) int r_bin_file_set_cur_by_fd (RBin *bin, unsigned int bin_fd);
__attribute__((visibility("default"))) int r_bin_file_set_cur_by_name (RBin * bin, const char * name);
__attribute__((visibility("default"))) RBinFile * r_bin_file_find_by_fd (RBin *bin, unsigned int bin_fd);
__attribute__((visibility("default"))) RBinFile * r_bin_file_find_by_name (RBin * bin, const char * name);
__attribute__((visibility("default"))) RBinFile * r_bin_file_find_by_name_n (RBin * bin, const char * name, int idx);
__attribute__((visibility("default"))) int r_bin_file_set_cur_binfile (RBin * bin, RBinFile *bf);
__attribute__((visibility("default"))) RBinPlugin * r_bin_file_cur_plugin (RBinFile *binfile);
__attribute__((visibility("default"))) void r_bin_force_plugin (RBin *bin, const char *pname);
__attribute__((visibility("default"))) const char *r_bin_string_type (int type);
__attribute__((visibility("default"))) int r_bin_addr2line(RBin *bin, unsigned long long addr, char *file, int len, int *line);
__attribute__((visibility("default"))) char *r_bin_addr2text(RBin *bin, unsigned long long addr, int origin);
__attribute__((visibility("default"))) char *r_bin_addr2fileline(RBin *bin, unsigned long long addr);
__attribute__((visibility("default"))) _Bool r_bin_wr_addlib(RBin *bin, const char *lib);
__attribute__((visibility("default"))) unsigned long long r_bin_wr_scn_resize(RBin *bin, const char *name, unsigned long long size);
__attribute__((visibility("default"))) _Bool r_bin_wr_scn_perms(RBin *bin, const char *name, int perms);
__attribute__((visibility("default"))) _Bool r_bin_wr_rpath_del(RBin *bin);
__attribute__((visibility("default"))) _Bool r_bin_wr_entry(RBin *bin, unsigned long long addr);
__attribute__((visibility("default"))) _Bool r_bin_wr_output(RBin *bin, const char *filename);
__attribute__((visibility("default"))) int r_bin_dwarf_parse_info(RBinDwarfDebugAbbrev *da, RBin *a, int mode);
__attribute__((visibility("default"))) RList *r_bin_dwarf_parse_line(RBin *a, int mode);
__attribute__((visibility("default"))) RList *r_bin_dwarf_parse_aranges(RBin *a, int mode);
__attribute__((visibility("default"))) RBinDwarfDebugAbbrev *r_bin_dwarf_parse_abbrev(RBin *a, int mode);
__attribute__((visibility("default"))) RBinPlugin * r_bin_get_binplugin_by_bytes (RBin *bin, const unsigned char* bytes, unsigned long long sz);
__attribute__((visibility("default"))) void r_bin_demangle_list(RBin *bin);
__attribute__((visibility("default"))) char *r_bin_demangle_plugin(RBin *bin, const char *name, const char *str);
__attribute__((visibility("default"))) RList *r_bin_get_mem (RBin *bin);
__attribute__((visibility("default"))) void r_bin_filter_name(Sdb *db, unsigned long long addr, char *name, int maxlen);
__attribute__((visibility("default"))) void r_bin_filter_symbols (RList *list);
__attribute__((visibility("default"))) void r_bin_filter_sections (RList *list);
__attribute__((visibility("default"))) void r_bin_filter_classes (RList *list);
extern RBinPlugin r_bin_plugin_any;
extern RBinPlugin r_bin_plugin_fs;
extern RBinPlugin r_bin_plugin_cgc;
extern RBinPlugin r_bin_plugin_elf;
extern RBinPlugin r_bin_plugin_elf64;
extern RBinPlugin r_bin_plugin_p9;
extern RBinPlugin r_bin_plugin_pe;
extern RBinPlugin r_bin_plugin_mz;
extern RBinPlugin r_bin_plugin_pe64;
extern RBinPlugin r_bin_plugin_pebble;
extern RBinPlugin r_bin_plugin_bios;
extern RBinPlugin r_bin_plugin_bf;
extern RBinPlugin r_bin_plugin_te;
extern RBinPlugin r_bin_plugin_mach0;
extern RBinPlugin r_bin_plugin_mach064;
extern RBinPlugin r_bin_plugin_mdmp;
extern RBinPlugin r_bin_plugin_java;
extern RBinPlugin r_bin_plugin_dex;
extern RBinPlugin r_bin_plugin_dummy;
extern RBinPlugin r_bin_plugin_coff;
extern RBinPlugin r_bin_plugin_ningb;
extern RBinPlugin r_bin_plugin_ningba;
extern RBinPlugin r_bin_plugin_ninds;
extern RBinPlugin r_bin_plugin_nin3ds;
extern RBinPlugin r_bin_plugin_xbe;
extern RBinPlugin r_bin_plugin_bflt;
extern RBinXtrPlugin r_bin_xtr_plugin_fatmach0;
extern RBinXtrPlugin r_bin_xtr_plugin_xtr_dyldcache;
extern RBinPlugin r_bin_plugin_zimg;
extern RBinPlugin r_bin_plugin_omf;
extern RBinPlugin r_bin_plugin_art;
extern RBinPlugin r_bin_plugin_bootimg;
extern RBinPlugin r_bin_plugin_dol;
extern RBinPlugin r_bin_plugin_nes;
extern RBinPlugin r_bin_plugin_mbn;
extern RBinPlugin r_bin_plugin_smd;
extern RBinPlugin r_bin_plugin_sms;
extern RBinPlugin r_bin_plugin_psxexe;
extern RBinPlugin r_bin_plugin_spc700;
extern RBinPlugin r_bin_plugin_vsf;
extern RBinPlugin r_bin_plugin_dyldcache;
extern RBinPlugin r_bin_plugin_avr;
extern RBinPlugin r_bin_plugin_menuet;
extern RBinPlugin r_bin_plugin_wasm;
extern RBinPlugin r_bin_plugin_nro;
extern RBinPlugin r_bin_plugin_nso;
extern RBinPlugin r_bin_plugin_sfc;
__attribute__((visibility("default"))) const char *r_flag_version(void);
typedef struct r_flag_zone_item_t {
 unsigned long long from;
 unsigned long long to;
 char *name;
} RFlagZoneItem;
typedef struct r_flags_at_offset_t {
 unsigned long long off;
 RList *flags; 
} RFlagsAtOffset;
typedef struct r_flag_item_t {
 char *name; 
 char *realname; 
 unsigned long long offset; 
 unsigned long long size; 
 int space; 
 char *color; 
 char *comment; 
 char *alias; 
} RFlagItem;
typedef struct r_flag_t {
 long long base; 
 int space_idx; 
 _Bool space_strict; 
 char *spaces[128]; 
 RNum *num;
 RSkipList *by_off; 
 SdbHash *ht_name; 
 RList *flags; 
 RList *spacestack;
 PrintfCallback cb_printf;
 RList *zones;
} RFlag;
typedef _Bool (*RFlagExistAt)(RFlag *f, const char *flag_prefix, unsigned short fp_size, unsigned long long off);
typedef RFlagItem* (*RFlagGet)(RFlag *f, const char *name);
typedef RFlagItem* (*RFlagGetAt)(RFlag *f, unsigned long long addr, _Bool closest);
typedef RFlagItem* (*RFlagSet)(RFlag *f, const char *name, unsigned long long addr, unsigned int size);
typedef int (*RFlagSetSpace)(RFlag *f, const char *name);
typedef struct r_flag_bind_t {
 int init;
 RFlag *f;
 RFlagExistAt exist_at;
 RFlagGet get;
 RFlagGetAt get_at;
 RFlagSet set;
 RFlagSetSpace set_fs;
} RFlagBind;
__attribute__((visibility("default"))) int r_flag_bind(RFlag *io, RFlagBind *bnd);
__attribute__((visibility("default"))) RFlag * r_flag_new(void);
__attribute__((visibility("default"))) RFlag * r_flag_free(RFlag *f);
__attribute__((visibility("default"))) void r_flag_list(RFlag *f, int rad, const char *pfx);
__attribute__((visibility("default"))) _Bool r_flag_exist_at(RFlag *f, const char *flag_prefix, unsigned short fp_size, unsigned long long off);
__attribute__((visibility("default"))) RFlagItem *r_flag_get(RFlag *f, const char *name);
__attribute__((visibility("default"))) RFlagItem *r_flag_get_i(RFlag *f, unsigned long long off);
__attribute__((visibility("default"))) RFlagItem *r_flag_get_i2(RFlag *f, unsigned long long off);
__attribute__((visibility("default"))) RFlagItem *r_flag_get_at(RFlag *f, unsigned long long off, _Bool closest);
__attribute__((visibility("default"))) const RList*  r_flag_get_list(RFlag *f, unsigned long long off);
__attribute__((visibility("default"))) char *r_flag_get_liststr(RFlag *f, unsigned long long off);
__attribute__((visibility("default"))) int r_flag_unset(RFlag *f, RFlagItem *item);
__attribute__((visibility("default"))) int r_flag_unset_name(RFlag *f, const char *name);
__attribute__((visibility("default"))) int r_flag_unset_off(RFlag *f, unsigned long long addr);
__attribute__((visibility("default"))) void r_flag_unset_all (RFlag *f);
__attribute__((visibility("default"))) RFlagItem *r_flag_set(RFlag *fo, const char *name, unsigned long long addr, unsigned int size);
__attribute__((visibility("default"))) RFlagItem *r_flag_set_next(RFlag *fo, const char *name, unsigned long long addr, unsigned int size);
__attribute__((visibility("default"))) int r_flag_sort(RFlag *f, int namesort);
__attribute__((visibility("default"))) void r_flag_item_set_alias(RFlagItem *item, const char *alias);
__attribute__((visibility("default"))) void r_flag_item_free (RFlagItem *item);
__attribute__((visibility("default"))) void r_flag_item_set_comment(RFlagItem *item, const char *comment);
__attribute__((visibility("default"))) void r_flag_item_set_realname(RFlagItem *item, const char *realname);
__attribute__((visibility("default"))) int r_flag_unset_glob(RFlag *f, const char *name);
__attribute__((visibility("default"))) int r_flag_rename(RFlag *f, RFlagItem *item, const char *name);
__attribute__((visibility("default"))) int r_flag_relocate (RFlag *f, unsigned long long off, unsigned long long off_mask, unsigned long long to);
__attribute__((visibility("default"))) int r_flag_move (RFlag *f, unsigned long long at, unsigned long long to);
__attribute__((visibility("default"))) const char *r_flag_color(RFlag *f, RFlagItem *it, const char *color);
__attribute__((visibility("default"))) int r_flag_space_get(RFlag *f, const char *name);
__attribute__((visibility("default"))) const char *r_flag_space_get_i(RFlag *f, int idx);
__attribute__((visibility("default"))) const char *r_flag_space_cur(RFlag *f);
__attribute__((visibility("default"))) int r_flag_space_set(RFlag *f, const char *name);
__attribute__((visibility("default"))) _Bool r_flag_space_set_i(RFlag *f, int idx);
__attribute__((visibility("default"))) int r_flag_count (RFlag *f, const char *name);
__attribute__((visibility("default"))) int r_flag_space_unset (RFlag *f, const char *fs);
__attribute__((visibility("default"))) int r_flag_space_list(RFlag *f, int mode);
__attribute__((visibility("default"))) int r_flag_space_rename (RFlag *f, const char *oname, const char *nname);
__attribute__((visibility("default"))) _Bool r_flag_space_pop(RFlag *f);
__attribute__((visibility("default"))) int r_flag_space_push(RFlag *f, const char *name);
__attribute__((visibility("default"))) int r_flag_space_stack_list(RFlag *f, int mode);
__attribute__((visibility("default"))) void r_flag_zone_item_free(void *a);
__attribute__((visibility("default"))) _Bool r_flag_zone_add(RFlag *fz, const char *name, unsigned long long addr);
__attribute__((visibility("default"))) _Bool r_flag_zone_del(RFlag *fz, const char *name);
__attribute__((visibility("default"))) _Bool r_flag_zone_around(RFlag *fz, unsigned long long addr, const char **prev, const char **next);
__attribute__((visibility("default"))) _Bool r_flag_zone_list(RFlag *fz, int mode);
__attribute__((visibility("default"))) _Bool r_flag_zone_reset(RFlag *f);
__attribute__((visibility("default"))) const char *r_reg_version(void);
typedef enum {
 R_REG_TYPE_GPR,
 R_REG_TYPE_DRX,
 R_REG_TYPE_FPU,
 R_REG_TYPE_MMX,
 R_REG_TYPE_XMM,
 R_REG_TYPE_FLG,
 R_REG_TYPE_SEG,
 R_REG_TYPE_LAST,
 R_REG_TYPE_ALL = -1, 
} RRegisterType;
typedef enum {
 R_REG_NAME_PC, 
 R_REG_NAME_SP, 
 R_REG_NAME_SR, 
 R_REG_NAME_BP, 
 R_REG_NAME_LR, 
 R_REG_NAME_A0, 
 R_REG_NAME_A1,
 R_REG_NAME_A2,
 R_REG_NAME_A3,
 R_REG_NAME_A4,
 R_REG_NAME_A5,
 R_REG_NAME_A6,
 R_REG_NAME_A7,
 R_REG_NAME_A8,
 R_REG_NAME_A9,
 R_REG_NAME_R0, 
 R_REG_NAME_R1,
 R_REG_NAME_R2,
 R_REG_NAME_R3,
 R_REG_NAME_ZF,
 R_REG_NAME_SF,
 R_REG_NAME_CF,
 R_REG_NAME_OF,
 R_REG_NAME_SN,
 R_REG_NAME_LAST,
} RRegisterId;
typedef struct r_reg_item_t {
 char *name;
 int  type;
 int size; 
 int offset; 
 int packed_size; 
 _Bool is_float;
 char *flags;
 int index;
 int arena; 
} RRegItem;
typedef struct r_reg_arena_t {
 unsigned char *bytes;
 int size;
} RRegArena;
typedef struct r_reg_set_t {
 RRegArena *arena;
 RList *pool; 
 RList *regs; 
 RListIter *cur;
 int maskregstype; 
} RRegSet;
typedef struct r_reg_t {
 char *profile;
 char *reg_profile_cmt;
 char *reg_profile_str;
 char *name[R_REG_NAME_LAST]; 
 RRegSet regset[R_REG_TYPE_LAST];
 RList *allregs;
 int iters;
 int arch;
 int bits;
 int size;
 _Bool is_thumb;
 _Bool big_endian;
} RReg;
typedef struct r_reg_flags_t {
 _Bool s; 
 _Bool z; 
 _Bool a; 
 _Bool c; 
 _Bool o; 
 _Bool p; 
} RRegFlags;
__attribute__((visibility("default"))) void r_reg_free(RReg *reg);
__attribute__((visibility("default"))) void r_reg_free_internal(RReg *reg, _Bool init);
__attribute__((visibility("default"))) RReg *r_reg_new(void);
__attribute__((visibility("default"))) int r_reg_set_name(RReg *reg, int role, const char *name);
__attribute__((visibility("default"))) int r_reg_set_profile_string(RReg *reg, const char *profile);
__attribute__((visibility("default"))) int r_reg_set_profile(RReg *reg, const char *profile);
__attribute__((visibility("default"))) int r_reg_parse_gdb_profile(const char *profile);
__attribute__((visibility("default"))) RRegSet *r_reg_regset_get(RReg *r, int type);
__attribute__((visibility("default"))) unsigned long long r_reg_getv(RReg *reg, const char *name);
__attribute__((visibility("default"))) unsigned long long r_reg_setv(RReg *reg, const char *name, unsigned long long val);
__attribute__((visibility("default"))) const char *r_reg_32_to_64(RReg *reg, const char *rreg32);
__attribute__((visibility("default"))) const char *r_reg_get_type(int idx);
__attribute__((visibility("default"))) const char *r_reg_get_name(RReg *reg, int kind);
__attribute__((visibility("default"))) const char *r_reg_get_role(int role);
__attribute__((visibility("default"))) RRegItem *r_reg_get(RReg *reg, const char *name, int type);
__attribute__((visibility("default"))) RList *r_reg_get_list(RReg *reg, int type);
__attribute__((visibility("default"))) RRegItem *r_reg_get_at(RReg *reg, int type, int regsize, int delta);
__attribute__((visibility("default"))) RRegItem *r_reg_next_diff(RReg *reg, int type, const unsigned char *buf, int buflen, RRegItem *prev_ri, int regsize);
__attribute__((visibility("default"))) void r_reg_reindex(RReg *reg);
__attribute__((visibility("default"))) RRegItem *r_reg_index_get(RReg *reg, int idx);
__attribute__((visibility("default"))) void r_reg_item_free(RRegItem *item);
__attribute__((visibility("default"))) int r_reg_type_by_name(const char *str);
__attribute__((visibility("default"))) int r_reg_get_name_idx(const char *type);
__attribute__((visibility("default"))) RRegItem *r_reg_cond_get(RReg *reg, const char *name);
__attribute__((visibility("default"))) int r_reg_cond_get_value(RReg *r, const char *name);
__attribute__((visibility("default"))) int r_reg_cond_bits(RReg *r, int type, RRegFlags *f);
__attribute__((visibility("default"))) RRegFlags *r_reg_cond_retrieve(RReg *r, RRegFlags *);
__attribute__((visibility("default"))) int r_reg_cond(RReg *r, int type);
__attribute__((visibility("default"))) unsigned long long r_reg_get_value(RReg *reg, RRegItem *item);
__attribute__((visibility("default"))) unsigned long long r_reg_get_value_big(RReg *reg, RRegItem *item, utX *val);
__attribute__((visibility("default"))) unsigned long long r_reg_get_value_by_role(RReg *reg, RRegisterId role);
__attribute__((visibility("default"))) _Bool r_reg_set_value(RReg *reg, RRegItem *item, unsigned long long value);
__attribute__((visibility("default"))) _Bool r_reg_set_value_by_role(RReg *reg, RRegisterId role, unsigned long long value);
__attribute__((visibility("default"))) float r_reg_get_float(RReg *reg, RRegItem *item);
__attribute__((visibility("default"))) _Bool r_reg_set_float(RReg *reg, RRegItem *item, float value);
__attribute__((visibility("default"))) double r_reg_get_double(RReg *reg, RRegItem *item);
__attribute__((visibility("default"))) _Bool r_reg_set_double(RReg *reg, RRegItem *item, double value);
__attribute__((visibility("default"))) long double r_reg_get_longdouble(RReg *reg, RRegItem *item);
__attribute__((visibility("default"))) _Bool r_reg_set_longdouble(RReg *reg, RRegItem *item, long double value);
__attribute__((visibility("default"))) char *r_reg_get_bvalue(RReg *reg, RRegItem *item);
__attribute__((visibility("default"))) unsigned long long r_reg_set_bvalue(RReg *reg, RRegItem *item, const char *str);
__attribute__((visibility("default"))) int r_reg_set_pack(RReg *reg, RRegItem *item, int packidx, int packbits, unsigned long long val);
__attribute__((visibility("default"))) unsigned long long r_reg_get_pack(RReg *reg, RRegItem *item, int packidx, int packbits);
__attribute__((visibility("default"))) unsigned char *r_reg_get_bytes(RReg *reg, int type, int *size);
__attribute__((visibility("default"))) _Bool r_reg_set_bytes(RReg *reg, int type, const unsigned char *buf, const int len);
__attribute__((visibility("default"))) _Bool r_reg_read_regs(RReg *reg, unsigned char *buf, const int len);
__attribute__((visibility("default"))) int r_reg_arena_set_bytes(RReg *reg, const char *str);
__attribute__((visibility("default"))) RRegArena *r_reg_arena_new(int size);
__attribute__((visibility("default"))) void r_reg_arena_free(RRegArena *ra);
__attribute__((visibility("default"))) int r_reg_fit_arena(RReg *reg);
__attribute__((visibility("default"))) void r_reg_arena_swap(RReg *reg, int copy);
__attribute__((visibility("default"))) int r_reg_arena_push(RReg *reg);
__attribute__((visibility("default"))) void r_reg_arena_pop(RReg *reg);
__attribute__((visibility("default"))) void r_reg_arena_zero(RReg *reg);
__attribute__((visibility("default"))) unsigned char *r_reg_arena_peek(RReg *reg);
__attribute__((visibility("default"))) void r_reg_arena_poke(RReg *reg, const unsigned char *buf);
__attribute__((visibility("default"))) unsigned char *r_reg_arena_dup(RReg *reg, const unsigned char *source);
__attribute__((visibility("default"))) const char *r_reg_cond_to_string(int n);
__attribute__((visibility("default"))) int r_reg_cond_from_string(const char *str);
__attribute__((visibility("default"))) void r_reg_arena_shrink(RReg *reg);
__attribute__((visibility("default"))) const char *r_syscall_version(void);
typedef struct r_syscall_regs_t {
 const char *arg[7];
} RSyscallRegs;
typedef struct r_syscall_item_t {
 char *name;
 int swi;
 int num;
 int args;
 char *sargs;
} RSyscallItem;
typedef struct r_syscall_port_t {
 int port;
 const char *name;
} RSyscallPort;
typedef struct r_syscall_t {
 FILE *fd;
 char *arch;
 char *os;
 int bits;
 RSyscallRegs *regs;
 RSyscallItem *sysptr;
 RSyscallPort *sysport;
 Sdb *db;
 PrintfCallback cb_printf;
} RSyscall;
typedef struct r_sysregs_item_t {
 unsigned long long address;
 unsigned long long size;
 int type;
 const char *name;
 const char *description;
} RSysregsItem;
typedef struct r_sysregs_t {
 FILE *fd;
 char *arch;
 char *cpu;
 RSysregsItem *sysregs;
 Sdb *db;
} RSysregs;
typedef struct r_syscall_plugin_t {
 char *name;
 char *arch;
 char *os;
 char *desc;
 int bits;
 int nargs;
 struct r_syscall_args_t *args;
} RSyscallPlugin;
typedef struct r_syscall_arch_plugin_t {
 char *name;
 char *arch;
 char *desc;
 int *bits;
 int nargs;
 struct r_syscall_args_t **args;
} RSyscallArchPlugin;
__attribute__((visibility("default"))) RSyscallItem *r_syscall_item_new_from_string(const char *name, const char *s);
__attribute__((visibility("default"))) void r_syscall_item_free(RSyscallItem *si);
__attribute__((visibility("default"))) RSyscall *r_syscall_new(void);
__attribute__((visibility("default"))) void r_syscall_free(RSyscall *ctx);
__attribute__((visibility("default"))) _Bool r_syscall_setup(RSyscall *ctx, const char *arch, const char *os, int bits);
__attribute__((visibility("default"))) int r_syscall_setup_file(RSyscall *ctx, const char *path);
__attribute__((visibility("default"))) RSyscallItem *r_syscall_get(RSyscall *ctx, int num, int swi);
__attribute__((visibility("default"))) int r_syscall_get_num(RSyscall *ctx, const char *str);
__attribute__((visibility("default"))) const char *r_syscall_get_i(RSyscall *ctx, int num, int swi);
__attribute__((visibility("default"))) const char *r_syscall_reg(RSyscall *s, int idx, int num);
__attribute__((visibility("default"))) RList *r_syscall_list(RSyscall *ctx);
__attribute__((visibility("default"))) int r_syscall_get_swi(RSyscall *s);
__attribute__((visibility("default"))) RSysregs *r_sysregs_new(void);
__attribute__((visibility("default"))) void r_sysregs_free(RSysregs *ctx);
__attribute__((visibility("default"))) int r_sysregs_setup(RSysregs *ctx, const char *arch, const char *cpu);
__attribute__((visibility("default"))) RSysregsItem *r_sysregs_get(RSysregs *ctx, unsigned long long addr, int type);
__attribute__((visibility("default"))) const char *r_syscall_get_io(RSyscall *s, int ioport);
__attribute__((visibility("default"))) const char *r_anal_version(void);
typedef struct r_anal_meta_item_t {
 unsigned long long from;
 unsigned long long to;
 unsigned long long size;
 int type;
 int subtype;
 char *str;
 int space;
} RAnalMetaItem;
typedef struct {
 struct r_anal_t *anal;
 int type;
 int rad;
 SdbForeachCallback cb;
 void *user;
 int count;
 struct r_anal_type_function_t *fcn;
} RAnalMetaUserItem;
typedef struct r_anal_range_t {
 unsigned long long from;
 unsigned long long to;
 int bits;
} RAnalRange;
enum {
 R_ANAL_DATA_TYPE_NULL = 0,
 R_ANAL_DATA_TYPE_UNKNOWN = 1,
 R_ANAL_DATA_TYPE_STRING = 2,
 R_ANAL_DATA_TYPE_WIDE_STRING = 3,
 R_ANAL_DATA_TYPE_POINTER = 4,
 R_ANAL_DATA_TYPE_NUMBER = 5,
 R_ANAL_DATA_TYPE_INVALID = 6,
 R_ANAL_DATA_TYPE_HEADER = 7,
 R_ANAL_DATA_TYPE_SEQUENCE = 8,
 R_ANAL_DATA_TYPE_PATTERN = 9,
};
typedef struct r_anal_type_var_t {
 char *name;
 int index;
 int scope;
 unsigned short type; 
 unsigned char size;
 union {
  unsigned char v8;
  unsigned short v16;
  unsigned int v32;
  unsigned long long v64;
 } value;
} RAnalTypeVar;
typedef struct r_anal_type_ptr_t {
 char *name;
 unsigned short type; 
 unsigned char size;
 union {
  unsigned char v8;
  unsigned short v16;
  unsigned int v32;
  unsigned long long v64;
 } value;
} RAnalTypePtr;
typedef struct r_anal_type_array_t {
 char *name;
 unsigned short type; 
 unsigned char size;
 unsigned long long count;
 union {
  unsigned char *v8;
  unsigned short *v16;
  unsigned int *v32;
  unsigned long long *v64;
 } value;
} RAnalTypeArray;
typedef struct r_anal_type_struct_t RAnalTypeStruct;
typedef struct r_anal_type_t RAnalType;
struct r_anal_type_struct_t {
 char *name;
 unsigned char type;
 unsigned int size;
 void *parent;
 RAnalType *items;
};
typedef struct r_anal_type_union_t {
 char *name;
 unsigned char type;
 unsigned int size;
 void *parent;
 RAnalType *items;
} RAnalTypeUnion;
typedef struct r_anal_type_alloca_t {
 long address;
 long size;
 void *parent;
 RAnalType *items;
} RAnalTypeAlloca;
enum {
 R_ANAL_FQUALIFIER_NONE = 0,
 R_ANAL_FQUALIFIER_STATIC = 1,
 R_ANAL_FQUALIFIER_VOLATILE = 2,
 R_ANAL_FQUALIFIER_INLINE = 3,
 R_ANAL_FQUALIFIER_NAKED = 4,
 R_ANAL_FQUALIFIER_VIRTUAL = 5,
};
enum {
 R_ANAL_FCN_TYPE_NULL = 0,
 R_ANAL_FCN_TYPE_FCN = 1 << 0,
 R_ANAL_FCN_TYPE_LOC = 1 << 1,
 R_ANAL_FCN_TYPE_SYM = 1 << 2,
 R_ANAL_FCN_TYPE_IMP = 1 << 3,
 R_ANAL_FCN_TYPE_INT = 1 << 4, 
 R_ANAL_FCN_TYPE_ROOT = 1 << 5 
};
typedef struct r_anal_varsub_t {
 char pat[128];
 char sub[128];
} RAnalVarSub;
enum {
 R_ANAL_DIFF_TYPE_NULL = 0,
 R_ANAL_DIFF_TYPE_MATCH = 'm',
 R_ANAL_DIFF_TYPE_UNMATCH = 'u'
};
typedef struct r_anal_diff_t {
 int type;
 unsigned long long addr;
 double dist;
 char *name;
 unsigned int size;
} RAnalDiff;
typedef struct r_anal_locals_t {
 RAnalType *items;
} RAnalLocals;
typedef struct r_anal_fcn_local_t {
 unsigned long long index;
 char* name;
 char* type;
} RAnalFcnLocal;
typedef struct r_anal_attr_t RAnalAttr;
struct r_anal_attr_t {
 char *key;
 long value;
 RAnalAttr *next;
};
typedef struct r_anal_fcn_store_t {
 SdbHash *h;
 RList *l;
} RAnalFcnStore;
typedef struct r_anal_fcn_meta_t {
 unsigned long long min; 
 unsigned long long max; 
 int numrefs; 
 int numcallrefs; 
 int sgnc; 
 int sgec; 
} RAnalFcnMeta;
typedef struct r_anal_type_function_t {
 char* name;
 char* dsc; 
 unsigned int _size;
 int bits; 
 int type;
 char *rets;
 short fmod; 
 const char *cc; 
 char* attr; 
 unsigned long long addr;
 unsigned long long rb_max_addr; 
 int stack; 
 int maxstack;
 int ninstr;
 int nargs; 
 int depth;
 _Bool folded;
 RAnalType *args; 
 unsigned char *fingerprint; 
 RAnalDiff *diff;
 RList *locs; 
 RList *fcn_locs; 
 RList *bbs;
 RList *refs;
 RList *xrefs;
 RAnalFcnMeta meta;
 RRangeTiny bbr;
 RBNode rb;
} RAnalFunction;
struct r_anal_type_t {
 char *name;
 unsigned int type;
 unsigned int size;
 RList *content;
};
enum {
 R_META_WHERE_PREV = -1,
 R_META_WHERE_HERE = 0,
 R_META_WHERE_NEXT = 1,
};
enum {
 R_META_TYPE_ANY = -1,
 R_META_TYPE_DATA = 'd',
 R_META_TYPE_CODE = 'c',
 R_META_TYPE_STRING = 's',
 R_META_TYPE_FORMAT = 'f',
 R_META_TYPE_MAGIC = 'm',
 R_META_TYPE_HIDE = 'h',
 R_META_TYPE_COMMENT = 'C',
 R_META_TYPE_RUN = 'r',
 R_META_TYPE_HIGHLIGHT = 'H',
};
enum {
 R_ANAL_OP_FAMILY_UNKNOWN = -1,
 R_ANAL_OP_FAMILY_CPU = 0,
 R_ANAL_OP_FAMILY_FPU, 
 R_ANAL_OP_FAMILY_MMX, 
 R_ANAL_OP_FAMILY_SSE, 
 R_ANAL_OP_FAMILY_PRIV, 
 R_ANAL_OP_FAMILY_CRYPTO, 
 R_ANAL_OP_FAMILY_VIRT, 
 R_ANAL_OP_FAMILY_IO, 
 R_ANAL_OP_FAMILY_LAST
};
 typedef enum {
  R_ANAL_OP_PREFIX_COND = 1,
  R_ANAL_OP_PREFIX_REP = 1<<1,
  R_ANAL_OP_PREFIX_REPNE = 1<<2,
  R_ANAL_OP_PREFIX_LOCK = 1<<3,
  R_ANAL_OP_PREFIX_LIKELY = 1<<4,
  R_ANAL_OP_PREFIX_UNLIKELY = 1<<5
 } RAnalOpPrefix;
typedef enum {
 R_ANAL_OP_TYPE_COND = 0x80000000, 
 R_ANAL_OP_TYPE_REP = 0x40000000, 
 R_ANAL_OP_TYPE_MEM = 0x20000000, 
 R_ANAL_OP_TYPE_REG = 0x10000000, 
 R_ANAL_OP_TYPE_IND = 0x08000000, 
 R_ANAL_OP_TYPE_NULL = 0,
 R_ANAL_OP_TYPE_JMP = 1, 
 R_ANAL_OP_TYPE_UJMP = 2, 
 R_ANAL_OP_TYPE_RJMP = R_ANAL_OP_TYPE_REG | R_ANAL_OP_TYPE_UJMP,
 R_ANAL_OP_TYPE_IJMP = R_ANAL_OP_TYPE_IND | R_ANAL_OP_TYPE_UJMP,
 R_ANAL_OP_TYPE_IRJMP = R_ANAL_OP_TYPE_IND | R_ANAL_OP_TYPE_REG | R_ANAL_OP_TYPE_UJMP,
 R_ANAL_OP_TYPE_CJMP = R_ANAL_OP_TYPE_COND | R_ANAL_OP_TYPE_JMP, 
 R_ANAL_OP_TYPE_MJMP = R_ANAL_OP_TYPE_MEM | R_ANAL_OP_TYPE_JMP, 
 R_ANAL_OP_TYPE_UCJMP = R_ANAL_OP_TYPE_COND | R_ANAL_OP_TYPE_UJMP, 
 R_ANAL_OP_TYPE_CALL = 3, 
 R_ANAL_OP_TYPE_UCALL = 4, 
 R_ANAL_OP_TYPE_RCALL = R_ANAL_OP_TYPE_REG | R_ANAL_OP_TYPE_UCALL,
 R_ANAL_OP_TYPE_ICALL = R_ANAL_OP_TYPE_IND | R_ANAL_OP_TYPE_UCALL,
 R_ANAL_OP_TYPE_IRCALL= R_ANAL_OP_TYPE_IND | R_ANAL_OP_TYPE_REG | R_ANAL_OP_TYPE_UCALL,
 R_ANAL_OP_TYPE_CCALL = R_ANAL_OP_TYPE_COND | R_ANAL_OP_TYPE_CALL, 
 R_ANAL_OP_TYPE_UCCALL= R_ANAL_OP_TYPE_COND | R_ANAL_OP_TYPE_UCALL, 
 R_ANAL_OP_TYPE_RET = 5, 
 R_ANAL_OP_TYPE_CRET = R_ANAL_OP_TYPE_COND | R_ANAL_OP_TYPE_RET, 
 R_ANAL_OP_TYPE_ILL = 6, 
 R_ANAL_OP_TYPE_UNK = 7, 
 R_ANAL_OP_TYPE_NOP = 8, 
 R_ANAL_OP_TYPE_MOV = 9, 
 R_ANAL_OP_TYPE_CMOV = 9 | R_ANAL_OP_TYPE_COND, 
 R_ANAL_OP_TYPE_TRAP = 10, 
 R_ANAL_OP_TYPE_SWI = 11, 
 R_ANAL_OP_TYPE_UPUSH = 12, 
 R_ANAL_OP_TYPE_PUSH = 13, 
 R_ANAL_OP_TYPE_POP = 14, 
 R_ANAL_OP_TYPE_CMP = 15, 
 R_ANAL_OP_TYPE_ACMP = 16, 
 R_ANAL_OP_TYPE_ADD = 17,
 R_ANAL_OP_TYPE_SUB = 18,
 R_ANAL_OP_TYPE_IO = 19,
 R_ANAL_OP_TYPE_MUL = 20,
 R_ANAL_OP_TYPE_DIV = 21,
 R_ANAL_OP_TYPE_SHR = 22,
 R_ANAL_OP_TYPE_SHL = 23,
 R_ANAL_OP_TYPE_SAL = 24,
 R_ANAL_OP_TYPE_SAR = 25,
 R_ANAL_OP_TYPE_OR = 26,
 R_ANAL_OP_TYPE_AND = 27,
 R_ANAL_OP_TYPE_XOR = 28,
 R_ANAL_OP_TYPE_NOR = 29,
 R_ANAL_OP_TYPE_NOT = 30,
 R_ANAL_OP_TYPE_STORE = 31, 
 R_ANAL_OP_TYPE_LOAD = 32, 
 R_ANAL_OP_TYPE_LEA = 33, 
 R_ANAL_OP_TYPE_LEAVE = 34,
 R_ANAL_OP_TYPE_ROR = 35,
 R_ANAL_OP_TYPE_ROL = 36,
 R_ANAL_OP_TYPE_XCHG = 37,
 R_ANAL_OP_TYPE_MOD = 38,
 R_ANAL_OP_TYPE_SWITCH = 39,
 R_ANAL_OP_TYPE_CASE = 40,
 R_ANAL_OP_TYPE_LENGTH = 41,
 R_ANAL_OP_TYPE_CAST = 42,
 R_ANAL_OP_TYPE_NEW = 43,
 R_ANAL_OP_TYPE_ABS = 44,
 R_ANAL_OP_TYPE_CPL = 45, 
 R_ANAL_OP_TYPE_CRYPTO = 46,
 R_ANAL_OP_TYPE_SYNC = 47,
} _RAnalOpType;
typedef enum {
 R_ANAL_COND_AL = 0, 
 R_ANAL_COND_EQ, 
 R_ANAL_COND_NE, 
 R_ANAL_COND_GE, 
 R_ANAL_COND_GT, 
 R_ANAL_COND_LE, 
 R_ANAL_COND_LT, 
 R_ANAL_COND_NV, 
 R_ANAL_COND_HS, 
 R_ANAL_COND_LO, 
 R_ANAL_COND_MI, 
 R_ANAL_COND_PL, 
 R_ANAL_COND_VS, 
 R_ANAL_COND_VC, 
 R_ANAL_COND_HI, 
 R_ANAL_COND_LS 
} _RAnalCond;
typedef enum {
 R_ANAL_VAR_SCOPE_NULL = 0,
 R_ANAL_VAR_SCOPE_GLOBAL = 0x00,
 R_ANAL_VAR_SCOPE_LOCAL = 0x01,
 R_ANAL_VAR_SCOPE_ARG = 0x04,
 R_ANAL_VAR_SCOPE_ARGREG = 0x08,
 R_ANAL_VAR_SCOPE_RET = 0x10,
} _RAnalVarScope;
typedef enum {
 R_ANAL_VAR_DIR_NONE = 0,
 R_ANAL_VAR_DIR_IN = 0x100,
 R_ANAL_VAR_DIR_OUT = 0x200
} _RAnalVarDir;
typedef enum {
 R_ANAL_DATA_NULL = 0,
 R_ANAL_DATA_HEX, 
 R_ANAL_DATA_STR, 
 R_ANAL_DATA_CODE, 
 R_ANAL_DATA_FUN, 
 R_ANAL_DATA_STRUCT, 
 R_ANAL_DATA_LAST
} _RAnalData;
typedef enum {
 R_ANAL_BB_TYPE_NULL = 0,
 R_ANAL_BB_TYPE_HEAD = 0x1, 
 R_ANAL_BB_TYPE_BODY = 0x2, 
 R_ANAL_BB_TYPE_LAST = 0x4, 
 R_ANAL_BB_TYPE_FOOT = 0x8, 
 R_ANAL_BB_TYPE_SWITCH = 0x10, 
 R_ANAL_BB_TYPE_RET = 0x0020, 
 R_ANAL_BB_TYPE_JMP = 0x0040, 
 R_ANAL_BB_TYPE_COND = 0x0100, 
 R_ANAL_BB_TYPE_CJMP = R_ANAL_BB_TYPE_COND | R_ANAL_BB_TYPE_JMP,
 R_ANAL_BB_TYPE_CALL = 0x0200,
 R_ANAL_BB_TYPE_CMP = 0x0400,
 R_ANAL_BB_TYPE_LD = 0x0800,
 R_ANAL_BB_TYPE_ST = 0x1000,
 R_ANAL_BB_TYPE_BINOP= 0x2000,
 R_ANAL_BB_TYPE_TAIL = 0x8000,
} _RAnalBlockType;
enum {
 R_ANAL_STACK_NULL = 0,
 R_ANAL_STACK_NOP,
 R_ANAL_STACK_INC,
 R_ANAL_STACK_GET,
 R_ANAL_STACK_SET,
 R_ANAL_STACK_RESET,
 R_ANAL_STACK_ALIGN,
};
enum {
 R_ANAL_REFLINE_TYPE_UTF8 = 1,
 R_ANAL_REFLINE_TYPE_WIDE = 2, 
 R_ANAL_REFLINE_TYPE_MIDDLE = 4 
};
enum {
 R_ANAL_RET_ERROR = -1,
 R_ANAL_RET_DUP = -2,
 R_ANAL_RET_NEW = -3,
 R_ANAL_RET_END = -4
};
typedef struct r_anal_case_obj_t {
 unsigned long long addr;
 unsigned long long jump;
 unsigned long long value;
 unsigned int cond; 
 unsigned long long bb_ref_to;
 unsigned long long bb_ref_from;
 struct r_anal_bb_t *jumpbb;
} RAnalCaseOp;
typedef struct r_anal_switch_obj_t {
 unsigned long long addr;
 unsigned long long min_val;
 unsigned long long def_val;
 unsigned long long max_val;
 RList *cases;
} RAnalSwitchOp;
typedef struct r_anal_callbacks_t {
 int (*on_fcn_new) (void*, void *user, RAnalFunction *fcn);
 int (*on_fcn_delete) (void* , void *user, RAnalFunction *fcn);
 int (*on_fcn_rename) (void*, void *user, RAnalFunction *fcn, const char *oldname);
 int (*on_fcn_bb_new) (void*, void *user, RAnalFunction *fcn, void* bb);
} RAnalCallbacks;
typedef struct r_anal_options_t {
 int cjmpref;
 int jmpref;
 int jmpabove;
 int followdatarefs;
 int searchstringrefs;
 int followbrokenfcnsrefs;
 int bbs_alignment;
 int bb_max_size;
 int afterjmp; 
 int recont; 
 int eobjmp; 
 int bbsplit;
 int noncode;
 int nopskip; 
 int hpskip; 
 int jmptbl; 
 _Bool pushret; 
 _Bool armthumb; 
} RAnalOptions;
typedef struct r_anal_t {
 char *cpu;
 char *os;
 int bits;
 int lineswidth; 
 int big_endian;
 int split; 
 int sleep; 
 void *user;
 unsigned long long gp; 
 RList *fcns;
 RBNode *fcn_tree;
 RListRange *fcnstore;
 RList *refs;
 RList *vartypes;
 RReg *reg;
 unsigned char *last_disasm_reg;
 RSysregs *sysregs;
 RSyscall *syscall;
 struct r_anal_op_t *queued;
 int diff_ops;
 double diff_thbb;
 double diff_thfcn;
 RIOBind iob;
 RFlagBind flb;
 RBinBind binb; 
 RCoreBind coreb;
 int decode;
 int maxreflines;
 int trace;
 int esil_goto_limit;
 int pcalign;
 int bitshift;
 RList *types;
 struct r_anal_esil_t *esil;
 struct r_anal_plugin_t *cur;
 RAnalRange *limit;
 RList *plugins;
 Sdb *sdb_xrefs;
 Sdb *sdb_types;
 Sdb *sdb_meta; 
 Sdb *sdb_zigns;
 RSpaces meta_spaces;
 RSpaces zign_spaces;
 char *zign_path;
 PrintfCallback cb_printf;
 Sdb *sdb; 
 Sdb *sdb_refs;
 Sdb *sdb_fcns;
 Sdb *sdb_pins;
 Sdb *sdb_args; 
 Sdb *sdb_vars; 
 Sdb *sdb_hints; 
 _Bool bits_hints_changed;
 Sdb *sdb_fcnsign; 
 Sdb *sdb_cc; 
 RAnalCallbacks cb;
 RAnalOptions opt;
 RList *reflines;
 RList *reflines2;
 RList  *bits_ranges;
 RListComparator columnSort;
 int stackptr;
 _Bool (*log)(struct r_anal_t *anal, const char *msg);
 char *cmdtail;
} RAnal;
typedef RAnalFunction *(* RAnalGetFcnIn)(RAnal *anal, unsigned long long addr, int type);
typedef struct r_anal_bind_t {
 RAnal *anal;
 RAnalGetFcnIn get_fcn_in;
} RAnalBind;
typedef struct r_anal_hint_t {
 unsigned long long addr;
 unsigned long long ptr;
 unsigned long long jump;
 unsigned long long fail;
 char *arch;
 char *opcode;
 char *syntax;
 char *esil;
 char *offset;
 int size;
 int bits;
 int immbase;
 _Bool high; 
} RAnalHint;
typedef struct r_anal_var_access_t {
 unsigned long long addr;
 int set;
} RAnalVarAccess;
typedef struct r_anal_var_t {
 char *name; 
 char *type; 
 char kind; 
 unsigned long long addr; 
 unsigned long long eaddr; 
 int size;
 int delta; 
 int scope; 
 RList *accesses; 
 RList *stores; 
} RAnalVar;
typedef struct r_anal_value_t {
 int absolute; 
 int memref; 
 unsigned long long base ; 
 long long delta; 
 long long imm; 
 int mul; 
 unsigned short sel; 
 RRegItem *reg; 
 RRegItem *regdelta; 
} RAnalValue;
enum RAnalOpDirection {
 R_ANAL_OP_DIR_READ = 1,
 R_ANAL_OP_DIR_WRITE = 2,
 R_ANAL_OP_DIR_EXEC = 4,
 R_ANAL_OP_DIR_REF = 8,
};
typedef struct r_anal_op_t {
 char *mnemonic; 
 unsigned long long addr; 
 unsigned long long type; 
 unsigned long long prefix; 
 unsigned long long type2; 
 int group; 
 int stackop; 
 int cond; 
 int size; 
 int nopcode; 
 int cycles; 
 int failcycles; 
 int family; 
 int id; 
 _Bool eob; 
 int delay; 
 unsigned long long jump; 
 unsigned long long fail; 
 int direction; 
 long long ptr;  
 unsigned long long val;  
 int ptrsize; 
 long long stackptr; 
 int refptr; 
 RAnalVar *var; 
 RAnalValue *src[3];
 RAnalValue *dst;
 struct r_anal_op_t *next; 
 RStrBuf esil;
 RStrBuf opex;
 const char *reg; 
 const char *ireg; 
 int scale;
 unsigned long long disp;
 RAnalSwitchOp *switch_op;
} RAnalOp;
typedef struct r_anal_cond_t {
 int type; 
 RAnalValue *arg[2]; 
} RAnalCond;
typedef struct r_anal_bb_t {
 char *name;
 unsigned long long addr;
 unsigned long long jump;
 unsigned long long type2;
 unsigned long long fail;
 int size;
 int type;
 int type_ex;
 int ninstr;
 int returnbb;
 int conditional;
 int traced;
 char *label;
 unsigned char *fingerprint;
 RAnalDiff *diff;
 RAnalCond *cond;
 RAnalSwitchOp *switch_op;
 unsigned short *op_pos;
 int op_pos_size;
 unsigned char *op_bytes;
 unsigned char op_sz;
 struct r_anal_bb_t *head;
 struct r_anal_bb_t *tail;
 struct r_anal_bb_t *next;
 struct r_anal_bb_t *prev;
 struct r_anal_bb_t *failbb;
 struct r_anal_bb_t *jumpbb;
 RList  *cases;
 unsigned char *parent_reg_arena;
 int stackptr;
 int parent_stackptr;
} RAnalBlock;
typedef enum {
 R_ANAL_REF_TYPE_NULL = 0,
 R_ANAL_REF_TYPE_CODE = 'c', 
 R_ANAL_REF_TYPE_CALL = 'C', 
 R_ANAL_REF_TYPE_DATA = 'd', 
 R_ANAL_REF_TYPE_STRING='s' 
} RAnalRefType;
typedef struct r_anal_ref_t {
 int type;
 unsigned long long addr;
 unsigned long long at;
} RAnalRef;
typedef struct r_anal_refline_t {
 unsigned long long from;
 unsigned long long to;
 int index;
 int level;
 int type;
 int direction;
} RAnalRefline;
typedef struct r_anal_state_type_t {
 unsigned long long start;
 unsigned long long end;
 const unsigned char* buffer;
 unsigned long long len;
 unsigned long long bytes_consumed;
 unsigned long long last_addr;
 unsigned long long current_addr;
 unsigned long long next_addr;
 RList *bbs;
 SdbHash *ht;
 unsigned long long ht_sz;
 RAnalFunction *current_fcn;
 RAnalOp *current_op;
 RAnalBlock *current_bb;
 RAnalBlock *current_bb_head;
 unsigned char done;
 int anal_ret_val;
 unsigned int current_depth;
 unsigned int max_depth;
 void *user_state;
} RAnalState;
typedef struct r_anal_cycle_frame_t {
 unsigned long long naddr; 
 RList *hooks;
 struct r_anal_cycle_frame_t *prev;
} RAnalCycleFrame;
typedef struct r_anal_cycle_hook_t { 
 unsigned long long addr;
 int cycles;
} RAnalCycleHook;
typedef struct r_anal_esil_word_t {
 int type;
 const char *str;
} RAnalEsilWord;
enum {
 R_ANAL_ESIL_FLAG_ZERO = 1,
 R_ANAL_ESIL_FLAG_CARRY = 2,
 R_ANAL_ESIL_FLAG_OVERFLOW = 4,
 R_ANAL_ESIL_FLAG_PARITY = 8,
 R_ANAL_ESIL_FLAG_SIGN = 16,
};
enum {
 R_ANAL_TRAP_NONE = 0,
 R_ANAL_TRAP_UNHANDLED = 1,
 R_ANAL_TRAP_BREAKPOINT = 2,
 R_ANAL_TRAP_DIVBYZERO = 3,
 R_ANAL_TRAP_WRITE_ERR = 4,
 R_ANAL_TRAP_READ_ERR = 5,
 R_ANAL_TRAP_EXEC_ERR = 6,
 R_ANAL_TRAP_TODO = 7,
 R_ANAL_TRAP_HALT = 8,
};
enum {
 R_ANAL_ESIL_PARM_INVALID = 0,
 R_ANAL_ESIL_PARM_INTERNAL,
 R_ANAL_ESIL_PARM_REG,
 R_ANAL_ESIL_PARM_NUM,
};
typedef enum {
 REIL_NOP, REIL_UNK, REIL_JCC, REIL_STR, REIL_STM, REIL_LDM, REIL_ADD, REIL_SUB, REIL_NEG, REIL_MUL, REIL_DIV, REIL_MOD, REIL_SMUL, REIL_SDIV, REIL_SMOD, REIL_SHL, REIL_SHR, REIL_AND, REIL_OR, REIL_XOR, REIL_NOT, REIL_EQ, REIL_LT,
} RAnalReilOpcode;
typedef enum {
 ARG_REG, 
 ARG_TEMP, 
 ARG_CONST, 
 ARG_ESIL_INTERNAL, 
 ARG_NONE 
} RAnalReilArgType;
typedef struct r_anal_reil_arg {
 RAnalReilArgType type; 
 unsigned char size; 
 char name[32]; 
} RAnalReilArg;
typedef struct r_anal_reil_inst {
 RAnalReilOpcode opcode;
 RAnalReilArg *arg[3];
} RAnalReilInst;
typedef struct r_anal_reil {
 char old[32]; 
 char cur[32];
 unsigned char lastsz;
 unsigned long long reilNextTemp; 
 unsigned long long addr; 
 unsigned char seq_num; 
 int skip;
 int cmd_count;
 char if_buf[64];
 char pc[8];
} RAnalReil;
typedef struct r_anal_esil_session_t {
 unsigned long long key;
 unsigned long long addr;
 unsigned long long size;
 unsigned char *data;
 RListIter *reg[R_REG_TYPE_LAST];
} RAnalEsilSession;
typedef struct r_anal_esil_callbacks_t {
 void *user;
 int (*hook_flag_read)(struct r_anal_esil_t *esil, const char *flag, unsigned long long *num);
 int (*hook_command)(struct r_anal_esil_t *esil, const char *op);
 int (*hook_mem_read)(struct r_anal_esil_t *esil, unsigned long long addr, unsigned char *buf, int len);
 int (*mem_read)(struct r_anal_esil_t *esil, unsigned long long addr, unsigned char *buf, int len);
 int (*hook_mem_write)(struct r_anal_esil_t *esil, unsigned long long addr, const unsigned char *buf, int len);
 int (*mem_write)(struct r_anal_esil_t *esil, unsigned long long addr, const unsigned char *buf, int len);
 int (*hook_reg_read)(struct r_anal_esil_t *esil, const char *name, unsigned long long *res, int *size);
 int (*reg_read)(struct r_anal_esil_t *esil, const char *name, unsigned long long *res, int *size);
 int (*hook_reg_write)(struct r_anal_esil_t *esil, const char *name, unsigned long long *val);
 int (*reg_write)(struct r_anal_esil_t *esil, const char *name, unsigned long long val);
} RAnalEsilCallbacks;
typedef struct r_anal_esil_t {
 RAnal *anal;
 char **stack;
 int stacksize;
 int stackptr;
 int skip;
 int nowrite;
 int iotrap;
 int exectrap;
 int repeat;
 int parse_stop;
 int parse_goto;
 int parse_goto_count;
 int verbose;
 unsigned long long flags;
 unsigned long long address;
 unsigned long long stack_addr;
 unsigned int stack_size;
 int delay; 
 unsigned long long jump_target; 
 int jump_target_set; 
 int trap;
 unsigned int trap_code; 
 unsigned long long old; 
 unsigned long long cur; 
 unsigned char lastsz; 
 Sdb *ops;
 Sdb *interrupts;
 Sdb *stats;
 Sdb *db_trace;
 int trace_idx;
 RAnalEsilCallbacks cb;
 RAnalReil *Reil;
 char *cmd_intr; 
 char *cmd_trap; 
 char *cmd_mdev; 
 char *cmd_todo; 
 char *cmd_ioer; 
 char *mdev_range; 
 _Bool (*cmd)(struct r_anal_esil_t *esil, const char *name, unsigned long long a0, unsigned long long a1);
 void *user;
 int stack_fd;
 RList *sessions; 
} RAnalEsil;
typedef int (*RAnalEsilOp)(RAnalEsil *esil);
typedef int (*RAnalCmdExt)(RAnal *anal, const char* input);
typedef int (*RAnalAnalyzeFunctions)(RAnal *a, unsigned long long at, unsigned long long from, int reftype, int depth);
typedef int (*RAnalExCallback)(RAnal *a, struct r_anal_state_type_t *state, unsigned long long addr);
typedef RList *(*RAnalExAnalysisAlgorithm)(RAnal *a, struct r_anal_state_type_t *state, unsigned long long addr);
typedef RAnalOp * (*RAnalOpFromBuffer) (RAnal *a, unsigned long long addr, const unsigned char* buf, unsigned long long len);
typedef RAnalBlock * (*RAnalBbFromBuffer) (RAnal *a, unsigned long long addr, const unsigned char* buf, unsigned long long len);
typedef RAnalFunction * (*RAnalFnFromBuffer)(RAnal *a, unsigned long long addr, const unsigned char* buf, unsigned long long len);
typedef int (*RAnalOpCallback)(RAnal *a, RAnalOp *op, unsigned long long addr, const unsigned char *data, int len);
typedef int (*RAnalBbCallback)(RAnal *a, RAnalBlock *bb, unsigned long long addr, const unsigned char *data, int len);
typedef int (*RAnalFnCallback)(RAnal *a, RAnalFunction *fcn, unsigned long long addr, const unsigned char *data, int len, int reftype);
typedef int (*RAnalRegProfCallback)(RAnal *a);
typedef char*(*RAnalRegProfGetCallback)(RAnal *a);
typedef int (*RAnalFPBBCallback)(RAnal *a, RAnalBlock *bb);
typedef int (*RAnalFPFcnCallback)(RAnal *a, RAnalFunction *fcn);
typedef int (*RAnalDiffBBCallback)(RAnal *anal, RAnalFunction *fcn, RAnalFunction *fcn2);
typedef int (*RAnalDiffFcnCallback)(RAnal *anal, RList *fcns, RList *fcns2);
typedef int (*RAnalDiffEvalCallback)(RAnal *anal);
typedef _Bool (*RAnalIsValidOffsetCB)(RAnal *anal, unsigned long long offset, int hasperm);
typedef int (*RAnalEsilCB)(RAnalEsil *esil);
typedef int (*RAnalEsilLoopCB)(RAnalEsil *esil, RAnalOp *op);
typedef int (*RAnalEsilInterruptCB)(RAnalEsil *esil, int interrupt);
typedef int (*RAnalEsilTrapCB)(RAnalEsil *esil, int trap_type, int trap_code);
typedef struct r_anal_plugin_t {
 char *name;
 char *desc;
 char *license;
 char *arch;
 char *author;
 char *version;
 int bits;
 int esil; 
 int fileformat_type;
 int custom_fn_anal;
 int (*init)(void *user);
 int (*fini)(void *user);
 int (*reset_counter) (RAnal *anal, unsigned long long start_addr);
 int (*archinfo)(RAnal *anal, int query);
 unsigned char* (*anal_mask)(RAnal *anal, int size, const unsigned char *data, unsigned long long at);
 RAnalOpCallback op;
 RAnalBbCallback bb;
 RAnalFnCallback fcn;
 RAnalAnalyzeFunctions analyze_fns;
 RAnalOpFromBuffer op_from_buffer;
 RAnalBbFromBuffer bb_from_buffer;
 RAnalFnFromBuffer fn_from_buffer;
 RAnalExAnalysisAlgorithm analysis_algorithm;
 RAnalExCallback pre_anal;
 RAnalExCallback pre_anal_fn_cb;
 RAnalExCallback pre_anal_op_cb;
 RAnalExCallback post_anal_op_cb;
 RAnalExCallback pre_anal_bb_cb;
 RAnalExCallback post_anal_bb_cb;
 RAnalExCallback post_anal_fn_cb;
 RAnalExCallback post_anal;
 RAnalExCallback revisit_bb_anal;
 RAnalCmdExt cmd_ext;
 RAnalRegProfCallback set_reg_profile;
 RAnalRegProfGetCallback get_reg_profile;
 RAnalFPBBCallback fingerprint_bb;
 RAnalFPFcnCallback fingerprint_fcn;
 RAnalDiffBBCallback diff_bb;
 RAnalDiffFcnCallback diff_fcn;
 RAnalDiffEvalCallback diff_eval;
 RAnalIsValidOffsetCB is_valid_offset;
 RAnalEsilCB esil_init; 
 RAnalEsilLoopCB esil_post_loop; 
 RAnalEsilInterruptCB esil_intr; 
 RAnalEsilTrapCB esil_trap; 
 RAnalEsilCB esil_fini; 
} RAnalPlugin;
int * (r_anal_compare) (RAnalFunction , RAnalFunction );
__attribute__((visibility("default"))) RListRange* r_listrange_new (void);
__attribute__((visibility("default"))) void r_listrange_free(RListRange *s);
__attribute__((visibility("default"))) void r_listrange_add(RListRange *s, RAnalFunction *f);
__attribute__((visibility("default"))) void r_listrange_del(RListRange *s, RAnalFunction *f);
__attribute__((visibility("default"))) void r_listrange_resize(RListRange *s, RAnalFunction *f, int newsize);
__attribute__((visibility("default"))) RAnalFunction *r_listrange_find_in_range(RListRange* s, unsigned long long addr);
__attribute__((visibility("default"))) RAnalFunction *r_listrange_find_root(RListRange* s, unsigned long long addr);
__attribute__((visibility("default"))) int r_anal_type_get_size (RAnal *anal, const char *type);
__attribute__((visibility("default"))) RList* r_anal_type_get_by_offset(RAnal *anal, unsigned long long offset);
__attribute__((visibility("default"))) RAnalType *r_anal_type_new(void);
__attribute__((visibility("default"))) void r_anal_type_add(RAnal *l, RAnalType *t);
__attribute__((visibility("default"))) void r_anal_type_del(RAnal *l, const char *name);
__attribute__((visibility("default"))) RList *r_anal_type_list_new(void);
__attribute__((visibility("default"))) RAnalType *r_anal_type_find(RAnal *a, const char* name);
__attribute__((visibility("default"))) void r_anal_type_list(RAnal *a, short category, short enabled);
__attribute__((visibility("default"))) RAnalType *r_anal_str_to_type(RAnal *a, const char* s);
__attribute__((visibility("default"))) char *r_anal_type_to_str(RAnal *a, const char *name);
__attribute__((visibility("default"))) const char *r_anal_optype_to_string(int t);
__attribute__((visibility("default"))) const char *r_anal_op_family_to_string (int n);
__attribute__((visibility("default"))) int r_anal_op_family_from_string(const char *f);
__attribute__((visibility("default"))) int r_anal_op_hint(RAnalOp *op, RAnalHint *hint);
__attribute__((visibility("default"))) RAnalType *r_anal_type_free(RAnalType *t);
__attribute__((visibility("default"))) RAnalType *r_anal_type_loadfile(RAnal *a, const char *path);
__attribute__((visibility("default"))) void r_anal_type_define (RAnal *anal, const char *key, const char *value);
__attribute__((visibility("default"))) void r_anal_type_header (RAnal *anal, const char *hdr);
__attribute__((visibility("default"))) int r_anal_type_link (RAnal *anal, const char *val, unsigned long long addr);
__attribute__((visibility("default"))) int r_anal_type_unlink(RAnal *anal, unsigned long long addr);
__attribute__((visibility("default"))) int r_anal_type_link_offset (RAnal *anal, const char *val, unsigned long long addr);
__attribute__((visibility("default"))) char *r_anal_type_format (RAnal *anal, const char *t);
__attribute__((visibility("default"))) int r_anal_type_set(RAnal *anal, unsigned long long at, const char *field, unsigned long long val);
__attribute__((visibility("default"))) int r_anal_type_func_exist(RAnal *anal, const char *func_name);
__attribute__((visibility("default"))) const char *r_anal_type_func_cc(RAnal *anal, const char *func_name);
 __attribute__((visibility("default"))) const char *r_anal_type_func_ret(RAnal *anal, const char *func_name);
__attribute__((visibility("default"))) int r_anal_type_func_args_count(RAnal *anal, const char *func_name);
__attribute__((visibility("default"))) char *r_anal_type_func_args_type(RAnal *anal, const char *func_name, int i);
__attribute__((visibility("default"))) char *r_anal_type_func_args_name(RAnal *anal, const char *func_name, int i);
__attribute__((visibility("default"))) char *r_anal_type_func_guess(RAnal *anal, char *func_name);
__attribute__((visibility("default"))) RAnal *r_anal_new(void);
__attribute__((visibility("default"))) int r_anal_purge (RAnal *anal);
__attribute__((visibility("default"))) RAnal *r_anal_free(RAnal *r);
__attribute__((visibility("default"))) void r_anal_set_user_ptr(RAnal *anal, void *user);
__attribute__((visibility("default"))) void r_anal_plugin_free (RAnalPlugin *p);
__attribute__((visibility("default"))) int r_anal_add(RAnal *anal, RAnalPlugin *foo);
__attribute__((visibility("default"))) void r_anal_list(RAnal *anal);
__attribute__((visibility("default"))) int r_anal_archinfo(RAnal *anal, int query);
__attribute__((visibility("default"))) _Bool r_anal_use(RAnal *anal, const char *name);
__attribute__((visibility("default"))) _Bool r_anal_set_reg_profile(RAnal *anal);
__attribute__((visibility("default"))) char *r_anal_get_reg_profile(RAnal *anal);
__attribute__((visibility("default"))) _Bool r_anal_set_bits(RAnal *anal, int bits);
__attribute__((visibility("default"))) _Bool r_anal_set_os(RAnal *anal, const char *os);
__attribute__((visibility("default"))) void r_anal_set_cpu(RAnal *anal, const char *cpu);
__attribute__((visibility("default"))) int r_anal_set_big_endian(RAnal *anal, int boolean);
__attribute__((visibility("default"))) unsigned char *r_anal_mask(RAnal *anal, int size, const unsigned char *data, unsigned long long at);
__attribute__((visibility("default"))) void r_anal_trace_bb(RAnal *anal, unsigned long long addr);
__attribute__((visibility("default"))) const char *r_anal_fcn_type_tostring(int type);
__attribute__((visibility("default"))) void r_anal_bind(RAnal *b, RAnalBind *bnd);
__attribute__((visibility("default"))) int r_anal_set_triplet(RAnal *anal, const char *os, const char *arch, int bits);
__attribute__((visibility("default"))) _Bool r_anal_set_fcnsign(RAnal *anal, const char *name);
__attribute__((visibility("default"))) const char *r_anal_get_fcnsign(RAnal *anal, const char *sym);
__attribute__((visibility("default"))) RAnalBlock *r_anal_bb_new(void);
__attribute__((visibility("default"))) RList *r_anal_bb_list_new(void);
__attribute__((visibility("default"))) void r_anal_bb_free(RAnalBlock *bb);
__attribute__((visibility("default"))) int r_anal_bb(RAnal *anal, RAnalBlock *bb, unsigned long long addr, unsigned char *buf, unsigned long long len, int head);
__attribute__((visibility("default"))) RAnalBlock *r_anal_bb_from_offset(RAnal *anal, unsigned long long off);
__attribute__((visibility("default"))) int r_anal_bb_is_in_offset(RAnalBlock *bb, unsigned long long addr);
__attribute__((visibility("default"))) _Bool r_anal_bb_set_offset(RAnalBlock *bb, int i, unsigned short v);
__attribute__((visibility("default"))) unsigned short r_anal_bb_offset_inst(RAnalBlock *bb, int i);
__attribute__((visibility("default"))) unsigned long long r_anal_bb_opaddr_at(RAnalBlock *bb, unsigned long long addr);
__attribute__((visibility("default"))) RAnalBlock *r_anal_bb_get_failbb(RAnalFunction *fcn, RAnalBlock *bb);
__attribute__((visibility("default"))) RAnalBlock *r_anal_bb_get_jumpbb(RAnalFunction *fcn, RAnalBlock *bb);
__attribute__((visibility("default"))) const char *r_anal_stackop_tostring (int s);
__attribute__((visibility("default"))) RAnalOp *r_anal_op_new(void);
__attribute__((visibility("default"))) void r_anal_op_free(void *op);
__attribute__((visibility("default"))) _Bool r_anal_op_fini(RAnalOp *op);
__attribute__((visibility("default"))) _Bool r_anal_op_is_eob (RAnalOp *op);
__attribute__((visibility("default"))) RList *r_anal_op_list_new(void);
__attribute__((visibility("default"))) int r_anal_op(RAnal *anal, RAnalOp *op, unsigned long long addr,
  const unsigned char *data, int len);
__attribute__((visibility("default"))) RAnalOp *r_anal_op_hexstr(RAnal *anal, unsigned long long addr,
  const char *hexstr);
__attribute__((visibility("default"))) char *r_anal_op_to_string(RAnal *anal, RAnalOp *op);
__attribute__((visibility("default"))) RAnalEsil *r_anal_esil_new (int stacksize, int iotrap);
__attribute__((visibility("default"))) void r_anal_esil_trace (RAnalEsil *esil, RAnalOp *op);
__attribute__((visibility("default"))) void r_anal_esil_trace_list (RAnalEsil *esil);
__attribute__((visibility("default"))) void r_anal_esil_trace_show (RAnalEsil *esil, int idx);
__attribute__((visibility("default"))) _Bool r_anal_esil_set_pc (RAnalEsil *esil, unsigned long long addr);
__attribute__((visibility("default"))) int r_anal_esil_setup (RAnalEsil *esil, RAnal *anal, int romem, int stats, int nonull);
__attribute__((visibility("default"))) void r_anal_esil_free (RAnalEsil *esil);
__attribute__((visibility("default"))) int r_anal_esil_runword (RAnalEsil *esil, const char *word);
__attribute__((visibility("default"))) int r_anal_esil_parse (RAnalEsil *esil, const char *str);
__attribute__((visibility("default"))) int r_anal_esil_dumpstack (RAnalEsil *esil);
__attribute__((visibility("default"))) int r_anal_esil_mem_read (RAnalEsil *esil, unsigned long long addr, unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_anal_esil_mem_write (RAnalEsil *esil, unsigned long long addr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_anal_esil_reg_read (RAnalEsil *esil, const char *regname, unsigned long long *num, int *size);
__attribute__((visibility("default"))) int r_anal_esil_reg_write (RAnalEsil *esil, const char *dst, unsigned long long num);
__attribute__((visibility("default"))) int r_anal_esil_pushnum (RAnalEsil *esil, unsigned long long num);
__attribute__((visibility("default"))) _Bool r_anal_esil_push (RAnalEsil *esil, const char *str);
__attribute__((visibility("default"))) char *r_anal_esil_pop (RAnalEsil *esil);
__attribute__((visibility("default"))) int r_anal_esil_set_op (RAnalEsil *esil, const char *op, RAnalEsilOp code);
__attribute__((visibility("default"))) void r_anal_esil_stack_free (RAnalEsil *esil);
__attribute__((visibility("default"))) int r_anal_esil_get_parm_type (RAnalEsil *esil, const char *str);
__attribute__((visibility("default"))) int r_anal_esil_get_parm (RAnalEsil *esil, const char *str, unsigned long long *num);
__attribute__((visibility("default"))) int r_anal_esil_condition (RAnalEsil *esil, const char *str);
__attribute__((visibility("default"))) int r_anal_esil_set_interrupt (RAnalEsil *esil, int interrupt, RAnalEsilInterruptCB interruptcb);
__attribute__((visibility("default"))) int r_anal_esil_fire_interrupt (RAnalEsil *esil, int interrupt);
__attribute__((visibility("default"))) void r_anal_esil_mem_ro(RAnalEsil *esil, int mem_readonly);
__attribute__((visibility("default"))) void r_anal_esil_stats(RAnalEsil *esil, int enable);
__attribute__((visibility("default"))) void r_anal_esil_session_list(RAnalEsil *esil);
__attribute__((visibility("default"))) RAnalEsilSession *r_anal_esil_session_add(RAnalEsil *esil);
__attribute__((visibility("default"))) void r_anal_esil_session_set(RAnalEsil *esil, RAnalEsilSession *session);
__attribute__((visibility("default"))) void r_anal_esil_session_free(void *p);
__attribute__((visibility("default"))) void r_anal_pin_init(RAnal *a);
__attribute__((visibility("default"))) void r_anal_pin_fini(RAnal *a);
__attribute__((visibility("default"))) void r_anal_pin (RAnal *a, unsigned long long addr, const char *name);
__attribute__((visibility("default"))) void r_anal_pin_unset (RAnal *a, unsigned long long addr);
__attribute__((visibility("default"))) const char *r_anal_pin_call(RAnal *a, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_pin_list(RAnal *a);
__attribute__((visibility("default"))) unsigned int r_anal_fcn_cost(RAnal *anal, RAnalFunction *fcn);
__attribute__((visibility("default"))) int r_anal_fcn_count_edges(RAnalFunction *fcn, int *ebbs);
__attribute__((visibility("default"))) RAnalFunction *r_anal_fcn_new(void);
__attribute__((visibility("default"))) int r_anal_fcn_is_in_offset (RAnalFunction *fcn, unsigned long long addr);
__attribute__((visibility("default"))) _Bool r_anal_fcn_in(RAnalFunction *fcn, unsigned long long addr);
__attribute__((visibility("default"))) RAnalFunction *r_anal_get_fcn_at(RAnal *anal, unsigned long long addr, int type);
__attribute__((visibility("default"))) RAnalFunction *r_anal_get_fcn_in(RAnal *anal, unsigned long long addr, int type);
__attribute__((visibility("default"))) RAnalFunction *r_anal_get_fcn_in_bounds(RAnal *anal, unsigned long long addr, int type);
__attribute__((visibility("default"))) RAnalFunction *r_anal_fcn_find_name(RAnal *anal, const char *name);
__attribute__((visibility("default"))) RList *r_anal_fcn_list_new(void);
__attribute__((visibility("default"))) int r_anal_fcn_insert(RAnal *anal, RAnalFunction *fcn);
__attribute__((visibility("default"))) void r_anal_fcn_free(void *fcn);
__attribute__((visibility("default"))) void r_anal_fcn_fill_args (RAnal *anal, RAnalFunction *fcn, RAnalOp *op);
__attribute__((visibility("default"))) int r_anal_fcn(RAnal *anal, RAnalFunction *fcn, unsigned long long addr,
  unsigned char *buf, unsigned long long len, int reftype);
__attribute__((visibility("default"))) int r_anal_fcn_add(RAnal *anal, unsigned long long addr, unsigned long long size,
  const char *name, int type, RAnalDiff *diff);
__attribute__((visibility("default"))) int r_anal_fcn_del(RAnal *anal, unsigned long long addr);
__attribute__((visibility("default"))) int r_anal_fcn_del_locs(RAnal *anal, unsigned long long addr);
__attribute__((visibility("default"))) int r_anal_fcn_add_bb(RAnal *anal, RAnalFunction *fcn,
  unsigned long long addr, unsigned long long size,
  unsigned long long jump, unsigned long long fail, int type, RAnalDiff *diff);
__attribute__((visibility("default"))) _Bool r_anal_check_fcn(RAnal *anal, unsigned char *buf, unsigned short bufsz, unsigned long long addr, unsigned long long low, unsigned long long high);
__attribute__((visibility("default"))) void r_anal_fcn_update_tinyrange_bbs(RAnalFunction *fcn);
__attribute__((visibility("default"))) int r_anal_fcn_var_del_bydelta (RAnal *a, unsigned long long fna, const char kind, int scope, unsigned int delta);
__attribute__((visibility("default"))) int r_anal_fcn_var_del_byindex (RAnal *a, unsigned long long fna, const char kind,
  int scope, unsigned int idx);
__attribute__((visibility("default"))) int r_anal_var_count(RAnal *a, RAnalFunction *fcn, int kind, int type);
__attribute__((visibility("default"))) _Bool r_anal_var_display(RAnal *anal, int delta, char kind, const char *type);
__attribute__((visibility("default"))) unsigned int r_anal_fcn_size(const RAnalFunction *fcn);
__attribute__((visibility("default"))) void r_anal_fcn_set_size(RAnalFunction *fcn, unsigned int size);
__attribute__((visibility("default"))) unsigned int r_anal_fcn_contsize(const RAnalFunction *fcn);
__attribute__((visibility("default"))) unsigned int r_anal_fcn_realsize(const RAnalFunction *fcn);
__attribute__((visibility("default"))) int r_anal_fcn_cc(RAnalFunction *fcn);
__attribute__((visibility("default"))) int r_anal_fcn_loops(RAnalFunction *fcn);
__attribute__((visibility("default"))) int r_anal_fcn_split_bb(RAnal *anal, RAnalFunction *fcn, RAnalBlock *bb, unsigned long long addr);
__attribute__((visibility("default"))) int r_anal_fcn_bb_overlaps(RAnalFunction *fcn, RAnalBlock *bb);
__attribute__((visibility("default"))) RAnalVar *r_anal_fcn_get_var(RAnalFunction *fs, int num, int dir);
__attribute__((visibility("default"))) void r_anal_fcn_fit_overlaps (RAnal *anal, RAnalFunction *fcn);
__attribute__((visibility("default"))) void r_anal_trim_jmprefs(RAnalFunction *fcn);
__attribute__((visibility("default"))) RAnalFunction *r_anal_fcn_next(RAnal *anal, unsigned long long addr);
__attribute__((visibility("default"))) char *r_anal_fcn_to_string(RAnal *a, RAnalFunction* fs);
__attribute__((visibility("default"))) int r_anal_str_to_fcn(RAnal *a, RAnalFunction *f, const char *_str);
__attribute__((visibility("default"))) int r_anal_fcn_count (RAnal *a, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) RAnalBlock *r_anal_fcn_bbget(RAnalFunction *fcn, unsigned long long addr);
__attribute__((visibility("default"))) _Bool r_anal_fcn_bbadd(RAnalFunction *fcn, RAnalBlock *bb);
__attribute__((visibility("default"))) int r_anal_fcn_resize (RAnalFunction *fcn, int newsize);
__attribute__((visibility("default"))) int r_anal_xrefs_count(RAnal *anal);
__attribute__((visibility("default"))) const char *r_anal_xrefs_type_tostring (char type);
__attribute__((visibility("default"))) RList *r_anal_xrefs_get (RAnal *anal, unsigned long long to);
__attribute__((visibility("default"))) RList *r_anal_refs_get (RAnal *anal, unsigned long long to);
__attribute__((visibility("default"))) RList *r_anal_xrefs_get_from (RAnal *anal, unsigned long long from);
__attribute__((visibility("default"))) void r_anal_xrefs_list(RAnal *anal, int rad);
__attribute__((visibility("default"))) RList* r_anal_fcn_get_refs (RAnalFunction *anal);
__attribute__((visibility("default"))) RList* r_anal_fcn_get_xrefs (RAnalFunction *anal);
__attribute__((visibility("default"))) int r_anal_xrefs_from (RAnal *anal, RList *list, const char *kind, const RAnalRefType type, unsigned long long addr);
__attribute__((visibility("default"))) int r_anal_xrefs_set (RAnal *anal, const RAnalRefType type, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) int r_anal_xrefs_deln (RAnal *anal, const RAnalRefType type, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) _Bool r_anal_xrefs_save(RAnal *anal, const char *prjfile);
__attribute__((visibility("default"))) RList* r_anal_fcn_get_vars (RAnalFunction *anal);
__attribute__((visibility("default"))) RList* r_anal_fcn_get_bbs (RAnalFunction *anal);
__attribute__((visibility("default"))) RList* r_anal_get_fcns (RAnal *anal);
__attribute__((visibility("default"))) RAnalRef *r_anal_ref_new(void);
__attribute__((visibility("default"))) RList *r_anal_ref_list_new(void);
__attribute__((visibility("default"))) void r_anal_ref_free(void *ref);
__attribute__((visibility("default"))) const char *r_anal_ref_to_string(int type);
__attribute__((visibility("default"))) int r_anal_ref_add(RAnal *anal, unsigned long long addr, unsigned long long at, int type);
__attribute__((visibility("default"))) int r_anal_ref_del(RAnal *anal, unsigned long long at, unsigned long long addr);
__attribute__((visibility("default"))) RList *r_anal_xref_get(RAnal *anal, unsigned long long addr);
__attribute__((visibility("default"))) RList *r_anal_ref_get(RAnal *anal, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_var_access_clear (RAnal *a, unsigned long long var_addr, int scope, int index);
__attribute__((visibility("default"))) int r_anal_var_access (RAnal *a, unsigned long long var_addr, char kind, int scope, int index, int xs_type, unsigned long long xs_addr);
__attribute__((visibility("default"))) RAnalVar *r_anal_var_new(void);
__attribute__((visibility("default"))) int r_anal_var_rename (RAnal *a, unsigned long long var_addr, int scope, char kind, const char *old_name, const char *new_name);
__attribute__((visibility("default"))) int r_anal_var_retype (RAnal *a, unsigned long long addr, int scope, int delta, char kind, const char *type, int size, const char *name);
__attribute__((visibility("default"))) RAnalVarAccess *r_anal_var_access_new(void);
__attribute__((visibility("default"))) RList *r_anal_var_list_new(void);
__attribute__((visibility("default"))) RList *r_anal_var_access_list_new(void);
__attribute__((visibility("default"))) void r_anal_var_free(RAnalVar *var);
__attribute__((visibility("default"))) void r_anal_var_access_free(void *access);
__attribute__((visibility("default"))) int r_anal_var_delete_all (RAnal *a, unsigned long long addr, const char kind);
__attribute__((visibility("default"))) int r_anal_var_delete (RAnal *a, unsigned long long var_addr, const char kind, int scope, int delta);
__attribute__((visibility("default"))) _Bool r_anal_var_delete_byname (RAnal *a, RAnalFunction *fcn, int type, const char *name);
__attribute__((visibility("default"))) _Bool r_anal_var_add (RAnal *a, unsigned long long addr, int scope, int delta, char kind, const char *type, int size, const char *name);
__attribute__((visibility("default"))) int r_anal_var_del(RAnal *anal, RAnalFunction *fcn, int delta, int scope);
__attribute__((visibility("default"))) RAnalVar *r_anal_var_get (RAnal *a, unsigned long long addr, char kind, int scope, int index);
__attribute__((visibility("default"))) const char *r_anal_var_scope_to_str(RAnal *anal, int scope);
__attribute__((visibility("default"))) int r_anal_var_access_add(RAnal *anal, RAnalVar *var, unsigned long long from, int set);
__attribute__((visibility("default"))) int r_anal_var_access_del(RAnal *anal, RAnalVar *var, unsigned long long from);
__attribute__((visibility("default"))) RAnalVarAccess *r_anal_var_access_get(RAnal *anal, RAnalVar *var, unsigned long long from);
__attribute__((visibility("default"))) RAnalVar *r_anal_var_get_byname (RAnal *anal, RAnalFunction *fcn, const char* name);
__attribute__((visibility("default"))) _Bool r_anal_project_save(RAnal *anal, const char *prjfile);
__attribute__((visibility("default"))) _Bool r_anal_xrefs_init (RAnal *anal);
__attribute__((visibility("default"))) RAnalDiff *r_anal_diff_new(void);
__attribute__((visibility("default"))) void r_anal_diff_setup(RAnal *anal, int doops, double thbb, double thfcn);
__attribute__((visibility("default"))) void r_anal_diff_setup_i(RAnal *anal, int doops, int thbb, int thfcn);
__attribute__((visibility("default"))) void* r_anal_diff_free(RAnalDiff *diff);
__attribute__((visibility("default"))) int r_anal_diff_fingerprint_bb(RAnal *anal, RAnalBlock *bb);
__attribute__((visibility("default"))) int r_anal_diff_fingerprint_fcn(RAnal *anal, RAnalFunction *fcn);
__attribute__((visibility("default"))) _Bool r_anal_diff_bb(RAnal *anal, RAnalFunction *fcn, RAnalFunction *fcn2);
__attribute__((visibility("default"))) int r_anal_diff_fcn(RAnal *anal, RList *fcns, RList *fcns2);
__attribute__((visibility("default"))) int r_anal_diff_eval(RAnal *anal);
__attribute__((visibility("default"))) RAnalValue *r_anal_value_new(void);
__attribute__((visibility("default"))) RAnalValue *r_anal_value_copy (RAnalValue *ov);
__attribute__((visibility("default"))) RAnalValue *r_anal_value_new_from_string(const char *str);
__attribute__((visibility("default"))) long long r_anal_value_eval(RAnalValue *value);
__attribute__((visibility("default"))) char *r_anal_value_to_string (RAnalValue *value);
__attribute__((visibility("default"))) unsigned long long r_anal_value_to_ut64(RAnal *anal, RAnalValue *val);
__attribute__((visibility("default"))) int r_anal_value_set_ut64(RAnal *anal, RAnalValue *val, unsigned long long num);
__attribute__((visibility("default"))) void r_anal_value_free(RAnalValue *value);
__attribute__((visibility("default"))) RAnalCond *r_anal_cond_new(void);
__attribute__((visibility("default"))) RAnalCond *r_anal_cond_new_from_op(RAnalOp *op);
__attribute__((visibility("default"))) void r_anal_cond_fini (RAnalCond *c);
__attribute__((visibility("default"))) void r_anal_cond_free (RAnalCond *c);
__attribute__((visibility("default"))) char *r_anal_cond_to_string(RAnalCond *cond);
__attribute__((visibility("default"))) int r_anal_cond_eval (RAnal *anal, RAnalCond *cond);
__attribute__((visibility("default"))) RAnalCond *r_anal_cond_new_from_string(const char *str);
__attribute__((visibility("default"))) const char *r_anal_cond_tostring(int cc);
__attribute__((visibility("default"))) RList*  r_anal_reflines_get(RAnal *anal,
  unsigned long long addr, const unsigned char *buf, unsigned long long len, int nlines, int linesout, int linescall);
__attribute__((visibility("default"))) int r_anal_reflines_middle(RAnal *anal, RList *list, unsigned long long addr, int len);
__attribute__((visibility("default"))) char* r_anal_reflines_str(void *core, unsigned long long addr, int opts);
__attribute__((visibility("default"))) RList *r_anal_reflines_fcn_get(struct r_anal_t *anal, RAnalFunction *fcn, int nlines, int linesout, int linescall);
__attribute__((visibility("default"))) void r_anal_var_list_show(RAnal *anal, RAnalFunction *fcn, int kind, int mode);
__attribute__((visibility("default"))) RList *r_anal_var_list(RAnal *anal, RAnalFunction *fcn, int kind);
__attribute__((visibility("default"))) RList *r_anal_var_all_list(RAnal *anal, RAnalFunction *fcn);
__attribute__((visibility("default"))) RList *r_anal_var_list_dynamic(RAnal *anal, RAnalFunction *fcn, int kind);
__attribute__((visibility("default"))) int r_anal_cc_exist (RAnal *anal, const char *convention);
__attribute__((visibility("default"))) const char *r_anal_cc_arg(RAnal *anal, const char *convention, int n);
__attribute__((visibility("default"))) const char *r_anal_cc_ret(RAnal *anal, const char *convention);
__attribute__((visibility("default"))) const char *r_anal_cc_default(RAnal *anal);
__attribute__((visibility("default"))) const char *r_anal_cc_to_constant(RAnal *anal, char *convention);
__attribute__((visibility("default"))) _Bool r_anal_noreturn_at(RAnal *anal, unsigned long long addr);
typedef struct r_anal_data_t {
 unsigned long long addr;
 int type;
 unsigned long long ptr;
 char *str;
 int len;
 unsigned char *buf;
 unsigned char sbuf[8];
} RAnalData;
__attribute__((visibility("default"))) RAnalData *r_anal_data (RAnal *anal, unsigned long long addr, const unsigned char *buf, int size, int wordsize);
__attribute__((visibility("default"))) const char *r_anal_data_kind (RAnal *anal, unsigned long long addr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) RAnalData *r_anal_data_new_string (unsigned long long addr, const char *p, int size, int wide);
__attribute__((visibility("default"))) RAnalData *r_anal_data_new (unsigned long long addr, int type, unsigned long long n, const unsigned char *buf, int len);
__attribute__((visibility("default"))) void r_anal_data_free (RAnalData *d);
typedef unsigned char cc_t;
typedef unsigned int speed_t;
typedef unsigned int tcflag_t;
struct termios
  {
    tcflag_t c_iflag; 
    tcflag_t c_oflag; 
    tcflag_t c_cflag; 
    tcflag_t c_lflag; 
    cc_t c_line; 
    cc_t c_cc[32]; 
    speed_t c_ispeed; 
    speed_t c_ospeed; 
  };
extern speed_t cfgetospeed (const struct termios *__termios_p) __attribute__ ((__nothrow__ ));
extern speed_t cfgetispeed (const struct termios *__termios_p) __attribute__ ((__nothrow__ ));
extern int cfsetospeed (struct termios *__termios_p, speed_t __speed) __attribute__ ((__nothrow__ ));
extern int cfsetispeed (struct termios *__termios_p, speed_t __speed) __attribute__ ((__nothrow__ ));
extern int cfsetspeed (struct termios *__termios_p, speed_t __speed) __attribute__ ((__nothrow__ ));
extern int tcgetattr (int __fd, struct termios *__termios_p) __attribute__ ((__nothrow__ ));
extern int tcsetattr (int __fd, int __optional_actions,
        const struct termios *__termios_p) __attribute__ ((__nothrow__ ));
extern void cfmakeraw (struct termios *__termios_p) __attribute__ ((__nothrow__ ));
extern int tcsendbreak (int __fd, int __duration) __attribute__ ((__nothrow__ ));
extern int tcdrain (int __fd);
extern int tcflush (int __fd, int __queue_selector) __attribute__ ((__nothrow__ ));
extern int tcflow (int __fd, int __action) __attribute__ ((__nothrow__ ));
extern __pid_t tcgetsid (int __fd) __attribute__ ((__nothrow__ ));
struct winsize
  {
    unsigned short int ws_row;
    unsigned short int ws_col;
    unsigned short int ws_xpixel;
    unsigned short int ws_ypixel;
  };
struct termio
  {
    unsigned short int c_iflag; 
    unsigned short int c_oflag; 
    unsigned short int c_cflag; 
    unsigned short int c_lflag; 
    unsigned char c_line; 
    unsigned char c_cc[8]; 
};
extern int ioctl (int __fd, unsigned long int __request, ...) __attribute__ ((__nothrow__ ));
__attribute__((visibility("default"))) const char *r_cons_version(void);
typedef int (*RConsGetSize)(int *rows);
typedef int (*RConsGetCursor)(int *rows);
typedef struct r_cons_bind_t {
 RConsGetSize get_size;
 RConsGetCursor get_cursor;
} RConsBind;
typedef struct r_cons_grep_t {
 char strings[10][64];
 int nstrings;
 char *str;
 int counter;
 _Bool charCounter;
 int less;
 int json;
 char *json_path;
 int range_line;
 int line;
 int sort;
 int sort_row;
 _Bool sort_invert;
 int f_line; 
 int l_line; 
 int tokens[64];
 int tokens_used;
 int amp;
 int neg;
 int begin;
 int end;
 int icase;
} RConsGrep;
typedef struct r_cons_palette_t {
 char *b0x00;
 char *b0x7f;
 char *b0xff;
 char *args;
 char *bin;
 char *btext;
 char *call;
 char *cjmp;
 char *cmp;
 char *comment;
 char *usercomment;
 char *creg;
 char *flag;
 char *fline;
 char *floc;
 char *flow;
 char *flow2;
 char *fname;
 char *help;
 char *input;
 char *invalid;
 char *jmp;
 char *label;
 char *math;
 char *mov;
 char *nop;
 char *num;
 char *offset;
 char *other;
 char *pop;
 char *prompt;
 char *push;
 char *crypto;
 char *reg;
 char *reset;
 char *ret;
 char *swi;
 char *trap;
 char *ai_read;
 char *ai_write;
 char *ai_exec;
 char *ai_seq;
 char *ai_ascii;
 char *gui_cflow;
 char *gui_dataoffset;
 char *gui_background;
 char *gui_alt_background;
 char *gui_border;
 char *highlight;
 char *graph_box;
 char *graph_box2;
 char *graph_box3;
 char *graph_box4;
 char *graph_true;
 char *graph_false;
 char *graph_trufae;
 char *graph_traced;
 char *graph_current;
 char *list[8];
 char **rainbow; 
 int rainbow_sz; 
} RConsPalette;
__attribute__((visibility("default"))) char *r_cons_rainbow_get(int idx, int last, _Bool bg);
__attribute__((visibility("default"))) void r_cons_rainbow_free(void);
__attribute__((visibility("default"))) void r_cons_rainbow_new(int sz);
typedef void (*RConsEvent)(void *);
typedef struct r_cons_canvas_attr_t {
 int loc;
 const char * a;
} RConsCanvasAttr;
typedef struct r_cons_canvas_t {
 int w;
 int h;
 int x;
 int y;
 char *b;
 int blen;
 const char * attr;
 RConsCanvasAttr * attrs;
 int attrslen;
 int sx; 
 int sy; 
 int color;
 int linemode; 
} RConsCanvas;
typedef char *(*RConsEditorCallback)(void *core, const char *file, const char *str);
typedef int (*RConsClickCallback)(void *core, int x, int y);
typedef struct r_cons_t {
 RConsGrep grep;
 RStack *cons_stack;
 RStack *break_stack;
 char *buffer;
 int buffer_len;
 int buffer_sz;
 char *lastline;
 int is_html;
 int is_interactive;
 int lines;
 int rows;
 int echo; 
 int fps;
 int columns;
 int force_rows;
 int force_columns;
 int fix_rows;
 int fix_columns;
 _Bool breaked;
 _Bool break_lines;
 int noflush;
 FILE *fdin; 
 int fdout; 
 const char *teefile;
 int (*user_fgets)(char *buf, int len);
 RConsEvent event_interrupt;
 RConsEvent event_resize;
 void *data;
 void *event_data;
 int mouse_event;
 RConsEditorCallback editor;
 void *user; 
 struct termios term_raw, term_buf;
 RNum *num;
 char *pager;
 int blankline;
 int truecolor; 
 char *highlight;
 int null; 
 int mouse;
 int is_wine;
 RConsPalette pal;
 struct r_line_t *line;
 const char **vline;
 int refcnt;
 RConsClickCallback onclick;
 _Bool newline;
 _Bool flush;
 _Bool use_utf8; 
 _Bool use_utf8_curvy; 
 int linesleep;
 int pagesize;
 char *break_word;
 int break_word_len;
 unsigned long long timeout;
 _Bool use_color;
 _Bool use_tts;
 _Bool filter;
 char* (*rgbstr)(char *str, unsigned long long addr);
} RCons;
enum {
 PAL_PROMPT = 0,
 PAL_ADDRESS,
 PAL_DEFAULT,
 PAL_CHANGED,
 PAL_JUMP,
 PAL_CALL,
 PAL_PUSH,
 PAL_TRAP,
 PAL_CMP,
 PAL_RET,
 PAL_NOP,
 PAL_METADATA,
 PAL_HEADER,
 PAL_PRINTABLE,
 PAL_LINES0,
 PAL_LINES1,
 PAL_LINES2,
 PAL_00,
 PAL_7F,
 PAL_FF
};
enum {
 LINE_NONE = 0,
 LINE_TRUE,
 LINE_FALSE,
 LINE_UNCJMP,
 LINE_NOSYM_VERT,
 LINE_NOSYM_HORIZ
};
typedef struct r_cons_canvas_line_style_t {
 int color;
 int symbol;
} RCanvasLineStyle;
__attribute__((visibility("default"))) RConsCanvas* r_cons_canvas_new(int w, int h);
__attribute__((visibility("default"))) void r_cons_canvas_free(RConsCanvas *c);
__attribute__((visibility("default"))) void r_cons_canvas_clear(RConsCanvas *c);
__attribute__((visibility("default"))) void r_cons_canvas_print(RConsCanvas *c);
__attribute__((visibility("default"))) void r_cons_canvas_print_region(RConsCanvas *c);
__attribute__((visibility("default"))) char *r_cons_canvas_to_string(RConsCanvas *c);
__attribute__((visibility("default"))) void r_cons_canvas_attr(RConsCanvas *c,const char * attr);
__attribute__((visibility("default"))) void r_cons_canvas_write(RConsCanvas *c, const char *_s);
__attribute__((visibility("default"))) _Bool r_cons_canvas_gotoxy(RConsCanvas *c, int x, int y);
__attribute__((visibility("default"))) void r_cons_canvas_goto_write(RConsCanvas *c,int x,int y, const char * s);
__attribute__((visibility("default"))) void r_cons_canvas_box(RConsCanvas *c, int x, int y, int w, int h, const char *color);
__attribute__((visibility("default"))) void r_cons_canvas_line(RConsCanvas *c, int x, int y, int x2, int y2, RCanvasLineStyle *style);
__attribute__((visibility("default"))) void r_cons_canvas_line_diagonal(RConsCanvas *c, int x, int y, int x2, int y2, RCanvasLineStyle *style);
__attribute__((visibility("default"))) void r_cons_canvas_line_square(RConsCanvas *c, int x, int y, int x2, int y2, RCanvasLineStyle *style);
__attribute__((visibility("default"))) int r_cons_canvas_resize(RConsCanvas *c, int w, int h);
__attribute__((visibility("default"))) void r_cons_canvas_fill(RConsCanvas *c, int x, int y, int w, int h, char ch, int replace);
__attribute__((visibility("default"))) void r_cons_canvas_line_square_defined (RConsCanvas *c, int x, int y, int x2, int y2, RCanvasLineStyle *style, int bendpoint, int isvert);
__attribute__((visibility("default"))) void r_cons_canvas_line_back_edge (RConsCanvas *c, int x, int y, int x2, int y2, RCanvasLineStyle *style, int ybendpoint1, int xbendpoint, int ybendpoint2, int isvert);
__attribute__((visibility("default"))) RCons *r_cons_new(void);
__attribute__((visibility("default"))) RCons *r_cons_singleton(void);
__attribute__((visibility("default"))) RCons *r_cons_free(void);
__attribute__((visibility("default"))) char *r_cons_lastline(int *size);
typedef void (*RConsBreak)(void *);
__attribute__((visibility("default"))) void r_cons_break_end(void);
__attribute__((visibility("default"))) _Bool r_cons_is_breaked(void);
__attribute__((visibility("default"))) void r_cons_break_timeout(int timeout);
__attribute__((visibility("default"))) void r_cons_breakword(const char *s);
__attribute__((visibility("default"))) int r_cons_pipe_open(const char *file, int fdn, int append);
__attribute__((visibility("default"))) void r_cons_pipe_close(int fd);
__attribute__((visibility("default"))) void r_cons_push(void);
__attribute__((visibility("default"))) void r_cons_pop(void);
__attribute__((visibility("default"))) void r_cons_break_pop(void);
__attribute__((visibility("default"))) void r_cons_break_push(RConsBreak cb, void*user);
__attribute__((visibility("default"))) void r_cons_break_clear(void);
__attribute__((visibility("default"))) char *r_cons_editor(const char *file, const char *str);
__attribute__((visibility("default"))) void r_cons_reset(void);
__attribute__((visibility("default"))) void r_cons_reset_colors(void);
__attribute__((visibility("default"))) void r_cons_print_clear(void);
__attribute__((visibility("default"))) void r_cons_zero(void);
__attribute__((visibility("default"))) void r_cons_highlight(const char *word);
__attribute__((visibility("default"))) void r_cons_clear(void);
__attribute__((visibility("default"))) void r_cons_clear00(void);
__attribute__((visibility("default"))) void r_cons_clear_line(int err);
__attribute__((visibility("default"))) void r_cons_fill_line(void);
__attribute__((visibility("default"))) void r_cons_stdout_open(const char *file, int append);
__attribute__((visibility("default"))) int r_cons_stdout_set_fd(int fd);
__attribute__((visibility("default"))) void r_cons_gotoxy(int x, int y);
__attribute__((visibility("default"))) void r_cons_show_cursor(int cursor);
__attribute__((visibility("default"))) char *r_cons_swap_ground(const char *col);
__attribute__((visibility("default"))) _Bool r_cons_drop(int n);
__attribute__((visibility("default"))) void r_cons_chop(void);
__attribute__((visibility("default"))) void r_cons_set_raw(int b);
__attribute__((visibility("default"))) void r_cons_set_interactive(int b);
__attribute__((visibility("default"))) void r_cons_set_last_interactive(void);
__attribute__((visibility("default"))) void r_cons_printf(const char *format, ...);
__attribute__((visibility("default"))) void r_cons_printf_list(const char *format, va_list ap);
__attribute__((visibility("default"))) void r_cons_strcat(const char *str);
__attribute__((visibility("default"))) void r_cons_println(const char* str);
__attribute__((visibility("default"))) void r_cons_strcat_justify(const char *str, int j, char c);
__attribute__((visibility("default"))) int r_cons_memcat(const char *str, int len);
__attribute__((visibility("default"))) void r_cons_newline(void);
__attribute__((visibility("default"))) void r_cons_filter(void);
__attribute__((visibility("default"))) void r_cons_flush(void);
__attribute__((visibility("default"))) int r_cons_less_str(const char *str, const char *exitkeys);
__attribute__((visibility("default"))) void r_cons_less(void);
__attribute__((visibility("default"))) void r_cons_2048(_Bool color);
__attribute__((visibility("default"))) void r_cons_memset(char ch, int len);
__attribute__((visibility("default"))) void r_cons_visual_flush(void);
__attribute__((visibility("default"))) void r_cons_visual_write(char *buffer);
__attribute__((visibility("default"))) int r_cons_is_utf8(void);
__attribute__((visibility("default"))) void r_cons_cmd_help(const char * help[], _Bool use_color);
__attribute__((visibility("default"))) int r_cons_controlz(int ch);
__attribute__((visibility("default"))) int r_cons_readchar(void);
__attribute__((visibility("default"))) int r_cons_readchar_timeout(unsigned int usec);
__attribute__((visibility("default"))) int r_cons_any_key(const char *msg);
__attribute__((visibility("default"))) int r_cons_eof(void);
__attribute__((visibility("default"))) int r_cons_palette_init(const unsigned char *pal);
__attribute__((visibility("default"))) int r_cons_pal_set(const char *key, const char *val);
__attribute__((visibility("default"))) void r_cons_pal_update_event(void);
__attribute__((visibility("default"))) void r_cons_pal_free(void);
__attribute__((visibility("default"))) void r_cons_pal_init(const char *foo);
__attribute__((visibility("default"))) char *r_cons_pal_parse(const char *str);
__attribute__((visibility("default"))) void r_cons_pal_random(void);
__attribute__((visibility("default"))) const char *r_cons_pal_get(const char *key);
__attribute__((visibility("default"))) const char *r_cons_pal_get_i(int n);
__attribute__((visibility("default"))) const char *r_cons_pal_get_color(int n);
__attribute__((visibility("default"))) int r_cons_rgb_parse(const char *p, unsigned char *r, unsigned char *g, unsigned char *b, int *is_bg);
__attribute__((visibility("default"))) char *r_cons_rgb_tostring(unsigned char r, unsigned char g, unsigned char b);
__attribute__((visibility("default"))) void r_cons_pal_list(int rad, const char *arg);
__attribute__((visibility("default"))) void r_cons_pal_show(void);
__attribute__((visibility("default"))) int r_cons_get_size(int *rows);
__attribute__((visibility("default"))) _Bool r_cons_isatty(void);
__attribute__((visibility("default"))) int r_cons_get_cursor(int *rows);
__attribute__((visibility("default"))) int r_cons_arrow_to_hjkl(int ch);
__attribute__((visibility("default"))) int r_cons_html_print(const char *ptr);
__attribute__((visibility("default"))) char *r_cons_html_filter(const char *ptr, int *newlen);
__attribute__((visibility("default"))) int r_cons_fgets(char *buf, int len, int argc, const char **argv);
__attribute__((visibility("default"))) char *r_cons_hud(RList *list, const char *prompt);
__attribute__((visibility("default"))) char *r_cons_hud_path(const char *path, int dir);
__attribute__((visibility("default"))) char *r_cons_hud_string(const char *s);
__attribute__((visibility("default"))) char *r_cons_hud_file(const char *f);
__attribute__((visibility("default"))) const char *r_cons_get_buffer(void);
__attribute__((visibility("default"))) void r_cons_grep_help(void);
__attribute__((visibility("default"))) void r_cons_grep_parsecmd(char *cmd, const char *quotestr);
__attribute__((visibility("default"))) char * r_cons_grep_strip(char *cmd, const char *quotestr);
__attribute__((visibility("default"))) void r_cons_grep_process(char * grep);
__attribute__((visibility("default"))) int r_cons_grep_line(char *buf, int len); 
__attribute__((visibility("default"))) int r_cons_grepbuf(char *buf, int len);
__attribute__((visibility("default"))) void r_cons_rgb(unsigned char r, unsigned char g, unsigned char b, int is_bg);
__attribute__((visibility("default"))) void r_cons_rgb_fgbg(unsigned char r, unsigned char g, unsigned char b, unsigned char R, unsigned char G, unsigned char B);
__attribute__((visibility("default"))) void r_cons_rgb_init(void);
__attribute__((visibility("default"))) char *r_cons_rgb_str(char *outstr, unsigned char r, unsigned char g, unsigned char b, int is_bg);
__attribute__((visibility("default"))) char *r_cons_rgb_str_off(char *outstr, unsigned long long off);
__attribute__((visibility("default"))) void r_cons_color(int fg, int r, int g, int b);
__attribute__((visibility("default"))) char *r_cons_color_random(int bg);
__attribute__((visibility("default"))) char *r_cons_color_random_string(int bg);
__attribute__((visibility("default"))) void r_cons_invert(int set, int color);
__attribute__((visibility("default"))) int r_cons_yesno(int def, const char *fmt, ...);
__attribute__((visibility("default"))) char *r_cons_input(const char *msg);
__attribute__((visibility("default"))) void r_cons_set_cup(int enable);
__attribute__((visibility("default"))) void r_cons_column(int c);
__attribute__((visibility("default"))) int r_cons_get_column(void);
__attribute__((visibility("default"))) char *r_cons_message(const char *msg);
__attribute__((visibility("default"))) void r_cons_set_title(const char *str);
__attribute__((visibility("default"))) _Bool r_cons_enable_mouse(const _Bool enable);
__attribute__((visibility("default"))) void r_cons_bind(RConsBind *bind);
__attribute__((visibility("default"))) const char* r_cons_get_rune(const unsigned char ch);
typedef struct r_line_hist_t {
 char **data;
 int size;
 int index;
 int top;
 int autosave;
} RLineHistory;
typedef struct r_line_buffer_t {
 char data[4096];
 int index;
 int length;
} RLineBuffer;
typedef struct r_line_t RLine; 
typedef int (*RLineCallback)(RLine *line);
typedef struct r_line_comp_t {
 int argc;
 const char **argv;
 RLineCallback run;
} RLineCompletion;
typedef char* (*RLineEditorCb)(void *core, const char *str);
struct r_line_t {
 RLineCompletion completion;
 RLineHistory history;
 RLineBuffer buffer;
 RLineEditorCb editor_cb;
 int echo;
 int has_echo;
 char *prompt;
 char *clipboard;
 int disable;
 void *user;
 int (*hist_up)(void *user);
 int (*hist_down)(void *user);
 char *contents;
 _Bool zerosep;
}; 
__attribute__((visibility("default"))) RLine *r_line_new(void);
__attribute__((visibility("default"))) RLine *r_line_singleton(void);
__attribute__((visibility("default"))) void r_line_free(void);
__attribute__((visibility("default"))) char *r_line_get_prompt(void);
__attribute__((visibility("default"))) void r_line_set_prompt(const char *prompt);
__attribute__((visibility("default"))) int r_line_dietline_init(void);
__attribute__((visibility("default"))) void r_line_hist_free(void);
typedef int (RLineReadCallback)(void *user, const char *line);
__attribute__((visibility("default"))) const char *r_line_readline(void);
__attribute__((visibility("default"))) const char *r_line_readline_cb(RLineReadCallback cb, void *user);
__attribute__((visibility("default"))) int r_line_hist_load(const char *file);
__attribute__((visibility("default"))) int r_line_hist_add(const char *line);
__attribute__((visibility("default"))) int r_line_hist_save(const char *file);
__attribute__((visibility("default"))) int r_line_hist_label(const char *label, void (*cb)(const char*));
__attribute__((visibility("default"))) void r_line_label_show(void);
__attribute__((visibility("default"))) int r_line_hist_list(void);
__attribute__((visibility("default"))) const char *r_line_hist_get(int n);
typedef struct r_ascii_node_t {
 RGraphNode *gnode;
 char *title;
 char *body;
 int x;
 int y;
 int w;
 int h;
 int layer;
 int layer_height;
 int layer_width;
 int pos_in_layer;
 int is_dummy;
 int is_reversed;
 int klass;
 _Bool is_mini;
} RANode;
typedef void (*RANodeCallback)(RANode *n, void *user);
typedef void (*RAEdgeCallback)(RANode *from, RANode *to, void *user);
typedef struct r_ascii_graph_t {
 RConsCanvas *can;
 RGraph *graph;
 const RGraphNode *curnode;
 char *title;
 Sdb *db;
 Sdb *nodes; 
 int layout;
 int is_instep;
 _Bool is_tiny;
 int mode;
 _Bool is_callgraph;
 int zoom;
 int movspeed;
 RANode *update_seek_on;
 _Bool need_reload_nodes;
 _Bool need_set_layout;
 int need_update_dim;
 int force_update_seek;
 RANodeCallback on_curnode_change;
 void *on_curnode_change_data;
 int x, y;
 int w, h;
 RList *back_edges;
 RList *long_edges;
 struct layer_t *layers;
 int n_layers;
 RList *dists; 
 RList *edges; 
 const char *color_box;
 const char *color_box2;
 const char *color_box3;
 const char *color_true;
 const char *color_false;
} RAGraph;
__attribute__((visibility("default"))) RAGraph *r_agraph_new(RConsCanvas *can);
__attribute__((visibility("default"))) void r_agraph_free(RAGraph *g);
__attribute__((visibility("default"))) void r_agraph_reset(RAGraph *g);
__attribute__((visibility("default"))) void r_agraph_set_title(RAGraph *g, const char *title);
__attribute__((visibility("default"))) RANode *r_agraph_get_first_node(const RAGraph *g);
__attribute__((visibility("default"))) RANode *r_agraph_get_node(const RAGraph *g, const char *title);
__attribute__((visibility("default"))) RANode *r_agraph_add_node(const RAGraph *g, const char *title, const char *body);
__attribute__((visibility("default"))) _Bool r_agraph_del_node(const RAGraph *g, const char *title);
__attribute__((visibility("default"))) void r_agraph_add_edge(const RAGraph *g, RANode *a, RANode *b);
__attribute__((visibility("default"))) void r_agraph_add_edge_at(const RAGraph *g, RANode *a, RANode *b, int nth);
__attribute__((visibility("default"))) void r_agraph_del_edge(const RAGraph *g, RANode *a, RANode *b);
__attribute__((visibility("default"))) void r_agraph_print(RAGraph *g);
__attribute__((visibility("default"))) Sdb *r_agraph_get_sdb(RAGraph *g);
__attribute__((visibility("default"))) void r_agraph_foreach(RAGraph *g, RANodeCallback cb, void *user);
__attribute__((visibility("default"))) void r_agraph_foreach_edge(RAGraph *g, RAEdgeCallback cb, void *user);
__attribute__((visibility("default"))) void r_agraph_set_curnode(RAGraph *g, RANode *node);
__attribute__((visibility("default"))) char *r_anal_data_to_string(RAnalData *d, RConsPalette *pal);
__attribute__((visibility("default"))) void r_meta_free(RAnal *m);
__attribute__((visibility("default"))) void r_meta_space_unset_for(RAnal *a, int type);
__attribute__((visibility("default"))) int r_meta_space_count_for(RAnal *a, int space_idx);
__attribute__((visibility("default"))) RList *r_meta_enumerate(RAnal *a, int type);
__attribute__((visibility("default"))) int r_meta_count(RAnal *m, int type, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) char *r_meta_get_string(RAnal *m, int type, unsigned long long addr);
__attribute__((visibility("default"))) char *r_meta_get_var_comment (RAnal *a, int type, unsigned long long idx, unsigned long long addr);
__attribute__((visibility("default"))) int r_meta_set_string(RAnal *m, int type, unsigned long long addr, const char *s);
__attribute__((visibility("default"))) int r_meta_set_var_comment (RAnal *a, int type, unsigned long long idx, unsigned long long addr, const char *s);
__attribute__((visibility("default"))) int r_meta_del(RAnal *m, int type, unsigned long long from, unsigned long long size);
__attribute__((visibility("default"))) int r_meta_var_comment_del(RAnal *a, int type, unsigned long long idx, unsigned long long addr);
__attribute__((visibility("default"))) int r_meta_add(RAnal *m, int type, unsigned long long from, unsigned long long size, const char *str);
__attribute__((visibility("default"))) int r_meta_add_with_subtype(RAnal *m, int type, int subtype, unsigned long long from, unsigned long long size, const char *str);
__attribute__((visibility("default"))) RAnalMetaItem *r_meta_find(RAnal *m, unsigned long long off, int type, int where);
__attribute__((visibility("default"))) int r_meta_cleanup(RAnal *m, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) const char *r_meta_type_to_string(int type);
__attribute__((visibility("default"))) RList *r_meta_enumerate(RAnal *a, int type);
__attribute__((visibility("default"))) int r_meta_list(RAnal *m, int type, int rad);
__attribute__((visibility("default"))) int r_meta_list_at(RAnal *m, int type, int rad, unsigned long long addr);
__attribute__((visibility("default"))) int r_meta_list_cb(RAnal *m, int type, int rad, SdbForeachCallback cb, void *user, unsigned long long addr);
__attribute__((visibility("default"))) void r_meta_item_free(void *_item);
__attribute__((visibility("default"))) RAnalMetaItem *r_meta_item_new(int type);
__attribute__((visibility("default"))) _Bool r_meta_deserialize_val(RAnalMetaItem *it, int type, unsigned long long from, const char *v);
__attribute__((visibility("default"))) void r_meta_print(RAnal *a, RAnalMetaItem *d, int rad, _Bool show_full);
__attribute__((visibility("default"))) int r_anal_fcn_xref_add (RAnal *anal, RAnalFunction *fcn, unsigned long long at, unsigned long long addr, int type);
__attribute__((visibility("default"))) int r_anal_fcn_xref_del (RAnal *anal, RAnalFunction *fcn, unsigned long long at, unsigned long long addr, int type);
__attribute__((visibility("default"))) void r_anal_build_range_on_hints (RAnal *a);
__attribute__((visibility("default"))) RAnalHint *r_anal_hint_from_string(RAnal *a, unsigned long long addr, const char *str);
__attribute__((visibility("default"))) void r_anal_hint_del (RAnal *anal, unsigned long long addr, int size);
__attribute__((visibility("default"))) void r_anal_hint_clear (RAnal *a);
__attribute__((visibility("default"))) RAnalHint *r_anal_hint_at (RAnal *a, unsigned long long from);
__attribute__((visibility("default"))) RAnalHint *r_anal_hint_add (RAnal *a, unsigned long long from, int size);
__attribute__((visibility("default"))) void r_anal_hint_free (RAnalHint *h);
__attribute__((visibility("default"))) RAnalHint *r_anal_hint_get(RAnal *anal, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_hint_set_syntax (RAnal *a, unsigned long long addr, const char *syn);
__attribute__((visibility("default"))) void r_anal_hint_set_jump (RAnal *a, unsigned long long addr, unsigned long long ptr);
__attribute__((visibility("default"))) void r_anal_hint_set_offset (RAnal *a, unsigned long long addr, const char *typeoff);
__attribute__((visibility("default"))) void r_anal_hint_set_immbase (RAnal *a, unsigned long long addr, int base);
__attribute__((visibility("default"))) void r_anal_hint_set_fail (RAnal *a, unsigned long long addr, unsigned long long ptr);
__attribute__((visibility("default"))) void r_anal_hint_set_length (RAnal *a, unsigned long long addr, int length);
__attribute__((visibility("default"))) void r_anal_hint_set_bits (RAnal *a, unsigned long long addr, int bits);
__attribute__((visibility("default"))) void r_anal_hint_set_arch (RAnal *a, unsigned long long addr, const char *arch);
__attribute__((visibility("default"))) void r_anal_hint_set_size (RAnal *a, unsigned long long addr, int length);
__attribute__((visibility("default"))) void r_anal_hint_set_opcode (RAnal *a, unsigned long long addr, const char *str);
__attribute__((visibility("default"))) void r_anal_hint_set_esil (RAnal *a, unsigned long long addr, const char *str);
__attribute__((visibility("default"))) void r_anal_hint_set_pointer (RAnal *a, unsigned long long addr, unsigned long long jump);
__attribute__((visibility("default"))) void r_anal_hint_set_high(RAnal *a, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_hint_unset_high(RAnal *a, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_hint_unset_size(RAnal *a, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_hint_unset_bits(RAnal *a, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_hint_unset_esil(RAnal *a, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_hint_unset_opcode(RAnal *a, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_hint_unset_arch(RAnal *a, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_hint_unset_syntax(RAnal *a, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_hint_unset_pointer(RAnal *a, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_hint_unset_offset(RAnal *a, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_hint_unset_jump(RAnal *a, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_hint_unset_fail(RAnal *a, unsigned long long addr);
__attribute__((visibility("default"))) int r_anal_esil_eval(RAnal *anal, const char *str);
__attribute__((visibility("default"))) RAnalSwitchOp * r_anal_switch_op_new(unsigned long long addr, unsigned long long min_val, unsigned long long max_val);
__attribute__((visibility("default"))) void r_anal_switch_op_free(RAnalSwitchOp * swop);
__attribute__((visibility("default"))) RAnalCaseOp* r_anal_switch_op_add_case(RAnalSwitchOp * swop, unsigned long long addr, unsigned long long value, unsigned long long jump);
__attribute__((visibility("default"))) RAnalCycleFrame* r_anal_cycle_frame_new (void);
__attribute__((visibility("default"))) void r_anal_cycle_frame_free (RAnalCycleFrame *cf);
__attribute__((visibility("default"))) RAnalState * r_anal_state_new (unsigned long long start, unsigned char* buffer, unsigned long long len);
__attribute__((visibility("default"))) void r_anal_state_insert_bb (RAnalState* state, RAnalBlock *bb);
__attribute__((visibility("default"))) int r_anal_state_need_rehash (RAnalState* state, RAnalBlock *bb);
__attribute__((visibility("default"))) RAnalBlock * r_anal_state_search_bb (RAnalState* state, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_state_free (RAnalState * state);
__attribute__((visibility("default"))) unsigned long long r_anal_state_get_len (RAnalState *state, unsigned long long addr);
__attribute__((visibility("default"))) const unsigned char * r_anal_state_get_buf_by_addr (RAnalState *state, unsigned long long addr);
__attribute__((visibility("default"))) _Bool r_anal_state_addr_is_valid (RAnalState *state, unsigned long long addr);
__attribute__((visibility("default"))) void r_anal_state_merge_bb_list (RAnalState *state, RList* bbs);
__attribute__((visibility("default"))) void r_anal_state_set_depth(RAnalState *state, unsigned int depth);
__attribute__((visibility("default"))) unsigned long long r_anal_fcn_label_get (RAnal *anal, RAnalFunction *fcn, const char *name);
__attribute__((visibility("default"))) const char *r_anal_fcn_label_at (RAnal *anal, RAnalFunction *fcn, unsigned long long addr);
__attribute__((visibility("default"))) int r_anal_fcn_label_set (RAnal *anal, RAnalFunction *fcn, const char *name, unsigned long long addr);
__attribute__((visibility("default"))) int r_anal_fcn_label_del (RAnal *anal, RAnalFunction *fcn, const char *name, unsigned long long addr);
__attribute__((visibility("default"))) int r_anal_fcn_labels (RAnal *anal, RAnalFunction *fcn, int rad);
__attribute__((visibility("default"))) void r_anal_set_limits(RAnal *anal, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) void r_anal_unset_limits(RAnal *anal);
__attribute__((visibility("default"))) int r_anal_esil_to_reil_setup (RAnalEsil *esil, RAnal *anal, int romem, int stats);
__attribute__((visibility("default"))) void r_anal_noreturn_list(RAnal *anal, int mode);
__attribute__((visibility("default"))) _Bool r_anal_noreturn_add(RAnal *anal, const char *name, unsigned long long addr);
__attribute__((visibility("default"))) int r_anal_noreturn_drop(RAnal *anal, const char *expr);
__attribute__((visibility("default"))) _Bool r_anal_noreturn_at_addr(RAnal *anal, unsigned long long addr);
__attribute__((visibility("default"))) int r_sign_space_count_for(RAnal *a, int idx);
__attribute__((visibility("default"))) void r_sign_space_unset_for(RAnal *a, int idx);
__attribute__((visibility("default"))) void r_sign_space_rename_for(RAnal *a, int idx, const char *oname, const char *nname);
extern RAnalPlugin r_anal_plugin_null;
extern RAnalPlugin r_anal_plugin_xap;
extern RAnalPlugin r_anal_plugin_tms320;
extern RAnalPlugin r_anal_plugin_tms320c64x;
extern RAnalPlugin r_anal_plugin_avr;
extern RAnalPlugin r_anal_plugin_arm_gnu;
extern RAnalPlugin r_anal_plugin_arm_cs;
extern RAnalPlugin r_anal_plugin_x86;
extern RAnalPlugin r_anal_plugin_x86_cs;
extern RAnalPlugin r_anal_plugin_x86_im;
extern RAnalPlugin r_anal_plugin_x86_udis;
extern RAnalPlugin r_anal_plugin_x86_simple;
extern RAnalPlugin r_anal_plugin_ppc_gnu;
extern RAnalPlugin r_anal_plugin_ppc_cs;
extern RAnalPlugin r_anal_plugin_java;
extern RAnalPlugin r_anal_plugin_mips_gnu;
extern RAnalPlugin r_anal_plugin_mips_cs;
extern RAnalPlugin r_anal_plugin_dalvik;
extern RAnalPlugin r_anal_plugin_sh;
extern RAnalPlugin r_anal_plugin_sparc_gnu;
extern RAnalPlugin r_anal_plugin_bf;
extern RAnalPlugin r_anal_plugin_m68k;
extern RAnalPlugin r_anal_plugin_m68k_cs;
extern RAnalPlugin r_anal_plugin_z80;
extern RAnalPlugin r_anal_plugin_i8080;
extern RAnalPlugin r_anal_plugin_8051;
extern RAnalPlugin r_anal_plugin_arc;
extern RAnalPlugin r_anal_plugin_ebc;
extern RAnalPlugin r_anal_plugin_gb;
extern RAnalPlugin r_anal_plugin_nios2;
extern RAnalPlugin r_anal_plugin_malbolge;
extern RAnalPlugin r_anal_plugin_ws;
extern RAnalPlugin r_anal_plugin_h8300;
extern RAnalPlugin r_anal_plugin_cr16;
extern RAnalPlugin r_anal_plugin_v850;
extern RAnalPlugin r_anal_plugin_sysz;
extern RAnalPlugin r_anal_plugin_sparc_cs;
extern RAnalPlugin r_anal_plugin_xcore_cs;
extern RAnalPlugin r_anal_plugin_propeller;
extern RAnalPlugin r_anal_plugin_msp430;
extern RAnalPlugin r_anal_plugin_chip8;
extern RAnalPlugin r_anal_plugin_cris;
extern RAnalPlugin r_anal_plugin_v810;
extern RAnalPlugin r_anal_plugin_6502;
extern RAnalPlugin r_anal_plugin_snes;
extern RAnalPlugin r_anal_plugin_riscv;
extern RAnalPlugin r_anal_plugin_vax;
extern RAnalPlugin r_anal_plugin_i4004;
extern RAnalPlugin r_anal_plugin_xtensa;
extern RAnalPlugin r_anal_plugin_pic18c;
extern RAnalPlugin r_anal_plugin_rsp;
__attribute__((visibility("default"))) const char *r_parse_version(void);
typedef RList* (*RAnalVarList)(RAnal *anal, RAnalFunction *fcn, int kind);
typedef struct r_parse_t {
 void *user;
 int flagspace;
 int notin_flagspace;
 _Bool relsub; 
 _Bool localvar_only; 
 int relsub_addr;
 int minval;
 char *retleave_asm;
 struct r_parse_plugin_t *cur;
 RAnal *anal; 
 RAnalHint *hint; 
 RList *parsers;
 RAnalVarList varlist;
 RAnalBind analb;
} RParse;
typedef struct r_parse_plugin_t {
 char *name;
 char *desc;
 int (*init)(void *user);
 int (*fini)(void *user);
 int (*parse)(RParse *p, const char *data, char *str);
 int (*assemble)(RParse *p, char *data, char *str);
 int (*filter)(RParse *p, RFlag *f, char *data, char *str, int len, _Bool big_endian);
 _Bool (*varsub)(RParse *p, RAnalFunction *f, unsigned long long addr, int oplen, char *data, char *str, int len);
 int (*replace)(int argc, const char *argv[], char *newstr);
} RParsePlugin;
__attribute__((visibility("default"))) struct r_parse_t *r_parse_new(void);
__attribute__((visibility("default"))) void r_parse_free(RParse *p);
__attribute__((visibility("default"))) void r_parse_set_user_ptr(RParse *p, void *user);
__attribute__((visibility("default"))) int r_parse_add(RParse *p, RParsePlugin *foo);
__attribute__((visibility("default"))) int r_parse_list(RParse *p);
__attribute__((visibility("default"))) int r_parse_use(RParse *p, const char *name);
__attribute__((visibility("default"))) int r_parse_parse(RParse *p, const char *data, char *str);
__attribute__((visibility("default"))) int r_parse_assemble(RParse *p, char *data, char *str);
__attribute__((visibility("default"))) int r_parse_filter(RParse *p, RFlag *f, char *data, char *str, int len, _Bool big_endian);
__attribute__((visibility("default"))) _Bool r_parse_varsub(RParse *p, RAnalFunction *f, unsigned long long addr, int oplen, char *data, char *str, int len);
__attribute__((visibility("default"))) char *r_parse_c_string(RAnal *anal, const char *code);
__attribute__((visibility("default"))) char *r_parse_c_file(RAnal *anal, const char *path);
__attribute__((visibility("default"))) int r_parse_is_c_file (const char *file);
__attribute__((visibility("default"))) _Bool r_parse_immtrim (char *opstr);
extern RParsePlugin r_parse_plugin_dummy;
extern RParsePlugin r_parse_plugin_att2intel;
extern RParsePlugin r_parse_plugin_x86_pseudo;
extern RParsePlugin r_parse_plugin_arm_pseudo;
extern RParsePlugin r_parse_plugin_mips_pseudo;
extern RParsePlugin r_parse_plugin_dalvik_pseudo;
extern RParsePlugin r_parse_plugin_mreplace;
extern RParsePlugin r_parse_plugin_ppc_pseudo;
extern RParsePlugin r_parse_plugin_sh_pseudo;
extern RParsePlugin r_parse_plugin_avr_pseudo;
extern RParsePlugin r_parse_plugin_6502_pseudo;
extern RParsePlugin r_parse_plugin_m68k_pseudo;
extern RParsePlugin r_parse_plugin_z80_pseudo;
__attribute__((visibility("default"))) const char *r_asm_version(void);
enum {
 R_ASM_SYNTAX_NONE = 0,
 R_ASM_SYNTAX_INTEL,
 R_ASM_SYNTAX_ATT,
 R_ASM_SYNTAX_MASM,
 R_ASM_SYNTAX_REGNUM, 
 R_ASM_SYNTAX_JZ, 
};
enum {
 R_ASM_MOD_RAWVALUE = 'r',
 R_ASM_MOD_VALUE = 'v',
 R_ASM_MOD_DSTREG = 'd',
 R_ASM_MOD_SRCREG0 = '0',
 R_ASM_MOD_SRCREG1 = '1',
 R_ASM_MOD_SRCREG2 = '2'
};
typedef struct r_asm_op_t {
 int size; 
 int bitsize; 
 int payload; 
 unsigned char buf[255 + 1];
 char buf_asm[255 + 1];
 char buf_hex[255 + 1];
} RAsmOp;
typedef struct r_asm_code_t {
 int len;
 unsigned char *buf;
 char *buf_hex;
 char *buf_asm;
 RList *equs; 
 unsigned long long code_offset;
 unsigned long long data_offset;
 int code_align;
} RAsmCode;
typedef struct {
 char *key;
 char *value;
} RAsmEqu;
typedef struct r_asm_t {
 char *cpu;
 int bits;
 int big_endian;
 int syntax;
 unsigned long long pc;
 void *user;
 struct r_asm_plugin_t *cur;
 struct r_asm_plugin_t *acur;
 RList *plugins;
 RBinBind binb;
 RParse *ifilter;
 RParse *ofilter;
 Sdb *pair;
 RSysregs *sysregs;
 RSyscall *syscall;
 RNum *num;
 char *features;
 int invhex; 
 int pcalign;
 int dataalign;
 int bitshift;
 _Bool immdisp; 
 SdbHash *flags;
} RAsm;
typedef int (*RAsmModifyCallback)(RAsm *a, unsigned char *buf, int field, unsigned long long val);
typedef struct r_asm_plugin_t {
 const char *name;
 const char *arch;
 const char *author;
 const char *version;
 const char *cpus;
 const char *desc;
 const char *license;
 void *user; 
 int bits;
 int endian;
 _Bool (*init)(void *user);
 _Bool (*fini)(void *user);
 int (*disassemble)(RAsm *a, RAsmOp *op, const unsigned char *buf, int len);
 int (*assemble)(RAsm *a, RAsmOp *op, const char *buf);
 RAsmModifyCallback modify;
 int (*set_subarch)(RAsm *a, const char *buf);
 char *(*mnemonics)(RAsm *a, int id, _Bool json);
 const char *features;
} RAsmPlugin;
__attribute__((visibility("default"))) RAsm *r_asm_new(void);
__attribute__((visibility("default"))) RAsm *r_asm_free(RAsm *a);
__attribute__((visibility("default"))) int r_asm_modify(RAsm *a, unsigned char *buf, int field, unsigned long long val);
__attribute__((visibility("default"))) char *r_asm_mnemonics(RAsm *a, int id, _Bool json);
__attribute__((visibility("default"))) int r_asm_mnemonics_byname(RAsm *a, const char *name);
__attribute__((visibility("default"))) void r_asm_set_user_ptr(RAsm *a, void *user);
__attribute__((visibility("default"))) _Bool r_asm_add(RAsm *a, RAsmPlugin *foo);
__attribute__((visibility("default"))) int r_asm_setup(RAsm *a, const char *arch, int bits, int big_endian);
__attribute__((visibility("default"))) int r_asm_is_valid(RAsm *a, const char *name);
__attribute__((visibility("default"))) int r_asm_use(RAsm *a, const char *name);
__attribute__((visibility("default"))) _Bool r_asm_use_assembler(RAsm *a, const char *name);
__attribute__((visibility("default"))) _Bool r_asm_set_arch(RAsm *a, const char *name, int bits);
__attribute__((visibility("default"))) int r_asm_set_bits(RAsm *a, int bits);
__attribute__((visibility("default"))) void r_asm_set_cpu(RAsm *a, const char *cpu);
__attribute__((visibility("default"))) _Bool r_asm_set_big_endian(RAsm *a, _Bool big_endian);
__attribute__((visibility("default"))) int r_asm_set_syntax(RAsm *a, int syntax);
__attribute__((visibility("default"))) int r_asm_syntax_from_string(const char *name);
__attribute__((visibility("default"))) int r_asm_set_pc(RAsm *a, unsigned long long pc);
__attribute__((visibility("default"))) int r_asm_disassemble(RAsm *a, RAsmOp *op, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_asm_assemble(RAsm *a, RAsmOp *op, const char *buf);
__attribute__((visibility("default"))) RAsmCode* r_asm_mdisassemble(RAsm *a, const unsigned char *buf, int len);
__attribute__((visibility("default"))) RAsmCode* r_asm_mdisassemble_hexstr(RAsm *a, const char *hexstr);
__attribute__((visibility("default"))) RAsmCode* r_asm_massemble(RAsm *a, const char *buf);
__attribute__((visibility("default"))) RAsmCode* r_asm_rasm_assemble(RAsm *a, const char *buf, _Bool use_spp);
__attribute__((visibility("default"))) RAsmCode* r_asm_assemble_file(RAsm *a, const char *file);
__attribute__((visibility("default"))) char *r_asm_to_string(RAsm *a, unsigned long long addr, const unsigned char *b, int l);
__attribute__((visibility("default"))) unsigned char *r_asm_from_string(RAsm *a, unsigned long long addr, const char *b, int *l);
__attribute__((visibility("default"))) int r_asm_filter_input(RAsm *a, const char *f);
__attribute__((visibility("default"))) int r_asm_filter_output(RAsm *a, const char *f);
__attribute__((visibility("default"))) char *r_asm_describe(RAsm *a, const char* str);
__attribute__((visibility("default"))) RList* r_asm_get_plugins(RAsm *a);
__attribute__((visibility("default"))) void r_asm_list_directives(void);
__attribute__((visibility("default"))) RAsmCode *r_asm_code_new(void);
__attribute__((visibility("default"))) void* r_asm_code_free(RAsmCode *acode);
__attribute__((visibility("default"))) void r_asm_equ_item_free(RAsmEqu *equ);
__attribute__((visibility("default"))) _Bool r_asm_code_set_equ (RAsmCode *code, const char *key, const char *value);
__attribute__((visibility("default"))) char *r_asm_code_equ_replace (RAsmCode *code, char *str);
__attribute__((visibility("default"))) char *r_asm_op_get_hex(RAsmOp *op);
__attribute__((visibility("default"))) char *r_asm_op_get_asm(RAsmOp *op);
__attribute__((visibility("default"))) int r_asm_op_get_size(RAsmOp *op);
extern RAsmPlugin r_asm_plugin_bf;
extern RAsmPlugin r_asm_plugin_java;
extern RAsmPlugin r_asm_plugin_mips_gnu;
extern RAsmPlugin r_asm_plugin_mips_cs;
extern RAsmPlugin r_asm_plugin_x86_udis;
extern RAsmPlugin r_asm_plugin_x86_as;
extern RAsmPlugin r_asm_plugin_x86_nz;
extern RAsmPlugin r_asm_plugin_x86_nasm;
extern RAsmPlugin r_asm_plugin_x86_cs;
extern RAsmPlugin r_asm_plugin_arm_gnu;
extern RAsmPlugin r_asm_plugin_arm_cs;
extern RAsmPlugin r_asm_plugin_arm_as;
extern RAsmPlugin r_asm_plugin_armthumb;
extern RAsmPlugin r_asm_plugin_arm_winedbg;
extern RAsmPlugin r_asm_plugin_xap;
extern RAsmPlugin r_asm_plugin_ppc_gnu;
extern RAsmPlugin r_asm_plugin_ppc_cs;
extern RAsmPlugin r_asm_plugin_sparc_gnu;
extern RAsmPlugin r_asm_plugin_avr;
extern RAsmPlugin r_asm_plugin_dalvik;
extern RAsmPlugin r_asm_plugin_sh;
extern RAsmPlugin r_asm_plugin_z80;
extern RAsmPlugin r_asm_plugin_i8080;
extern RAsmPlugin r_asm_plugin_m68k;
extern RAsmPlugin r_asm_plugin_m68k_cs;
extern RAsmPlugin r_asm_plugin_arc;
extern RAsmPlugin r_asm_plugin_dcpu16;
extern RAsmPlugin r_asm_plugin_8051;
extern RAsmPlugin r_asm_plugin_tms320;
extern RAsmPlugin r_asm_plugin_gb;
extern RAsmPlugin r_asm_plugin_snes;
extern RAsmPlugin r_asm_plugin_ebc;
extern RAsmPlugin r_asm_plugin_nios2;
extern RAsmPlugin r_asm_plugin_malbolge;
extern RAsmPlugin r_asm_plugin_ws;
extern RAsmPlugin r_asm_plugin_6502;
extern RAsmPlugin r_asm_plugin_h8300;
extern RAsmPlugin r_asm_plugin_chip8;
extern RAsmPlugin r_asm_plugin_cr16;
extern RAsmPlugin r_asm_plugin_v850;
extern RAsmPlugin r_asm_plugin_sysz;
extern RAsmPlugin r_asm_plugin_sparc_cs;
extern RAsmPlugin r_asm_plugin_xcore_cs;
extern RAsmPlugin r_asm_plugin_spc700;
extern RAsmPlugin r_asm_plugin_propeller;
extern RAsmPlugin r_asm_plugin_msp430;
extern RAsmPlugin r_asm_plugin_i4004;
extern RAsmPlugin r_asm_plugin_cris_gnu;
extern RAsmPlugin r_asm_plugin_lh5801;
extern RAsmPlugin r_asm_plugin_hppa_gnu;
extern RAsmPlugin r_asm_plugin_v810;
extern RAsmPlugin r_asm_plugin_mcs96;
extern RAsmPlugin r_asm_plugin_lm32;
extern RAsmPlugin r_asm_plugin_riscv;
extern RAsmPlugin r_asm_plugin_vax;
extern RAsmPlugin r_asm_plugin_lanai_gnu;
extern RAsmPlugin r_asm_plugin_xtensa;
extern RAsmPlugin r_asm_plugin_tricore;
extern RAsmPlugin r_asm_plugin_pic18c;
extern RAsmPlugin r_asm_plugin_rsp;
extern RAsmPlugin r_asm_plugin_hexagon_gnu;
extern RAsmPlugin r_asm_plugin_wasm;
extern RAsmPlugin r_asm_plugin_tms320c64x;
extern RAsmPlugin r_asm_plugin_evm;
__attribute__((visibility("default"))) const char *r_egg_version(void);
typedef struct r_egg_plugin_t {
 const char *name;
 const char *desc;
 int type;
 RBuffer* (*build) (void *egg);
} REggPlugin;
typedef struct r_egg_lang_t {
 int pushargs;
 int nalias;
 int nsyscalls;
 char *conditionstr;
 char *syscallbody;
 char *includefile;
 char *setenviron;
 char *mathline;
 int commentmode;
 int varsize;
 int varxs;
 int lastctxdelta;
 int nargs;
 int docall;
 int nfunctions;
 int nbrackets;
 int slurpin;
 int slurp;
 int line;
 char elem[1024];
 int attsyntax;
 int elem_n;
 char *callname;
 char *endframe;
 char *ctxpush[32];
 char *file;
 char *dstvar;
 char *dstval;
 char *includedir;
 char *ifelse_table[32][32];
 int ndstval;
 int skipline;
 int quoteline;
 int quotelinevar;
 int stackframe;
 int stackfixed;
 int oc;
 int mode;
  int inlinectr;
 struct {
  char *name;
  char *body;
 } inlines[256];
 int ninlines;
 struct {
  char *name;
  char *arg;
 } syscalls[256];
 struct {
  char *name;
  char *content;
 } aliases[256];
 char *nested[32];
 char *nested_callname[32];
 int nestedi[32];
} REggLang;
typedef struct r_egg_t {
 RBuffer *src;
 RBuffer *buf;
 RBuffer *bin;
 RList *list;
 RAsm *rasm;
 RSyscall *syscall;
 REggLang lang;
 Sdb *db;
 RList *plugins;
 RList *patches; 
 struct r_egg_emit_t *remit;
 int arch;
 int endian;
 int bits;
 unsigned int os;
 int context;
} REgg;
typedef struct r_egg_emit_t {
 const char *arch;
 int size; 
 const char *retvar;
 const char* (*regs)(REgg *egg, int idx);
 void (*init)(REgg *egg);
 void (*call)(REgg *egg, const char *addr, int ptr);
 void (*jmp)(REgg *egg, const char *addr, int ptr);
 void (*frame)(REgg *egg, int sz);
 char *(*syscall)(REgg *egg, int num);
 void (*trap)(REgg *egg);
 void (*frame_end)(REgg *egg, int sz, int ctx);
 void (*comment)(REgg *egg, const char *fmt, ...);
 void (*push_arg)(REgg *egg, int xs, int num, const char *str);
 void (*set_string)(REgg *egg, const char *dstvar, const char *str, int j);
 void (*equ)(REgg *egg, const char *key, const char *value);
 void (*get_result)(REgg *egg, const char *ocn);
 void (*restore_stack)(REgg *egg, int size);
 void (*syscall_args)(REgg *egg, int nargs);
 void (*get_var)(REgg *egg, int type, char *out, int idx);
 void (*get_ar)(REgg *egg, char *out, int idx);
 void (*while_end)(REgg *egg, const char *label);
 void (*load)(REgg *egg, const char *str, int sz);
 void (*load_ptr)(REgg *egg, const char *str);
 void (*branch)(REgg *egg, char *b, char *g, char *e, char *n, int sz, const char *dst);
 void (*mathop)(REgg *egg, int ch, int sz, int type, const char *eq, const char *p);
 void (*get_while_end)(REgg *egg, char *out, const char *ctxpush, const char *label);
} REggEmit;
__attribute__((visibility("default"))) REgg *r_egg_new (void);
__attribute__((visibility("default"))) void r_egg_lang_init(REgg *egg);
__attribute__((visibility("default"))) void r_egg_lang_free(REgg *egg);
__attribute__((visibility("default"))) char *r_egg_to_string (REgg *egg);
__attribute__((visibility("default"))) void r_egg_free (REgg *egg);
__attribute__((visibility("default"))) int r_egg_add (REgg *a, REggPlugin *foo);
__attribute__((visibility("default"))) void r_egg_reset (REgg *egg);
__attribute__((visibility("default"))) int r_egg_setup(REgg *egg, const char *arch, int bits, int endian, const char *os);
__attribute__((visibility("default"))) int r_egg_include(REgg *egg, const char *file, int format);
__attribute__((visibility("default"))) void r_egg_load(REgg *egg, const char *code, int format);
__attribute__((visibility("default"))) void r_egg_syscall(REgg *egg, const char *arg, ...);
__attribute__((visibility("default"))) void r_egg_alloc(REgg *egg, int n);
__attribute__((visibility("default"))) void r_egg_label(REgg *egg, const char *name);
__attribute__((visibility("default"))) int r_egg_raw(REgg *egg, const unsigned char *b, int len);
__attribute__((visibility("default"))) int r_egg_encode(REgg *egg, const char *name);
__attribute__((visibility("default"))) int r_egg_shellcode(REgg *egg, const char *name);
__attribute__((visibility("default"))) void r_egg_option_set (REgg *egg, const char *k, const char *v);
__attribute__((visibility("default"))) char *r_egg_option_get (REgg *egg, const char *k);
__attribute__((visibility("default"))) void r_egg_if(REgg *egg, const char *reg, char cmp, int v);
__attribute__((visibility("default"))) void r_egg_printf(REgg *egg, const char *fmt, ...);
__attribute__((visibility("default"))) int r_egg_compile(REgg *egg);
__attribute__((visibility("default"))) int r_egg_padding (REgg *egg, const char *pad);
__attribute__((visibility("default"))) int r_egg_assemble(REgg *egg);
__attribute__((visibility("default"))) int r_egg_assemble_asm(REgg *egg, char **asm_list);
__attribute__((visibility("default"))) void r_egg_pattern(REgg *egg, int size);
__attribute__((visibility("default"))) RBuffer *r_egg_get_bin(REgg *egg);
__attribute__((visibility("default"))) char *r_egg_get_source(REgg *egg);
__attribute__((visibility("default"))) RBuffer *r_egg_get_bin(REgg *egg);
__attribute__((visibility("default"))) char *r_egg_get_assembly(REgg *egg);
__attribute__((visibility("default"))) void r_egg_append(REgg *egg, const char *src);
__attribute__((visibility("default"))) int r_egg_run(REgg *egg);
__attribute__((visibility("default"))) int r_egg_patch(REgg *egg, int off, const unsigned char *b, int l);
__attribute__((visibility("default"))) void r_egg_finalize(REgg *egg);
__attribute__((visibility("default"))) char *r_egg_mkvar(REgg *egg, char *out, const char *_str, int delta);
__attribute__((visibility("default"))) int r_egg_lang_parsechar(REgg *egg, char c);
__attribute__((visibility("default"))) void r_egg_lang_include_path (REgg *egg, const char *path);
__attribute__((visibility("default"))) void r_egg_lang_include_init (REgg *egg);
extern REggPlugin r_egg_plugin_xor;
extern REggPlugin r_egg_plugin_shya;
extern REggPlugin r_egg_plugin_exec;
__attribute__((visibility("default"))) const char *r_lang_version(void);
typedef char* (*RCoreCmdStrCallback)(void* core, const char *s);
typedef int (*RCoreCmdfCallback)(void* core, const char *s, ...);
typedef struct r_lang_t {
 struct r_lang_plugin_t *cur;
 void *user;
 RList *defs;
 RList *langs;
 PrintfCallback cb_printf;
 RCoreCmdStrCallback cmd_str;
 RCoreCmdfCallback cmdf;
} RLang;
typedef struct r_lang_plugin_t {
 const char *name;
 const char *alias;
 const char *desc;
 const char *license;
 const char **help;
 const char *ext;
 int (*init)(RLang *user);
 _Bool (*setup)(RLang *user);
 int (*fini)(RLang *user);
 int (*prompt)(RLang *user);
 int (*run)(RLang *user, const char *code, int len);
 int (*run_file)(RLang *user, const char *file);
 int (*set_argv)(RLang *user, int argc, char **argv);
} RLangPlugin;
typedef struct r_lang_def_t {
 char *name;
 char *type;
 void *value;
} RLangDef;
__attribute__((visibility("default"))) RLang *r_lang_new(void);
__attribute__((visibility("default"))) void *r_lang_free(RLang *lang);
__attribute__((visibility("default"))) _Bool r_lang_setup(RLang *lang);
__attribute__((visibility("default"))) _Bool r_lang_add(RLang *lang, RLangPlugin *foo);
__attribute__((visibility("default"))) _Bool r_lang_list(RLang *lang);
__attribute__((visibility("default"))) _Bool r_lang_use(RLang *lang, const char *name);
__attribute__((visibility("default"))) int r_lang_run(RLang *lang, const char *code, int len);
__attribute__((visibility("default"))) int r_lang_run_string(RLang *lang, const char *code);
__attribute__((visibility("default"))) void r_lang_set_user_ptr(RLang *lang, void *user);
__attribute__((visibility("default"))) _Bool r_lang_set_argv(RLang *lang, int argc, char **argv);
__attribute__((visibility("default"))) int r_lang_run(RLang *lang, const char *code, int len);
__attribute__((visibility("default"))) int r_lang_run_file(RLang *lang, const char *file);
__attribute__((visibility("default"))) int r_lang_prompt(RLang *lang);
__attribute__((visibility("default"))) void r_lang_plugin_free(RLangPlugin *p); 
__attribute__((visibility("default"))) RLangPlugin *r_lang_get_by_name(RLang *lang, const char *name);
__attribute__((visibility("default"))) RLangPlugin *r_lang_get_by_extension(RLang *lang, const char *ext);
__attribute__((visibility("default"))) _Bool r_lang_define(RLang *lang, const char *type, const char *name, void *value);
__attribute__((visibility("default"))) void r_lang_undef(RLang *lang, const char *name);
__attribute__((visibility("default"))) void r_lang_def_free(RLangDef *def);
typedef struct r_cmd_macro_label_t {
 char name[80];
 char *ptr;
} RCmdMacroLabel;
typedef struct r_cmd_macro_item_t {
 char *name;
 char *args;
 char *code;
 int codelen;
 int nargs;
} RCmdMacroItem;
typedef struct r_cmd_macro_t {
 int counter;
 unsigned long long *brk_value;
 unsigned long long _brk_value;
 int brk;
 int (*cmd)(void *user, const char *cmd);
 PrintfCallback cb_printf;
 void *user;
 RNum *num;
 int labels_n;
 RCmdMacroLabel labels[20];
 RList *macros;
} RCmdMacro;
typedef int (*RCmdCallback)(void *user, const char *cmd);
typedef struct r_cmd_item_t {
 char cmd[64];
 char desc[128];
 int (*callback)(void *data, const char *input);
} RCmdItem;
typedef struct r_cmd_long_item_t {
 char cmd[64]; 
 int cmd_len;
 char cmd_short[32]; 
 char desc[128];
} RCmdLongItem;
typedef struct r_cmd_alias_t {
 int count;
 char **keys;
 char **values;
 int *remote;
} RCmdAlias;
typedef struct r_cmd_t {
 void *data;
 int (*nullcallback)(void *data);
 RCmdItem *cmds[0xFFU];
 RCmdMacro macro;
 RList *lcmds;
 RList *plist;
 RCmdAlias aliases;
} RCmd;
typedef struct r_cmd_descriptor_t {
 const char *cmd;
 const char **help_msg;
 const char **help_detail;
 const char **help_detail2;
 struct r_cmd_descriptor_t *sub[127];
} RCmdDescriptor;
typedef struct r_core_plugin_t {
 const char *name;
 const char *desc;
 const char *license;
 const char *author;
 const char *version;
 RCmdCallback call;
 RCmdCallback init;
 RCmdCallback deinit;
} RCorePlugin;
__attribute__((visibility("default"))) int r_core_plugin_init(RCmd *cmd);
__attribute__((visibility("default"))) int r_core_plugin_add(RCmd *cmd, RCorePlugin *plugin);
__attribute__((visibility("default"))) int r_core_plugin_check(RCmd *cmd, const char *a0);
__attribute__((visibility("default"))) int r_core_plugin_deinit(RCmd *cmd);
__attribute__((visibility("default"))) RCmd *r_cmd_new(void);
__attribute__((visibility("default"))) RCmd *r_cmd_free(RCmd *cmd);
__attribute__((visibility("default"))) int r_cmd_set_data(RCmd *cmd, void *data);
__attribute__((visibility("default"))) int r_cmd_add(RCmd *cmd, const char *command, const char *desc, int (*callback)(void *data, const char *input));
__attribute__((visibility("default"))) int r_cmd_add_long(RCmd *cmd, const char *longcmd, const char *shortcmd, const char *desc);
__attribute__((visibility("default"))) int r_core_del(RCmd *cmd, const char *command);
__attribute__((visibility("default"))) int r_cmd_call(RCmd *cmd, const char *command);
__attribute__((visibility("default"))) int r_cmd_call_long(RCmd *cmd, const char *input);
__attribute__((visibility("default"))) char **r_cmd_args(RCmd *cmd, int *argc);
__attribute__((visibility("default"))) void r_cmd_macro_init(RCmdMacro *mac);
__attribute__((visibility("default"))) int r_cmd_macro_add(RCmdMacro *mac, const char *name);
__attribute__((visibility("default"))) int r_cmd_macro_rm(RCmdMacro *mac, const char *_name);
__attribute__((visibility("default"))) void r_cmd_macro_list(RCmdMacro *mac);
__attribute__((visibility("default"))) void r_cmd_macro_meta(RCmdMacro *mac);
__attribute__((visibility("default"))) int r_cmd_macro_call(RCmdMacro *mac, const char *name);
__attribute__((visibility("default"))) int r_cmd_macro_break(RCmdMacro *mac, const char *value);
__attribute__((visibility("default"))) int r_cmd_alias_del (RCmd *cmd, const char *k);
__attribute__((visibility("default"))) char **r_cmd_alias_keys(RCmd *cmd, int *sz);
__attribute__((visibility("default"))) int r_cmd_alias_set (RCmd *cmd, const char *k, const char *v, int remote);
__attribute__((visibility("default"))) char *r_cmd_alias_get (RCmd *cmd, const char *k, int remote);
__attribute__((visibility("default"))) void r_cmd_alias_free (RCmd *cmd);
__attribute__((visibility("default"))) void r_cmd_macro_free (RCmdMacro *mac);
typedef int (*RPrintZoomCallback)(void *user, int mode, unsigned long long addr, unsigned char *bufz, unsigned long long size);
typedef const char *(*RPrintNameCallback)(void *user, unsigned long long addr);
typedef char *(*RPrintCommentCallback)(void *user, unsigned long long addr);
typedef const char *(*RPrintColorFor)(void *user, unsigned long long addr, _Bool verbose);
typedef struct r_print_zoom_t {
 unsigned char *buf;
 unsigned long long from;
 unsigned long long to;
 int size;
 int mode;
} RPrintZoom;
typedef struct r_print_t {
 void *user;
 RIOBind iob;
 char datefmt[32];
 int datezone;
 int (*write)(const unsigned char *buf, int len);
 void (*cb_printf)(const char *str, ...);
 char *(*cb_color)(int idx, int last, _Bool bg);
 int (*disasm)(void *p, unsigned long long addr);
 void (*oprintf)(const char *str, ...);
 char* (*get_bitfield)(void *user, const char *name, unsigned long long value);
 char* (*get_enumname)(void *user, const char *name, unsigned long long value);
 int interrupt;
 int big_endian;
 int width;
 int limit;
 int bits;
 _Bool cur_enabled;
 int cur;
 int ocur;
 int cols;
 int flags;
 _Bool use_comments;
 int addrmod;
 int col;
 int stride;
 int bytespace;
 int pairs;
 RPrintZoom *zoom;
 RPrintNameCallback offname;
 RPrintColorFor colorfor;
 RPrintColorFor hasrefs;
 RPrintCommentCallback get_comments;
 Sdb *formats;
 RCons *cons;
 RConsBind consbind;
 RNum *num;
 RReg *reg;
 RRegItem* (*get_register)(RReg *reg, const char *name, int type);
 unsigned long long (*get_register_value)(RReg *reg, RRegItem *item);
 unsigned long long* lines_cache;
 int lines_cache_sz;
 int lines_abs;
 _Bool esc_bslash;
 unsigned int *row_offsets;
 int row_offsets_sz;
 _Bool vflush;
 unsigned long long screen_bounds;
} RPrint;
__attribute__((visibility("default"))) int r_print_is_interrupted(void);
__attribute__((visibility("default"))) void r_print_set_interrupt(int i);
__attribute__((visibility("default"))) char *r_print_hexpair(RPrint *p, const char *str, int idx);
__attribute__((visibility("default"))) void r_print_hex_from_bin (RPrint *p, char *bin_str);
__attribute__((visibility("default"))) RPrint *r_print_new(void);
__attribute__((visibility("default"))) RPrint *r_print_free(RPrint *p);
__attribute__((visibility("default"))) _Bool r_print_mute(RPrint *p, int x);
__attribute__((visibility("default"))) void r_print_set_flags(RPrint *p, int _flags);
__attribute__((visibility("default"))) void r_print_unset_flags(RPrint *p, int flags);
__attribute__((visibility("default"))) void r_print_addr(RPrint *p, unsigned long long addr);
__attribute__((visibility("default"))) void r_print_columns (RPrint *p, const unsigned char *buf, int len, int height);
__attribute__((visibility("default"))) void r_print_hexii(RPrint *p, unsigned long long addr, const unsigned char *buf, int len, int step);
__attribute__((visibility("default"))) void r_print_hexdump(RPrint *p, unsigned long long addr, const unsigned char *buf, int len, int base, int step, int zoomsz);
__attribute__((visibility("default"))) int r_print_jsondump(RPrint *p, const unsigned char *buf, int len, int wordsize);
__attribute__((visibility("default"))) void r_print_hexpairs(RPrint *p, unsigned long long addr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) void r_print_hexdiff(RPrint *p, unsigned long long aa, const unsigned char* a, unsigned long long ba, const unsigned char *b, int len, int scndcol);
__attribute__((visibility("default"))) void r_print_bytes(RPrint *p, const unsigned char* buf, int len, const char *fmt);
__attribute__((visibility("default"))) void r_print_fill(RPrint *p, const unsigned char *arr, int size, unsigned long long addr, int step);
__attribute__((visibility("default"))) void r_print_byte(RPrint *p, const char *fmt, int idx, unsigned char ch);
__attribute__((visibility("default"))) void r_print_c(RPrint *p, const unsigned char *str, int len);
__attribute__((visibility("default"))) void r_print_raw(RPrint *p, unsigned long long addr, const unsigned char* buf, int len, int offlines);
__attribute__((visibility("default"))) void r_print_cursor(RPrint *p, int cur, int set);
__attribute__((visibility("default"))) void r_print_cursor_range(RPrint *p, int cur, int to, int set);
__attribute__((visibility("default"))) int r_print_get_cursor(RPrint *p);
__attribute__((visibility("default"))) void r_print_set_cursor(RPrint *p, int curset, int ocursor, int cursor);
__attribute__((visibility("default"))) void r_print_code(RPrint *p, unsigned long long addr, unsigned char *buf, int len, char lang);
__attribute__((visibility("default"))) int r_print_format_struct_size(const char *format, RPrint *p, int mode, int n);
__attribute__((visibility("default"))) int r_print_format(RPrint *p, unsigned long long seek, const unsigned char* buf, const int len, const char *fmt, int elem, const char *setval, char *field);
__attribute__((visibility("default"))) int r_print_format_length(const char *fmt);
__attribute__((visibility("default"))) void r_print_offset(RPrint *p, unsigned long long off, int invert, int opt, int dec, int delta, const char *label);
__attribute__((visibility("default"))) int r_print_string(RPrint *p, unsigned long long seek, const unsigned char *str, int len, int options);
__attribute__((visibility("default"))) int r_print_date_dos(RPrint *p, unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_print_date_hfs(RPrint *p, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_print_date_w32(RPrint *p, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_print_date_unix(RPrint *p, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_print_date_get_now(RPrint *p, char *str);
__attribute__((visibility("default"))) void r_print_zoom(RPrint *p, void *user, RPrintZoomCallback cb, unsigned long long from, unsigned long long to, int len, int maxlen);
__attribute__((visibility("default"))) void r_print_progressbar(RPrint *pr, int pc, int _cols);
__attribute__((visibility("default"))) void r_print_portionbar(RPrint *p, const unsigned long long *portions, int n_portions);
__attribute__((visibility("default"))) void r_print_rangebar(RPrint *p, unsigned long long startA, unsigned long long endA, unsigned long long min, unsigned long long max, int cols);
__attribute__((visibility("default"))) char * r_print_randomart(const unsigned char *dgst_raw, unsigned int dgst_raw_len, unsigned long long addr);
__attribute__((visibility("default"))) void r_print_2bpp_row(RPrint *p, unsigned char *buf);
__attribute__((visibility("default"))) void r_print_2bpp_tiles(RPrint *p, unsigned char *buf, unsigned int tiles);
__attribute__((visibility("default"))) char * r_print_colorize_opcode(RPrint *print, char *p, const char *reg, const char *num, _Bool partial_reset);
__attribute__((visibility("default"))) const char * r_print_color_op_type(RPrint *p, unsigned long long anal_type);
__attribute__((visibility("default"))) void r_print_set_interrupted(int i);
__attribute__((visibility("default"))) void r_print_init_rowoffsets(RPrint *p);
__attribute__((visibility("default"))) unsigned int r_print_rowoff(RPrint *p, int i);
__attribute__((visibility("default"))) void r_print_set_rowoff(RPrint *p, int i, unsigned int offset);
__attribute__((visibility("default"))) int r_print_row_at_off(RPrint *p, unsigned int offset);
__attribute__((visibility("default"))) int r_print_unpack7bit(const char *src, char *dest);
__attribute__((visibility("default"))) int r_print_pack7bit(const char *src, char *dest);
__attribute__((visibility("default"))) char *r_print_stereogram_bytes(const unsigned char *buf, int len);
__attribute__((visibility("default"))) char *r_print_stereogram(const char *bump, int w, int h);
__attribute__((visibility("default"))) void r_print_stereogram_print(RPrint *p, const char *buf);
__attribute__((visibility("default"))) void r_print_set_screenbounds(RPrint *p, unsigned long long addr);
__attribute__((visibility("default"))) int r_util_lines_getline(unsigned long long *lines_cache, int lines_cache_sz, unsigned long long off);
__attribute__((visibility("default"))) char* r_print_json_indent(const char* s, _Bool color, const char *tab, const char **colors);
__attribute__((visibility("default"))) char* r_print_json_path(const char* s, int pos);
__attribute__((visibility("default"))) const char *r_search_version(void);
enum {
 R_SEARCH_KEYWORD,
 R_SEARCH_REGEXP,
 R_SEARCH_PATTERN,
 R_SEARCH_STRING,
 R_SEARCH_XREFS,
 R_SEARCH_AES,
 R_SEARCH_DELTAKEY,
 R_SEARCH_MAGIC,
 R_SEARCH_LAST
};
typedef struct r_search_keyword_t {
 unsigned char *bin_keyword;
 unsigned char *bin_binmask;
 unsigned int keyword_length;
 unsigned int binmask_length;
 void *data;
 int count;
 int kwidx;
 int icase; 
 int type;
 unsigned long long last; 
} RSearchKeyword;
typedef struct r_search_hit_t {
 RSearchKeyword *kw;
 unsigned long long addr;
} RSearchHit;
typedef int (*RSearchCallback)(RSearchKeyword *kw, void *user, unsigned long long where);
typedef struct r_search_t {
 int n_kws; 
 int mode;
 unsigned int pattern_size;
 unsigned int string_min; 
 unsigned int string_max; 
 void *data; 
 void *user; 
 RSearchCallback callback;
 unsigned long long nhits;
 unsigned long long maxhits; 
 RList *hits;
 RMemoryPool *pool;
 int distance;
 int inverse;
 _Bool overlap; 
 int contiguous;
 int align;
 int (*update)(struct r_search_t *s, unsigned long long from, const unsigned char *buf, int len);
 RList *kws; 
 RIOBind iob;
 char bckwrds;
} RSearch;
__attribute__((visibility("default"))) RSearch *r_search_new(int mode);
__attribute__((visibility("default"))) int r_search_set_mode(RSearch *s, int mode);
__attribute__((visibility("default"))) RSearch *r_search_free(RSearch *s);
__attribute__((visibility("default"))) RList *r_search_find(RSearch *s, unsigned long long addr, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_search_update(RSearch *s, unsigned long long from, const unsigned char *buf, long len);
__attribute__((visibility("default"))) int r_search_update_i(RSearch *s, unsigned long long from, const unsigned char *buf, long len);
__attribute__((visibility("default"))) void r_search_keyword_free (RSearchKeyword *kw);
__attribute__((visibility("default"))) RSearchKeyword* r_search_keyword_new(const unsigned char *kw, int kwlen, const unsigned char *bm, int bmlen, const char *data);
__attribute__((visibility("default"))) RSearchKeyword* r_search_keyword_new_str(const char *kw, const char *bm, const char *data, int icase);
__attribute__((visibility("default"))) RSearchKeyword* r_search_keyword_new_wide(const char *kw, const char *bm, const char *data, int icase);
__attribute__((visibility("default"))) RSearchKeyword* r_search_keyword_new_hex(const char *kwstr, const char *bmstr, const char *data);
__attribute__((visibility("default"))) RSearchKeyword* r_search_keyword_new_hexmask(const char *kwstr, const char *data);
__attribute__((visibility("default"))) RSearchKeyword *r_search_keyword_new_regexp (const char *str, const char *data);
__attribute__((visibility("default"))) int r_search_kw_add(RSearch *s, RSearchKeyword *kw);
__attribute__((visibility("default"))) void r_search_reset(RSearch *s, int mode);
__attribute__((visibility("default"))) void r_search_kw_reset(RSearch *s);
__attribute__((visibility("default"))) void r_search_string_prepare_backward(RSearch *s);
__attribute__((visibility("default"))) void r_search_kw_reset(RSearch *s);
__attribute__((visibility("default"))) int r_search_range_add(RSearch *s, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) int r_search_range_set(RSearch *s, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) int r_search_range_reset(RSearch *s);
__attribute__((visibility("default"))) int r_search_set_blocksize(RSearch *s, unsigned int bsize);
__attribute__((visibility("default"))) int r_search_bmh(const RSearchKeyword *kw, const unsigned long long from, const unsigned char *buf, const int len, unsigned long long *out);
__attribute__((visibility("default"))) int r_search_mybinparse_update(RSearch *s, unsigned long long from, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_search_aes_update(RSearch *s, unsigned long long from, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_search_rsa_update(RSearch *s, unsigned long long from, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_search_magic_update(RSearch *_s, unsigned long long from, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_search_deltakey_update(RSearch *s, unsigned long long from, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_search_strings_update(RSearch *s, unsigned long long from, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_search_regexp_update(RSearch *s, unsigned long long from, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_search_xrefs_update(RSearch *s, unsigned long long from, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_search_hit_new(RSearch *s, RSearchKeyword *kw, unsigned long long addr);
__attribute__((visibility("default"))) void r_search_set_distance(RSearch *s, int dist);
__attribute__((visibility("default"))) int r_search_strings(RSearch *s, unsigned int min, unsigned int max);
__attribute__((visibility("default"))) int r_search_set_string_limits(RSearch *s, unsigned int min, unsigned int max); 
__attribute__((visibility("default"))) void r_search_set_callback(RSearch *s, RSearchCallback(callback), void *user);
__attribute__((visibility("default"))) int r_search_begin(RSearch *s);
__attribute__((visibility("default"))) void r_search_pattern_size(RSearch *s, int size);
__attribute__((visibility("default"))) int r_search_pattern(RSearch *s, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) const char *r_sign_version(void);
enum {
 R_SIGN_BYTES = 'b', 
 R_SIGN_ANAL = 'a', 
 R_SIGN_GRAPH = 'g', 
 R_SIGN_OFFSET = 'o', 
 R_SIGN_REFS = 'r', 
};
typedef struct r_sign_graph_t {
 int cc;
 int nbbs;
 int edges;
 int ebbs;
} RSignGraph;
typedef struct r_sign_bytes_t {
 int size;
 unsigned char *bytes;
 unsigned char *mask;
} RSignBytes;
typedef struct r_sign_item_t {
 char *name;
 int space;
 RSignBytes *bytes;
 RSignGraph *graph;
 unsigned long long offset;
 RList *refs;
} RSignItem;
typedef int (*RSignForeachCallback)(RSignItem *it, void *user);
typedef int (*RSignSearchCallback)(RSignItem *it, RSearchKeyword *kw, unsigned long long addr, void *user);
typedef int (*RSignGraphMatchCallback)(RSignItem *it, RAnalFunction *fcn, void *user);
typedef int (*RSignOffsetMatchCallback)(RSignItem *it, RAnalFunction *fcn, void *user);
typedef int (*RSignRefsMatchCallback)(RSignItem *it, RAnalFunction *fcn, void *user);
typedef struct r_sign_search_t {
 RSearch *search;
 RList *items;
 RSignSearchCallback cb;
 void *user;
} RSignSearch;
__attribute__((visibility("default"))) _Bool r_sign_add_bytes(RAnal *a, const char *name, unsigned long long size, const unsigned char *bytes, const unsigned char *mask);
__attribute__((visibility("default"))) _Bool r_sign_add_anal(RAnal *a, const char *name, unsigned long long size, const unsigned char *bytes, unsigned long long at);
__attribute__((visibility("default"))) _Bool r_sign_add_graph(RAnal *a, const char *name, RSignGraph graph);
__attribute__((visibility("default"))) _Bool r_sign_add_offset(RAnal *a, const char *name, unsigned long long offset);
__attribute__((visibility("default"))) _Bool r_sign_add_refs(RAnal *a, const char *name, RList *refs);
__attribute__((visibility("default"))) _Bool r_sign_delete(RAnal *a, const char *name);
__attribute__((visibility("default"))) void r_sign_list(RAnal *a, int format);
__attribute__((visibility("default"))) _Bool r_sign_foreach(RAnal *a, RSignForeachCallback cb, void *user);
__attribute__((visibility("default"))) RSignSearch *r_sign_search_new(void);
__attribute__((visibility("default"))) void r_sign_search_free(RSignSearch *ss);
__attribute__((visibility("default"))) void r_sign_search_init(RAnal *a, RSignSearch *ss, int minsz, RSignSearchCallback cb, void *user);
__attribute__((visibility("default"))) int r_sign_search_update(RAnal *a, RSignSearch *ss, unsigned long long *at, const unsigned char *buf, int len);
__attribute__((visibility("default"))) _Bool r_sign_match_graph(RAnal *a, RAnalFunction *fcn, int mincc, RSignGraphMatchCallback cb, void *user);
__attribute__((visibility("default"))) _Bool r_sign_match_offset(RAnal *a, RAnalFunction *fcn, RSignOffsetMatchCallback cb, void *user);
__attribute__((visibility("default"))) _Bool r_sign_match_refs(RAnal *a, RAnalFunction *fcn, RSignRefsMatchCallback cb, void *user);
__attribute__((visibility("default"))) _Bool r_sign_load(RAnal *a, const char *file);
__attribute__((visibility("default"))) _Bool r_sign_load_gz(RAnal *a, const char *filename);
__attribute__((visibility("default"))) char *r_sign_path(RAnal *a, const char *file);
__attribute__((visibility("default"))) _Bool r_sign_save(RAnal *a, const char *file);
__attribute__((visibility("default"))) RSignItem *r_sign_item_new(void);
__attribute__((visibility("default"))) RSignItem *r_sign_item_dup(RSignItem *it);
__attribute__((visibility("default"))) void r_sign_item_free(RSignItem *item);
__attribute__((visibility("default"))) RList *r_sign_fcn_refs(RAnal *a, RAnalFunction *fcn);
__attribute__((visibility("default"))) int r_sign_is_flirt(RBuffer *buf);
__attribute__((visibility("default"))) void r_sign_flirt_dump(const RAnal *anal, const char *flirt_file);
__attribute__((visibility("default"))) void r_sign_flirt_scan(const RAnal *anal, const char *flirt_file);
__attribute__((visibility("default"))) const char *r_hash_version(void);
typedef struct {
 unsigned int state[4];
 unsigned int count[2];
 unsigned char buffer[64];
} R_MD5_CTX;
typedef struct {
 unsigned int H[5];
 unsigned int W[80];
 int lenW;
 unsigned int sizeHi, sizeLo;
} R_SHA_CTX;
typedef struct {
 unsigned int crc;
 unsigned int size;
 int reflect;
 unsigned int poly;
 unsigned int xout;
} R_CRC_CTX;
enum CRC_PRESETS {
 CRC_PRESET_32 = 0,
 CRC_PRESET_16,
 CRC_PRESET_32_ECMA_267,
 CRC_PRESET_32C,
 CRC_PRESET_24,
 CRC_PRESET_16_CITT,
 CRC_PRESET_16_USB,
 CRC_PRESET_16_HDLC,
 CRC_PRESET_15_CAN,
 CRC_PRESET_8_SMBUS,
 CRC_PRESET_SIZE
};
typedef struct _SHA256_CTX {
 unsigned int state[8];
 unsigned long long bitcount;
 unsigned char buffer[64];
} R_SHA256_CTX;
typedef struct _SHA512_CTX {
 unsigned long long state[8];
 unsigned long long bitcount[2];
 unsigned char buffer[128];
} R_SHA512_CTX;
typedef R_SHA512_CTX R_SHA384_CTX;
struct r_hash_t {
 R_MD5_CTX md5;
 R_SHA_CTX sha1;
 R_SHA256_CTX sha256;
 R_SHA384_CTX sha384;
 R_SHA512_CTX sha512;
 _Bool rst;
 unsigned char digest[128];
};
typedef struct r_hash_seed_t {
 int prefix;
 unsigned char *buf;
 int len;
} RHashSeed;
__attribute__((visibility("default"))) struct r_hash_t *r_hash_new(_Bool rst, int flags);
__attribute__((visibility("default"))) void r_hash_free(struct r_hash_t *ctx);
__attribute__((visibility("default"))) unsigned char *r_hash_do_md4(struct r_hash_t *ctx, const unsigned char *input, int len);
__attribute__((visibility("default"))) unsigned char *r_hash_do_md5(struct r_hash_t *ctx, const unsigned char *input, int len);
__attribute__((visibility("default"))) unsigned char *r_hash_do_sha1(struct r_hash_t *ctx, const unsigned char *input, int len);
__attribute__((visibility("default"))) unsigned char *r_hash_do_sha256(struct r_hash_t *ctx, const unsigned char *input, int len);
__attribute__((visibility("default"))) unsigned char *r_hash_do_sha384(struct r_hash_t *ctx, const unsigned char *input, int len);
__attribute__((visibility("default"))) unsigned char *r_hash_do_sha512(struct r_hash_t *ctx, const unsigned char *input, int len);
__attribute__((visibility("default"))) unsigned char *r_hash_do_xxhash(struct r_hash_t *ctx, const unsigned char *input, int len);
__attribute__((visibility("default"))) char *r_hash_to_string(struct r_hash_t *ctx, const char *name, const unsigned char *data, int len);
__attribute__((visibility("default"))) const char *r_hash_name(unsigned long long bit);
__attribute__((visibility("default"))) unsigned long long r_hash_name_to_bits(const char *name);
__attribute__((visibility("default"))) int r_hash_size(unsigned long long bit);
__attribute__((visibility("default"))) int r_hash_calculate(struct r_hash_t *ctx, unsigned long long algobit, const unsigned char *input, int len);
__attribute__((visibility("default"))) unsigned char r_hash_deviation(const unsigned char *b, unsigned long long len);
__attribute__((visibility("default"))) unsigned int r_hash_adler32(const unsigned char *buf, int len);
__attribute__((visibility("default"))) unsigned int r_hash_xxhash(const unsigned char *buf, unsigned long long len);
__attribute__((visibility("default"))) unsigned char r_hash_xor(const unsigned char *b, unsigned long long len);
__attribute__((visibility("default"))) unsigned short r_hash_xorpair(const unsigned char *a, unsigned long long len);
__attribute__((visibility("default"))) int r_hash_parity(const unsigned char *buf, unsigned long long len);
__attribute__((visibility("default"))) unsigned char r_hash_mod255(const unsigned char *b, unsigned long long len);
__attribute__((visibility("default"))) unsigned long long r_hash_luhn(const unsigned char *buf, unsigned long long len);
__attribute__((visibility("default"))) unsigned int r_hash_crc_preset (const unsigned char *data, unsigned int size, enum CRC_PRESETS preset);
__attribute__((visibility("default"))) unsigned char r_hash_hamdist(const unsigned char *buf, int len);
__attribute__((visibility("default"))) double r_hash_entropy(const unsigned char *data, unsigned long long len);
__attribute__((visibility("default"))) double r_hash_entropy_fraction(const unsigned char *data, unsigned long long len);
__attribute__((visibility("default"))) int r_hash_pcprint(const unsigned char *buffer, unsigned long long len);
__attribute__((visibility("default"))) void r_hash_do_begin(struct r_hash_t *ctx, int flags);
__attribute__((visibility("default"))) void r_hash_do_end(struct r_hash_t *ctx, int flags);
__attribute__((visibility("default"))) void r_hash_do_spice(struct r_hash_t *ctx, int algo, int loops, RHashSeed *seed);
__attribute__((visibility("default"))) const char *r_bp_version(void);
typedef struct r_bp_arch_t {
 int bits;
 int length;
 int endian;
 const unsigned char *bytes;
} RBreakpointArch;
enum {
 R_BP_TYPE_SW,
 R_BP_TYPE_HW,
 R_BP_TYPE_COND,
 R_BP_TYPE_FAULT,
 R_BP_TYPE_DELETE,
};
typedef struct r_bp_plugin_t {
 char *name;
 char *arch;
 int type; 
 int nbps;
 RBreakpointArch *bps;
} RBreakpointPlugin;
typedef struct r_bp_item_t {
 char *name;
 char *module_name; 
 long long module_delta; 
 unsigned long long addr;
 int size; 
 int recoil; 
 _Bool swstep; 
 int rwx;
 int hw;
 int trace;
 int internal; 
 int enabled;
 int hits;
 unsigned char *obytes; 
 unsigned char *bbytes; 
 int pids[10];
 char *data;
 char *cond; 
} RBreakpointItem;
typedef int (*RBreakpointCallback)(void *bp, RBreakpointItem *b, _Bool set);
typedef struct r_bp_t {
 void *user;
 int stepcont;
 int endian;
 int bits;
 RIOBind iob; 
 RBreakpointPlugin *cur;
 RList *traces; 
 RList *plugins;
 PrintfCallback cb_printf;
 RBreakpointCallback breakpoint;
 int nbps;
 int nhwbps;
 RList *bps; 
 RBreakpointItem **bps_idx;
 int bps_idx_count;
 long long delta;
} RBreakpoint;
enum {
 R_BP_PROT_EXEC = 1,
 R_BP_PROT_WRITE = 2,
 R_BP_PROT_READ = 4,
};
typedef struct r_bp_trace_t {
 unsigned long long addr;
 unsigned long long addr_end;
 unsigned char *traps;
 unsigned char *buffer;
 unsigned char *bits;
 int length;
 int bitlen;
} RBreakpointTrace;
__attribute__((visibility("default"))) RBreakpoint *r_bp_new(void);
__attribute__((visibility("default"))) RBreakpoint *r_bp_free(RBreakpoint *bp);
__attribute__((visibility("default"))) int r_bp_del(RBreakpoint *bp, unsigned long long addr);
__attribute__((visibility("default"))) int r_bp_del_all(RBreakpoint *bp);
__attribute__((visibility("default"))) int r_bp_plugin_add(RBreakpoint *bp, RBreakpointPlugin *foo);
__attribute__((visibility("default"))) int r_bp_use(RBreakpoint *bp, const char *name, int bits);
__attribute__((visibility("default"))) int r_bp_plugin_del(RBreakpoint *bp, const char *name);
__attribute__((visibility("default"))) void r_bp_plugin_list(RBreakpoint *bp);
__attribute__((visibility("default"))) int r_bp_in(RBreakpoint *bp, unsigned long long addr, int rwx);
__attribute__((visibility("default"))) int r_bp_list(RBreakpoint *bp, int rad);
__attribute__((visibility("default"))) int r_bp_size(RBreakpoint *bp);
__attribute__((visibility("default"))) int r_bp_get_bytes(RBreakpoint *bp, unsigned char *buf, int len, int endian, int idx);
__attribute__((visibility("default"))) int r_bp_set_trace(RBreakpoint *bp, unsigned long long addr, int set);
__attribute__((visibility("default"))) int r_bp_set_trace_all(RBreakpoint *bp, int set);
__attribute__((visibility("default"))) RBreakpointItem *r_bp_enable(RBreakpoint *bp, unsigned long long addr, int set);
__attribute__((visibility("default"))) int r_bp_enable_all(RBreakpoint *bp, int set);
__attribute__((visibility("default"))) int r_bp_del_index(RBreakpoint *bp, int idx);
__attribute__((visibility("default"))) RBreakpointItem *r_bp_get_index(RBreakpoint *bp, int idx);
__attribute__((visibility("default"))) RBreakpointItem *r_bp_item_new (RBreakpoint *bp);
__attribute__((visibility("default"))) RBreakpointItem *r_bp_get_at (RBreakpoint *bp, unsigned long long addr);
__attribute__((visibility("default"))) RBreakpointItem *r_bp_get_in (RBreakpoint *bp, unsigned long long addr, int rwx);
__attribute__((visibility("default"))) int r_bp_add_cond(RBreakpoint *bp, const char *cond);
__attribute__((visibility("default"))) int r_bp_del_cond(RBreakpoint *bp, int idx);
__attribute__((visibility("default"))) int r_bp_add_fault(RBreakpoint *bp, unsigned long long addr, int size, int rwx);
__attribute__((visibility("default"))) RBreakpointItem *r_bp_add_sw(RBreakpoint *bp, unsigned long long addr, int size, int rwx);
__attribute__((visibility("default"))) RBreakpointItem *r_bp_add_hw(RBreakpoint *bp, unsigned long long addr, int size, int rwx);
__attribute__((visibility("default"))) void r_bp_restore_one(RBreakpoint *bp, RBreakpointItem *b, _Bool set);
__attribute__((visibility("default"))) int r_bp_restore(RBreakpoint *bp, _Bool set);
__attribute__((visibility("default"))) _Bool r_bp_restore_except(RBreakpoint *bp, _Bool set, unsigned long long addr);
__attribute__((visibility("default"))) void r_bp_traptrace_free(void *ptr);
__attribute__((visibility("default"))) void r_bp_traptrace_enable(RBreakpoint *bp, int enable);
__attribute__((visibility("default"))) void r_bp_traptrace_reset(RBreakpoint *bp, int hard);
__attribute__((visibility("default"))) unsigned long long r_bp_traptrace_next(RBreakpoint *bp, unsigned long long addr);
__attribute__((visibility("default"))) int r_bp_traptrace_add(RBreakpoint *bp, unsigned long long from, unsigned long long to);
__attribute__((visibility("default"))) int r_bp_traptrace_free_at(RBreakpoint *bp, unsigned long long from);
__attribute__((visibility("default"))) void r_bp_traptrace_list(RBreakpoint *bp);
__attribute__((visibility("default"))) int r_bp_traptrace_at(RBreakpoint *bp, unsigned long long from, int len);
__attribute__((visibility("default"))) RList *r_bp_traptrace_new(void);
__attribute__((visibility("default"))) void r_bp_traptrace_enable(RBreakpoint *bp, int enable);
__attribute__((visibility("default"))) RBreakpointItem *r_bp_watch_add(RBreakpoint *bp, unsigned long long addr, int size, int hw, int rw);
extern RBreakpointPlugin r_bp_plugin_x86;
extern RBreakpointPlugin r_bp_plugin_arm;
extern RBreakpointPlugin r_bp_plugin_mips;
extern RBreakpointPlugin r_bp_plugin_ppc;
extern RBreakpointPlugin r_bp_plugin_sh;
extern RBreakpointPlugin r_bp_plugin_bf;
__attribute__((visibility("default"))) const char *r_config_version(void);
typedef int (*RConfigCallback)(void *user, void *data);
typedef struct r_config_node_t {
 char *name;
 int flags;
 char *value;
 unsigned long long i_value;
 unsigned long long *cb_ptr_q;
 int *cb_ptr_i;
 char **cb_ptr_s;
 RConfigCallback getter;
 RConfigCallback setter;
 char *desc;
 RList *options;
} RConfigNode;
__attribute__((visibility("default"))) const char *r_config_node_type(RConfigNode *node);
typedef struct r_config_t {
 int lock;
 int last_notfound;
 int n_nodes;
 void *user;
 RNum *num;
 PrintfCallback cb_printf;
 RList *nodes;
 SdbHash *ht;
} RConfig;
typedef struct r_config_hold_num_t {
 char *key;
 unsigned long long value;
} RConfigHoldNum;
typedef struct r_config_hold_char_t {
 char *key;
 const char *value;
} RConfigHoldChar;
typedef struct r_config_hold_t {
 RConfig *cfg;
 RList *list_num; 
 RList *list_char; 
} RConfigHold;
__attribute__((visibility("default"))) _Bool r_config_save_num(RConfigHold *h, ...);
__attribute__((visibility("default"))) _Bool r_config_save_char(RConfigHold *h, ...);
__attribute__((visibility("default"))) RConfigHold* r_config_hold_new(RConfig *cfg);
__attribute__((visibility("default"))) void r_config_hold_free(RConfigHold *h);
__attribute__((visibility("default"))) void r_config_restore(RConfigHold *h);
__attribute__((visibility("default"))) RConfig *r_config_new(void *user);
__attribute__((visibility("default"))) RConfig *r_config_clone (RConfig *cfg);
__attribute__((visibility("default"))) int r_config_free(RConfig *cfg);
__attribute__((visibility("default"))) void r_config_lock(RConfig *cfg, int l);
__attribute__((visibility("default"))) int r_config_eval(RConfig *cfg, const char *str);
__attribute__((visibility("default"))) void r_config_bump(RConfig *cfg, const char *key);
__attribute__((visibility("default"))) RConfigNode *r_config_set_i(RConfig *cfg, const char *name, const unsigned long long i);
__attribute__((visibility("default"))) RConfigNode *r_config_set_cb(RConfig *cfg, const char *name, const char *value, int (*callback)(void *user, void *data));
__attribute__((visibility("default"))) RConfigNode *r_config_set_i_cb(RConfig *cfg, const char *name, int ivalue, int (*callback)(void *user, void *data));
__attribute__((visibility("default"))) RConfigNode *r_config_set(RConfig *cfg, const char *name, const char *value);
__attribute__((visibility("default"))) int r_config_rm(RConfig *cfg, const char *name);
__attribute__((visibility("default"))) unsigned long long r_config_get_i(RConfig *cfg, const char *name);
__attribute__((visibility("default"))) const char *r_config_get(RConfig *cfg, const char *name);
__attribute__((visibility("default"))) const char *r_config_desc(RConfig *cfg, const char *name, const char *desc);
__attribute__((visibility("default"))) const char *r_config_node_desc(RConfigNode *node, const char *desc);
__attribute__((visibility("default"))) void r_config_list(RConfig *cfg, const char *str, int rad);
__attribute__((visibility("default"))) RConfigNode *r_config_node_get(RConfig *cfg, const char *name);
__attribute__((visibility("default"))) RConfigNode *r_config_node_new(const char *name, const char *value);
__attribute__((visibility("default"))) void r_config_node_free(void *n);
__attribute__((visibility("default"))) int r_config_toggle(RConfig *cfg, const char *name);
__attribute__((visibility("default"))) int r_config_readonly (RConfig *cfg, const char *key);
__attribute__((visibility("default"))) void r_config_set_sort_column (char *column);
__attribute__((visibility("default"))) int r_config_set_setter (RConfig *cfg, const char *key, RConfigCallback cb);
__attribute__((visibility("default"))) int r_config_set_getter (RConfig *cfg, const char *key, RConfigCallback cb);
__attribute__((visibility("default"))) const char *r_debug_version(void);
typedef enum {
 R_DBG_PROC_STOP = 's',
 R_DBG_PROC_RUN = 'r',
 R_DBG_PROC_SLEEP = 'S',
 R_DBG_PROC_ZOMBIE = 'z',
 R_DBG_PROC_DEAD = 'd',
 R_DBG_PROC_RAISED = 'R' 
} RDebugPidState;
typedef enum {
 R_DBG_SIGNAL_IGNORE = 0, 
 R_DBG_SIGNAL_CONT = 1, 
 R_DBG_SIGNAL_SKIP = 2, 
} RDebugSignalMode;
typedef enum {
 R_DBG_RECOIL_NONE = 0,
 R_DBG_RECOIL_STEP,
 R_DBG_RECOIL_CONTINUE
} RDebugRecoilMode;
typedef enum {
 R_DEBUG_REASON_DEAD = -1,
 R_DEBUG_REASON_NONE = 0,
 R_DEBUG_REASON_SIGNAL,
 R_DEBUG_REASON_SEGFAULT,
 R_DEBUG_REASON_BREAKPOINT,
 R_DEBUG_REASON_TRACEPOINT,
 R_DEBUG_REASON_COND,
 R_DEBUG_REASON_READERR,
 R_DEBUG_REASON_STEP,
 R_DEBUG_REASON_ABORT,
 R_DEBUG_REASON_WRITERR,
 R_DEBUG_REASON_DIVBYZERO,
 R_DEBUG_REASON_ILLEGAL,
 R_DEBUG_REASON_UNKNOWN,
 R_DEBUG_REASON_ERROR,
 R_DEBUG_REASON_NEW_PID,
 R_DEBUG_REASON_NEW_TID,
 R_DEBUG_REASON_NEW_LIB,
 R_DEBUG_REASON_EXIT_PID,
 R_DEBUG_REASON_EXIT_TID,
 R_DEBUG_REASON_EXIT_LIB,
 R_DEBUG_REASON_TRAP,
 R_DEBUG_REASON_SWI,
 R_DEBUG_REASON_INT,
 R_DEBUG_REASON_FPU,
 R_DEBUG_REASON_USERSUSP,
} RDebugReasonType;
typedef struct r_debug_frame_t {
 unsigned long long addr;
 int size;
 unsigned long long sp;
 unsigned long long bp;
} RDebugFrame;
typedef struct r_debug_reason_t {
 int  type;
 int tid;
 int signum;
 unsigned long long bp_addr;
 unsigned long long timestamp;
 unsigned long long addr;
 unsigned long long ptr;
} RDebugReason;
typedef struct r_debug_map_t {
 char *name;
 unsigned long long addr;
 unsigned long long addr_end;
 unsigned long long size;
 unsigned long long offset;
 char *file;
 int perm;
 int user;
 _Bool shared;
} RDebugMap;
typedef struct r_debug_signal_t {
 int type;
 int num;
 unsigned long long handler;
} RDebugSignal;
typedef struct r_debug_desc_t {
 int fd;
 char *path;
 int perm;
 int type;
 unsigned long long off;
} RDebugDesc;
struct r_debug_snap_diff_t;
typedef struct r_page_data_t {
 struct r_debug_snap_diff_t *diff; 
 unsigned int page_off;
 unsigned char *data;
 unsigned char hash[128];
} RPageData;
struct r_debug_snap_t;
typedef struct r_debug_snap_diff_t {
 struct r_debug_snap_t *base;
 RList *pages; 
 RPageData **last_changes; 
} RDebugSnapDiff;
typedef struct r_debug_snap_t {
 unsigned long long addr;
 unsigned long long addr_end;
 unsigned char *data;
 unsigned int size;
 unsigned int page_num;
 unsigned long long timestamp;
 struct r_hash_t *hash_ctx;
 unsigned char **hashes; 
 RList *history; 
 int perm;
 char *comment;
} RDebugSnap;
typedef struct r_debug_key {
 unsigned long long addr;
 unsigned int id;
} RDebugKey;
typedef struct r_debug_session_t {
 RDebugKey key;
 RListIter *reg[R_REG_TYPE_LAST];
 RList *memlist; 
 char *comment;
} RDebugSession;
typedef struct r_session_header {
 unsigned long long addr;
 unsigned int id;
 unsigned int difflist_len;
} RSessionHeader;
typedef struct r_diff_entry {
 unsigned int base_idx;
 unsigned int pages_len;
} RDiffEntry;
typedef struct r_snap_entry {
 unsigned long long addr;
 unsigned int size;
 unsigned long long timestamp;
 int perm;
} RSnapEntry;
typedef struct r_debug_trace_t {
 RList *traces;
 int count;
 int enabled;
 int tag;
 int dup;
 char *addresses;
 Sdb *db;
} RDebugTrace;
typedef struct r_debug_tracepoint_t {
 unsigned long long addr;
 unsigned long long tags; 
 int tag; 
 int size;
 int count;
 int times;
 unsigned long long stamp;
} RDebugTracepoint;
typedef struct r_debug_t {
 char *arch;
 int bits; 
 int hitinfo;
 int main_pid;
 int pid; 
 int tid; 
 int forked_pid; 
 int n_threads;
 RList *threads; 
 char *malloc; 
 int bpsize; 
 char *btalgo; 
 int btdepth; 
 int regcols; 
 int swstep; 
 int stop_all_threads; 
 int trace_forks; 
 int trace_execs; 
 int trace_aftersyscall; 
 int trace_clone; 
 int follow_child; 
 char *glob_libs; 
 char *glob_unlibs; 
 _Bool consbreak; 
 _Bool continue_all_threads;
 int steps; 
 RDebugReason reason; 
 RDebugRecoilMode recoil_mode; 
 RDebugTrace *trace;
 Sdb *tracenodes;
 RTree *tree;
 RReg *reg;
 const char *creg; 
 RBreakpoint *bp;
 void *user; 
 char *snap_path;
 /* io */
 PrintfCallback cb_printf;
 RIOBind iob;
 struct r_debug_plugin_t *h;
 RList *plugins;
 RAnal *anal;
 RList *maps; 
 RList *maps_user; 
 RList *snaps; 
 RList *sessions; 
 Sdb *sgnls;
 RCoreBind corebind;
 int _mode;
 RNum *num;
 REgg *egg;
} RDebug;
typedef struct r_debug_desc_plugin_t {
 int (*open)(const char *path);
 int (*close)(int fd);
 int (*read)(int fd, unsigned long long addr, int len);
 int (*write)(int fd, unsigned long long addr, int len);
 int (*seek)(int fd, unsigned long long addr);
 int (*dup)(int fd, int newfd);
 RList* (*list)(int pid);
} RDebugDescPlugin;
typedef struct r_debug_info_t {
 int pid;
 int tid;
 int uid;
 int gid;
 char *usr;
 char *exe;
 char *cmdline;
 char *libname;
 char *cwd;
 int status; 
 int signum;
 void * lib;
 void * thread;
 char *kernel_stack;
} RDebugInfo;
/* TODO: pass dbg and user data pointer everywhere */
typedef struct r_debug_plugin_t {
 const char *name;
 const char *license;
 const char *author;
 const char *version;
 unsigned int bits;
 const char *arch;
 int canstep;
 int keepio;
 /* life */
 RDebugInfo* (*info)(RDebug *dbg, const char *arg);
 int (*startv)(int argc, char **argv);
 int (*attach)(RDebug *dbg, int pid);
 int (*detach)(RDebug *dbg, int pid);
 int (*select)(int pid, int tid);
 RList *(*threads)(RDebug *dbg, int pid);
 RList *(*pids)(RDebug *dbg, int pid);
 RList *(*tids)(RDebug *dbg, int pid);
 void** (*backtrace)(RDebug *dbg, int count);
 /* flow */
 int (*stop)(RDebug *dbg);
 int (*step)(RDebug *dbg);
 int (*step_over)(RDebug *dbg);
 int (*cont)(RDebug *dbg, int pid, int tid, int sig);
 int (*wait)(RDebug *dbg, int pid);
 _Bool (*gcore)(RDebug *dbg, RBuffer *dest);
 _Bool (*kill)(RDebug *dbg, int pid, int tid, int sig);
 RList* (*kill_list)(RDebug *dbg);
 int (*contsc)(RDebug *dbg, int pid, int sc);
 RList* (*frames)(RDebug *dbg, unsigned long long at);
 RBreakpointCallback breakpoint;
 int (*reg_read)(RDebug *dbg, int type, unsigned char *buf, int size);
 int (*reg_write)(RDebug *dbg, int type, const unsigned char *buf, int size); 
 char* (*reg_profile)(RDebug *dbg);
 /* memory */
 RList *(*map_get)(RDebug *dbg);
 RList *(*modules_get)(RDebug *dbg);
 RDebugMap* (*map_alloc)(RDebug *dbg, unsigned long long addr, int size);
 int (*map_dealloc)(RDebug *dbg, unsigned long long addr, int size);
 int (*map_protect)(RDebug *dbg, unsigned long long addr, int size, int perms);
 int (*init)(RDebug *dbg);
 int (*drx)(RDebug *dbg, int n, unsigned long long addr, int size, int rwx, int g);
 RDebugDescPlugin desc;
} RDebugPlugin;
typedef struct r_debug_pid_t {
 int pid;
 char status; /* stopped, running, zombie, sleeping ,... */
 int runnable; /* when using 'run', 'continue', .. this proc will be runnable */
 _Bool signalled;
 char *path;
 int uid;
 int gid;
 unsigned long long pc;
} RDebugPid;
/*
 * Radare's debugger has both an external and internal API.
 *
 * TODO(jjd): reconcile external API and extend it for better funcitonality
 * when using R2 as a library.
 */
__attribute__((visibility("default"))) RDebug *r_debug_new(int hard);
__attribute__((visibility("default"))) RDebug *r_debug_free(RDebug *dbg);
__attribute__((visibility("default"))) int r_debug_attach(RDebug *dbg, int pid);
__attribute__((visibility("default"))) int r_debug_detach(RDebug *dbg, int pid);
__attribute__((visibility("default"))) int r_debug_startv(RDebug *dbg, int argc, char **argv);
__attribute__((visibility("default"))) int r_debug_start(RDebug *dbg, const char *cmd);
__attribute__((visibility("default"))) RDebugReasonType r_debug_stop_reason(RDebug *dbg);
__attribute__((visibility("default"))) const char *r_debug_reason_to_string(int type);
__attribute__((visibility("default"))) RDebugReasonType r_debug_wait(RDebug *dbg, RBreakpointItem **bp);
__attribute__((visibility("default"))) int r_debug_step(RDebug *dbg, int steps);
__attribute__((visibility("default"))) int r_debug_step_over(RDebug *dbg, int steps);
__attribute__((visibility("default"))) int r_debug_continue_until(RDebug *dbg, unsigned long long addr);
__attribute__((visibility("default"))) int r_debug_continue_until_nonblock(RDebug *dbg, unsigned long long addr);
__attribute__((visibility("default"))) int r_debug_continue_until_optype(RDebug *dbg, int type, int over);
__attribute__((visibility("default"))) int r_debug_continue_until_nontraced(RDebug *dbg);
__attribute__((visibility("default"))) int r_debug_continue_syscall(RDebug *dbg, int sc);
__attribute__((visibility("default"))) int r_debug_continue_syscalls(RDebug *dbg, int *sc, int n_sc);
__attribute__((visibility("default"))) int r_debug_continue(RDebug *dbg);
__attribute__((visibility("default"))) int r_debug_continue_kill(RDebug *dbg, int signal);
__attribute__((visibility("default"))) _Bool r_debug_select(RDebug *dbg, int pid, int tid);
__attribute__((visibility("default"))) int r_debug_pid_list(RDebug *dbg, int pid, char fmt);
__attribute__((visibility("default"))) RDebugPid *r_debug_pid_new(const char *path, int pid, int uid, char status, unsigned long long pc);
__attribute__((visibility("default"))) RDebugPid *r_debug_pid_free(RDebugPid *pid);
__attribute__((visibility("default"))) RList *r_debug_pids(RDebug *dbg, int pid);
__attribute__((visibility("default"))) _Bool r_debug_set_arch(RDebug *dbg, const char *arch, int bits);
__attribute__((visibility("default"))) _Bool r_debug_use(RDebug *dbg, const char *str);
__attribute__((visibility("default"))) RDebugInfo *r_debug_info(RDebug *dbg, const char *arg);
__attribute__((visibility("default"))) void r_debug_info_free (RDebugInfo *rdi);
__attribute__((visibility("default"))) unsigned long long r_debug_get_baddr(RDebug *dbg, const char *file);
__attribute__((visibility("default"))) void r_debug_signal_init(RDebug *dbg);
__attribute__((visibility("default"))) int r_debug_signal_send(RDebug *dbg, int num);
__attribute__((visibility("default"))) int r_debug_signal_what(RDebug *dbg, int num);
__attribute__((visibility("default"))) int r_debug_signal_resolve(RDebug *dbg, const char *signame);
__attribute__((visibility("default"))) const char *r_debug_signal_resolve_i(RDebug *dbg, int signum);
__attribute__((visibility("default"))) void r_debug_signal_setup(RDebug *dbg, int num, int opt);
__attribute__((visibility("default"))) int r_debug_signal_set(RDebug *dbg, int num, unsigned long long addr);
__attribute__((visibility("default"))) void r_debug_signal_list(RDebug *dbg, int mode);
__attribute__((visibility("default"))) int r_debug_kill(RDebug *dbg, int pid, int tid, int sig);
__attribute__((visibility("default"))) RList *r_debug_kill_list(RDebug *dbg);
__attribute__((visibility("default"))) int r_debug_kill_setup(RDebug *dbg, int sig, int action);
__attribute__((visibility("default"))) void r_debug_plugin_init(RDebug *dbg);
__attribute__((visibility("default"))) int r_debug_plugin_set(RDebug *dbg, const char *str);
__attribute__((visibility("default"))) int r_debug_plugin_list(RDebug *dbg, int mode);
__attribute__((visibility("default"))) _Bool r_debug_plugin_add(RDebug *dbg, RDebugPlugin *foo);
__attribute__((visibility("default"))) RList *r_debug_modules_list(RDebug*);
__attribute__((visibility("default"))) RDebugMap *r_debug_map_alloc(RDebug *dbg, unsigned long long addr, int size);
__attribute__((visibility("default"))) int r_debug_map_dealloc(RDebug *dbg, RDebugMap *map);
__attribute__((visibility("default"))) RList *r_debug_map_list_new(void);
__attribute__((visibility("default"))) RDebugMap *r_debug_map_get(RDebug *dbg, unsigned long long addr);
__attribute__((visibility("default"))) RDebugMap *r_debug_map_new (char *name, unsigned long long addr, unsigned long long addr_end, int perm, int user);
__attribute__((visibility("default"))) void r_debug_map_free(RDebugMap *map);
__attribute__((visibility("default"))) void r_debug_map_list(RDebug *dbg, unsigned long long addr, int rad);
__attribute__((visibility("default"))) void r_debug_map_list_visual(RDebug *dbg, unsigned long long addr, int use_color, int cons_cols);
__attribute__((visibility("default"))) RDebugDesc *r_debug_desc_new (int fd, char* path, int perm, int type, int off);
__attribute__((visibility("default"))) void r_debug_desc_free (RDebugDesc *p);
__attribute__((visibility("default"))) int r_debug_desc_open(RDebug *dbg, const char *path);
__attribute__((visibility("default"))) int r_debug_desc_close(RDebug *dbg, int fd);
__attribute__((visibility("default"))) int r_debug_desc_dup(RDebug *dbg, int fd, int newfd);
__attribute__((visibility("default"))) int r_debug_desc_read(RDebug *dbg, int fd, unsigned long long addr, int len);
__attribute__((visibility("default"))) int r_debug_desc_seek(RDebug *dbg, int fd, unsigned long long addr); 
__attribute__((visibility("default"))) int r_debug_desc_write(RDebug *dbg, int fd, unsigned long long addr, int len);
__attribute__((visibility("default"))) int r_debug_desc_list(RDebug *dbg, int rad);
__attribute__((visibility("default"))) int r_debug_reg_sync(RDebug *dbg, int type, int write);
__attribute__((visibility("default"))) int r_debug_reg_list(RDebug *dbg, int type, int size, int rad, const char *use_color);
__attribute__((visibility("default"))) int r_debug_reg_set(RDebug *dbg, const char *name, unsigned long long num);
__attribute__((visibility("default"))) unsigned long long r_debug_reg_get(RDebug *dbg, const char *name);
__attribute__((visibility("default"))) unsigned long long r_debug_reg_get_err(RDebug *dbg, const char *name, int *err, utX *value);
__attribute__((visibility("default"))) unsigned long long r_debug_execute(RDebug *dbg, const unsigned char *buf, int len, int restore);
__attribute__((visibility("default"))) int r_debug_map_sync(RDebug *dbg);
__attribute__((visibility("default"))) int r_debug_stop(RDebug *dbg);
__attribute__((visibility("default"))) RList *r_debug_frames(RDebug *dbg, unsigned long long at);
__attribute__((visibility("default"))) _Bool r_debug_is_dead(RDebug *dbg);
__attribute__((visibility("default"))) int r_debug_map_protect(RDebug *dbg, unsigned long long addr, int size, int perms);
__attribute__((visibility("default"))) unsigned long long r_debug_arg_get(RDebug *dbg, int fast, int num);
__attribute__((visibility("default"))) _Bool r_debug_arg_set(RDebug *dbg, int fast, int num, unsigned long long value);
__attribute__((visibility("default"))) RBreakpointItem *r_debug_bp_add(RDebug *dbg, unsigned long long addr, int hw, _Bool watch, int rw, char *module, long long m_delta);
__attribute__((visibility("default"))) int r_debug_thread_list(RDebug *dbg, int pid);
__attribute__((visibility("default"))) void r_debug_tracenodes_reset(RDebug *dbg);
__attribute__((visibility("default"))) void r_debug_trace_reset(RDebug *dbg);
__attribute__((visibility("default"))) int r_debug_trace_pc(RDebug *dbg, unsigned long long pc);
__attribute__((visibility("default"))) void r_debug_trace_at(RDebug *dbg, const char *str);
__attribute__((visibility("default"))) RDebugTracepoint *r_debug_trace_get(RDebug *dbg, unsigned long long addr);
__attribute__((visibility("default"))) void r_debug_trace_list(RDebug *dbg, int mode);
__attribute__((visibility("default"))) RDebugTracepoint *r_debug_trace_add(RDebug *dbg, unsigned long long addr, int size);
__attribute__((visibility("default"))) RDebugTrace *r_debug_trace_new(void);
__attribute__((visibility("default"))) void r_debug_trace_free(RDebugTrace *dbg);
__attribute__((visibility("default"))) int r_debug_trace_tag(RDebug *dbg, int tag);
__attribute__((visibility("default"))) int r_debug_child_fork(RDebug *dbg);
__attribute__((visibility("default"))) int r_debug_child_clone(RDebug *dbg);
__attribute__((visibility("default"))) void r_debug_drx_list(RDebug *dbg);
__attribute__((visibility("default"))) int r_debug_drx_set(RDebug *dbg, int idx, unsigned long long addr, int len, int rwx, int g);
__attribute__((visibility("default"))) int r_debug_drx_unset(RDebug *dbg, int idx);
__attribute__((visibility("default"))) unsigned long long r_debug_num_callback(RNum *userptr, const char *str, int *ok);
__attribute__((visibility("default"))) int r_debug_esil_stepi(RDebug *dbg);
__attribute__((visibility("default"))) unsigned long long r_debug_esil_step(RDebug *dbg, unsigned int count);
__attribute__((visibility("default"))) unsigned long long r_debug_esil_continue(RDebug *dbg);
__attribute__((visibility("default"))) void r_debug_esil_watch(RDebug *dbg, int rwx, int dev, const char *expr);
__attribute__((visibility("default"))) void r_debug_esil_watch_reset(RDebug *dbg);
__attribute__((visibility("default"))) void r_debug_esil_watch_list(RDebug *dbg);
__attribute__((visibility("default"))) int r_debug_esil_watch_empty(RDebug *dbg);
__attribute__((visibility("default"))) void r_debug_esil_prestep (RDebug *d, int p);
__attribute__((visibility("default"))) RDebugSnap *r_debug_snap_new(void);
__attribute__((visibility("default"))) void r_debug_snap_free(void *snap);
__attribute__((visibility("default"))) int r_debug_snap_delete(RDebug *dbg, int idx);
__attribute__((visibility("default"))) void r_debug_snap_list(RDebug *dbg, int idx, int mode);
__attribute__((visibility("default"))) int r_debug_snap(RDebug *dbg, unsigned long long addr);
__attribute__((visibility("default"))) int r_debug_snap_comment(RDebug *dbg, int idx, const char *msg);
__attribute__((visibility("default"))) RDebugSnapDiff *r_debug_snap_map(RDebug *dbg, RDebugMap *map);
__attribute__((visibility("default"))) int r_debug_snap_all(RDebug *dbg, int perms);
__attribute__((visibility("default"))) RDebugSnap *r_debug_snap_get(RDebug *dbg, unsigned long long addr);
__attribute__((visibility("default"))) int r_debug_snap_set_idx(RDebug *dbg, int idx);
__attribute__((visibility("default"))) int r_debug_snap_set(RDebug *dbg, RDebugSnap *snap);
__attribute__((visibility("default"))) void r_debug_diff_free(void *p);
__attribute__((visibility("default"))) RDebugSnapDiff *r_debug_diff_add(RDebug *dbg, RDebugSnap *base);
__attribute__((visibility("default"))) void r_debug_diff_set(RDebug *dbg, RDebugSnapDiff *diff);
__attribute__((visibility("default"))) void r_debug_diff_set_base(RDebug *dbg, RDebugSnap *base);
__attribute__((visibility("default"))) void r_page_data_free(void *p);
__attribute__((visibility("default"))) void r_debug_session_free(void *p);
__attribute__((visibility("default"))) void r_debug_session_list(RDebug *dbg);
__attribute__((visibility("default"))) RDebugSession *r_debug_session_add(RDebug *dbg, RListIter **tail);
__attribute__((visibility("default"))) _Bool r_debug_session_delete(RDebug *dbg, int idx);
__attribute__((visibility("default"))) _Bool r_debug_session_comment(RDebug *dbg, int idx, const char *msg);
__attribute__((visibility("default"))) void r_debug_session_path(RDebug *dbg, const char *path);
__attribute__((visibility("default"))) void r_debug_session_set(RDebug *dbg, RDebugSession *session);
__attribute__((visibility("default"))) _Bool r_debug_session_set_idx(RDebug *dbg, int idx);
__attribute__((visibility("default"))) RDebugSession *r_debug_session_get(RDebug *dbg, RListIter *tail);
__attribute__((visibility("default"))) void r_debug_session_save(RDebug *dbg, const char *file);
__attribute__((visibility("default"))) void r_debug_session_restore(RDebug *dbg, const char *file);
__attribute__((visibility("default"))) _Bool r_debug_step_back(RDebug *dbg);
__attribute__((visibility("default"))) _Bool r_debug_continue_back(RDebug *dbg);
extern RDebugPlugin r_debug_plugin_native;
extern RDebugPlugin r_debug_plugin_esil;
extern RDebugPlugin r_debug_plugin_rap;
extern RDebugPlugin r_debug_plugin_gdb;
extern RDebugPlugin r_debug_plugin_bf;
extern RDebugPlugin r_debug_plugin_io;
extern RDebugPlugin r_debug_plugin_windbg;
extern RDebugPlugin r_debug_plugin_bochs;
extern RDebugPlugin r_debug_plugin_qnx;
extern RDebugPlugin r_debug_plugin_null;
__attribute__((visibility("default"))) const char *r_crypto_version(void);
enum {
 R_CRYPTO_MODE_ECB,
 R_CRYPTO_MODE_CBC,
 R_CRYPTO_MODE_OFB,
 R_CRYPTO_MODE_CFB,
};
enum {
 R_CRYPTO_DIR_CIPHER,
 R_CRYPTO_DIR_DECIPHER,
};
typedef struct r_crypto_t {
 struct r_crypto_plugin_t* h;
 unsigned char *key;
 unsigned char *iv;
 int key_len;
 unsigned char *output;
 int output_len;
 int output_size;
 int dir;
 void *user;
 RList *plugins;
} RCrypto;
typedef struct r_crypto_plugin_t {
 const char *name;
 const char *license;
 int (*get_key_size)(RCrypto *cry);
 _Bool (*set_iv)(RCrypto *cry, const unsigned char *iv, int ivlen);
 _Bool (*set_key)(RCrypto *cry, const unsigned char *key, int keylen, int mode, int direction);
 _Bool (*update)(RCrypto *cry, const unsigned char *buf, int len);
 _Bool (*final)(RCrypto *cry, const unsigned char *buf, int len);
 _Bool (*use)(const char *algo);
 int (*fini)(RCrypto *cry);
} RCryptoPlugin;
__attribute__((visibility("default"))) RCrypto *r_crypto_init(RCrypto *cry, int hard);
__attribute__((visibility("default"))) RCrypto *r_crypto_as_new(RCrypto *cry);
__attribute__((visibility("default"))) int r_crypto_add(RCrypto *cry, RCryptoPlugin *h);
__attribute__((visibility("default"))) RCrypto *r_crypto_new(void);
__attribute__((visibility("default"))) RCrypto *r_crypto_free(RCrypto *cry);
__attribute__((visibility("default"))) _Bool r_crypto_use(RCrypto *cry, const char *algo);
__attribute__((visibility("default"))) _Bool r_crypto_set_key(RCrypto *cry, const unsigned char* key, int keylen, int mode, int direction);
__attribute__((visibility("default"))) _Bool r_crypto_set_iv(RCrypto *cry, const unsigned char *iv, int ivlen);
__attribute__((visibility("default"))) int r_crypto_update(RCrypto *cry, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_crypto_final(RCrypto *cry, const unsigned char *buf, int len);
__attribute__((visibility("default"))) int r_crypto_append(RCrypto *cry, const unsigned char *buf, int len);
__attribute__((visibility("default"))) unsigned char *r_crypto_get_output(RCrypto *cry, int *size);
__attribute__((visibility("default"))) const char *r_crypto_name(unsigned long long bit);
extern RCryptoPlugin r_crypto_plugin_aes;
extern RCryptoPlugin r_crypto_plugin_des;
extern RCryptoPlugin r_crypto_plugin_rc4;
extern RCryptoPlugin r_crypto_plugin_xor;
extern RCryptoPlugin r_crypto_plugin_blowfish;
extern RCryptoPlugin r_crypto_plugin_rc2;
extern RCryptoPlugin r_crypto_plugin_rot;
extern RCryptoPlugin r_crypto_plugin_rol;
extern RCryptoPlugin r_crypto_plugin_ror;
extern RCryptoPlugin r_crypto_plugin_base64;
extern RCryptoPlugin r_crypto_plugin_base91;
extern RCryptoPlugin r_crypto_plugin_aes_cbc;
extern RCryptoPlugin r_crypto_plugin_punycode;
extern RCryptoPlugin r_crypto_plugin_rc6;
extern RCryptoPlugin r_crypto_plugin_cps2;
extern RCryptoPlugin r_crypto_plugin_serpent;
__attribute__((visibility("default"))) const char *r_core_version(void);
typedef struct r_core_rtr_host_t {
 int proto;
 char host[512];
 int port;
 char file[1024];
 RSocket *fd;
} RCoreRtrHost;
typedef struct r_core_log_t {
 int first;
 int last;
 RStrpool *sp;
} RCoreLog;
typedef struct r_core_file_t {
 int dbg;
 int fd;
 RBinBind binb;
 const struct r_core_t *core;
 unsigned char alive;
} RCoreFile;
typedef struct r_core_times_t {
 unsigned long long loadlibs_init_time;
 unsigned long long loadlibs_time;
 unsigned long long file_open_time;
} RCoreTimes;
typedef struct r_core_asmsteps_t {
 unsigned long long offset;
 int cols;
} RCoreAsmsteps;
typedef struct r_core_t {
 RBin *bin;
 RConfig *config;
 unsigned long long offset;
 unsigned int blocksize;
 unsigned int blocksize_max;
 unsigned char *block;
 unsigned char *oobi; 
 int oobi_len;
 RBuffer *yank_buf;
 int tmpseek;
 _Bool vmode;
 int interrupted; 
 RCons *cons;
 RIO *io;
 RCoreFile *file;
 RList *files;
 RNum *num;
 RNum *old_num;
 RLib *lib;
 RCmd *rcmd;
 RCmdDescriptor root_cmd_descriptor;
 RList *cmd_descriptors;
 RAnal *anal;
 RAsm *assembler;
 RCoreTimes *times;
 RParse *parser;
 RPrint *print;
 RLang *lang;
 RDebug *dbg;
 RFlag *flags;
 RSearch *search;
 RIOSection *section;
 RFS *fs;
 REgg *egg;
 RCoreLog *log;
 RAGraph *graph;
 char *cmdqueue;
 char *lastcmd;
 char *cmdlog;
 _Bool cfglog;
 int cmdrepeat;
 unsigned long long inc;
 int rtr_n;
 RCoreRtrHost rtr_host[255];
 int curasmstep;
 RCoreAsmsteps asmsteps[128];
 unsigned long long *asmqjmps;
 int asmqjmps_count;
 int asmqjmps_size;
 _Bool is_asmqjmps_letter;
 _Bool keep_asmqjmps;
 int http_up;
 int gdbserver_up;
 int printidx;
 int vseek;
 _Bool in_search;
 RList *watchers;
 RList *scriptstack;
 RList *tasks;
 int cmd_depth;
 unsigned char switch_file_view;
 Sdb *sdb;
 int incomment;
 int curtab; 
 int seltab; 
 int cmdremote;
 char *lastsearch;
 _Bool fixedblock;
 char *cmdfilter;
 _Bool break_loop;
 RThreadLock *lock;
} RCore;
__attribute__((visibility("default"))) int r_core_bind(RCore *core, RCoreBind *bnd);
typedef struct r_core_cmpwatch_t {
 unsigned long long addr;
 int size;
 char cmd[32];
 unsigned char *odata;
 unsigned char *ndata;
} RCoreCmpWatcher;
typedef int (*RCoreSearchCallback)(RCore *core, unsigned long long from, unsigned char *buf, int len);
__attribute__((visibility("default"))) RList *r_core_list_themes (RCore *core);
__attribute__((visibility("default"))) RCons *r_core_get_cons (RCore *core);
__attribute__((visibility("default"))) RBin *r_core_get_bin (RCore *core);
__attribute__((visibility("default"))) RConfig *r_core_get_config (RCore *core);
__attribute__((visibility("default"))) RAsmOp *r_core_disassemble (RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) _Bool r_core_init(RCore *core);
__attribute__((visibility("default"))) RCore *r_core_new(void);
__attribute__((visibility("default"))) RCore *r_core_free(RCore *core);
__attribute__((visibility("default"))) RCore *r_core_fini(RCore *c);
__attribute__((visibility("default"))) RCore *r_core_ncast(unsigned long long p);
__attribute__((visibility("default"))) RCore *r_core_cast(void *p);
__attribute__((visibility("default"))) int r_core_config_init(RCore *core);
__attribute__((visibility("default"))) int r_core_prompt(RCore *core, int sync);
__attribute__((visibility("default"))) int r_core_prompt_exec(RCore *core);
__attribute__((visibility("default"))) int r_core_lines_initcache (RCore *core, unsigned long long start_addr, unsigned long long end_addr);
__attribute__((visibility("default"))) int r_core_lines_currline (RCore *core);
__attribute__((visibility("default"))) void r_core_prompt_loop(RCore *core);
__attribute__((visibility("default"))) int r_core_cmd(RCore *core, const char *cmd, int log);
__attribute__((visibility("default"))) void r_core_cmd_repeat(RCore *core, int next);
__attribute__((visibility("default"))) char *r_core_editor (const RCore *core, const char *file, const char *str);
__attribute__((visibility("default"))) int r_core_fgets(char *buf, int len);
__attribute__((visibility("default"))) int r_core_cmdf(void *user, const char *fmt, ...);
__attribute__((visibility("default"))) int r_core_flush(void *user, const char *cmd);
__attribute__((visibility("default"))) int r_core_cmd0(void *user, const char *cmd);
__attribute__((visibility("default"))) void r_core_cmd_init(RCore *core);
__attribute__((visibility("default"))) int r_core_cmd_pipe(RCore *core, char *radare_cmd, char *shell_cmd);
__attribute__((visibility("default"))) char *r_core_cmd_str(RCore *core, const char *cmd);
__attribute__((visibility("default"))) char *r_core_cmd_strf(RCore *core, const char *fmt, ...);
__attribute__((visibility("default"))) char *r_core_cmd_str_pipe(RCore *core, const char *cmd);
__attribute__((visibility("default"))) int r_core_cmd_file(RCore *core, const char *file);
__attribute__((visibility("default"))) int r_core_cmd_lines(RCore *core, const char *lines);
__attribute__((visibility("default"))) int r_core_cmd_command(RCore *core, const char *command);
__attribute__((visibility("default"))) int r_core_run_script (RCore *core, const char *file);
__attribute__((visibility("default"))) _Bool r_core_seek(RCore *core, unsigned long long addr, _Bool rb);
__attribute__((visibility("default"))) int r_core_seek_base (RCore *core, const char *hex);
__attribute__((visibility("default"))) void r_core_seek_previous (RCore *core, const char *type);
__attribute__((visibility("default"))) void r_core_seek_next (RCore *core, const char *type);
__attribute__((visibility("default"))) int r_core_seek_align(RCore *core, unsigned long long align, int count);
__attribute__((visibility("default"))) void r_core_seek_archbits (RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) int r_core_block_read(RCore *core);
__attribute__((visibility("default"))) int r_core_block_size(RCore *core, int bsize);
__attribute__((visibility("default"))) _Bool r_core_read_at(RCore *core, unsigned long long addr, unsigned char *buf, int size);
__attribute__((visibility("default"))) int r_core_is_valid_offset (RCore *core, unsigned long long offset);
__attribute__((visibility("default"))) int r_core_shift_block(RCore *core, unsigned long long addr, unsigned long long b_size, long long dist);
__attribute__((visibility("default"))) void r_core_visual_prompt_input (RCore *core);
__attribute__((visibility("default"))) int r_core_visual_refs(RCore *core, _Bool xref);
__attribute__((visibility("default"))) _Bool r_core_prevop_addr(RCore* core, unsigned long long start_addr, int numinstrs, unsigned long long* prev_addr);
__attribute__((visibility("default"))) unsigned long long r_core_prevop_addr_force(RCore *core, unsigned long long start_addr, int numinstrs);
__attribute__((visibility("default"))) _Bool r_core_visual_hudstuff(RCore *core);
__attribute__((visibility("default"))) int r_core_visual_classes(RCore *core);
__attribute__((visibility("default"))) int r_core_visual_types(RCore *core);
__attribute__((visibility("default"))) int r_core_visual(RCore *core, const char *input);
__attribute__((visibility("default"))) int r_core_visual_graph(RCore *core, RAGraph *g, RAnalFunction *_fcn, int is_interactive);
__attribute__((visibility("default"))) int r_core_fcn_graph(RCore *core, RAnalFunction *_fcn);
__attribute__((visibility("default"))) int r_core_visual_panels(RCore *core);
__attribute__((visibility("default"))) int r_core_visual_cmd(RCore *core, const char *arg);
__attribute__((visibility("default"))) void r_core_visual_seek_animation (RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) void r_core_visual_asm(RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) void r_core_visual_colors(RCore *core);
__attribute__((visibility("default"))) int r_core_visual_xrefs_x(RCore *core);
__attribute__((visibility("default"))) int r_core_visual_xrefs_X(RCore *core);
__attribute__((visibility("default"))) int r_core_visual_hud(RCore *core);
__attribute__((visibility("default"))) unsigned long long r_core_get_asmqjmps(RCore *core, const char *str);
__attribute__((visibility("default"))) void r_core_set_asmqjmps(RCore *core, char *str, size_t len, int i);
__attribute__((visibility("default"))) char* r_core_add_asmqjmp(RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) void r_core_anal_type_init(RCore *core);
__attribute__((visibility("default"))) void r_core_anal_cc_init(RCore *core);
__attribute__((visibility("default"))) void r_core_list_io(RCore *core);
__attribute__((visibility("default"))) void r_core_visual_mark_seek(RCore *core, unsigned char ch);
__attribute__((visibility("default"))) void r_core_visual_mark(RCore *core, unsigned char ch);
__attribute__((visibility("default"))) void r_core_visual_mark_set(RCore *core, unsigned char ch, unsigned long long addr);
__attribute__((visibility("default"))) void r_core_visual_mark_dump(RCore *core);
__attribute__((visibility("default"))) void r_core_visual_mark_reset(RCore *core);
__attribute__((visibility("default"))) int r_core_search_cb(RCore *core, unsigned long long from, unsigned long long to, RCoreSearchCallback cb);
__attribute__((visibility("default"))) int r_core_serve(RCore *core, RIODesc *fd);
__attribute__((visibility("default"))) int r_core_file_reopen(RCore *core, const char *args, int perm, int binload);
__attribute__((visibility("default"))) void r_core_file_reopen_debug(RCore *core, const char *args);
__attribute__((visibility("default"))) RCoreFile * r_core_file_find_by_fd(RCore* core, unsigned long long fd);
__attribute__((visibility("default"))) RCoreFile * r_core_file_find_by_name (RCore * core, const char * name);
__attribute__((visibility("default"))) RCoreFile * r_core_file_cur (RCore *r);
__attribute__((visibility("default"))) int r_core_file_set_by_fd(RCore *core, unsigned long long fd);
__attribute__((visibility("default"))) int r_core_file_set_by_name(RCore *core, const char * name);
__attribute__((visibility("default"))) int r_core_file_set_by_file (RCore * core, RCoreFile *cf);
__attribute__((visibility("default"))) int r_core_setup_debugger (RCore *r, const char *debugbackend, _Bool attach);
__attribute__((visibility("default"))) int r_core_files_free(const RCore *core, RCoreFile *cf);
__attribute__((visibility("default"))) void r_core_file_free(RCoreFile *cf);
__attribute__((visibility("default"))) RCoreFile *r_core_file_open(RCore *core, const char *file, int flags, unsigned long long loadaddr);
__attribute__((visibility("default"))) RCoreFile *r_core_file_open_many(RCore *r, const char *file, int flags, unsigned long long loadaddr);
__attribute__((visibility("default"))) RCoreFile *r_core_file_get_by_fd(RCore *core, int fd);
__attribute__((visibility("default"))) int r_core_file_close(RCore *core, RCoreFile *fh);
__attribute__((visibility("default"))) _Bool r_core_file_close_fd(RCore *core, int fd);
__attribute__((visibility("default"))) _Bool r_core_file_close_all_but(RCore *core);
__attribute__((visibility("default"))) int r_core_file_list(RCore *core, int mode);
__attribute__((visibility("default"))) int r_core_file_binlist(RCore *core);
__attribute__((visibility("default"))) int r_core_file_bin_raise(RCore *core, unsigned int num);
__attribute__((visibility("default"))) int r_core_seek_delta(RCore *core, long long addr);
__attribute__((visibility("default"))) int r_core_extend_at(RCore *core, unsigned long long addr, int size);
__attribute__((visibility("default"))) _Bool r_core_write_at(RCore *core, unsigned long long addr, const unsigned char *buf, int size);
__attribute__((visibility("default"))) int r_core_write_op(RCore *core, const char *arg, char op);
__attribute__((visibility("default"))) int r_core_set_file_by_fd (RCore * core, unsigned long long bin_fd);
__attribute__((visibility("default"))) int r_core_set_file_by_name (RBin * bin, const char * name);
__attribute__((visibility("default"))) RBinFile * r_core_bin_cur (RCore *core);
__attribute__((visibility("default"))) unsigned int r_core_file_cur_fd (RCore *core);
__attribute__((visibility("default"))) void r_core_debug_rr (RCore *core, RReg *reg);
__attribute__((visibility("default"))) void r_core_fortune_list_types(void);
__attribute__((visibility("default"))) void r_core_fortune_list(RCore *core);
__attribute__((visibility("default"))) void r_core_fortune_print_random(RCore *core);
__attribute__((visibility("default"))) _Bool r_core_project_load(RCore *core, const char *prjfile, const char *rcfile);
__attribute__((visibility("default"))) RThread *r_core_project_load_bg(RCore *core, const char *prjfile, const char *rcfile);
__attribute__((visibility("default"))) void r_core_project_execute_cmds(RCore *core, const char *prjfile);
__attribute__((visibility("default"))) int r_core_yank(RCore *core, unsigned long long addr, int len);
__attribute__((visibility("default"))) int r_core_yank_string(RCore *core, unsigned long long addr, int maxlen);
__attribute__((visibility("default"))) int r_core_yank_paste(RCore *core, unsigned long long addr, int len);
__attribute__((visibility("default"))) int r_core_yank_set (RCore *core, unsigned long long addr, const unsigned char *buf, unsigned int len); 
__attribute__((visibility("default"))) int r_core_yank_set_str (RCore *core, unsigned long long addr, const char *buf, unsigned int len); 
__attribute__((visibility("default"))) int r_core_yank_to(RCore *core, const char *arg);
__attribute__((visibility("default"))) int r_core_yank_dump (RCore *core, unsigned long long pos);
__attribute__((visibility("default"))) int r_core_yank_hexdump (RCore *core, unsigned long long pos);
__attribute__((visibility("default"))) int r_core_yank_cat (RCore *core, unsigned long long pos);
__attribute__((visibility("default"))) int r_core_yank_cat_string (RCore *core, unsigned long long pos);
__attribute__((visibility("default"))) int r_core_yank_hud_file (RCore *core, const char *input);
__attribute__((visibility("default"))) int r_core_yank_hud_path (RCore *core, const char *input, int dir);
__attribute__((visibility("default"))) _Bool r_core_yank_file_ex (RCore *core, const char *input);
__attribute__((visibility("default"))) int r_core_yank_file_all (RCore *core, const char *input);
__attribute__((visibility("default"))) void r_core_loadlibs_init(RCore *core);
__attribute__((visibility("default"))) int r_core_loadlibs(RCore *core, int where, const char *path);
__attribute__((visibility("default"))) int r_core_cmd_buffer(void *user, const char *buf);
__attribute__((visibility("default"))) int r_core_cmdf(void *user, const char *fmt, ...);
__attribute__((visibility("default"))) int r_core_cmd0(void *user, const char *cmd);
__attribute__((visibility("default"))) char *r_core_cmd_str(RCore *core, const char *cmd);
__attribute__((visibility("default"))) int r_core_cmd_foreach(RCore *core, const char *cmd, char *each);
__attribute__((visibility("default"))) int r_core_cmd_foreach3(RCore *core, const char *cmd, char *each);
__attribute__((visibility("default"))) char *r_core_op_str(RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) RAnalOp *r_core_op_anal(RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) char *r_core_disassemble_instr(RCore *core, unsigned long long addr, int l);
__attribute__((visibility("default"))) char *r_core_disassemble_bytes(RCore *core, unsigned long long addr, int b);
__attribute__((visibility("default"))) int r_core_process_input_pade(RCore *core, const char *input, char** hex, char **asm_arch, unsigned int *bits);
__attribute__((visibility("default"))) RAnalOp* r_core_anal_op(RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) void r_core_anal_esil(RCore *core, const char *str, const char *addr);
__attribute__((visibility("default"))) void r_core_anal_fcn_merge (RCore *core, unsigned long long addr, unsigned long long addr2);
__attribute__((visibility("default"))) const char *r_core_anal_optype_colorfor(RCore *core, unsigned long long addr, _Bool verbose);
__attribute__((visibility("default"))) unsigned long long r_core_anal_address (RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) void r_core_anal_undefine (RCore *core, unsigned long long off);
__attribute__((visibility("default"))) void r_core_anal_hint_print (RAnal* a, unsigned long long addr, int mode);
__attribute__((visibility("default"))) void r_core_anal_hint_list (RAnal *a, int mode);
__attribute__((visibility("default"))) int r_core_anal_search(RCore *core, unsigned long long from, unsigned long long to, unsigned long long ref, int mode);
__attribute__((visibility("default"))) int r_core_anal_search_xrefs(RCore *core, unsigned long long from, unsigned long long to, int rad);
__attribute__((visibility("default"))) int r_core_anal_data (RCore *core, unsigned long long addr, int count, int depth, int wordsize);
__attribute__((visibility("default"))) void r_core_anal_coderefs(RCore *core, unsigned long long addr, int gv);
__attribute__((visibility("default"))) void r_core_anal_codexrefs(RCore *core, unsigned long long addr, int fmt);
__attribute__((visibility("default"))) int r_core_anal_refs(RCore *core, const char *input);
__attribute__((visibility("default"))) int r_core_esil_step(RCore *core, unsigned long long until_addr, const char *until_expr, unsigned long long *prev_addr);
__attribute__((visibility("default"))) int r_core_esil_step_back(RCore *core);
__attribute__((visibility("default"))) int r_core_anal_bb(RCore *core, RAnalFunction *fcn, unsigned long long at, int head);
__attribute__((visibility("default"))) unsigned long long r_core_anal_get_bbaddr(RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) int r_core_anal_bb_seek(RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) int r_core_anal_fcn(RCore *core, unsigned long long at, unsigned long long from, int reftype, int depth);
__attribute__((visibility("default"))) char *r_core_anal_fcn_autoname(RCore *core, unsigned long long addr, int dump);
__attribute__((visibility("default"))) void r_core_anal_autoname_all_fcns(RCore *core);
__attribute__((visibility("default"))) int r_core_anal_fcn_list(RCore *core, const char *input, const char *rad);
__attribute__((visibility("default"))) int r_core_anal_fcn_list_size(RCore *core);
__attribute__((visibility("default"))) void r_core_anal_fcn_labels(RCore *core, RAnalFunction *fcn, int rad);
__attribute__((visibility("default"))) int r_core_anal_fcn_clean(RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) int r_core_anal_graph(RCore *core, unsigned long long addr, int opts);
__attribute__((visibility("default"))) int r_core_anal_graph_fcn(RCore *core, char *input, int opts);
__attribute__((visibility("default"))) RList* r_core_anal_graph_to(RCore *core, unsigned long long addr, int n);
__attribute__((visibility("default"))) int r_core_anal_ref_list(RCore *core, int rad);
__attribute__((visibility("default"))) int r_core_anal_all(RCore *core);
__attribute__((visibility("default"))) RList* r_core_anal_cycles (RCore *core, int ccl);
__attribute__((visibility("default"))) void r_core_anal_type_match(RCore *core, RAnalFunction *fcn);
typedef struct r_core_asm_hit {
 char *code;
 int len;
 unsigned long long addr;
 unsigned char valid;
} RCoreAsmHit;
__attribute__((visibility("default"))) RBuffer *r_core_syscall (RCore *core, const char *name, const char *args);
__attribute__((visibility("default"))) RBuffer *r_core_syscallf (RCore *core, const char *name, const char *fmt, ...);
__attribute__((visibility("default"))) RCoreAsmHit *r_core_asm_hit_new(void);
__attribute__((visibility("default"))) RList *r_core_asm_hit_list_new(void);
__attribute__((visibility("default"))) void r_core_asm_hit_free(void *_hit);
__attribute__((visibility("default"))) void r_core_set_asm_configs(RCore *core, char *arch, unsigned int bits, int segoff);
__attribute__((visibility("default"))) char* r_core_asm_search(RCore *core, const char *input);
__attribute__((visibility("default"))) RList *r_core_asm_strsearch(RCore *core, const char *input, unsigned long long from, unsigned long long to, int maxhits, int regexp, int everyByte, int mode);
__attribute__((visibility("default"))) RList *r_core_asm_bwdisassemble (RCore *core, unsigned long long addr, int n, int len);
__attribute__((visibility("default"))) RList *r_core_asm_back_disassemble_instr (RCore *core, unsigned long long addr, int len, unsigned int hit_count, unsigned int extra_padding);
__attribute__((visibility("default"))) RList *r_core_asm_back_disassemble_byte (RCore *core, unsigned long long addr, int len, unsigned int hit_count, unsigned int extra_padding);
__attribute__((visibility("default"))) unsigned int r_core_asm_bwdis_len (RCore* core, int* len, unsigned long long* start_addr, unsigned int l);
__attribute__((visibility("default"))) int r_core_print_disasm(RPrint *p, RCore *core, unsigned long long addr, unsigned char *buf, int len, int lines, int invbreak, int nbytes, _Bool json);
__attribute__((visibility("default"))) int r_core_print_disasm_json(RCore *core, unsigned long long addr, unsigned char *buf, int len, int lines);
__attribute__((visibility("default"))) int r_core_print_disasm_instructions (RCore *core, int len, int l);
__attribute__((visibility("default"))) int r_core_print_disasm_all (RCore *core, unsigned long long addr, int l, int len, int mode);
__attribute__((visibility("default"))) int r_core_disasm_pdi(RCore *core, int nb_opcodes, int nb_bytes, int fmt);
__attribute__((visibility("default"))) int r_core_print_fcn_disasm(RPrint *p, RCore *core, unsigned long long addr, int l, int invbreak, int cbytes);
__attribute__((visibility("default"))) int r_core_file_bin_raise (RCore *core, unsigned int binfile_idx);
__attribute__((visibility("default"))) int r_core_bin_set_env (RCore *r, RBinFile *binfile);
__attribute__((visibility("default"))) int r_core_bin_set_by_fd (RCore *core, unsigned long long bin_fd);
__attribute__((visibility("default"))) int r_core_bin_set_by_name (RCore *core, const char *name);
__attribute__((visibility("default"))) int r_core_bin_reload(RCore *core, const char *file, unsigned long long baseaddr);
__attribute__((visibility("default"))) _Bool r_core_bin_load(RCore *core, const char *file, unsigned long long baseaddr);
__attribute__((visibility("default"))) int r_core_bin_rebase(RCore *core, unsigned long long baddr);
__attribute__((visibility("default"))) void r_core_bin_export_info_rad(RCore *core);
__attribute__((visibility("default"))) int r_core_hash_load(RCore *core, const char *file);
__attribute__((visibility("default"))) int r_core_bin_list(RCore *core, int mode);
__attribute__((visibility("default"))) int r_core_bin_raise (RCore *core, unsigned int binfile_idx, unsigned int obj_idx);
__attribute__((visibility("default"))) _Bool r_core_bin_delete (RCore *core, unsigned int binfile_idx, unsigned int binobj_idx);
__attribute__((visibility("default"))) int r_core_bin_refresh_strings(RCore *core);
__attribute__((visibility("default"))) int r_core_pseudo_code (RCore *core, const char *input);
__attribute__((visibility("default"))) int r_core_gdiff(RCore *core1, RCore *core2);
__attribute__((visibility("default"))) int r_core_gdiff_fcn(RCore *c, unsigned long long addr, unsigned long long addr2);
__attribute__((visibility("default"))) _Bool r_core_project_open(RCore *core, const char *file, _Bool thready);
__attribute__((visibility("default"))) int r_core_project_cat(RCore *core, const char *name);
__attribute__((visibility("default"))) int r_core_project_delete(RCore *core, const char *prjfile);
__attribute__((visibility("default"))) int r_core_project_list(RCore *core, int mode);
__attribute__((visibility("default"))) _Bool r_core_project_save_rdb(RCore *core, const char *file, int opts);
__attribute__((visibility("default"))) _Bool r_core_project_save(RCore *core, const char *file);
__attribute__((visibility("default"))) char *r_core_project_info(RCore *core, const char *file);
__attribute__((visibility("default"))) char *r_core_project_notes_file (RCore *core, const char *file);
__attribute__((visibility("default"))) char *r_core_sysenv_begin(RCore *core, const char *cmd);
__attribute__((visibility("default"))) void r_core_sysenv_end(RCore *core, const char *cmd);
__attribute__((visibility("default"))) void r_core_sysenv_help(const RCore* core);
__attribute__((visibility("default"))) void fcn_callconv (RCore *core, RAnalFunction *fcn);
typedef struct r_core_bin_filter_t {
 unsigned long long offset;
 const char *name;
} RCoreBinFilter;
__attribute__((visibility("default"))) int r_core_bin_info (RCore *core, int action, int mode, int va, RCoreBinFilter *filter, const char *chksum);
__attribute__((visibility("default"))) int r_core_bin_set_arch_bits (RCore *r, const char *name, const char * arch, unsigned short bits);
__attribute__((visibility("default"))) int r_core_bin_update_arch_bits (RCore *r);
__attribute__((visibility("default"))) char *r_core_bin_method_flags_str(unsigned long long flags, int mode);
__attribute__((visibility("default"))) int r_core_rtr_cmds (RCore *core, const char *port);
__attribute__((visibility("default"))) char *r_core_rtr_cmds_query (RCore *core, const char *host, const char *port, const char *cmd);
__attribute__((visibility("default"))) void r_core_rtr_help(RCore *core);
__attribute__((visibility("default"))) void r_core_rtr_pushout(RCore *core, const char *input);
__attribute__((visibility("default"))) void r_core_rtr_list(RCore *core);
__attribute__((visibility("default"))) void r_core_rtr_add(RCore *core, const char *input);
__attribute__((visibility("default"))) void r_core_rtr_remove(RCore *core, const char *input);
__attribute__((visibility("default"))) void r_core_rtr_session(RCore *core, const char *input);
__attribute__((visibility("default"))) void r_core_rtr_cmd(RCore *core, const char *input);
__attribute__((visibility("default"))) int r_core_rtr_http(RCore *core, int launch, const char *path);
__attribute__((visibility("default"))) int r_core_rtr_http_stop(RCore *u);
__attribute__((visibility("default"))) int r_core_rtr_gdb(RCore *core, int launch, const char *path);
__attribute__((visibility("default"))) void r_core_visual_config (RCore *core);
__attribute__((visibility("default"))) void r_core_visual_mounts (RCore *core);
__attribute__((visibility("default"))) void r_core_visual_anal (RCore *core);
__attribute__((visibility("default"))) void r_core_seek_next (RCore *core, const char *type);
__attribute__((visibility("default"))) void r_core_seek_previous (RCore *core, const char *type);
__attribute__((visibility("default"))) void r_core_visual_define (RCore *core, const char *arg);
__attribute__((visibility("default"))) int r_core_visual_trackflags (RCore *core);
__attribute__((visibility("default"))) int r_core_visual_comments (RCore *core);
__attribute__((visibility("default"))) int r_core_visual_prompt (RCore *core);
__attribute__((visibility("default"))) _Bool r_core_visual_esil (RCore *core);
__attribute__((visibility("default"))) int r_core_search_preludes(RCore *core);
__attribute__((visibility("default"))) int r_core_search_prelude(RCore *core, unsigned long long from, unsigned long long to, const unsigned char *buf, int blen, const unsigned char *mask, int mlen);
__attribute__((visibility("default"))) RList*  r_core_get_boundaries_prot (RCore *core, int protection, const char *mode);
__attribute__((visibility("default"))) RList*  r_core_get_boundaries (RCore *core, const char *mode);
__attribute__((visibility("default"))) RList* r_core_get_boundaries_ok(RCore *core);
__attribute__((visibility("default"))) int r_core_patch (RCore *core, const char *patch);
__attribute__((visibility("default"))) void r_core_hack_help(const RCore *core);
__attribute__((visibility("default"))) int r_core_hack(RCore *core, const char *op);
__attribute__((visibility("default"))) _Bool r_core_dump(RCore *core, const char *file, unsigned long long addr, unsigned long long size, int append);
__attribute__((visibility("default"))) void r_core_diff_show(RCore *core, RCore *core2);
__attribute__((visibility("default"))) void r_core_clippy(const char *msg);
__attribute__((visibility("default"))) void r_core_cmpwatch_free (RCoreCmpWatcher *w);
__attribute__((visibility("default"))) RCoreCmpWatcher *r_core_cmpwatch_get (RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) int r_core_cmpwatch_add (RCore *core, unsigned long long addr, int size, const char *cmd);
__attribute__((visibility("default"))) int r_core_cmpwatch_del (RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) int r_core_cmpwatch_update (RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) int r_core_cmpwatch_show (RCore *core, unsigned long long addr, int mode);
__attribute__((visibility("default"))) int r_core_cmpwatch_revert (RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) void r_core_log_free(RCoreLog *log);
__attribute__((visibility("default"))) void r_core_log_init (RCoreLog *log);
__attribute__((visibility("default"))) RCoreLog *r_core_log_new (void);
__attribute__((visibility("default"))) int r_core_log_list(RCore *core, int n, int count, char fmt);
__attribute__((visibility("default"))) void r_core_log_add(RCore *core, const char *msg);
__attribute__((visibility("default"))) void r_core_log_del(RCore *core, int n);
__attribute__((visibility("default"))) void r_core_cmd_help(const RCore *core, const char * help[]);
typedef struct {
 unsigned int youarehere;
 unsigned int flags;
 unsigned int comments;
 unsigned int functions;
 unsigned int symbols;
 unsigned int strings;
 unsigned int rwx;
} RCoreAnalStatsItem;
typedef struct {
 RCoreAnalStatsItem *block;
} RCoreAnalStats;
__attribute__((visibility("default"))) _Bool core_anal_bbs(RCore *core, const char* input);
__attribute__((visibility("default"))) char *r_core_anal_hasrefs(RCore *core, unsigned long long value, _Bool verbose);
__attribute__((visibility("default"))) char *r_core_anal_get_comments(RCore *core, unsigned long long addr);
__attribute__((visibility("default"))) RCoreAnalStats* r_core_anal_get_stats (RCore *a, unsigned long long from, unsigned long long to, unsigned long long step);
__attribute__((visibility("default"))) void r_core_anal_stats_free (RCoreAnalStats *s);
__attribute__((visibility("default"))) void r_core_anal_list_vtables (void *core, _Bool printJson);
__attribute__((visibility("default"))) void r_core_anal_print_rtti (void *core);
__attribute__((visibility("default"))) void r_core_syscmd_ls(const char *input);
__attribute__((visibility("default"))) void r_core_syscmd_cat(const char *file);
__attribute__((visibility("default"))) void r_core_syscmd_mkdir(const char *dir);
__attribute__((visibility("default"))) char *cmd_syscall_dostr(RCore *core, int num);
typedef void (*RCoreTaskCallback)(void *user, char *out);
typedef struct r_core_task_t {
 int id;
 char state;
 void *user;
 RCore *core;
 RThreadMsg *msg;
 RCoreTaskCallback cb;
} RCoreTask;
__attribute__((visibility("default"))) RCoreTask *r_core_task_get (RCore *core, int id);
__attribute__((visibility("default"))) void r_core_task_list (RCore *core, int mode);
__attribute__((visibility("default"))) RCoreTask *r_core_task_new (RCore *core, const char *cmd, RCoreTaskCallback cb, void *user);
__attribute__((visibility("default"))) void r_core_task_run(RCore *core, RCoreTask *_task);
__attribute__((visibility("default"))) void r_core_task_run_bg(RCore *core, RCoreTask *_task);
__attribute__((visibility("default"))) RCoreTask *r_core_task_add (RCore *core, RCoreTask *task);
__attribute__((visibility("default"))) void r_core_task_add_bg (RCore *core, RCoreTask *task);
__attribute__((visibility("default"))) int r_core_task_del (RCore *core, int id);
__attribute__((visibility("default"))) void r_core_task_join (RCore *core, RCoreTask *task);
typedef void (*inRangeCb) (RCore *core, unsigned long long from, unsigned long long to, int vsize,
      _Bool asterisk, int count);
__attribute__((visibility("default"))) int r_core_search_value_in_range (RCore *core, RAddrInterval search_itv,
  unsigned long long vmin, unsigned long long vmax, int vsize, _Bool asterisk, inRangeCb cb);
extern RCorePlugin r_core_plugin_java;
extern RCorePlugin r_core_plugin_anal;
typedef struct type_descriptor_t {
 unsigned long long pVFTable;
 int spare;
 char* className;
} type_descriptor;
typedef struct class_hierarchy_descriptor_t {
 int signature;
 int attributes;
 int numBaseClasses;
 RList* baseClassArray;
} class_hierarchy_descriptor;
typedef struct base_class_descriptor_t {
 type_descriptor* typeDescriptor;
 int numContainedBases;
 int mdisp;
 int pdisp;
 int vdisp;
 int attributes;
 class_hierarchy_descriptor* classDescriptor;
} base_class_descriptor;
typedef struct rtti_complete_object_locator_t {
 int signature;
 int vftableOffset;
 int cdOffset;
 type_descriptor* typeDescriptor;
 class_hierarchy_descriptor* hierarchyDescriptor;
} rtti_complete_object_locator;
typedef struct run_time_type_information_t {
 unsigned long long vtable_start_addr;
 unsigned long long rtti_addr;
} rtti_struct;
